C
C ***************************************************
C **  FUNKTION ZUR BERECHNUNG DES SKALARPRODUKTES  **
C ***************************************************
C
       FUNCTION SKALAR(X,Y)
C
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION X(3),Y(3)
C
       XERG = 0.0
       DO I = 1,3
	  XERG = XERG + X(I) * Y(I)
       END DO
       SKALAR = XERG
       RETURN
       END
C
C ************************************************
C **  ROUTINE ZUR BERECHNUNG DES KREUZPRODUKTES **
C ************************************************
C
       SUBROUTINE CROSSP(X,Y,Z)
C
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION X(3),Y(3),Z(3)
C
       Z(1) = X(2)*Y(3) - X(3)*Y(2)
       Z(2) = X(3)*Y(1) - X(1)*Y(3)
       Z(3) = X(1)*Y(2) - X(2)*Y(1)
C
       RETURN
       END
C
