C
C     SUBROUTINE FOR GENERATING 3-D extended mesh along given direction
C
      SUBROUTINE MESH_EX3D4
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C     DIMENSION LNODS_BASE(3000,MXNOD_2D)
C---  lnods-base wurde umbenannt in die common-variable lnods-2d
C
      DIMENSION LCELDF(20,20,20),LCNDDF(30),LCWORK(10,6),
     & COEF_CD(20,6),NODE_CD(20,6,6),INTE_ND(20,6),NE_IETYP(6),IEL(50)
C
      TEXT='NOW EXCUTING SUB. MESH_EX3D4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_EX3D4'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. MESH_EX3D4'
C
      IMSET_ext = 1
      CALL LOCCHR(STRING,'ELSET',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET_ext
      END IF
C
      READ(IO_INPUT,'(A)') STRING
      READ(IO_INPUT,*) NEXT,AEXT
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
      IF(STRING(1:2).EQ.'XL') THEN
        KEY_SND = 1
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI =-1.0
        IEX_AXI = 1
        KW1_AXI = 3
        KW2_AXI = 2
        ILC_TYP = 2
C
      ELSE IF(STRING(1:2).EQ.'XR') THEN
        KEY_SND = 2
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI = 1.0
        IEX_AXI = 1
        KW1_AXI = 3
        KW2_AXI = 2
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'YU') THEN
        KEY_SND = 4
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI = 1.0
        IEX_AXI = 2
        KW1_AXI = 3
        KW2_AXI = 1
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'YD') THEN
        KEY_SND =3
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI =-1.0
        IEX_AXI = 2
        KW1_AXI = 3
        KW2_AXI = 1
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'ZB') THEN
        KEY_SND =5
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI =-1.0
        IEX_AXI = 3
        KW1_AXI = 1
        KW2_AXI = 2
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'ZF') THEN
        KEY_SND = 6
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI = 1.0
        IEX_AXI = 3
        KW1_AXI = 1
        KW2_AXI = 2
        ILC_TYP = 2
      END IF
C
C     GENERATING LNODS BASE ELEMENT DINIFITION
C
      NE_BS = 0
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        IMSET=LNODS(IE,MXNOD-1)
        DO K=1,10
          IEL(K) = 0
        END DO
        NDEL = 0
        IF(NODE.LE.8) THEN
          NN = NODE
          ND_BS = 4
          KDEN = 1
          KDOB = 1
          NFAC = 6
        ELSE IF(NODE.EQ.20) THEN
          NN = 8
          ND_BS = 8
          KDEN = 1
          KDOB = 2
          NFAC = 6
        ELSE IF(NODE.GT.20) THEN
          NN = 8
          ND_BS = 9
          KDEN = 1
          KDOB = 2
          NFAC = 6
        ELSE IF(NODE.GT.10) THEN
          NN = 6
          KDEN = 2
          KDOB = 2
          NFAC = 6
        END IF
        DO IN=1,NN
          LN = LNODS(IE,IN)
          XI = COORD(LN,IEX_AXI)
          IF(ABS(XI-CBOUND(KEY_SND)).LT.TOLER) THEN
            NDEL = NDEL + 1
            IEL(NDEL) = IN
          END IF
        END DO
C-----  element ie is at structure surface
        IF(NDEL.GT.2) THEN
          STRING = '         '
          WRITE(STRING,'(4I1)') (IEL(K),K=1,NDEL)
          KF = 0
          DO K=1,NFAC
            KF = K
            IF(STRING(1:4).EQ.CFACE_DF(K,KDEN)) GOTO 50
          END DO
          GOTO 99
   50     CONTINUE
          NE_BS = NE_BS + 1
          LNODS_2D(NE_BS,MXNOD_2D)=ND_BS
          DO K =1,ND_BS
            IN = NFACE_DF(K,KF,KDEN)
            LNODS_2D(NE_BS,K) = LNODS(IE,IN)
          END DO
        END IF
   99   CONTINUE
      END DO
C
      DO K = 1,NNODE
        IWORK(K)=0
      END DO
      NP_BS = 0
      DO IE_BS=1,NE_BS
        NODE = LNODS_2D(IE_BS,MXNOD_2D)
        DO K=1,NODE
          LN = LNODS_2D(IE_BS,K)
	  IF (IWORK(LN).EQ.0) THEN
	     NP_BS = NP_BS + 1
             IWORK(LN) = NP_BS
	  ENDIF
        END DO
      END DO
C
      LN  = LNODS_2D(1,1)
      CD_EXT=COORD(LN,IEX_AXI)
      RL=AEXT-CD_EXT
      IF(RL*VW3_AXI.LT.0.0) GOTO 900
C
      IF(NEXT.GT.0) THEN
C-----  scaled element length
        BL_MIN = 1.0D30
        BL_MAX = 0.0D0
C-----  looking for maximum (bl_max) and minimum (bl_min) element edge
        DO IE=1,NE_BS
          NODE = LNODS_2D(IE,MXNOD_2D)
          DO K=1,2
            K1 = K
            K2 = K + 1
            LN1 = LNODS_2D(IE,K1)
            LN2 = LNODS_2D(IE,K2)
            X1  = COORD(LN1,KW1_AXI)
            Y1  = COORD(LN1,KW2_AXI)
            X2  = COORD(LN2,KW1_AXI)
            Y2  = COORD(LN2,KW2_AXI)
  	    ZZ  = 0.0
            BL  = DISTN(X1,Y1,ZZ,X2,Y2,ZZ)
            IF(BL.GT.BL_MAX) BL_MAX = BL
            IF(BL.LT.BL_MIN) BL_MIN = BL
          END DO
        END DO
        BL_EXT=0.5*(BL_MIN+BL_MAX)
        IF(BL_MAX.GT.3*BL_MIN) BL_EXT=0.40*(BL_MIN+BL_MAX)
        IF(BL_MAX.GT.5*BL_MIN) BL_EXT=0.30*(BL_MIN+BL_MAX)
        EL_EXT0=BL_EXT*VW3_AXI
C
        CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
	IF (NEXT.LT.1) NEXT = 1
        IF (SCL.LT.0.9) THEN
          NEXT=INT(RL/EL_EXT0)
          SCL=1.0
          EL_EXT0 = RL/FLOAT(NEXT)
        ELSEIF (SCL.LT.1.0) THEN
          SCL=1.0
          EL_EXT0 = RL/FLOAT(NEXT)
        ELSE IF (SCL.GT.SCMAX) THEN
          DO I=1,900
            NEXT=NEXT+1
            CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
            IF(SCL.LT.SCMAX) GOTO 92
          END DO
   92     CONTINUE
          CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
        END IF
      ELSE
C-----  constant element length
        NEXT   =-NEXT
        EL_EXT0=RL/FLOAT(NEXT)
        SCL    =1.0
      END IF
      SC_EXT = SCL
      IE     = NELEM
      ND0    = NNODE-NP_BS
      DL_EXT = EL_EXT0
      DO IEX=1,NEXT
        DL_EXT = DL_EXT*SC_EXT
        CD_EXT = CD_EXT+DL_EXT
        DO IE_BS =1,NE_BS
          IE=IE+1
          NODE_2D = LNODS_2D(IE_BS,MXNOD_2D)
          IF(NODE_2D.EQ.4) THEN
            NODE = 8
            DO K=1,NODE_2D
              LN = LNODS_2D(IE_BS,K)
              LN_BS = ND0+IWORK(LN)
              IF(IEX.GT.1) LN = LN_BS
              LNODS(IE,K) = LN
              LNODS(IE,K+4) = LN_BS+NP_BS
            END DO
            ELTYP(IE)='C3D8'
            LNODS(IE,MXNOD)=8
          ELSE IF(NODE_2D.EQ.8) THEN
            NODE = 20
            DO K=1,4
              LN    = LNODS_2D(IE_BS,K)
              LN_BS = ND0+IWORK(LN)
              IF(IEX.GT.1) LN = LN_BS
              LNODS(IE,K) = LN
              LNODS(IE,K+ 4) = LN_BS+NP_BS*2
              LNODS(IE,K+16) = LN_BS+NP_BS
              LN    = LNODS_2D(IE_BS,K+4)
              LN_BS = ND0+IWORK(LN)
              IF(IEX.GT.1) LN = LN_BS
              LNODS(IE,K+ 8) = LN
              LNODS(IE,K+12) = LN_BS+NP_BS*2
            END DO
            ELTYP(IE)='C3D20'
            LNODS(IE,MXNOD)=20
          ELSE IF(NODE_2D.EQ.9) THEN
            NODE = 27
            DO K=1,4
              LN    = LNODS_2D(IE_BS,K)
              LN_BS = ND0+IWORK(LN)
              IF(IEX.GT.1) LN = LN_BS
              LNODS(IE,K) = LN
              LNODS(IE,K+ 4) = LN_BS+NP_BS*2
              LNODS(IE,K+16) = LN_BS+NP_BS
              LN    = LNODS_2D(IE_BS,K+4)
              LN_BS = ND0+IWORK(LN)
              IF(IEX.GT.1) LN = LN_BS
              LNODS(IE,K+ 8) = LN
              LNODS(IE,K+12) = LN_BS+NP_BS*2
            END DO
            LN9 = LNODS_2D(IE_BS,9)
            LN9_BS = ND0+IWORK(LN9)
            IF(IEX.GT.1) LN9 = LN9_BS
            LNODS(IE,21) = LN9_BS+NP_BS
            LNODS(IE,22) = LN9
            LNODS(IE,23) = LN9_BS+NP_BS*2
            DO K=1,4
              LN    = LNODS_2D(IE_BS,K+4)
              LN_BS = ND0+IWORK(LN)
              LNODS(IE,K+23) = LN_BS+NP_BS
            END DO
            ELTYP(IE)='C3D27'
            LNODS(IE,MXNOD)=27
          END IF
          DO K=1,4
            LN1 = LNODS(IE,K)
            LN2 = LNODS(IE,K+4)
            COORD(LN2,IEX_AXI)=COORD(LN1,IEX_AXI)+DL_EXT
            COORD(LN2,KW1_AXI)=COORD(LN1,KW1_AXI)
            COORD(LN2,KW2_AXI)=COORD(LN1,KW2_AXI)
          END DO
          IMSET=IMSET_EXT
          LNODS(IE,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IE
          CALL DNODE(IE,NODE)
          IF(NODE.GE.20) CALL NODXYn(IE)
        END DO
        ND0 = ND0+KDOB*NP_BS
      END DO
      NELEM=IE
      NNODE=ND0+NP_BS
C
C     CALL REORDER
C
      TEXT='END OF EXCUTING SUB. MESH_EX3D4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  900 CONTINUE
      WRITE(6,1000) AEXT
 1000 FORMAT(///4X,'*** ERROR IN INPUT DATA FOR OPTION *EXT_3D4 *** ',
     &          4X,'AEXT=',E10.4,' must be positive '///)
      STOP
      END
