C******************************************************************
C     Added in Aug.21, 1995
C******************************************************************
C
C     SUBROUTINE FOR GENERATING CRACK TIP MESH
C
      SUBROUTINE CRACKTIP1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CRACKTIP1'
C
      TEXT='NOW EXCUTING SUB. CRACKTIP1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      NELEM0 = NELEM
C
    1 READ(IO_INPUT,*) IMSET,NODE,DELEMX,DELEMY
      NDTYP  = NODE/4
      DELEMX = DELEMX/(2.0D0*NDTYP)
      DELEMY = DELEMY/(2.0D0*NDTYP)
      XTIP   = XORIGN
      YTIP   = YORIGN
      NTNUM  = 1
      NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
      IF(NODE.EQ.4) THEN
        NDTIP(NTNUM,NDTIP(NTNUM,1))=5
      ELSE IF(NODE.GE.8) THEN
        NDTIP(NTNUM,NDTIP(NTNUM,1))=15
      END IF
      IF(NODE.EQ.4) THEN
        CALL ELEV4_2U(DELEMX,DELEMY,IMSET,NODE)
      ELSE IF(NODE.GE.8) THEN
        CALL ELEV8_2U(DELEMX,DELEMY,IMSET,NODE)
      END IF
      ELL  = DELEMX
      ELR  = DELEMX
      ELU  = DELEMY
      ELD  = DELEMY
      RETURN
      END
      SUBROUTINE ELEV8_2U(DELEMX,DELEMY,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER ( NNLOC  = 33, NGENE  = 6)
      DIMENSION LNLOC(9,NGENE),CDLOC(2,NNLOC),NDLOC(NNLOC)
      DATA LNLOC/ 1, 7, 9, 3, 4, 8, 6, 2, 5,
     &            7,15,17, 9,10,16,12, 8,11,
     &            9,17,19, 3,12,18,14, 6,13,
     &           15,25,27,17,20,26,22,16,21,
     &           25,31,33,27,28,32,30,26,29,
     &           17,27,33,19,22,30,24,18,23/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,0.0D0,4.0D0,1.0D0,0.0D0,
     &           1.0D0,1.5D0,1.0D0,3.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.0D0,3.0D0,2.0D0,
     &           2.5D0,3.0D0,2.0D0,4.0D0,4.0D0,0.0D0,4.0D0,1.0D0,
     &           4.0D0,2.0D0,4.0D0,3.0D0,4.0D0,4.0D0,5.0D0,0.0D0,
     &           5.0D0,1.0D0,5.0D0,2.0D0,5.5D0,3.0D0,6.0D0,4.0D0,
     &           6.0D0,0.0D0,6.0D0,1.0D0,6.0D0,2.0D0,7.0D0,0.0D0,
     &           7.0D0,1.5D0,7.0D0,3.0D0,8.0D0,0.0D0,8.0D0,2.0D0,
     &           8.0D0,4.0D0/
C
      NNODE0 = NNODE
      IE     = NELEM
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      XI = XTIP - 4.0D0*DELEMX
      YI = YTIP
      DO K=1,NGENE
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE0
          XNEW = XI+CDLOC(1,NGASH)*DELEMX
          YNEW = YI+CDLOC(2,NGASH)*DELEMY
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        ELTYP(IE)='C2D8'
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE0+NNLOC
      RETURN
      END
      SUBROUTINE ELEV4_2U(DELEMX,DELEMY,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER ( NNLOC  = 11, NGENE  = 6)
      DIMENSION LNLOC(4,NGENE),CDLOC(2,NNLOC),NDLOC(NNLOC)
      DATA LNLOC/ 1, 3, 4, 2, 3, 5, 6, 4, 4, 6, 7, 2, 5, 8, 9, 6,
     &            6, 9,11, 7, 8,10,11, 9/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,1.0D0,0.0D0,1.0D0,1.0D0,
     &           2.0D0,0.0D0,2.0D0,1.0D0,2.0D0,2.0D0,3.0D0,0.0D0,
     &           3.0D0,1.0D0,4.0D0,0.0D0,4.0D0,2.0D0/
      NNODE0 = NNODE
      IE     = NELEM
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      XI = XTIP - 2.0D0*DELEMX
      YI=YTIP
      DO K=1,NGENE
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE0
          XNEW = XI+CDLOC(1,NGASH)*DELEMX
          YNEW = YI+CDLOC(2,NGASH)*DELEMY
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        ELTYP(IE)='C2D4'
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE0+NNLOC
      RETURN
      END
