C
C     SUBROUTINE FOR MESH COPYING
C
      SUBROUTINE MCOPY
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDSYS(5000),NESYS(5000),NSYSE(9000),IEL(8),XB(6),XBD(3)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MFLIP  '
C
      TEXT='NOW EXCUTING SUB. MCOPY  '
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KDIR   = 1
      CALL LOCCHR(STRING,'DIR     ',3,4,K1,K2)
      IF(K2.GE.K1.AND.STRING(K1:K1).EQ.'Y') THEN
        KDIR = 2
      ELSE IF(K2.GE.K1.AND.STRING(K1:K1).EQ.'Z') THEN
        KDIR = 3
      END IF
      AREF = 0.0E0
      CALL LOCCHR(STRING,'REF     ',3,4,K1,K2)
      IF(K2.GE.K1) READ(STRING(K1:K2),*) AREF
      NREP = 1
      CALL LOCCHR(STRING,'REP     ',3,4,K1,K2)
      IF(K2.GE.K1) READ(STRING(K1:K2),*) NREP
C
      XB(1) = -1.0E30
      XB(2) = -1.0E30
      XB(3) = -1.0E30
      XB(4) =  1.0E30
      XB(5) =  1.0E30
      XB(6) =  1.0E30
C
   10 CONTINUE
      READ(IO_INPUT,'(A)',END=30) STRING
   20 CONTINUE
      LEN = 150
      CALL DTEXT(STRING,LEN)
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 10
      ELSE IF(STRING(1:7).EQ.'*DETAIL') THEN
        READ(IO_INPUT,*) XB
        GOTO 10
      ELSE IF(STRING(1:1).EQ.'*') THEN
	BACKSPACE IO_INPUT
        GOTO 30
      ELSE
        GOTO 10
      END IF
      GOTO 10
   30 CONTINUE
      DREF = AREF
      XBD(1) = XB(4)-XB(1)
      XBD(2) = XB(5)-XB(2)
      XBD(3) = XB(6)-XB(3)
C
C     CALL SEAND(NDSYS,KSYSM,ASYSM,KNSYS,2)
C
      NCE   = 0
      DO IE=1,NELEM
        NODE  = LNODS(IE,MXNOD)
        IMSET = LNODS(IE,MXNOD-1)
        XM    = 0.0E0
        YM    = 0.0E0
        ZM    = 0.0E0
        KINS  = 0
        DO K=1,NODE
          LNODE = LNODS(IE,K)
          XM = XM + COORD(LNODE,1)
          YM = YM + COORD(LNODE,2)
          ZM = ZM + COORD(LNODE,3)
          X1 = COORD(LNODE,1)
          Y1 = COORD(LNODE,2)
          Z1 = COORD(LNODE,3)
          HX = (X1-XB(1))*(X1-XB(4))
          HY = (Y1-XB(2))*(Y1-XB(5))
          HZ = (Z1-XB(3))*(Z1-XB(6))
          IF(HX.GT.0.0E0.OR.HY.GT.0.0E0) KINS = 1
        END DO
        XM = XM/FLOAT(NODE)
        YM = YM/FLOAT(NODE)
        ZM = ZM/FLOAT(NODE)
        HXM = (XM-XB(1))*(XM-XB(4))
        HYM = (YM-XB(2))*(YM-XB(5))
        HZM = (ZM-XB(3))*(ZM-XB(6))
        IF(HXM.LE.0.0E0.AND.HYM.LE.0.0E0.AND.HZM.LE.0.0E0) THEN
          NCE = NCE + 1
          IWORK(NCE) = IE
        END IF
      END DO
      IADD0 = 1
      IADD1 = NCE + IADD0
      DO I=1,NNODE
        IGASH = IADD1 + I
        IWORK(IGASH) = 0
      END DO
      DO ICE=1,NCE
        IE    = IWORK(ICE)
        DO K=1,NODE
          LNODE = LNODS(IE,K)
          IGASH = IADD1 + LNODE
          IWORK(IGASH) = 1
        END DO
      END DO
      IADD2 = IADD1 + NNODE
      NCN   = 0
      DO I=1,NNODE
        IF(IWORK(IADD1+I).EQ.1) THEN
          NCN   = NCN   + 1
          IGASH = IADD2 + NCN
          IWORK(IGASH) = I
          IGASH = IADD1 + I
          IWORK(IGASH) = NCN+NNODE
          IWORK(IGASH) = NCN
        END IF
      END DO
      IF(XBD(1).GT.1.0E30) THEN
        XB(1) =  1.0E30
        XB(2) =  1.0E30
        XB(3) =  1.0E30
        XB(4) = -1.0E30
        XB(5) = -1.0E30
        XB(6) = -1.0E30
        DO ICN = 1,NCN
          IGASH = IADD2 + ICN
          I = IWORK(IGASH)
          IF(INCOD(I).GT.0) THEN
            IF(XB(1).GT.COORD(I,1)) XB(1) = COORD(I,1)
            IF(XB(4).LT.COORD(I,1)) XB(4) = COORD(I,1)
            IF(XB(2).GT.COORD(I,2)) XB(2) = COORD(I,2)
            IF(XB(5).LT.COORD(I,2)) XB(5) = COORD(I,2)
            IF(XB(3).GT.COORD(I,3)) XB(3) = COORD(I,3)
            IF(XB(6).LT.COORD(I,3)) XB(6) = COORD(I,3)
          END IF
        END DO
        XBD(1) = XB(4)-XB(1)
        XBD(2) = XB(5)-XB(2)
        XBD(3) = XB(6)-XB(3)
      END IF
      DO IREP=1,NREP
C *** REPEAT LOOP
      DO ICN = 1,NCN
        IGASH = IADD2 + ICN
        I = IWORK(IGASH)
        IF(INCOD(I).GT.0) THEN
          INS=ICN+NNODE
          IF(KDIR.EQ.1) THEN
            COORD(INS,1)=AREF+COORD(I,1)
            COORD(INS,2)=COORD(I,2)
            COORD(INS,3)=COORD(I,3)
          ELSE IF(KDIR.EQ.2) THEN
            COORD(INS,1)=COORD(I,1)
            COORD(INS,2)=AREF+COORD(I,2)
            COORD(INS,3)=COORD(I,3)
          ELSE IF(KDIR.EQ.3) THEN
            COORD(INS,1)=COORD(I,1)
            COORD(INS,2)=COORD(I,2)
            COORD(INS,3)=AREF+COORD(I,3)
          ENDIF
        ENDIF
      END DO
      DO ICE= 1,NCE
        IES   = ICE+NELEM
        IGASH = ICE
        IE    = IWORK(IGASH)
        NODE  = LNODS(IE,MXNOD)
        IMSET = LNODS(IE,MXNOD-1)
        LNODS(IES,MXNOD)   = NODE
        LNODS(IES,MXNOD-1) = IMSET
        IF(ELTYP(IE)(1:4).EQ.'C2D8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPE8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPS8') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))+NNODE
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,2))+NNODE
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,3))+NNODE
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,4))+NNODE
          LNODS(IES,5)=IWORK(IADD1+LNODS(IE,5))+NNODE
          LNODS(IES,6)=IWORK(IADD1+LNODS(IE,6))+NNODE
          LNODS(IES,7)=IWORK(IADD1+LNODS(IE,7))+NNODE
          LNODS(IES,8)=IWORK(IADD1+LNODS(IE,8))+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS6') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))+NNODE
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,2))+NNODE
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,3))+NNODE
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,4))+NNODE
          LNODS(IES,5)=IWORK(IADD1+LNODS(IE,5))+NNODE
          LNODS(IES,6)=IWORK(IADD1+LNODS(IE,6))+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS4') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))+NNODE
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,2))+NNODE
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,3))+NNODE
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,4))+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS3') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))+NNODE
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,2))+NNODE
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,3))+NNODE
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D20') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))+NNODE
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 2))+NNODE
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))+NNODE
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))+NNODE
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))+NNODE
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 6))+NNODE
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 7))+NNODE
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 8))+NNODE
          LNODS(IES, 9)=IWORK(IADD1+LNODS(IE, 9))+NNODE
          LNODS(IES,10)=IWORK(IADD1+LNODS(IE,10))+NNODE
          LNODS(IES,11)=IWORK(IADD1+LNODS(IE,11))+NNODE
          LNODS(IES,12)=IWORK(IADD1+LNODS(IE,12))+NNODE
          LNODS(IES,13)=IWORK(IADD1+LNODS(IE,13))+NNODE
          LNODS(IES,14)=IWORK(IADD1+LNODS(IE,14))+NNODE
          LNODS(IES,15)=IWORK(IADD1+LNODS(IE,15))+NNODE
          LNODS(IES,16)=IWORK(IADD1+LNODS(IE,16))+NNODE
          LNODS(IES,17)=IWORK(IADD1+LNODS(IE,17))+NNODE
          LNODS(IES,18)=IWORK(IADD1+LNODS(IE,18))+NNODE
          LNODS(IES,19)=IWORK(IADD1+LNODS(IE,19))+NNODE
          LNODS(IES,20)=IWORK(IADD1+LNODS(IE,20))+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D6') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))+NNODE
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 2))+NNODE
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))+NNODE
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))+NNODE
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))+NNODE
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 6))+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D8') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))+NNODE
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 2))+NNODE
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))+NNODE
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))+NNODE
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))+NNODE
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 6))+NNODE
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 7))+NNODE
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 8))+NNODE
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D15') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))+NNODE
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 2))+NNODE
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))+NNODE
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))+NNODE
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))+NNODE
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 6))+NNODE
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 7))+NNODE
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 8))+NNODE
          LNODS(IES, 9)=IWORK(IADD1+LNODS(IE, 9))+NNODE
          LNODS(IES,10)=IWORK(IADD1+LNODS(IE,10))+NNODE
          LNODS(IES,11)=IWORK(IADD1+LNODS(IE,11))+NNODE
          LNODS(IES,12)=IWORK(IADD1+LNODS(IE,12))+NNODE
          LNODS(IES,13)=IWORK(IADD1+LNODS(IE,13))+NNODE
          LNODS(IES,14)=IWORK(IADD1+LNODS(IE,14))+NNODE
          LNODS(IES,15)=IWORK(IADD1+LNODS(IE,15))+NNODE
        ENDIF
        CALL DNODE(IES,NODE)
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IES
        ELTYP(IES)=ELTYP(IE)
      END DO
C
      NNODE = NNODE + NCN
      NELEM = NELEM + NCE
      AREF  = AREF + DREF
      XB(KDIR) = XB(KDIR) + XBD(KDIR)
      XB(KDIR+3) = XB(KDIR+3) + XBD(KDIR)
C *** REPEAT LOOP
      END DO
C
      TEXT='END OF EXCUTING SUB. MCOPY'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
