      SUBROUTINE CVMAXN(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN,XP1,XP2)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(*),XP2(*)
      XMAX=-1.0E20
      XMIN=1.0E20
      YMAX=-1.0E20
      YMIN=1.0E20
      ZMAX=-1.0E20
      ZMIN=1.0E20
      I1  =IRAXIS(1)
      I2  =IRAXIS(2)
      I3  =IRAXIS(3)
      DO I=1,NNODE
        IF(INCOD(I).NE.0) THEN
          X1=COORD(I,I1)
          Y1=COORD(I,I2)
          Z1=COORD(I,I3)
          H1 = (X1-XP1(1))*(X1-XP2(1))
          H2 = (Y1-XP1(2))*(Y1-XP2(2))
          H3 = (Z1-XP1(3))*(Z1-XP2(3))
          IF(H1.LT.TOLER.AND.H2.LT.TOLER.AND.H3.LT.TOLER) THEN
            IF(KEY_ROTAT2.EQ.0) THEN
              IF(X1.LT.XMIN) XMIN=X1
              IF(X1.GT.XMAX) XMAX=X1
              IF(Y1.LT.YMIN) YMIN=Y1
              IF(Y1.GT.YMAX) YMAX=Y1
              IF(Z1.LT.ZMIN) ZMIN=Z1
              IF(Z1.GT.ZMAX) ZMAX=Z1
            ELSE
              DX=X1-XO_ROTAT2
              DY=Y1-YO_ROTAT2
              RO=SQRT(DX*DX+DY*DY)
              IF(DX.EQ.0.0E0.AND.DY.EQ.0.0E0) THEN
                TH=0.0E0
              ELSE
                TH=ACOS(DX/RO)
              END IF
              IF(DY.LT.0.0) TH=2*PI-TH
              IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
              IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
              IF(RO.LT.XMIN) XMIN=RO
              IF(RO.GT.XMAX) XMAX=RO
              IF(TH.LT.YMIN) YMIN=TH
              IF(TH.GT.YMAX) YMAX=TH
              IF(Z1.LT.ZMIN) ZMIN=Z1
              IF(Z1.GT.ZMAX) ZMAX=Z1
            END IF
          END IF
        END IF
      END DO
      RETURN
      END
