C
C     DEFINE THE NODE SETS AND THE ELEMENT SETS
C     (KOMMANDO *SET DEFINE)
C
      SUBROUTINE DFSET
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER ENSET_NAME*8, ENSET_BASE*6
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. DFSET'
C
      TEXT='NOW EXCUTING SUB. SET DEFINE'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'ELSET    ',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      IENSET = IENSET + 1
      ENSET_NAME ='ENSET'//CNUM(IENSET)
      CALL LOCCHR(STRING,'NAME     ',4,1,K1,K2)
      IF(K2.GE.K1) ENSET_NAME(1:8) = STRING(K1:K2)
C
      CALL LOCCHR(STRING,'OPTI     ',4,1,K1,K2)
      KOPTION = 1
      IF(STRING(K1:K1+3).EQ.'NSET') KOPTION = 2
      IF(STRING(K1:K1+3).EQ.'JSET') KOPTION = 3
C
      DFNUMB = 0
C
C---  definition of node sets
      IF(KOPTION.EQ.2) THEN
        CALL FIND_NSET(IWORK)
        NDSET = NDSET + 1
        DO K=2,IWORK(1)
          INSET(K-1,NDSET) = IWORK(K)
        END DO
        NNSET(NDSET)  = IWORK(1)-1
        CNDSET(NDSET) = ENSET_NAME
        IF(IOUT.NE.1.AND.IWORK(1).GT.1) THEN
          WRITE(IO_OUTP,1210) ENSET_NAME
          WRITE(IO_OUTP,1000) (IWORK(K),K=2,IWORK(1))
          WRITE(IO_JNL,2000) 'NODE',ENSET_NAME,IWORK(1) - 1
          WRITE(IO_WRITE,2000) 'NODE',ENSET_NAME,IWORK(1) - 1
        END IF
C---  definition of j-integral sets
      ELSEIF (KOPTION.EQ.3) THEN
	LSETNAM = 6
        CALL DTEXT(ENSET_NAME,LSETNAM)
	LSETNAM = MIN(LSETNAM,6)
	ENSET_BASE = ENSET_NAME(1:LSETNAM)
	READ (IO_INPUT,*) XP1,YP1,XP2,YP2
	DO I = 1,NTNUM
	   NDSET = NDSET + 1
	   ENSET_NAME = ENSET_BASE(1:LSETNAM) // CNUM(I)
           CALL FIND_JSET(ZTHICK(I),XP1,YP1,XP2,YP2)
           DO K=2,IWORK(1)
             INSET(K-1,NDSET) = IWORK(K)
           END DO
           NNSET(NDSET)  = IWORK(1)-1
Ctest      print *,'found',nnset(ndset),' nodes at z=',zthick(i)
           CNDSET(NDSET) = ENSET_NAME
           IF(IOUT.NE.1.AND.IWORK(1).GT.1) THEN
              WRITE(IO_OUTP,1210) ENSET_NAME
              WRITE(IO_OUTP,1000) (IWORK(K),K=2,IWORK(1))
              WRITE(IO_JNL,2000) 'NODE',ENSET_NAME,IWORK(1) - 1
              WRITE(IO_WRITE,2000) 'NODE',ENSET_NAME,IWORK(1) - 1
           END IF
	END DO
C---  definition of element sets
      ELSE
        CALL FIND_ELSET_new(IMSET1,IWORK,NELE)
        IF(IOUT.NE.1.AND.NELE.GT.0) THEN
          WRITE(IO_OUTP,1211) ENSET_NAME
          WRITE(IO_OUTP,1000) (IWORK(K),K=1,NELE)
          WRITE(IO_JNL,2000) 'ELEMENT',ENSET_NAME,IWORK(1) - 1
          WRITE(IO_WRITE,2000) 'ELEMENT',ENSET_NAME,IWORK(1) - 1
        END IF
      END IF
      RETURN
C
 1000 FORMAT(11(I6,','))
 1210 FORMAT('*NSET,NSET=',A8)
 1211 FORMAT('*ELSET,ELSET=',A8)
 1220 FORMAT('*NSET,NSET=',A7,I1)
 2000 FORMAT(A,'SET ',A,' GENERATED WITH ',I4,' MEMBER(S)')
 1221 FORMAT('*ELSET,ELSET=',A7,I1)
C
      END
C
C---  UTITLITY ROUTINE FOR FINDING ELEMENTS IN A REGION
C---  (USED BY SEVERAL OTHER ROUTINES)
C
      SUBROUTINE FIND_ELSET_new(IMSET1,IW,NELE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (MXPOLY=20)
      DIMENSION IW(*),XP(MXPOLY),YP(MXPOLY),ZP(MXPOLY),XPL(4),YPL(4)
C
C
      NELE  = 0
      TOL   = TOLER
   5  CONTINUE
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:7).EQ.'*CIRCLE') THEN
        KEY=1
        READ(IO_INPUT,*) X0,Y0
        READ(IO_INPUT,*) R1,T1,Z1,R2,T2,Z2
      ELSE IF(STRING(1:8).EQ.'*POLYGON') THEN
        KEY=2
        READ(IO_INPUT,*) X1,Y1,Z1,X2,Y2,Z2
      ELSE IF(STRING(1:6).EQ.'*POINT') THEN
        KEY=3
        READ(IO_INPUT,*) X1,Y1,Z1
      ELSE IF(STRING(1:8).EQ.'*POLYLIN') THEN
        KEY=4
        READ(IO_INPUT,*) NP,(XP(I),YP(I),ZP(I),I=1,NP)
      ELSE IF(STRING(1:2).EQ.'**') THEN
	GOTO 5
      ELSE IF(STRING(1:1).EQ.'*') THEN
	BACKSPACE IO_INPUT
	RETURN
      END IF
C
C
      NSETS = 0
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) NSETS=NSETS+1
      END DO
      KSETB = 1
      KSETE = NSETS
      IF(IMSET1.GT.0) THEN
        KSETB = IMSET1
        KSETE = IMSET1
      END IF
      DO IMSET=KSETB,KSETE
        NMELE=MATSET(IMSET,1)
        DO K=2,NMELE
          IE=MATSET(IMSET,K)
          NODE=LNODS(IE,MXNOD)
          IF(NODE.GT.8) NODE = 8
          X=0.0
          Y=0.0
          Z=0.0
          NN = 0
          DO J=1,NODE
            IN=LNODS(IE,J)
            IF(IN.NE.0) THEN
              NN =NN + 1
	      IF (KEY .EQ.3) THEN
C--------------  looking for *POINT connection
		 H1 = ABS(X1 - COORD(IN,1))
		 H2 = ABS(Y1 - COORD(IN,2))
		 H3 = ABS(Z1 - COORD(IN,3))
                 IF(H1.LT.TOL.AND.H2.LT.TOL.AND.H3.LT.TOL) THEN
                    NELE = NELE + 1
                    IW(NELE) = IE
		    GOTO 250
                 END IF
	      ENDIF
              X=X+COORD(IN,1)
              Y=Y+COORD(IN,2)
              Z=Z+COORD(IN,3)
            END IF
          END DO
	  IF (KEY .EQ. 3) GOTO 250
          X=X/FLOAT(NN)
          Y=Y/FLOAT(NN)
          Z=Z/FLOAT(NN)
          IF(KEY.EQ.1) THEN
            DX=X-X0
            DY=Y-Y0
            RM=SQRT(DX*DX+DY*DY)
            TM=ACOS(DX/RM)*180.0/PI
            IF(DY.LT.0.0) TM=360.0-TM
            H1 = (RM-R1)*(RM-R2)
            H2 = (TM-T1)*(TM-T2)
            H3 = (Z-Z1)*(Z-Z2)
          ELSE IF(KEY.EQ.2) THEN
            H1 = (X-X1)*(X-X2)
            H2 = (Y-Y1)*(Y-Y2)
            H3 = (Z-Z1)*(Z-Z2)
          ELSE IF(KEY.EQ.4) THEN
	    XPL(1) = X
	    YPL(1) = Y 
	    KFAIL  = 0
	    NPL    = 3
	    DO INP = 1,NP
	       INP1 = INP + 1
	       IF (INP1.GT.NP) INP1 = 1
	       XPL(2) = XP(INP)
	       YPL(2) = YP(INP)
	       XPL(3) = XP(INP1)
	       YPL(3) = YP(INP1)
	       CALL POLAREA (XPL,YPL,NPL,FAREA)
C              PRINT *,"area reg. to point ",x,"/",y," is ",farea
	       IF (FAREA.LT.0.0) KFAIL = 1
	    END DO
	    IF (KFAIL .EQ. 0) THEN
	       NELE = NELE + 1
	       IW(NELE) = IE
	    ENDIF
	    GOTO 250
          END IF
  200     CONTINUE
          IF(H1.LT.TOL.AND.H2.LT.TOL.AND.H3.LT.TOL) THEN
            NELE = NELE + 1
            IW(NELE) = IE
          END IF
  250     CONTINUE
        END DO
      END DO
      RETURN
      END
C----------------------------------------------------------------------
C *** FIND NODE AT A GIVEN POINT, LINE OR INSIDE A POLYGON ETC.
C----------------------------------------------------------------------
      SUBROUTINE FIND_NSET(NDU)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(*),IAXI(3),XP(3),YP(3),RDIR1(3),RDIR2(3),XAKT(3)
      TOL    = TOLER*TOLER
      DSTMIN = 1.E+20
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:5).EQ.'*LINE') THEN
        KEY_FIND=1
        IF(STRING(6:6).EQ.'x'.OR.STRING(6:6).EQ.'X') THEN
          IAXI(1)=2
          IAXI(2)=3
          IAXI(3)=1
        ELSE IF(STRING(6:6).EQ.'y'.OR.STRING(6:6).EQ.'Y') THEN
          IAXI(1)=3
          IAXI(2)=1
          IAXI(3)=2
        ELSE IF(STRING(6:6).EQ.'z'.OR.STRING(6:6).EQ.'Z') THEN
          IAXI(1)=1
          IAXI(2)=2
          IAXI(3)=3
        END IF
        READ(IO_INPUT,*) XP(1),XP(2),YP(1),YP(2)
      ELSE IF(STRING(1:5).EQ.'*POIN') THEN
        KEY_FIND=0
        IAXI(1)=1
        IAXI(2)=2
        IAXI(3)=3
        READ(IO_INPUT,*) XP(1),XP(2),XP(3)
C     find nodes in a polygon
      ELSE IF(STRING(1:5).EQ.'*POLY') THEN
        KEY_FIND=2
        IAXI(1)=1
        IAXI(2)=2
        IAXI(3)=3
        READ(IO_INPUT,*) XP,YP
C     find nodes on a plane
      ELSE IF(STRING(1:4).EQ.'*PLA') THEN
        KEY_FIND=3
        READ(IO_INPUT,*) XP
        READ(IO_INPUT,*) RDIR1,RDIR2
	CALL CROSSP (RDIR1,RDIR2,YP)
C     find nodes on a circle
      ELSE IF(STRING(1:5).EQ.'*CIRC') THEN
        KEY_FIND=4
        IAXI(1)=1
        IAXI(2)=2
        IAXI(3)=3
        READ(IO_INPUT,*) X0,Y0
        READ(IO_INPUT,*) XP,YP
      END IF
    5 CONTINUE
      NDU(1)=1
      DO I=1,NNODE
	X = COORD(I,IAXI(1))
	Y = COORD(I,IAXI(2))
	Z = COORD(I,IAXI(3))
        XAKT(1) = X - XP(1)
        XAKT(2) = Y - XP(2)
        XAKT(3) = Z - XP(3)
        KEY=0
        IF(KEY_FIND.EQ.0) THEN
C-------  point
          DIST = SKALAR(XAKT,XAKT)
          DIST = SQRT(DIST)
          IF (DIST.LT.TOLER) THEN
	     KEY=1
	  ELSEIF (DIST.LT.DSTMIN) THEN
	     DSTMIN = DIST
	     KNEAR  = I
	  ENDIF
        ELSE IF(KEY_FIND.EQ.1) THEN
C-------  line
          DIST = (X-XP(1))*(X-XP(1)) + (Y-XP(2))*(Y-XP(2))
          DIST = SQRT(DIST)
          AG  = (Z-YP(1))*(Z-YP(2))
          IF(DIST.LT.TOLER.AND.AG.LT.TOL) KEY=1
        ELSE IF(KEY_FIND.EQ.2) THEN
C-------  polygon
          H1 = (X-XP(1))*(X-YP(1))
          H2 = (Y-XP(2))*(Y-YP(2))
          H3 = (Z-XP(3))*(Z-YP(3))
          IF(H1.LT.TOL.AND.H2.LE.TOL.AND.H3.LE.TOL) KEY=1
        ELSE IF(KEY_FIND.EQ.3) THEN
C-------   plane
	   H1 = SKALAR(XAKT,YP)
	   H2 = SKALAR(XAKT,RDIR1)
	   H3 = SKALAR(XAKT,RDIR2)
           IF (H1.LT. TOL .AND. H2.GT.-TOL.AND.H2.LT.(1.0+TOL) .AND.
     1                          H3.GT.-TOL.AND.H3.LT.(1.0+TOL)) KEY=1
        ELSE IF(KEY_FIND.EQ.4) THEN
C-------  circle
	  XA = X-X0
	  YA = Y-Y0
	  R  = SQRT(XA*XA+YA*YA)
	  THE = ATAN2(YA,XA) * 45.0/ATAN(1.0)
	  IF (THE.LT.XP(2)) THE = THE + 360.0
          H1 = (R-XP(1))*(R-YP(1))
          H2 = (THE-XP(2))*(THE-YP(2))
          H3 = (Z-XP(3))*(Z-YP(3))
          IF(H1.LT.TOL.AND.H2.LE.TOL.AND.H3.LE.TOL) KEY=1
        END IF
        IF(KEY.EQ.1) THEN
          NDU(1)=NDU(1)+1
          NDU(NDU(1))=I
          IF(KEY_FIND.EQ.0) GOTO 999
        END IF
      END DO
C---  did not find any node in point search, then take nearest
      IF (NDU(1).LT.2 .AND. KEY_FIND.EQ.0) THEN
	 NDU(1) = 2
	 NDU(2) = KNEAR
         WRITE(IO_JNL,1000) KNEAR,DSTMIN
         WRITE(IO_WRITE,1000) KNEAR,DSTMIN
      ENDIF
  999 CONTINUE
      RETURN
 1000 FORMAT ('NODE ',I5,' HAS NOT EXACT POSITION REQUESTED',
     1        '(DISTANCE:',F8.4,')')
      END
C----------------------------------------------------------------------
C *** FIND NODES IN A POLYGON OF SPEZIFIED Z-PLANE
C----------------------------------------------------------------------
      SUBROUTINE FIND_JSET(ZCOO,XP1,YP1,XP2,YP2)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      TOL   = TOLER*TOLER
      IWORK(1)=1
      ZCOO1 = ZCOO - TOLER
      ZCOO2 = ZCOO + TOLER
      DO I=1,NNODE
	X = COORD(I,1)
	Y = COORD(I,2)
	Z = COORD(I,3)
        H1 = (X-XP1)*(X-XP2)
        H2 = (Y-YP1)*(Y-YP2)
        H3 = (Z-ZCOO1)*(Z-ZCOO2)
        IF(H1.LT.TOL.AND.H2.LE.TOL.AND.H3.LE.TOL) THEN
          IWORK(1)=IWORK(1)+1
          IWORK(IWORK(1))=I
        END IF
      END DO
      RETURN
      END
C----------------------------------------------------------------------
C *** FIND NODE INSIDE AN ELEMENT
C----------------------------------------------------------------------
      SUBROUTINE FIND_IELEM(IPOIN,IELEM)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        STRING=ELSET_TYP(IMSET)
        IF(STRING(1:1).NE.'C') GOTO 100
        IELEM = I
        DO IN=1,NODE
          IF(IPOIN.EQ.LNODS(I,IN)) RETURN
        END DO
  100   CONTINUE
      END DO
      RETURN
      END
