C
      SUBROUTINE MDR_FR_ED(KEY_DRAW)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*4 SPSIZE
      INCLUDE 'common'
CCCC  INCLUDE 'mcommon1'
      DIMENSION X_CORD(100),Y_CORD(100),NW(10)
C     COMMON /AMESH1/LNODS(15000,28),COORD(50000,3),INCOD(15000),
C    1 IELNS(9000),INTEREL(2000,20),MATSET(10,9000),NSLINE(2000,5)
C     COMMON /AMESH2/NELEM,NNODE,NSETS
      COMMON /MESHBORD/IX1_BORD,IY1_BORD,IX2_BORD,IY2_BORD
      CHARACTER KEYCHR*80
C
      WRITE(IO_JNL,'(5X,A)') 'Now excuting MDR_FR_ED'
C
      CALL DELEDGE (IWORK,IADDEDGE,IADMBOD,NGEDGE)
C
      XMIN= 1.0E30
      YMIN= 1.0E30
      XMAX=-1.0E30
      YMAX=-1.0E30
      PHAI=45.0
      PI=4.0*ATAN(1.0)
      CHPHAI=COS(PHAI/180.0*PI)
      SHPHAI=SIN(PHAI/180.0*PI)
      DO I=1,NNODE
        X=COORD(I,1)-CHPHAI*COORD(I,3)
        Y=COORD(I,2)-SHPHAI*COORD(I,3)
        IF(XMIN.GT.X) XMIN=X
        IF(YMIN.GT.Y) YMIN=Y
        IF(XMAX.LT.X) XMAX=X
        IF(YMAX.LT.Y) YMAX=Y
      END DO
C
      SC_EXTR=1.0
      ICENTER=0
      IINPUT=1
      IF(KEY_DRAW.EQ.1) GOTO 5
    1 READ(IINPUT,'(A)') KEYCHR
      IF(KEYCHR(1:1).EQ.'*') THEN
        BACKSPACE IINPUT
        GOTO 5
      ELSE IF(KEYCHR(1:5).EQ.'SCALE') THEN
        BACKSPACE IINPUT
        READ(IINPUT,'(6X,E12.5)') SC_EXTR
        GOTO 1
      ELSE IF(KEYCHR(1:6).EQ.'CENTER') THEN
        ICENTER=1
        READ(IINPUT,*) XCENT_P,YCENT_P
        GOTO 1
      ELSE
        GOTO 1
      END IF
    5 CONTINUE
      CALL X11OPN(IFLAG,IWPX,IHPX)
      IF(IFLAG.EQ.0) RETURN
      SPSIZE=12.
      IP1X=40
      IP1Y=0
      IP2X=IWPX-IP1X
      IP2Y=IHPX-IP1Y-200
      CALL X11WIN(IP1X,IP1Y,IP2X,IP2Y)
  100 CONTINUE
      CALL X11COL(2)
      IX1_BORD=IP1X+20
      IY1_BORD=IP1Y+40
      IX2_BORD=IP2X-50
      IY2_BORD=IP2Y-40
      XSCAL=(IX2_BORD-IX1_BORD)/(XMAX-XMIN)
      YSCAL=(IY2_BORD-IY1_BORD)/(YMAX-YMIN)
      SCAL=DMIN1(XSCAL,YSCAL)
      SCAL=SCAL*0.85*SC_EXTR
      XCENT_S=(IX2_BORD+IX1_BORD)/2.0
      YCENT_S=(IY2_BORD+IY1_BORD)/2.0
      IF(ICENTER.NE.1) THEN
        XCENT_P=(XMAX+XMIN)/2.0
        YCENT_P=(YMAX+YMIN)/2.0
      END IF
      CALL X11COL(4)
C
      IADDRES = IADDEDGE
      DO IGEDGE=1,NGEDGE
        IADDRES = IADDRES + 1
        NGASH = IWORK(IADDRES)
        JNM   = NGASH/10
        KDOUB = NGASH - JNM*10
        NW(1) = 1
        NW(2) = 2
        IF(JNM.EQ.3) THEN
          NW(2) = 3
          NW(3) = 2
        END IF
        IF(KDOUB.EQ.0) THEN
          DO J =1,JNM
            IT = NW(J)
            IADDRES = IADDRES + 1
            JPOIN   =IWORK(IADDRES)
            Z=COORD(JPOIN,3)
            X=(COORD(JPOIN,1)-XCENT_P-CHPHAI*Z)*SCAL
            Y=(COORD(JPOIN,2)-YCENT_P-SHPHAI*Z)*SCAL
            X_CORD(IT)= X+XCENT_S
            Y_CORD(IT)=-Y+YCENT_S
          END DO
          CALL DRW_LINE(X_CORD,Y_CORD,JNM)
        ELSE
          IADDRES = IADDRES + JNM
        END IF
      END DO
C
      CALL X11COL(1)
      SPSIZE=12.0
      NCHAR=26
      TEXT(1:NCHAR)=' *** Present EXTR_SCALE = '
      WRITE(TEXT(NCHAR:NCHAR+8),'(E8.3)') SC_EXTR
      NCHAR=NCHAR+8
      IX=IX1_BORD
      IY=IY2_BORD
      CALL X11CHI(SPSIZE)
      CALL X11CHR(IX,IY,NCHAR,TEXT)
      NCHAR=35
      TEXT(1:NCHAR)=' *** Press RETURN for continue *** '
      IX=IX1_BORD
      IY=IY2_BORD+SPSIZE+3
      CALL X11CHI(SPSIZE)
      CALL X11CHR(IX,IY,NCHAR,TEXT)
      CALL X11FLS
      READ (6,'(I1)') IDUM
      RETURN
      END
