C
C     GENERATING COHESIVE ELEMENT JOINING TWO MATERIALS
C
      SUBROUTINE COHESIV2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(1000,2,2),AWORK(1000,2,2),JAMAT(2),KWORK1(1000)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV1'
C
      TEXT='NOW EXCUTING SUB. COHESIV2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET=2
      DO K=1,2
        JAMAT(K)=0
      END DO
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        RETURN
      ELSE IF(STRING(1:1).EQ.'H') THEN
        KCASE = 1
        IDI1  = 1
        IDI2  = 2
        READ(IO_INPUT,*) IMSET,YB,XB,XE
      ELSE IF(STRING(1:1).EQ.'V') THEN
        KCASE = 1
        IDI1  = 2
        IDI2  = 1
        READ(IO_INPUT,*) IMSET,YB,XB,XE
      ELSE IF(STRING(1:1).EQ.'C') THEN
        KCASE = 2
        IDI1  = 1
        IDI2  = 2
        READ(IO_INPUT,*) IMSET,X0,Y0,R0,T1,T2
      END IF
C
      DO K=1,NNODE
        IWORK(K)=INCOD(K)
      END DO
      KWORK1(1) = 1
C
      IELEM=NELEM
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        ISET=LNODS(IE,MXNOD-1)
        STRING=ELTYP(IE)
        IF(STRING(1:1).NE.'C') GOTO 331
        IF(NODE.LE.4) THEN
          NN=NODE
          NCOHE=2
        ELSE 
          NN=NODE/2
          NCOHE=3
        END IF
        NCONT  = 0
        ICOHE1 = 0
        XM = 0.0
        YM = 0.0
        DO J=1,NN
          IN  = LNODS(IE,J)
          XM  = XM + COORD(IN,IDI1)
          YM  = YM + COORD(IN,IDI2)
        END DO
        YM  = YM/FLOAT(NN)
        XM  = XM/FLOAT(NN)
        RM  = DISTN(X0,Y0,0.0E0,XM,YM,0.0E0)
        AGM = ANGLE(X0,Y0,XM,YM)
        DO J=1,NN
          J1 = J
          J2 = J + 1
          J3 = J1 + NN
          IF(J2.GT.NN) J2 = 1
          IN1 = LNODS(IE,J1)
          IN2 = LNODS(IE,J2)
          X1  = COORD(IN1,IDI1)
          Y1  = COORD(IN1,IDI2)
          X2  = COORD(IN2,IDI1)
          Y2  = COORD(IN2,IDI2)
          RL=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
          IF(KCASE.EQ.1) THEN
            H1  = (XB-X1)*(XE-X1)
            IF(ABS(Y1-YB).LT.TOLER.AND.
     &         ABS(Y2-YB).LT.TOLER.AND.RL.GT.TOLER.AND.
     &        X1-XB.GT.-1.0E-12.AND.X1-XE.LT.1.0E-12.AND.
     &        X2-XB.GT.-1.0E-12.AND.X2-XE.LT.1.0E-12) THEN
              IF(YM.LT.YB) THEN
                JCMAT = 1
              ELSE
                JCMAT = 2
              END IF
              IF(X1.GT.X2) THEN
                M   = J1
                J1  = J2
                J2  = M
                M   = IN1
                IN1 = IN2
                IN2 = M
                A   = X1
                X1  = X2
                X2  = A
                A   = Y1
                Y1  = Y2
                Y2  = A
              END IF
              JAMAT(JCMAT) = JAMAT(JCMAT) + 1
              ICOHE1 = JAMAT(JCMAT)
              KWORK(ICOHE1,1,JCMAT) = IE*100+J1
              KWORK(ICOHE1,2,JCMAT) = IN1
              AWORK(ICOHE1,1,JCMAT) = X1
              AWORK(ICOHE1,2,JCMAT) = Y1
              JAMAT(JCMAT) = JAMAT(JCMAT) + 1
              ICOHE1 = JAMAT(JCMAT)
              KWORK(ICOHE1,1,JCMAT) = IE*100+J2
              KWORK(ICOHE1,2,JCMAT) = IN2
              AWORK(ICOHE1,1,JCMAT) = X2
              AWORK(ICOHE1,2,JCMAT) = Y2
              IF(NCOHE.EQ.3) THEN
                IN3 = LNODS(IE,J3)
                X3  = COORD(IN3,IDI1)
                Y3  = COORD(IN3,IDI2)
                JAMAT(JCMAT) = JAMAT(JCMAT) + 1
                ICOHE1 = JAMAT(JCMAT)
                KWORK(ICOHE1,1,JCMAT) = IE*100+J3
                KWORK(ICOHE1,2,JCMAT) = IN3
                AWORK(ICOHE1,1,JCMAT) = X3
                AWORK(ICOHE1,2,JCMAT) = Y3
              END IF
            ENDIF
            IF(ABS(Y1-YB).LT.TOLER.AND.H1.LE.1.0E-10.AND.
     &             JCMAT.EQ.2) THEN
              NCONT  = NCONT + 1
              IEINM  = IE*100+J1
            ENDIF
          ELSE IF(KCASE.EQ.2) THEN
            R1  = DISTN(X0,Y0,0.0E0,X1,Y1,0.0E0)
            AG1 = ANGLE(X0,Y0,X1,Y1)
            R2  = DISTN(X0,Y0,0.0E0,X2,Y2,0.0E0)
            AG2 = ANGLE(X0,Y0,X2,Y2)
            IF(ABS(AG1-180.0D0)/180.0D0.LT.1.0E-4)THEN
              IF(AGM.LT.0.0D0) AG1 = -180.0D0
            ELSE IF(ABS(AG2-180.0D0)/180.0D0.LT.1.0E-4)THEN
              IF(AGM.LT.0.0D0) AG2 = -180.0D0
            END IF
            H1  = (T1-AG1)*(T2-AG1)
            H2  = (T1-AG2)*(T2-AG2)
            IF(RM.LT.R0) THEN
              JCMAT = 1
            ELSE
              JCMAT = 2
            END IF
            IF(ABS(R1-R0).LT.TOLER.AND.ABS(R2-R0).LT.TOLER.AND.
     &         H1.LE.1.0E-10.AND.H2.LE.1.0E-10) THEN
C             IF(X1.GT.X2) THEN
              IF(AG1.LT.AG2) THEN
                M   = J1
                J1  = J2
                J2  = M
                M   = IN1
                IN1 = IN2
                IN2 = M
                A   = X1
                X1  = X2 
                X2  = A
                A   = Y1
                Y1  = Y2
                Y2  = A
              END IF
              JAMAT(JCMAT) = JAMAT(JCMAT) + 1
              ICOHE1 = JAMAT(JCMAT)
              KWORK(ICOHE1,1,JCMAT) = IE*100+J1
              KWORK(ICOHE1,2,JCMAT) = IN1
              AWORK(ICOHE1,1,JCMAT) = X1
              AWORK(ICOHE1,2,JCMAT) = Y1
              JAMAT(JCMAT) = JAMAT(JCMAT) + 1
              ICOHE1 = JAMAT(JCMAT)
              KWORK(ICOHE1,1,JCMAT) = IE*100+J2
              KWORK(ICOHE1,2,JCMAT) = IN2
              AWORK(ICOHE1,1,JCMAT) = X2
              AWORK(ICOHE1,2,JCMAT) = Y2
              IF(NCOHE.EQ.3) THEN
                IN3 = LNODS(IE,J3)
                X3  = COORD(IN3,IDI1)
                Y3  = COORD(IN3,IDI2)
                JAMAT(JCMAT) = JAMAT(JCMAT) + 1
                ICOHE1 = JAMAT(JCMAT)
                KWORK(ICOHE1,1,JCMAT) = IE*100+J3
                KWORK(ICOHE1,2,JCMAT) = IN3
                AWORK(ICOHE1,1,JCMAT) = X3
                AWORK(ICOHE1,2,JCMAT) = Y3
              END IF
            END IF
            IF(ABS(R1-R0).LT.TOLER.AND.H1.LE.1.0E-10.AND.
     &             JCMAT.EQ.2) THEN
              NCONT  = NCONT + 1
              IEINM  = IE*100+J1
            END IF
          ENDIF
        END DO
        IF(NCONT.EQ.1) THEN
          KWORK1(1) = KWORK1(1) + 1
          KWORK1(KWORK1(1)) = IEINM
        ENDIF
  331   CONTINUE
      END DO
      IF(KCASE.LE.2) THEN
        IF(JAMAT(1).NE.JAMAT(2)) THEN
          WRITE(IO_INFO,1001) ' *** ERROR ***:','Subroutine COHESIVE2',
     &   'Different element number is found on two side of interface.',
     &   'Down side is ',JAMAT(1),'Upper side is',JAMAT(2)
 1001 FORMAT(A,2X,A/10X,A/10X,A,1X,I5,1X,A,1X,I5)
        ELSE
          MCOHE = JAMAT(1)/NCOHE
          DO JCMAT=1,2
            DO I1=1,MCOHE-1
              ICOHE1 = (I1-1)*NCOHE+1
              IN1 = KWORK(ICOHE1,2,JCMAT)
              X1  = (AWORK(ICOHE1,1,JCMAT)+AWORK(ICOHE1+1,1,JCMAT))
              Y1  = (AWORK(ICOHE1,2,JCMAT)+AWORK(ICOHE1+1,2,JCMAT))
              X1  = 0.5*X1
              Y1  = 0.5*Y1
              AG1 = ANGLE(X0,Y0,X1,Y1)
              IM  = 0
              XM  = X1
              IF(KCASE.EQ.2) XM = -AG1
              DO I2=I1+1,MCOHE
                ICOHE2 = (I2-1)*NCOHE+1
                IN2 = KWORK(ICOHE2,2,JCMAT)
                X2  = (AWORK(ICOHE2,1,JCMAT)+AWORK(ICOHE2+1,1,JCMAT))
                Y2  = (AWORK(ICOHE2,2,JCMAT)+AWORK(ICOHE2+1,2,JCMAT))
                X2  = 0.5*X2
                Y2  = 0.5*Y2
                AG2 = ANGLE(X0,Y0,X2,Y2)
                XI  = X2
                IF(KCASE.EQ.2) XI = -AG2
                IF(XI.LT.XM) THEN
                  IM = I2
                  XM = XI
                END IF
              END DO
              IF(IM.GT.0) THEN
                ICOHE1 = (I1-1)*NCOHE
                ICOHEM = (IM-1)*NCOHE
                DO J=1,NCOHE
                  ICOHE1 = ICOHE1 + 1
                  ICOHEM = ICOHEM + 1
                  DO K=1,2
                    M = KWORK(ICOHE1,K,JCMAT)
                    KWORK(ICOHE1,K,JCMAT) = KWORK(ICOHEM,K,JCMAT)
                    KWORK(ICOHEM,K,JCMAT) = M
                    A = AWORK(ICOHE1,K,JCMAT)
                    AWORK(ICOHE1,K,JCMAT) = AWORK(ICOHEM,K,JCMAT)
                    AWORK(ICOHEM,K,JCMAT) = A
                  END DO
                END DO
              END IF
            END DO
            GOTO 11
            DO I1=1,MCOHE
              ICOHE1 = 2*I1-1
              IN1 = KWORK(ICOHE1,2,JCMAT)
              X1  = AWORK(ICOHE1,1,JCMAT)
              ICOHE1 = 2*I1
              IN1 = KWORK(ICOHE1,2,JCMAT)
              X2  = AWORK(ICOHE1,1,JCMAT)
              IF(X1.GT.X2) THEN
                ICOHE1 = 2*I1-1
                ICOHEM = 2*I1
                DO K=1,2
                  M = KWORK(ICOHE1,K,JCMAT)
                  KWORK(ICOHE1,K,JCMAT) = KWORK(ICOHEM,K,JCMAT)
                  KWORK(ICOHEM,K,JCMAT) = M
                  A = AWORK(ICOHE1,K,JCMAT)
                  AWORK(ICOHE1,K,JCMAT) = AWORK(ICOHEM,K,JCMAT)
                  AWORK(ICOHEM,K,JCMAT) = A
                END DO
              END IF
            END DO
   11       CONTINUE
          END DO
        END IF
        IELEM = NELEM
        IPOIN = NNODE
        DO I1=1,MCOHE
          IELEM = IELEM + 1
          IPOIN1 = IPOIN  + 1
          IPOIN2 = IPOIN1 + 1 + (NCOHE-2)
          ICOHE1 = (I1-1)*NCOHE+1
          ICOHE2 = (I1-1)*NCOHE+2
          NGASH = KWORK(ICOHE1,1,2)
          IE1   = NGASH/100
          IN1   = NGASH-IE1*100
          NGASH = KWORK(ICOHE2,1,2)
          IE2   = NGASH/100
          IN2   = NGASH-IE2*100
          IF(NCOHE.EQ.2) THEN
            LNODS(IELEM,1)=KWORK(ICOHE1,2,1)
            LNODS(IELEM,2)=KWORK(ICOHE2,2,1)
            LNODS(IELEM,3)=IPOIN1
            LNODS(IELEM,4)=IPOIN2
            COORD(IPOIN1,IDI1) = AWORK(ICOHE1,1,2)
            COORD(IPOIN1,IDI2) = AWORK(ICOHE1,2,2)
            COORD(IPOIN2,IDI1) = AWORK(ICOHE2,1,2)
            COORD(IPOIN2,IDI2) = AWORK(ICOHE2,2,2)
            IWORK(LNODS(IE2,IN1)) = IPOIN1
            IWORK(LNODS(IE2,IN2)) = IPOIN2
            LNODS(IE2,IN1) = IPOIN1
            LNODS(IE2,IN2) = IPOIN2
            ELTYP(IELEM)='ICOHE2'
          ELSE IF(NCOHE.EQ.3) THEN
            ICOHE3 = (I1-1)*NCOHE+3
            IPOIN3 = IPOIN1 + 1
            NGASH = KWORK(ICOHE3,1,2)
            IN3   = NGASH-IE2*100
            LNODS(IELEM,1)=KWORK(ICOHE1,2,1)
            LNODS(IELEM,2)=KWORK(ICOHE3,2,1)
            LNODS(IELEM,3)=KWORK(ICOHE2,2,1)
            LNODS(IELEM,4)=IPOIN1
            LNODS(IELEM,5)=IPOIN3
            LNODS(IELEM,6)=IPOIN2
            COORD(IPOIN1,IDI1) = AWORK(ICOHE1,1,2)
            COORD(IPOIN1,IDI2) = AWORK(ICOHE1,2,2)
            COORD(IPOIN2,IDI1) = AWORK(ICOHE2,1,2)
            COORD(IPOIN2,IDI2) = AWORK(ICOHE2,2,2)
            COORD(IPOIN3,IDI1) = AWORK(ICOHE3,1,2)
            COORD(IPOIN3,IDI2) = AWORK(ICOHE3,2,2)
            IWORK(LNODS(IE2,IN1)) = IPOIN1
            IWORK(LNODS(IE2,IN2)) = IPOIN2
            IWORK(LNODS(IE2,IN3)) = IPOIN3
            LNODS(IE2,IN1) = IPOIN1
            LNODS(IE2,IN2) = IPOIN2
            LNODS(IE2,IN3) = IPOIN3
            ELTYP(IELEM)='ICOHE3'
          END IF
          IPOIN = IPOIN2 - 1
          NODEN = NCOHE*2
          LNODS(IELEM,MXNOD)=NODEN
          LNODS(IELEM,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IELEM
          CALL DNODE(IELEM,NODEN)
        END DO
        NELEM = IELEM
        NNODE = IPOIN + 1
        IF(KWORK1(1).GT.1) THEN
          DO K=2,KWORK1(1)
            NGASH = KWORK1(K)
            IE1   = NGASH/100
            IN1   = NGASH-IE1*100
            KPOIN          = LNODS(IE1,IN1)
            LNODS(IE1,IN1) = IWORK(KPOIN)
          END DO
        END IF
      END IF
      RETURN
      END
