C
C     GENERATING 2D COHESIVE ELEMENT FOR 3D SOLID ELEMENT
C
      SUBROUTINE COHESIV3
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(20,2),LNODE(8)
C
C
      TEXT='NOW EXCUTING SUB. COHESIV3'
      TEXT1=' '
      WRITE(IO_JNL,'(5X,A)') TEXT
      WRITE(IO_WRITE,'(5X,A)') TEXT
C
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
C
      IMSET2 = 1
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) IMSET2 = IMSET2 + 1
      END DO
C
C---  INPUT
C 
C     ICONOD = 8
C     CALL LOCCHR(STRING,'NOD     ',3,1,K1,K2)
C     IF(K2.GE.K1) THEN
C       READ(STRING(K1:K2),*) ICONOD
C       IF (ICONOD.EQ.6) ICONOD = 1
C       IF (ICONOD.GE.4) ICONOD = 8
C       IF (ICONOD.LT.4) ICONOD = 6
C     END IF
C
      READ(IO_INPUT,'(A)') STRING
      BACKSPACE IO_INPUT
      IF(STRING(1:1).EQ.'*') THEN
         XL=XTIP-TOLER
         XE=XL+1.0E10
      ELSE
         CALL GETLINE (LEN,IERR)
         ITYPE(1) = 1
         DO I = 2,5
            ITYPE(I) = 2
         END DO
         INVAR = 5
         CALL SLVLINE (STRING,LEN,IERR)
         IMSET = IVARR(1)
	 XL = RVARR(2)
	 XE = RVARR(3)
	 ZL = RVARR(4)
	 ZE = RVARR(5)
      END IF
      IELEM  = NELEM
      INEWND = NNODE
C
C---  ELEMENT LOOP
C
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        STRING=ELTYP(IE)
        IF(STRING(1:2).NE.'C3') GOTO 331
        IF(STRING(4:4).EQ.'8') THEN
          NN=NODE
          NCOHE=4
        ELSE IF(STRING(4:4).EQ.'4') THEN
          NN=NODE
          NCOHE=3
        ELSE IF(STRING(4:5).EQ.'20') THEN
          NN=NODE
          NCOHE=8
        ELSE IF(STRING(4:5).EQ.'10') THEN
          NN=NODE
          NCOHE=6
        END IF
        ICOHE=0
C------ ELEMENT NODE LOOP
        DO J=1,NN
          IN=LNODS(IE,J)
          IF(IN.NE.0) THEN
            X=COORD(IN,1)
            Y=COORD(IN,2)
            Z=COORD(IN,3)
            IF(ABS(Y-YORIGN).LT.TOLER.AND.
     &         X-XL.GT.-1.0E-12.AND.X-XE.LT.1.0E-12.AND.
     &         Z-ZL.GT.-1.0E-12.AND.Z-ZE.LT.1.0E-12) THEN
              ICOHE=ICOHE+1
              KWORK(ICOHE,1)=IN
              KWORK(ICOHE,2)=J
            IF(ABS(X-XL).LT.TOLER.OR.ABS(X-XE).LT.TOLER.OR.
     &         ABS(Z-ZL).LT.TOLER.OR.ABS(Z-ZE).LT.TOLER) IWORK(IN)=-1
            ENDIF
          ENDIF
        END DO
  100   CONTINUE 
C
C------ FOUND INTERFACE ELEMENT EDGE/FACE
        IF(ICOHE.EQ.NCOHE) THEN 
C-------- ABAQUS CZ ELEMENTS FOR C3 ELEMENTS
          CALL IARRANGE(KWORK(1,2),ICOHE,ICOHE)
	  IF (ICOHE.EQ.3 .OR. ICOHE.EQ.6) THEN
             WRITE(STRING(1:3),'(3I1)') (KWORK(I,2),I=1,3)
             DO K=1,4
                IF(STRING(1:3).EQ.CFACE_DF(K,3)) GOTO 105
             END DO
	  ELSE
             WRITE(STRING(1:4),'(4I1)') (KWORK(I,2),I=1,4)
             DO K=1,6
                IF(STRING(1:4).EQ.CFACE_DF(K,1)) GOTO 105
             END DO
	  ENDIF
	  write (*,*) 'Couldn''t find element edge ',STRING(1:3)
  105     CONTINUE
          IELEM = IELEM + 1
          LNODS(IELEM,MXNOD)=2*ICOHE
          LNODS(IELEM,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IELEM
          ELTYP(IELEM)='ICOHE3'
	  DO I = 1,ICOHE
	     LNODE(I) = LNODS(IE,NFACE_DF(I,K,1))
	     IF (INCOD(LNODE(I)+NNODE).LT.NNODE) THEN
	        INEWND = INEWND + 1
		INCOD(LNODE(I)+NNODE) = INEWND
		COORD(INEWND,1) = COORD(LNODE(I),1)
		COORD(INEWND,2) = COORD(LNODE(I),2)
	        COORD(INEWND,3) = COORD(LNODE(I),3)
Ctest           write (*,*) 'generating node',inewnd,' from',lnode(i)
C-------------  DEFINING NODESET BOTTOM AND BOTTOM2 for equations
                INSET(INEWND-NNODE,NDSET+1) = INEWND
                INSET(INEWND-NNODE,NDSET+2) = LNODE(I)
	     ELSE
Ctest           WRITE (*,*) LNODE(I),'already defined with',
Ctest1                      incod(lnode(i)+nnode)
	     ENDIF
             LNODS(IELEM,I)=INCOD(LNODE(I)+NNODE)
             LNODS(IELEM,I+ICOHE)=LNODE(I)
	  END DO
Ctest     write (*,*) 'found element face',(lnode(ii),ii=1,icohe)
Ctest     write (*,*) 'generating element',ielem,' with',
Ctest1             (lnods(ielem+i,j),j=1,2*icohe)
        ELSE
          DO I=1,ICOHE
            IN=KWORK(1,I)
            IWORK(IN)=0
          END DO
        END IF
  331   CONTINUE
C---  END OF ELEMENT LOOP
      END DO
C
      IF(IELEM.GT.NELEM) NELEM=IELEM
C
C---  DEFINING NEW NODE SET FOR ABAQUS CZE's
      IF (INEWND.GT.NNODE) THEN
        DO K = NNODE+1,INEWND
	  INCOD(K)       = K
        END DO
        NDSET = NDSET + 1
        NNSET(NDSET)  = INEWND-NNODE
        CNDSET(NDSET) = 'BOTTOM  '
        NDSET = NDSET + 1
        NNSET(NDSET)  = INEWND-NNODE
        CNDSET(NDSET) = 'BOTTOM2 '
	NNODE = INEWND
      ENDIF
C
      IF(NDLIG(1).LT.2) RETURN
      NT=1
      DO K=2,NDLIG(1)
        IN=NDLIG(K)
        IF(IWORK(IN).NE.-1) THEN
          NT=NT+1
          NDLIG(NT)=IN
        END IF
      END DO
      NDLIG(1)=NT
      RETURN
      END
