C
C     GENERATING 2D COHESIVE ELEMENT FOR 3D SOLID ELEMENT
C
      SUBROUTINE CZM3DEL
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(20,2),IW(10),IEL(20)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV3'
C
      TEXT='NOW EXCUTING SUB. CZM3DEL'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      MAT_NEW = 0
      IMSET1 = 1
      IMSET  = 2
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET
      END IF
      IMSET2 = IMSET+1
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        XL=XTIP-TOLER
        XE=XL+1.0E10
      ELSE
        READ(STRING,*) XL,XE,ZL,ZE
      END IF
C
      IELEM=NELEM
      IF(IMSET1.EQ.0) THEN
        NUMEL1 = 1
        NUMEL2 = NELEM
        IE     = 1
      ELSE
        NUMEL1 = 2
        NUMEL2 = MATSET(IMSET1,1)
        IE     = MATSET(IMSET1,2)
      END IF
      DO II = NUMEL1,NUMEL2
        IF(IMSET1.EQ.0) THEN
          IE   = II
        ELSE
          IE   = MATSET(IMSET1,II)
        END IF
        NODE=LNODS(IE,MXNOD)
        DO K=1,10
          IEL(K) = 0
        END DO
        NDEL = 0
        IF(NODE.LE.8) THEN
          NN = NODE
          ND_BS = 4
          KDEN = 1
          KDOB = 1
          NFAC = 6
        ELSE IF(NODE.EQ.20) THEN
          NN = 8
          ND_BS = 8
          KDEN = 1
          KDOB = 2
          NFAC = 6
        ELSE IF(NODE.GT.20) THEN
          NN = 8
          ND_BS = 9
          KDEN = 1
          KDOB = 2
          NFAC = 6
        END IF
        DO IN=1,NN
          LN = LNODS(IE,IN)
          X  = COORD(LN,1)
          Y  = COORD(LN,2)
          Z  = COORD(LN,3)
          IF(ABS(Y-YORIGN).LT.TOLER.AND.
     &       X-XL.GT.-1.0E-12.AND.X-XE.LT.1.0E-12.AND.
     &       Z-ZL.GT.-1.0E-12.AND.Z-ZE.LT.1.0E-12) THEN
            NDEL = NDEL + 1
            IEL(NDEL) = IN
            IF(ABS(X-XL).LT.TOLER.OR.ABS(X-XL).LT.TOLER.OR.
     &       ABS(Z-ZL).LT.TOLER.OR.ABS(Z-ZL).LT.TOLER) NDIDN(IN,1)=-1
          END IF
        END DO
        IF(NDEL.GT.2) THEN
          STRING = '         '
          WRITE(STRING,'(4I1)') (IEL(K),K=1,NDEL)
          KF = 0
          DO K=1,NFAC
            KF = K
            IF(STRING(1:4).EQ.CFACE_DF(K,KDEN)) GOTO 50
          END DO
          GOTO 98
   50     CONTINUE
          IELEM = IELEM + 1
          LNODS(IELEM,MXNOD)=ND_BS
          IF(ND_BS.EQ.4) THEN
            LNODS(IELEM,MXNOD)=ND_BS
            IN = NFACE_DF(1,KF,KDEN)
            LNODS(IELEM,1) = LNODS(IE,IN)
            IN = NFACE_DF(4,KF,KDEN)
            LNODS(IELEM,2) = LNODS(IE,IN)
            IN = NFACE_DF(3,KF,KDEN)
            LNODS(IELEM,3) = LNODS(IE,IN)
            IN = NFACE_DF(2,KF,KDEN)
            LNODS(IELEM,4) = LNODS(IE,IN)
          ELSE IF(ND_BS.EQ.8) THEN
            LNODS(IELEM,MXNOD)= 9
            IN = NFACE_DF(1,KF,KDEN)
            LNODS(IELEM,1) = LNODS(IE,IN)
            IN = NFACE_DF(4,KF,KDEN)
            LNODS(IELEM,2) = LNODS(IE,IN)
            IN = NFACE_DF(3,KF,KDEN)
            LNODS(IELEM,3) = LNODS(IE,IN)
            IN = NFACE_DF(2,KF,KDEN)
            LNODS(IELEM,4) = LNODS(IE,IN)
            IN = NFACE_DF(8,KF,KDEN)
            LNODS(IELEM,5) = LNODS(IE,IN)
            IN = NFACE_DF(7,KF,KDEN)
            LNODS(IELEM,6) = LNODS(IE,IN)
            IN = NFACE_DF(6,KF,KDEN)
            LNODS(IELEM,7) = LNODS(IE,IN)
            IN = NFACE_DF(5,KF,KDEN)
            LNODS(IELEM,8) = LNODS(IE,IN)
            NNODE = NNODE + 1
            LNODS(IELEM,9) = NNODE
            LNODS(IE,22) = NNODE
            NNODE = NNODE + 1
            LNODS(IE,21) = NNODE
            MATSET(IMSET1,II) = 0
            LNODS(IE,MXNOD)= 27
            LNODS(IE,MXNOD-1)=IMSET2
            MATSET(IMSET2,1)=MATSET(IMSET2,1)+1
            MATSET(IMSET2,MATSET(IMSET2,1))=IE
            ELTYP(IE)='C3D27R'
            INCOD(LNODS(IE,22)) = LNODS(IE,22)
            INCOD(LNODS(IE,21)) = LNODS(IE,21)
            X = 0.0E0
            Y = 0.0E0
            Z = 0.0E0
            DO K=1,8
              LN = LNODS(IE,K)
              X = X + COORD(LN,1)
              Y = Y + COORD(LN,2)
              Z = Z + COORD(LN,3)
            END DO
            COORD(LNODS(IE,21),1) = X/8.0E0
            COORD(LNODS(IE,21),2) = Y/8.0E0
            COORD(LNODS(IE,21),3) = Z/8.0E0
            X = 0.0E0
            Y = 0.0E0
            Z = 0.0E0
            DO K=1,4
              IN = NFACE_DF(K,KF,KDEN)
              LN = LNODS(IE,IN)
              X = X + COORD(LN,1)
              Y = Y + COORD(LN,2)
              Z = Z + COORD(LN,3)
            END DO
            COORD(LNODS(IE,22),1) = X/4.0E0
            COORD(LNODS(IE,22),2) = Y/4.0E0
            COORD(LNODS(IE,22),3) = Z/4.0E0
            MAT_NEW = 1
            DO K=1,20
              IWORK(K) = LNODS(IE,K)
            END DO
            IF(KF.EQ.2) THEN
              LNODS(IE, 1) = IWORK( 5)
              LNODS(IE, 2) = IWORK( 8)
              LNODS(IE, 3) = IWORK( 7)
              LNODS(IE, 4) = IWORK( 6)
              LNODS(IE, 5) = IWORK( 1)
              LNODS(IE, 6) = IWORK( 4)
              LNODS(IE, 7) = IWORK( 3)
              LNODS(IE, 8) = IWORK( 2)
              LNODS(IE, 9) = IWORK(16)
              LNODS(IE,10) = IWORK(15)
              LNODS(IE,11) = IWORK(14)
              LNODS(IE,12) = IWORK(13)
              LNODS(IE,13) = IWORK(12)
              LNODS(IE,14) = IWORK(11)
              LNODS(IE,15) = IWORK(10)
              LNODS(IE,16) = IWORK( 9)
              LNODS(IE,17) = IWORK(17)
              LNODS(IE,18) = IWORK(20)
              LNODS(IE,19) = IWORK(19)
              LNODS(IE,20) = IWORK(18)
            ELSE IF(KF.EQ.3) THEN
              LNODS(IE, 1) = IWORK( 5)
              LNODS(IE, 2) = IWORK( 6)
              LNODS(IE, 3) = IWORK( 2)
              LNODS(IE, 4) = IWORK( 1)
              LNODS(IE, 5) = IWORK( 8)
              LNODS(IE, 6) = IWORK( 7)
              LNODS(IE, 7) = IWORK( 3)
              LNODS(IE, 8) = IWORK( 4)
              LNODS(IE, 9) = IWORK(13)
              LNODS(IE,10) = IWORK(18)
              LNODS(IE,11) = IWORK( 9)
              LNODS(IE,12) = IWORK(17)
              LNODS(IE,13) = IWORK(15)
              LNODS(IE,14) = IWORK(19)
              LNODS(IE,15) = IWORK(11)
              LNODS(IE,16) = IWORK(20)
              LNODS(IE,17) = IWORK(16)
              LNODS(IE,18) = IWORK(14)
              LNODS(IE,19) = IWORK(10)
              LNODS(IE,20) = IWORK(12)
            ELSE IF(KF.EQ.4) THEN
              LNODS(IE, 1) = IWORK( 6)
              LNODS(IE, 2) = IWORK( 7)
              LNODS(IE, 3) = IWORK( 3)
              LNODS(IE, 4) = IWORK( 2)
              LNODS(IE, 5) = IWORK( 5)
              LNODS(IE, 6) = IWORK( 8)
              LNODS(IE, 7) = IWORK( 4)
              LNODS(IE, 8) = IWORK( 1)
              LNODS(IE, 9) = IWORK(14)
              LNODS(IE,10) = IWORK(19)
              LNODS(IE,11) = IWORK(10)
              LNODS(IE,12) = IWORK(18)
              LNODS(IE,13) = IWORK(16)
              LNODS(IE,14) = IWORK(20)
              LNODS(IE,15) = IWORK(12)
              LNODS(IE,16) = IWORK(17)
              LNODS(IE,17) = IWORK(13)
              LNODS(IE,18) = IWORK(15)
              LNODS(IE,19) = IWORK(11)
              LNODS(IE,20) = IWORK( 9)
            ELSE IF(KF.EQ.5) THEN
              LNODS(IE, 1) = IWORK( 7)
              LNODS(IE, 2) = IWORK( 8)
              LNODS(IE, 3) = IWORK( 4)
              LNODS(IE, 4) = IWORK( 3)
              LNODS(IE, 5) = IWORK( 6)
              LNODS(IE, 6) = IWORK( 5)
              LNODS(IE, 7) = IWORK( 1)
              LNODS(IE, 8) = IWORK( 2)
              LNODS(IE, 9) = IWORK(15)
              LNODS(IE,10) = IWORK(20)
              LNODS(IE,11) = IWORK(11)
              LNODS(IE,12) = IWORK(19)
              LNODS(IE,13) = IWORK(13)
              LNODS(IE,14) = IWORK(17)
              LNODS(IE,15) = IWORK( 9)
              LNODS(IE,16) = IWORK(18)
              LNODS(IE,17) = IWORK(14)
              LNODS(IE,18) = IWORK(16)
              LNODS(IE,19) = IWORK(12)
              LNODS(IE,20) = IWORK(10)
            ELSE IF(KF.EQ.6) THEN
              LNODS(IE, 1) = IWORK( 5)
              LNODS(IE, 2) = IWORK( 1)
              LNODS(IE, 3) = IWORK( 4)
              LNODS(IE, 4) = IWORK( 8)
              LNODS(IE, 5) = IWORK( 6)
              LNODS(IE, 6) = IWORK( 2)
              LNODS(IE, 7) = IWORK( 3)
              LNODS(IE, 8) = IWORK( 7)
              LNODS(IE, 9) = IWORK(17)
              LNODS(IE,10) = IWORK(12)
              LNODS(IE,11) = IWORK(20)
              LNODS(IE,12) = IWORK(16)
              LNODS(IE,13) = IWORK(18)
              LNODS(IE,14) = IWORK(10)
              LNODS(IE,15) = IWORK(19)
              LNODS(IE,16) = IWORK(14)
              LNODS(IE,17) = IWORK(13)
              LNODS(IE,18) = IWORK( 9)
              LNODS(IE,19) = IWORK(11)
              LNODS(IE,20) = IWORK(15)
            END IF
          ELSE IF(ND_BS.EQ.9) THEN
            LNODS(IELEM,MXNOD)=ND_BS
            IN = NFACE_DF(1,KF,KDEN)
            LNODS(IELEM,1) = LNODS(IE,IN)
            IN = NFACE_DF(4,KF,KDEN)
            LNODS(IELEM,2) = LNODS(IE,IN)
            IN = NFACE_DF(3,KF,KDEN)
            LNODS(IELEM,3) = LNODS(IE,IN)
            IN = NFACE_DF(2,KF,KDEN)
            LNODS(IELEM,4) = LNODS(IE,IN)
            IN = NFACE_DF(8,KF,KDEN)
            LNODS(IELEM,5) = LNODS(IE,IN)
            IN = NFACE_DF(7,KF,KDEN)
            LNODS(IELEM,6) = LNODS(IE,IN)
            IN = NFACE_DF(6,KF,KDEN)
            LNODS(IELEM,7) = LNODS(IE,IN)
            IN = NFACE_DF(5,KF,KDEN)
            LNODS(IELEM,8) = LNODS(IE,IN)
            IN = NFACE_DF(9,KF,KDEN)
            LNODS(IELEM,9) = LNODS(IE,IN)
          END IF
          LNODS(IELEM,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IELEM
          ELTYP(IELEM)='ICOHE1'
          CALL DNODE(IELEM,NDEL)
          GOTO 99
   98     CONTINUE
          DO I=1,NDEL
            IN=IEL(I)
            NDIDN(IN,1)=0
          END DO
   99     CONTINUE
        ELSE
          DO I=1,NDEL
            IN=IEL(I)
            NDIDN(IN,1)=0
          END DO
        END IF
      END DO
      IF(IELEM.GT.NELEM) NELEM=IELEM
      IF(MAT_NEW.EQ.1) CALL MATSET_ORDER
      IF(NDLIG(1).LT.2) RETURN
      NT=1
      DO K=2,NDLIG(1)
        IN=NDLIG(K)
        IF(NDIDN(IN,1).NE.-1) THEN
          NT=NT+1
          NDLIG(NT)=IN
        END IF
      END DO
      NDLIG(1)=NT
      RETURN
      END
