C
C     GENERATING COHESIVE ELEMENT IN A ELSET OR GIVEN AREA
C
      SUBROUTINE CZM2DEL1
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KWORK(50,2,2),IW1(100),IW2(100)
      DIMENSION XP(6)
      CHARACTER CHAR1*8,CHAR2*8
      INCLUDE 'common'
CCCC  INCLUDE 'mcommon1'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CZM2DEL1'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. CZM2DEL1'
C
      TEXT='NOW EXCUTING SUB. CZM2DEL1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
      IF(IMSET2.EQ.0) THEN
        WRITE(IO_WRITE,1000) 'CZM2DEL1','No (NEW ELSET) parameter.',
     &  ' Please check file *.inf'
        WRITE(IO_INFO ,1000) 'CZM2DEL1','No (NEW ELSET) parameter.'
        WRITE(IO_INFO ,1001) 'CZM2DEL1'
        STOP
      END IF
      KEY = 1
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*CZM2DEL1,OLD ELSET=?,NEW ELSET=?')
C *** CHECKING MESH BOARD   
C----------------------------------------------------------------------
C     CALL DELEDGE
C
      IADA  = 0
      IADI  = 0
      DO K=1,NNODE
        IWORK(IADA+K) = 0
      END DO
      IADI  = IADI+NNODE
      IADB  = IADI
      MXEL  = 20
      DO K=1,NNODE*MXEL
        IWORK(IADB+K) = 0
      END DO
      IADI  = IADI+NNODE*MXEL
      IADC  = IADI
      IF(IMSET1.EQ.0) THEN
        NUMEL1 = 1
        NUMEL2 = NELEM
        IE     = 1
      ELSE
        NUMEL1 = 2
        NUMEL2 = MATSET(IMSET1,1)
        IE     = MATSET(IMSET1,2)
      END IF
      NND   = LNODS(IE,MXNOD)
      KND   = 1
      IF(NND.GT.4) KND = 2
      ND2 = NND/KND
      NN  = NND/KND
      DO K1 = NUMEL1,NUMEL2
        IF(IMSET1.EQ.0) THEN
          IE   = K1
        ELSE
          IE   = MATSET(IMSET1,K1)
        END IF
        IF(IE.GT.0) THEN
          DO IN = 1, ND2
            LN = LNODS(IE,IN)
            NCONT = IWORK(IADA+LN)
            NCONT = NCONT + 1
            IWORK(IADA+LN) = NCONT
            IWORK(IADB+(LN-1)*MXEL+NCONT) = IE*100+IN
          END DO
        END IF
      END DO
      NDIS = 0
      DO IP=1,NNODE
        IF(IWORK(IADA+IP).GT.1) THEN
          NDIS = NDIS + 1
          IWORK(IADC+NDIS) = IP
        END IF
      END DO
      IADI  = IADI+NDIS
      IADD  = IADI
      IADI  = IADI+NDIS
      IADE  = IADI
      IA    = IADE
      DO IDIS=1,NDIS
        LN = IWORK(IADC+IDIS)
        NDEL = IWORK(IADA+LN)
        IADS = IADB+(LN-1)*MXEL
        NPA  = 0
        DO IDEL=1,NDEL-1
          NG = IWORK(IADS+IDEL)
          IE = NG/100
          IN1= NG-IE*100
          IW1(1) = 0
          IW1(2) = 0
          IW2(1) = 0
          IW2(2) = 0
          DO IN=1,ND2
            IP = LNODS(IE,IN)
            DO JDEL=IDEL+1,NDEL
              NG = IWORK(IADS+JDEL)
              JE = NG/100
              JN1= NG-JE*100
              DO JN=1,ND2
                JP = LNODS(JE,JN)
                IF(IP.EQ.JP.AND.IP.GT.LN) THEN
                  IW1(1) = IE*100+IN1
                  IW1(2) = JE*100+JN1
                  IW2(1) = IE*100+IN
                  IW2(2) = JE*100+JN
                  IW2(3) = JP
                  GOTO 100
                END IF
              END DO
            END DO
            GOTO 200
  100       CONTINUE
            NPA = NPA + 1
            IA = IA + 1
            IWORK(IA) = IW2(3)
            IA = IA + 1
            IWORK(IA) = IW1(1)
            IA = IA + 1
            IWORK(IA) = IW1(2)
            IA = IA + 1
            IWORK(IA) = IW2(1)
            IA = IA + 1
            IWORK(IA) = IW2(2)
  200       CONTINUE
          END DO
        END DO
        IWORK(IADD+IDIS) = NPA
      END DO
      IADI  = IA
C----------------------------------------------------------------------
      IADF  = IADI
      DO K=1,NNODE
        IWORK(IADF+K) = 0
      END DO
      IADI  = IADI+NNODE
      IADG  = IADI
      MXEL  = 20
      DO K=1,NNODE*MXEL
        IWORK(IADG+K) = 0
      END DO
      DO IE = 1,NELEM
        IM = LNODS(IE,MXNOD-1)
        NI = LNODS(IE,MXNOD)
        IF(IM.EQ.IMSET1) NI = ND2
        DO IN = 1, NI
          LN = LNODS(IE,IN)
          NCONT = IWORK(IADF+LN)
          NCONT = NCONT + 1
          IWORK(IADF+LN) = NCONT
          IWORK(IADG+(LN-1)*MXEL+NCONT) = IE*100+IN
        END DO
      END DO
      IADI  = IADI+NNODE*MXEL
      IADH  = IADI
      NCOR = 0
      DO IP=1,NNODE
        IF(IWORK(IADF+IP).GT.1) THEN
          NN = IWORK(IADF+IP)
          DO K=1,NN
            NG=IWORK(IADG+(IP-1)*MXEL+K)
            IE=NG/100
            IM=LNODS(IE,MXNOD-1)
            IF(IM.EQ.IMSET1) THEN
              NCOR = NCOR + 1
              IWORK(IADH+NCOR) = IP
              GOTO 250
            END IF
          END DO
        END IF
  250   CONTINUE
      END DO
      IADI  = IADI+NCOR
      IADL  = IADI
      IADI  = IADI+NCOR
      IADM  = IADI
      IA    = IADM
      DO ICOR=1,NCOR
        LN = IWORK(IADH+ICOR)
        NDEL = IWORK(IADF+LN)
        IADS = IADG+(LN-1)*MXEL
        NPA  = 0
        DO IDEL=1,NDEL-1
          NG = IWORK(IADS+IDEL)
          IE = NG/100
          IN1= NG-IE*100
          IM = LNODS(IE,MXNOD-1)
          NI = LNODS(IE,MXNOD)
          IT = 2
          IF(IM.EQ.IMSET1) THEN
            IT = 1
            NI = ND2
          END IF
          IW1(1) = 0
          IW1(2) = 0
          IW2(1) = 0
          IW2(2) = 0
          DO IN=1,NI
            IP = LNODS(IE,IN)
            DO JDEL=IDEL+1,NDEL
              NG = IWORK(IADS+JDEL)
              JE = NG/100
              JN1= NG-JE*100
              JM = LNODS(JE,MXNOD-1)
              NJ = LNODS(JE,MXNOD)
              JT = 2
              IF(JM.EQ.IMSET1) THEN
                JT = 1
                NJ = ND2
              END IF
              DO JN=1,NJ
                JP = LNODS(JE,JN)
                IF(IP.EQ.JP.AND.IP.GT.LN.AND.IT.NE.JT) THEN
                  IW1(IT) = IE*100+IN1
                  IW1(JT) = JE*100+JN1
                  IW2(IT) = IE*100+IN
                  IW2(JT) = JE*100+JN
                  GOTO 300
                END IF
              END DO
            END DO
          GOTO 400
  300     CONTINUE
          NPA = NPA + 1
          IA = IA + 1
          IWORK(IA) = IW1(1)
          IA = IA + 1
          IWORK(IA) = IW1(2)
          IA = IA + 1
          IWORK(IA) = IW2(1)
          IA = IA + 1
          IWORK(IA) = IW2(2)
  400     CONTINUE
          END DO
        END DO
        IWORK(IADL+ICOR) = NPA
      END DO
      IADI  = IA
C----------------------------------------------------------------------
      IADN  = IADI
      DO K=1,NNODE
        IWORK(IADN+K) = 0
      END DO
      NNODE0 = NNODE
      NELEM0 = NELEM
      IA    = IADE
      IENEW = NELEM
      NDNEW = 2*(1+KND)
      DO IDIS=1,NDIS
        NPA = IWORK(IADD+IDIS)
        DO IPA=1,NPA
          IENEW = IENEW + 1
          LN1 = IWORK(IADC+IDIS)
          XI1 = COORD(LN1,1)
          YI1 = COORD(LN1,2)
          IA = IA + 1
          LN2 = IWORK(IA)
          XI2 = COORD(LN2,1)
          YI2 = COORD(LN2,2)
          IA = IA + 1
          NG  = IWORK(IA)
          IE1 = NG/100
          IN1 = NG-IE1*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE1 = NG/100
          JN1 = NG-JE1*100
          IA = IA + 1
          NG  = IWORK(IA)
          IE2 = NG/100
          IN2 = NG-IE2*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE2 = NG/100
          JN2 = NG-JE2*100
          IE1 = IE2
          JE1 = JE2
          XMI = 0.0E0
          YMI = 0.0E0
          DO K = 1, ND2
            LN  = IABS(LNODS(IE1,K))
            XMI = XMI + COORD(LN,1)
            YMI = YMI + COORD(LN,2)
          END DO
          XMI = XMI/FLOAT(ND2)
          YMI = YMI/FLOAT(ND2)
          AI = FAREA(XMI,YMI,XI1,YI1,XI2,YI2)
          XMJ = 0.0E0
          YMJ = 0.0E0
          DO K = 1, ND2
            LN  = IABS(LNODS(JE1,K))
            XMJ = XMJ + COORD(LN,1)
            YMJ = YMJ + COORD(LN,2)
          END DO
          XMJ = XMJ/FLOAT(ND2)
          YMJ = YMJ/FLOAT(ND2)
          AJ = FAREA(XMJ,YMJ,XI1,YI1,XI2,YI2)
          IF(AI.LT.0) THEN
            NG  = LN1
            LN1 = LN2
            LN2 = NG
            NG  = IN1
            IN1 = IN2
            IN2 = NG
            NG  = JN1
            JN1 = JN2
            JN2 = NG
          END IF
          MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
          MATSET(IMSET2,MATSET(IMSET2,1))=IENEW
          LNODS(IENEW,MXNOD)=NDNEW
          LNODS(IENEW,MXNOD-1)=IMSET2
          NDE = 1
          IP0 = IABS(LNODS(JE1,JN1))
          IPn = 0
          IF(IP0.LE.NNODE0) IPn = IWORK(IADN+IP0)
          IF(LNODS(JE1,JN1).LT.0.OR.IPn.LE.0) THEN
            IWORK(IADN+IP0) = IP0
            IW1(NDE) = IABS(LNODS(JE1,JN1))
            IF(LNODS(JE1,JN1).GT.0) LNODS(JE1,JN1) = -LNODS(JE1,JN1)
          ELSE
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(JE1,JN1) = -NNODE
            COORD(NNODE,1)=COORD(LN1,1)
            COORD(NNODE,2)=COORD(LN1,2)
          END IF
          IF(KND.EQ.2) THEN
            NDE = NDE+1
            JM = JN2 + ND2
            IW1(NDE) = IABS(LNODS(JE1,JM ))
          END IF
          NDE = NDE+1
          IP0 = IABS(LNODS(JE1,JN2))
          IPn = 0
          IF(IP0.LE.NNODE0) IPn = IWORK(IADN+IP0)
          IF(LNODS(JE1,JN2).LT.0.OR.IPn.LE.0) THEN
            IWORK(IADN+IP0) = IP0
            IW1(NDE) = IABS(LNODS(JE1,JN2))
            IF(LNODS(JE1,JN2).GT.0) LNODS(JE1,JN2) = -LNODS(JE1,JN2)
          ELSE
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(JE1,JN2) = -NNODE
            COORD(NNODE,1)=COORD(LN2,1)
            COORD(NNODE,2)=COORD(LN2,2)
          END IF
C
          NDE = NDE+1
          IP0 = IABS(LNODS(IE1,IN1))
          IPn = 0
          IF(IP0.LE.NNODE0) IPn = IWORK(IADN+IP0)
          IF(LNODS(IE1,IN1).LT.0.OR.IPn.LE.0) THEN
            IWORK(IADN+IP0) = IP0
            IW1(NDE) = IABS(LNODS(IE1,IN1))
            IF(LNODS(IE1,IN1).GT.0) LNODS(IE1,IN1) = -LNODS(IE1,IN1)
          ELSE
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(IE1,IN1) = -NNODE
            COORD(NNODE,1)=COORD(LN1,1)
            COORD(NNODE,2)=COORD(LN1,2)
          END IF
          IF(KND.EQ.2) THEN
            NNODE = NNODE + 1
            NDE = NDE+1
            JM = IN1 + ND2
            LM = LNODS(IE1,JM )
            IW1(NDE) = NNODE
            LNODS(IE1,JM ) = NNODE
            COORD(NNODE,1)=COORD(LM ,1)
            COORD(NNODE,2)=COORD(LM ,2)
          END IF
          NDE = NDE+1
          IP0 = IABS(LNODS(IE1,IN2))
          IPn = 0
          IF(IP0.LE.NNODE0) IPn = IWORK(IADN+IP0)
          IF(LNODS(IE1,IN2).LT.0.OR.IPn.LE.0) THEN
            IWORK(IADN+IP0) = IP0
            IW1(NDE) = IABS(LNODS(IE1,IN2))
            IF(LNODS(IE1,IN2).GT.0) LNODS(IE1,IN2) = -LNODS(IE1,IN2)
          ELSE
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(IE1,IN2) = -NNODE
            COORD(NNODE,1)=COORD(LN2,1)
            COORD(NNODE,2)=COORD(LN2,2)
          END IF
          DO IDE=1,NDE
            LNODS(IENEW,IDE) = IW1(IDE)
          END DO
          ELTYP(IENEW)   = 'ICOHE2'
          CALL DNODE(IENEW,NDNEW)
        END DO
      END DO
      NELEM = IENEW
      DO K1 = NUMEL1,NUMEL2
        IF(IMSET1.EQ.0) THEN
          IE   = K1
        ELSE
          IE   = MATSET(IMSET1,K1)
        END IF
        ND = LNODS(IE,MXNOD)
        DO IN=1,ND
          LNODS(IE,IN) = IABS(LNODS(IE,IN))
        END DO
        CALL DNODE(IE,ND)
      END DO
      IA = IADM
      DO ICOR=1,NCOR
        NPA = IWORK(IADL+ICOR)
        DO IPA=1,NPA
          IA = IA + 1
          NG  = IWORK(IA)
          IE1 = NG/100
          IN1 = NG-IE1*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE1 = NG/100
          JN1 = NG-JE1*100
          LNODS(JE1,JN1) = LNODS(IE1,IN1)
          IA = IA + 1
          NG  = IWORK(IA)
          IE2 = NG/100
          IN2 = NG-IE2*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE2 = NG/100
          JN2 = NG-JE2*100
          LNODS(JE2,JN2) = LNODS(IE2,IN2)
        END DO
      END DO
C
      KEY_CHK = 0
      WRITE(IO_INFO,2000) 
     &  'EXAMING ELEMENT DEFINITION IN Sub. CZM2DEL1'
      WRITE(IO_WRITE,2000) 
     &  'EXAMING ELEMENT DEFINITION IN Sub. CZM2DEL1'
      DO IE = NELEM0+1,NELEM
        ND = LNODS(IE,MXNOD)
        ND2=ND/2
        DO IN=1,ND2
          IP1 = IABS(LNODS(IE,IN))
          IP2 = IABS(LNODS(IE,IN+ND2))
          X1  = COORD(IP1,1)
          Y1  = COORD(IP1,2)
          Z1  = COORD(IP1,3)
          X2  = COORD(IP2,1)
          Y2  = COORD(IP2,2)
          Z2  = COORD(IP2,3)
          DIST = SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2)+(Z1-Z2)*(Z1-Z2))
          IF(DIST.GT.TOLER) THEN
            KEY_CHK = 1
            WRITE(IO_INFO,2010) IE,IN,IP1,X1,Y1,IP2,X2,Y2
          END IF
        END DO
      END DO
      IF(KEY_CHK.EQ.1) THEN
        WRITE(IO_INFO ,2000) 
     &  'NO IDENTICAL NODE COORNATES FOUND IN ELEMENT',
     &  ' DEFINITION(INTERFACE ELEMENT)'
        WRITE(IO_WRITE,2000) 
     &  'NO IDENTICAL NODE COORNATES FOUND IN ELEMENT',
     &  ' DEFINITION(INTERFACE ELEMENT)'
      ELSE
        WRITE(IO_INFO ,2000) 
     &  'ELEMENT DEFINITION EXAMING IS OK'
        WRITE(IO_WRITE,2000) 
     &  'ELEMENT DEFINITION EXAMING IS OK'
      END IF
 2000 FORMAT(//5X,5A)
 2010 FORMAT(2I6,2X,2(I6,2E13.6))
C
      WRITE(IO_JNL,'(5X,A)') 'NOW END OF   SUB. CZM2DEL1'
      WRITE(IO_WRITE,'(5X,A)') 'NOW END OF   SUB. CZM2DEL1'
C
      RETURN
      END
