C
C     GENERATING COHESIVE ELEMENT IN A ELSET OR GIVEN AREA
C
      SUBROUTINE CZM2DEL2
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KWORK(50,2,2),IW1(100),IW2(100)
      DIMENSION XP(6)
      CHARACTER CHAR1*8,CHAR2*8
      INCLUDE 'common'
CCCC  INCLUDE 'mcommon1'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CZM2DEL2'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. CZM2DEL2'
C
      TEXT='NOW EXCUTING SUB. CZM2DEL2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
      IF(IMSET2.EQ.0) THEN
        WRITE(IO_WRITE,1000) 'CZM2DEL2','No (NEW ELSET) parameter.',
     &  ' Please check file *.inf'
        WRITE(IO_INFO ,1000) 'CZM2DEL2','No (NEW ELSET) parameter.'
        WRITE(IO_INFO ,1001) 'CZM2DEL2'
        WRITE(IO_INFO ,1002)
        STOP
      END IF
      KEY = 1
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*CZM2DEL2,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*LINE   ',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*POLYGON',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*CIRCLE ',20X,'(option)'/21X,'Xo, Yo , Ri, TH1, TH2'/,
     & /20X,'*ELSET  ',20X,'(option)'/21X,'ELSET1 , ELSET2 '/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:5).EQ.'*POLY') THEN
        KEY = 2
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*LINE') THEN
        KEY = 3
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*CIRC') THEN
        KEY = 4
        READ(IO_INPUT,*) (XP(K),K=1,5)
        GOTO 1
      ELSE IF(STRING(1:6).EQ.'*ELSET') THEN
        KEY = 5
        IESET1 = 0
        READ(IO_INPUT,'(A)') STRING
        IF(STRING(1:1).EQ.'*') THEN
          WRITE(IO_INFO ,1000) 'COHESIV4','No (*ELSET) parameter.',
     &    ' Please give ELSET1, ELSET2'
          WRITE(IO_WRITE,1000) 'COHESIV4','No (*ELSET) parameter.',
     &    ' Please give ELSET1, ELSET2'
          WRITE(IO_INFO ,1001) 'COHESIV4'
          WRITE(IO_INFO ,1002)
        ELSE
          READ(STRING(1:100),*) IMESET1,IMESET2
        END IF
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
      ELSE
        WRITE(IO_INFO,1010) 'COHESIV4',STRING
        GOTO 1
      END IF
C *** CHECKING MESH BOARD   
C----------------------------------------------------------------------
C     CALL DELEDGE
C
      IADA  = 0
      IADI  = 0
      DO K=1,NNODE
        IWORK(IADA+K) = 0
      END DO
      IADI  = IADI+NNODE
      IADB  = IADI
      MXEL  = 10
      DO K=1,NNODE*MXEL
        IWORK(IADB+K) = 0
      END DO
      IADI  = IADI+NNODE*MXEL
      IADC  = IADI
      DO K=1,NNODE
        IWORK(IADC+K) = 0
      END DO
      IF(KEY.EQ.5) THEN
        NUMEL1 = 2
        NUMEL2 = MATSET(IMESET1,1)
        IE     = MATSET(IMESET1,2)
        NND1  = LNODS(IE,MXNOD)
        KND1  = 1
        IF(NND1.GT.4) KND1 = 2
        ND1 = NND1/KND1
        DO K1 = NUMEL1,NUMEL2
          IE   = MATSET(IMESET1,K1)
          IF(IE.GT.0) THEN
            DO IN = 1, ND1
              LN = LNODS(IE,IN)
              NCONT = IWORK(IADA+LN)
              NCONT = NCONT + 1
              IWORK(IADA+LN) = NCONT
              IWORK(IADB+(LN-1)*MXEL+NCONT) = IE*100+IN
            END DO
          END IF
        END DO
        NUMEL1 = 2
        NUMEL2 = MATSET(IMESET2,1)
        IE     = MATSET(IMESET2,2)
        NND2  = LNODS(IE,MXNOD)
        KND2  = 1
        IF(NND2.GT.4) KND2 = 2
        ND2 = NND2/KND2
        DO K1 = NUMEL1,NUMEL2
          IE   = MATSET(IMESET2,K1)
          IF(IE.GT.0) THEN
            DO IN = 1, ND2
              LN = LNODS(IE,IN)
              NCONT = IWORK(IADA+LN)
              IF(NCONT.GT.0) THEN
                IWORK(IADC+LN) = 1
                NCONT = NCONT + 1
                IWORK(IADA+LN) = NCONT
                IWORK(IADB+(LN-1)*MXEL+NCONT) = IE*100+IN
              END IF
            END DO
          END IF
        END DO
      END IF
      NDIS = 0
      DO IP=1,NNODE
        IF(IWORK(IADC+IP).EQ.1) THEN
          NDIS = NDIS + 1
          IWORK(IADC+NDIS) = IP
        END IF
      END DO
      IADI  = IADI+NDIS
      IADD  = IADI
      IADI  = IADI+NDIS
      IADE  = IADI
      IA    = IADE
      DO IDIS=1,NDIS
        LN = IWORK(IADC+IDIS)
        NDEL = IWORK(IADA+LN)
        IADS = IADB+(LN-1)*MXEL
        NPA  = 0
        DO IDEL=1,NDEL-1
          NG = IWORK(IADS+IDEL)
          IE = NG/100
          IN = NG-IE*100
          IM = LNODS(IE,MXNOD-1)
          NI = ND2
          IT = 2
          IF(IM.EQ.IMESET1) THEN
            IT = 1
            NI = ND1
          END IF
          IW1(1) = 0
          IW1(2) = 0
          IW2(1) = 0
          IW2(2) = 0
          IW1(1) = 0
          IW1(2) = 0
          IW2(1) = 0
          IW2(2) = 0
          DO KI=1,NI
            IP = LNODS(IE,KI)
            DO JDEL=IDEL+1,NDEL
              NG = IWORK(IADS+JDEL)
              JE = NG/100
              JN = NG-JE*100
              JM = LNODS(JE,MXNOD-1)
              NJ = ND2
              JT = 2
              IF(JM.EQ.IMESET1) THEN
                JT = 1
                NJ = ND1
              END IF
              DO KJ=1,NJ
                JP = LNODS(JE,KJ)
                IF(IP.EQ.JP.AND.IP.GT.LN.AND.IM.NE.JM) THEN
                  IW1(IT) = IE*100+IN
                  IW1(JT) = JE*100+JN
                  IW2(IT) = IE*100+KI
                  IW2(JT) = JE*100+KJ
                  IW2(3)  = JP
                  GOTO 300
                END IF
              END DO
            END DO
          END DO
          GOTO 400
  300     CONTINUE
          NPA = NPA + 1
          IA = IA + 1
          IWORK(IA) = IW2(3)
          IA = IA + 1
          IWORK(IA) = IW1(1)
          IA = IA + 1
          IWORK(IA) = IW1(2)
          IA = IA + 1
          IWORK(IA) = IW2(1)
          IA = IA + 1
          IWORK(IA) = IW2(2)
  400     CONTINUE
        END DO
        IWORK(IADD+IDIS) = NPA
      END DO
      IADI  = IA
      IADF  = IADI
      DO K=1,NNODE
        IWORK(IADF+K) = K
      END DO
      NNODE0 = NNODE
      IA    = IADE
      IENEW = NELEM
      NDNEW = 2*(1+KND1)
      DO IDIS=1,NDIS
        LN1 = IWORK(IADC+IDIS)
        XI1 = COORD(LN1,1)
        YI1 = COORD(LN1,2)
        NPA = IWORK(IADD+IDIS)
        DO IPA=1,NPA
          IENEW = IENEW + 1
          IA = IA + 1
          LN2 = IWORK(IA)
          XI2 = COORD(LN2,1)
          YI2 = COORD(LN2,2)
          IA = IA + 1
          NG  = IWORK(IA)
          IE1 = NG/100
          IN1 = NG-IE1*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE1 = NG/100
          JN1 = NG-JE1*100
          IA = IA + 1
          NG  = IWORK(IA)
          IE2 = NG/100
          IN2 = NG-IE2*100
          IA = IA + 1
          NG  = IWORK(IA)
          JE2 = NG/100
          JN2 = NG-JE2*100
          XMI = 0.0E0
          YMI = 0.0E0
          DO K = 1, ND1
            LN  = IABS(LNODS(IE1,K))
            XMI = XMI + COORD(LN,1)
            YMI = YMI + COORD(LN,2)
          END DO
          XMI = XMI/FLOAT(ND1)
          YMI = YMI/FLOAT(ND1)
          AI = FAREA(XMI,YMI,XI1,YI1,XI2,YI2)
          XMJ = 0.0E0
          YMJ = 0.0E0
          DO K = 1, ND2
            LN  = IABS(LNODS(JE1,K))
            XMJ = XMJ + COORD(LN,1)
            YMJ = YMJ + COORD(LN,2)
          END DO
          XMJ = XMJ/FLOAT(ND2)
          YMJ = YMJ/FLOAT(ND2)
          AJ = FAREA(XMJ,YMJ,XI1,YI1,XI2,YI2)
          IF(AI.LT.0) THEN
            NG  = LN1
            LN1 = LN2
            LN2 = NG 
            NG  = IN1
            IN1 = IN2
            IN2 = NG 
            NG  = JN1
            JN1 = JN2
            JN2 = NG 
          END IF
          MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
          MATSET(IMSET2,MATSET(IMSET2,1))=IENEW
          LNODS(IENEW,MXNOD)=NDNEW
          LNODS(IENEW,MXNOD-1)=IMSET2
          NDE = 1
          IW1(NDE) = IABS(LNODS(JE1,JN1))
          IF(KND1.EQ.2) THEN
            NDE = NDE+1
            JM = JN2 + ND1
            IW1(NDE) = IABS(LNODS(JE1,JM ))
          END IF
          NDE = NDE+1
          IW1(NDE) = IABS(LNODS(JE1,JN2))
C
          NDE = NDE+1
          IP1 = LNODS(IE1,IN1)
          IP2 = IWORK(IADF+IP1)
          IF(IP2.EQ.IP1) THEN
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(IE1,IN1) = NNODE
            IWORK(IADF+IP1) = NNODE
            COORD(NNODE,1)=COORD(LN1,1)
            COORD(NNODE,2)=COORD(LN1,2)
          ELSE
            IW1(NDE) = IP2
            LNODS(IE1,IN1) = IP2
          END IF
          IF(KND1.EQ.2) THEN
            NNODE = NNODE + 1
            NDE = NDE+1
            JM = IN1 + ND2
            LM = LNODS(IE1,JM )
            IW1(NDE) = NNODE
            LNODS(IE1,JM ) = NNODE
            COORD(NNODE,1)=COORD(LM ,1)
            COORD(NNODE,2)=COORD(LM ,2)
          END IF
          NDE = NDE+1
          IP1 = LNODS(IE1,IN2)
          IP2 = IWORK(IADF+IP1)
          IF(IP2.EQ.IP1) THEN
            NNODE = NNODE + 1
            IW1(NDE) = NNODE
            LNODS(IE1,IN2) = NNODE
            IWORK(IADF+IP1) = NNODE
            COORD(NNODE,1)=COORD(LN2,1)
            COORD(NNODE,2)=COORD(LN2,2)
          ELSE
            IW1(NDE) = IP2
            LNODS(IE1,IN2) = IP2
          END IF
          DO IDE=1,NDE
            LNODS(IENEW,IDE) = IW1(IDE)
          END DO
          ELTYP(IENEW)   = 'ICOHE2'
          CALL DNODE(IENEW,NDNEW)
        END DO
      END DO
      DO IDIS=1,NDIS
        LN  = IWORK(IADC+IDIS)
        NC  = IWORK(IADA+LN)
        DO K=1,NC
          NG=IWORK(IADB+(LN-1)*MXEL+K)
          IE=NG/100
          IN=NG-IE*100
          KM=LNODS(IE,MXNOD-1)
          IF(KM.EQ.IMESET1) THEN
            LNODS(IE,IN) = IWORK(IADF+LN)
          END IF
        END DO
      END DO
      NELEM = IENEW
      NUMEL1 = 2
      NUMEL2 = MATSET(IMESET1,1)
      DO K1 = NUMEL1,NUMEL2
        IE = MATSET(IMESET1,K1)
        ND = LNODS(IE,MXNOD)
        DO IN=1,ND
          LNODS(IE,IN) = IABS(LNODS(IE,IN))
        END DO
      END DO
      NUMEL1 = 2
      NUMEL2 = MATSET(IMESET2,1)
      DO K1 = NUMEL1,NUMEL2
        IE = MATSET(IMESET2,K1)
        ND = LNODS(IE,MXNOD)
        DO IN=1,ND
          LNODS(IE,IN) = IABS(LNODS(IE,IN))
        END DO
      END DO
C
      WRITE(IO_JNL,'(5X,A)') 'NOW END OF   SUB. CZM2DEL2'
      WRITE(IO_WRITE,'(5X,A)') 'NOW END OF   SUB. CZM2DEL2'
C
      RETURN
      END
