C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE MESH1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(200),YB(200),XE(200),YE(200),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(200),SC2(200),N1OUT(1000),
     2 NDYLF(500),NDYRT(500),NDU(500),NDDWN(500),NCT(500),
     & NOUTCL(1000),MSEC(10),SECCD(1000,2,2),SECXY(10,5)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH1'
      TEXT='NOW EXCUTING SUB. MESH1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
    1 READ(IO_INPUT,'(A)',END=999) STRING
C
      IF(STRING(1:10).EQ.'*END MESH1') THEN
        GOTO 99
      ELSE IF(STRING(1:8).EQ.'*FULL CI') THEN
      READ(IO_INPUT,*) NEXT,IMSET,NODE
      READ(IO_INPUT,*) NSEC,((SECXY(I,J),J=1,5),I=1,NSEC)
C
      KFULL = 0
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'FULL    ',4,1,K1,K2)
        IF(K2.GE.K1) THEN
          IF(STRING(K1:K1).EQ.'L') THEN
            KFULL = 1
          ELSE
          END IF
          READ(IO_INPUT,*) B_REF
        END IF
      END IF
C
      KEY_PL=0
      IF(NEXT.LT.0) THEN
        KEY_PL=1
        NEXT=-NEXT
      END IF
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NEXT/2)*2.NE.NEXT) NEXT=NEXT+1
      IF(NTOUTC.EQ.0) THEN
        CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
        CALL SEAND(NDYLF,1,XMIN,NYLF,1)
        CALL SEAND(NDU,2,YMAX,KU,1)
        CALL SEAND(NDYRT,1,XMAX,NYRT,3)
        CALL SEAND(NDDWN,2,YMIN,NDWN,3)
        IF(KFULL.EQ.1) THEN
          NTOUTC=0
          DO I=1,NYLF
            LNODE = NDYLF(I)
            YI    = COORD(LNODE,2)
            IF(YI.GT.B_REF) THEN
              NTOUTC=NTOUTC+1
              NOUTCL(NTOUTC)=NDYLF(I)
            ELSE IF(ABS(YI-B_REF).LT.TOLER) THEN
              DO IE=1,NELEM
                NODE=LNODS(IE,MXNOD)
                IMSET=LNODS(IE,MXNOD-1)
                STRING=ELSET_TYP(IMSET)
                IF(STRING(1:1).EQ.'C') THEN
                  DO J=1,NODE
                    IN=LNODS(IE,J)
                    IF(IN.EQ.LNODE) GOTO 13
                  END DO
                END IF
              END DO
   13         CONTINUE
              XM=0.0
              YM=0.0
              ZM=0.0
              DO J=1,NODE
                IN=LNODS(IE,J)
                XM=XM+COORD(IN,1)
                YM=YM+COORD(IN,2)
                ZM=ZM+COORD(IN,3)
              END DO
              XM=XM/FLOAT(NODE)
              YM=YM/FLOAT(NODE)
              ZM=ZM/FLOAT(NODE)
              IF(YM.GT.B_REF) THEN
                NTOUTC=NTOUTC+1
                NOUTCL(NTOUTC)=NDYLF(I)
              ELSE
              END IF
            END IF
          END DO
          NSECT = NSECT + 1
          MSEC(NSECT)=NTOUTC
          DO I=2,KU
            NTOUTC=NTOUTC+1
            NOUTCL(NTOUTC)=NDU  (I)
          END DO
          NSECT = NSECT + 1
          MSEC(NSECT)=NTOUTC
          DO I=2,NYRT
            NTOUTC=NTOUTC+1
            NOUTCL(NTOUTC)=NDYRT(I)
          END DO
          NSECT = NSECT + 1
          MSEC(NSECT)=NTOUTC
          DO I=2,NDWN
            NTOUTC=NTOUTC+1
            NOUTCL(NTOUTC)=NDDWN(I)
          END DO
          NSECT = NSECT + 1
          MSEC(NSECT)=NTOUTC
          DO I=2,NYLF
            LNODE = NDYLF(I)
            YI    = COORD(LNODE,2)
            IF(YI.LT.B_REF) THEN
              NTOUTC=NTOUTC+1
              NOUTCL(NTOUTC)=NDYLF(I)
            ELSE IF(ABS(YI-B_REF).LT.TOLER) THEN
              DO IE=1,NELEM
                NODE=LNODS(IE,MXNOD)
                IMSET=LNODS(IE,MXNOD-1)
                STRING=ELSET_TYP(IMSET)
                IF(STRING(1:1).EQ.'C') THEN
                  DO J=1,NODE
                    IN=LNODS(IE,J)
                    IF(IN.EQ.LNODE) GOTO 15
                  END DO
                END IF
              END DO
   15         CONTINUE
              XM=0.0
              YM=0.0
              ZM=0.0
              DO J=1,NODE
                IN=LNODS(IE,J)
                XM=XM+COORD(IN,1)
                YM=YM+COORD(IN,2)
                ZM=ZM+COORD(IN,3)
              END DO
              XM=XM/FLOAT(NODE)
              YM=YM/FLOAT(NODE)
              ZM=ZM/FLOAT(NODE)
              IF(YM.LT.B_REF) THEN
                NTOUTC=NTOUTC+1
                NOUTCL(NTOUTC)=NDYLF(I)
              ELSE
              END IF
            END IF
          END DO
          NSECT = NSECT + 1
          MSEC(NSECT)=NTOUTC
        END IF
      END IF
      DO I=1,NTOUTC
        INP=NOUTCL(I)
        X=COORD(INP,1)
        Y=COORD(INP,2)
        SECCD(I,1,1)=X
        SECCD(I,2,1)=Y
      END DO
      NSECD=1
      JBEGIN=1
      DO K=1,NSEC
        X0=SECXY(K,1)
        Y0=SECXY(K,2)
        R0=SECXY(K,3)
        T1=SECXY(K,4)*PI/180.0D0
        T2=SECXY(K,5)*PI/180.0D0
        JSTOP =NTOUTC
        JSTOP =MSEC(K)
        NSECD=JSTOP-JBEGIN
        DT=(T2-T1)/NSECD
        T=T1-DT
        DO J=JBEGIN,JSTOP
          T=T+DT
          X=X0+R0*COS(T)
          Y=Y0+R0*SIN(T)
          SECCD(J,1,2)=X
          SECCD(J,2,2)=Y
        END DO
        JBEGIN=JSTOP
      END DO
      NX123=MSEC(NSEC)-1
C     NX123=MSEC(NSECT)-1
      IF(NODE.EQ.8) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=NNODE-(NX123+1)
        DO I=1,NEXT
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX123+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            IF(I.EQ.1) THEN
              IK1=J
              IK2=J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK2)
            END IF
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
C
C     GENERATE NODE COORDINATES
C
      EL0=ELL
      IF(EL0.LT.ELU) EL0=ELU
      IF(EL0.LT.ELR) EL0=ELR
      IF(EL0.LT.ELD) EL0=ELD
      DO I=1,NX123+1
        X1=SECCD(I,1,1)
        Y1=SECCD(I,2,1)
        X2=SECCD(I,1,2)
        Y2=SECCD(I,2,2)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NEXT,EL0,RL,SCL)
        IF(SCL.LT.1.0.OR.KEY_PL.EQ.1) THEN
          SCL=1.0
          EL0=RL/NEXT
          ST=RL/EL0
        END IF
        SC2(I)=SCL
        SL=0.0
        IN=NNODE-NX123-1+I
        DO J=1,NEXT
          IN=IN+NX123+1
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(J.EQ.NEXT) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELL=EL0*SCL**NEXT
        IF(I.EQ.NX12+1) ELU=EL0*SCL**NEXT
        IF(I.EQ.NX123+1) ELR=EL0*SCL**NEXT
      END DO
C
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NX123
      INL2=INL1-NX123-1
      INR1=IN
      INR2=INR1-NX123-1
      INU1=IN-NX34
      INU2=INU1-NX123-1
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NX123
C     WRITE(IO_WORK,903) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NX123+1)
C     WRITE(IO_WORK,*) ' INL1',INL1,INL2,INR1,INR2
  903 FORMAT(' FRAME REGION I'/
     1 2(5X,2HXB,10X,2HYB,10X,2HXE,10X,2HYE,10X,2HSC,5X)
     1 /(2(5E12.4)))
C
      GOTO 1
C
      ELSE IF(STRING(1:7).EQ.'*CIRCLE') THEN
      READ(IO_INPUT,*) NEXT,IMSET,NODE
      READ(IO_INPUT,*) NSEC,((SECXY(I,J),J=1,5),I=1,NSEC)
C
      KFULL = 0
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'FULL    ',4,1,K1,K2)
        IF(K2.GT.K1) THEN
          IF(STRING(K1:K1).EQ.'L') THEN
            KFULL = 1
          ELSE
          END IF
          READ(IO_INPUT,*) B_REF
        END IF
      END IF
C
      KEY_PL=0
      IF(NEXT.LT.0) THEN
        KEY_PL=1
        NEXT=-NEXT
      END IF
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NEXT/2)*2.NE.NEXT) NEXT=NEXT+1
      IF(NTOUTC.EQ.0) THEN
        CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
        CALL SEAND(NDYLF,1,XMIN,NYLF,1)
        CALL SEAND(NDU,2,YMAX,KU,1)
        CALL SEAND(NDYRT,1,XMAX,NYRT,3)
        CALL SEAND(NDDWN,2,YMIN,NDWN,3)
        NTOUTC=0
        DO I=1,NYLF
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDYLF(I)
        END DO
        MSEC(1)=NTOUTC
        DO I=2,KU
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDU  (I)
        END DO
        MSEC(2)=NTOUTC
        DO I=2,NYRT
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDYRT(I)
        END DO
        MSEC(3)=NTOUTC
      END IF
      DO I=1,NTOUTC
        INP=NOUTCL(I)
        X=COORD(INP,1)
        Y=COORD(INP,2)
        SECCD(I,1,1)=X
        SECCD(I,2,1)=Y
      END DO
      NSECD=1
      JBEGIN=1
      DO K=1,NSEC
        X0=SECXY(K,1)
        Y0=SECXY(K,2)
        R0=SECXY(K,3)
        T1=SECXY(K,4)*PI/180.0D0
        T2=SECXY(K,5)*PI/180.0D0
        JSTOP =MSEC(K)
        NSECD=JSTOP-JBEGIN
        DT=(T2-T1)/NSECD
        T=T1-DT
        DO J=JBEGIN,JSTOP
          T=T+DT
          X=X0+R0*COS(T)
          Y=Y0+R0*SIN(T)
          SECCD(J,1,2)=X
          SECCD(J,2,2)=Y
        END DO
        JBEGIN=JSTOP
      END DO
      NX123=MSEC(NSEC)-1
      IF(NODE.EQ.8) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=NNODE-(NX123+1)
        DO I=1,NEXT
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX123+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            IF(I.EQ.1) THEN
              IK1=J
              IK2=J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK2)
            END IF
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
C
C     GENERATE NODE COORDINATES
C
      EL0=ELL
      IF(EL0.LT.ELU) EL0=ELU
      IF(EL0.LT.ELR) EL0=ELR
      IF(EL0.LT.ELD) EL0=ELD
      DO I=1,NX123+1
        X1=SECCD(I,1,1)
        Y1=SECCD(I,2,1)
        X2=SECCD(I,1,2)
        Y2=SECCD(I,2,2)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NEXT,EL0,RL,SCL)
        IF(SCL.LT.1.0.OR.KEY_PL.EQ.1) THEN
          SCL=1.0
          EL0=RL/NEXT
          ST=RL/EL0
        END IF
        SC2(I)=SCL
        SL=0.0
        IN=NNODE-NX123-1+I
        DO J=1,NEXT
          IN=IN+NX123+1
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(J.EQ.NEXT) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELL=EL0*SCL**NEXT
        IF(I.EQ.NX12+1) ELU=EL0*SCL**NEXT
        IF(I.EQ.NX123+1) ELR=EL0*SCL**NEXT
      END DO
C
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NX123
      INL2=INL1-NX123-1
      INR1=IN
      INR2=INR1-NX123-1
      INU1=IN-NX34
      INU2=INU1-NX123-1
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NX123
C     WRITE(IO_WORK,903) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NX123+1)
C     WRITE(IO_WORK,*) ' INL1',INL1,INL2,INR1,INR2
C
      GOTO 1
C
      ELSE IF(STRING(1:8).EQ.'*IPLMESH') THEN
      READ(IO_INPUT,*) NY,IMSET,NODE
C
      KEY_PL=0
      IF(NY.LT.0) THEN
        KEY_PL=1
        NY=-NY
      END IF
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NY/2)*2.NE.NY) NY=NY+1
      IF(NODE.EQ.8) THEN
        L6=NNODE-NX123-1
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK3)
              LNODS(IE,5)=NXYB(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NX123-1
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK3)
              LNODS(IE,5)=NXYB(IK2)
            END IF
            LNODS(IE,27)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=NNODE-(NX123+1)
        DO I=1,NY
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX123+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            IF(I.EQ.1) THEN
              IK1=J
              IK2=J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK2)
            END IF
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
C
      READ(IO_INPUT,*) (XSG(I),YSG(I),I=1,5)
c     WRITE(IO_WRITE,'(2E20.12)') (XSG(I),YSG(I),I=1,5)
      XE(1)=XSG(1)
      YE(1)=YSG(1)
      II=1
      X1=XSG(1)
      Y1=YSG(1)
      X2=XSG(2)
      Y2=YSG(2)
      DO J=1,NX1
        II=II+1
        X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX1)
        Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX1)
        XE(II)=X
        YE(II)=Y
      END DO
      X1=XSG(2)
      Y1=YSG(2)
      X2=XSG(3)
      Y2=YSG(3)
      DO J=1,NX2
        II=II+1
        X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX2)
        Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX2)
        XE(II)=X
        YE(II)=Y
      END DO
      DO I=3,4
        X1=XSG(I)
        Y1=YSG(I)
        X2=XSG(I+1)
        Y2=YSG(I+1)
        DO J=1,NX34/2
          II=II+1
          X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX34/2)
          Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX34/2)
          XE(II)=X
          YE(II)=Y
        END DO
      END DO
      II=NNODE-NX123-1
      DO I=1,NX123+1
        II=NXYB(I)
        XB(I)=COORD(II,1)
        YB(I)=COORD(II,2)
      END DO
C
C     GENERATE NODE COORDINATES
C
      EL0=ELL
      IF(EL0.LT.ELU) EL0=ELU
      IF(EL0.LT.ELR) EL0=ELR
      DO I=1,NX123+1
        X1=XB(I)
        Y1=YB(I)
        X2=XE(I)
        Y2=YE(I)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NY,EL0,RL,SCL)
        IF(SCL.LT.1.0.OR.KEY_PL.EQ.1) THEN
          SCL=1.0
          EL0=RL/NY
          ST=RL/EL0
        END IF
        SC2(I)=SCL
        SL=0.0
        IN=NNODE-NX123-1+I
        DO J=1,NY
          IN=IN+NX123+1
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(J.EQ.NY) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELL=EL0*SCL**NY
        IF(I.EQ.NX12+1) ELU=EL0*SCL**NY
        IF(I.EQ.NX123+1) ELR=EL0*SCL**NY
      END DO
C
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NX123
      INL2=INL1-NX123-1
      INR1=IN
      INR2=INR1-NX123-1
      INU1=IN-NX34
      INU2=INU1-NX123-1
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NX123
C     WRITE(IO_WORK,903) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NX123+1)
C     WRITE(IO_WORK,*) ' INL1',INL1,INL2,INR1,INR2
C
      GOTO 1
C
C     GENERATE RECTANGULE FRAME SHAPE MESH
C
      ELSE IF(STRING(1:8).EQ.'*IRTMESH') THEN
      READ(IO_INPUT,*) NY,IMSET,NODE
C
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NY/2)*2.NE.NY) NY=NY+1
      READ(IO_INPUT,*) (XSG1(I),YSG1(I),I=1,3)
c     WRITE(IO_WRITE,'(i5/6E12.5)') NY,(XSG1(I),YSG1(I),I=1,3)
      DO I=1,NX2+NX34+1
        XB(I)=XE(I+NX1)
        YB(I)=YE(I+NX1)
      END DO
      X1=XSG1(1)
      X2=XSG1(2)
      Y1=YSG1(1)
      Y2=YSG1(2)
      XE(1)=XSG1(1)
      YE(1)=YSG1(1)
      II=1
      DO I=1,NX2+NX34/2
        II=II+1
        X=X1+FLOAT(I)*(X2-X1)/FLOAT(NX2+NX34/2)
        Y=Y1+FLOAT(I)*(Y2-Y1)/FLOAT(NX2+NX34/2)
        XE(II)=X
        YE(II)=Y
      END DO 
      X1=XSG1(2)
      X2=XSG1(3)
      Y1=YSG1(2)
      Y2=YSG1(3)
      DO I=1,NX34/2
        II=II+1
        X=X1+FLOAT(I)*(X2-X1)/FLOAT(NX34/2)
        Y=Y1+FLOAT(I)*(Y2-Y1)/FLOAT(NX34/2)
        XE(II)=X
        YE(II)=Y
      END DO
      NXRT=II
      N1RT=NNODE-NXRT
C
C     GENERATE NODE COORDINATES
C
      DO I=1,NXRT
        IK=I
        IF(I.LT.NX2+NX34/2+1) IK=1
        IF(I.GE.NX2+NX34/2+1) IK=NXRT
        X1=COORD(N1RT+IK,1)
        X2=COORD(N1RT+IK-NX123-1,1)
        Y1=COORD(N1RT+IK,2)
        Y2=COORD(N1RT+IK-NX123-1,2)
        EL0=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        X1=XB(I)
        Y1=YB(I)
        X2=XE(I)
        Y2=YE(I)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NY,EL0,RL,SCL)
        SC2(I)=SCL
        SL=0.0
        IN=N1RT+I
        DO J=1,NY
          IN=IN+NXRT
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(ABS(X).LT.1.0D-10) X=0.0
          IF(ABS(Y).LT.1.0D-10) Y=0.0
          IF(J.EQ.NY) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELU=EL0*SCL**NY
        IF(I.EQ.NXRT) ELR=EL0*SCL**NY
      END DO
C
C     GENERATE NODE DEFINITION 
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NXRT
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NXRT/2
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NXRT
            L5=L4+1
            L6=L5+1
            L7=L4+NXRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D8'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NXRT
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NXRT/2
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NXRT
            L5=L4+1
            L6=L5+1
            L7=L4+NXRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D9'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NXRT
        DO I=1,NY
          L1=L2
          DO J=1,NXRT-1
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NXRT
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INR1=IN
      INR2=INR1-NXRT
      INU1=IN-NXRT+1
      INU2=INU1-NXRT
C     WRITE(IO_WORK,904) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NXRT)
  904 FORMAT(' FRAME REGION II'/
     1 2(5X,2HXB,10X,2HYB,10X,2HXE,10X,2HYE,10X,2HSC,5X)
     1 /(2(5E12.4)))
      GOTO 1
C
C     GENERATING LEFT SIDE ELEMENT
C
C
      ELSE IF(STRING(1:8).EQ.'*LEFMESH') THEN
      READ(IO_INPUT,*) ILEFT
      ND0=NNODE
C
      DO IL=1,ILEFT
C
      READ(IO_INPUT,*) NLEFT,XLEFT,IMSET,NODE
C
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      CALL SEAND(NDYLF,1,XMIN,NYLF,1)
      IN1=NDYLF(1)
      IN2=IN1-NX123-1
      EL0=ELL
      RL=COORD(IN1,1)-XLEFT
      IF(NLEFT.GT.0) THEN
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        CALL SOLVSL(NLEFT,EL0,RL,SCL)
      ELSE IF(NLEFT.EQ.-999) THEN
        NLEFT=NINT(RL/EL0)
        IF(NODE.GE.8) NLEFT=2*NINT(RL/EL0/2.0)
        EL0=RL/NLEFT
        SCL=1.0
      ELSE
        NLEFT=IABS(NLEFT)
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        EL0=RL/NLEFT
        SCL=1.0
      END IF
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6000) SCL,NLEFT,EL0,RL
 6000 format(/' Suggest SCL in  left side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
        SCL=1.2
        B=RL*(SCL-1.0)/SCL/EL0+1.0
        NLEFT=LOG(B)/LOG(SCL)
        IF(NLEFT.LT.1) NLEFT=1
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        CALL SOLVSL(NLEFT,EL0,RL,SCL)
C       WRITE(IO_WORK,6001) scl,nleft,el0,rl
 6001   format(' SCL > SCMAX Program sets ',
     1   'that in  left side SCL=',F6.3,' N=',I2,
     1   ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
        NLEFT=RL/EL0
        IF(NLEFT.LT.1) NLEFT=1
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        EL0=RL/NLEFT
        SCL=1.0D0
C       WRITE(IO_WORK,6012) scl,nleft,el0,rl
 6012   format(' SCL < 1.0 Program sets ',
     1   'that in  left side SCL=',F6.3,' N=',I2,
     1   ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      X=COORD(IN1,1)
      DO K=1,NLEFT
      X=X-EL0*SCL**K
      IF(K.EQ.NLEFT) X=XLEFT
      DO I=1,NYLF
      IN=IN+1
      INP=NDYLF(I)
      Y=COORD(INP,2)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
      ELL=EL0*SCL**NLEFT
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT/2
          L1=L6-1
          DO I=1,NYLF/2
            L01=NDYLF(2*I-1)
            L02=NDYLF(2*I)
            L03=NDYLF(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYLF
            L5=L4+1
            L6=L5+1
            L7=L4+NYLF
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT/2
          L1=L6-1
          DO I=1,NYLF/2
            L01=NDYLF(2*I-1)
            L02=NDYLF(2*I)
            L03=NDYLF(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYLF
            L5=L4+1
            L6=L5+1
            L7=L4+NYLF
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT
          L1=L2
          DO I=1,NYLF-1
            L01=NDYLF(I)
            L02=NDYLF(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+NYLF
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L1
            LNODS(IE,3)=L2
            LNODS(IE,4)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NYLF+1
      INL2=INL1-NYLF
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NYLF
C
C     FOR LOOP IL=1,ILEFT
C
      END DO
C
      GOTO 1
      ELSE IF(STRING(1:8).EQ.'*RIGMESH') THEN
C
C     GENERATING RIGHT SIDE ELEMENT
C
      READ(IO_INPUT,*) IRIGT
      DO III=1,IRIGT
      READ(IO_INPUT,*) NRIGT,XRIGT,IMSET,NODE
C
      IF(NODE.GE.8) SCMAX=1.5
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      CALL SEAND(NDYRT,1,XMAX,NYRT,3)
      IN1=NDYRT(NYRT)
      IN2=IN1-NX123-1
      EL0=ELR
      RL=XRIGT-COORD(IN1,1)
      IF(NRIGT.GT.0) THEN
        IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
        CALL SOLVSL(NRIGT,EL0,RL,SCL)
      ELSE IF(NRIGT.EQ.-999) THEN
        NRIGT=NINT(RL/EL0)
        IF(NODE.GE.8) NRIGT=2*NINT(RL/EL0/2.0)
        EL0=RL/NRIGT
        SCL=1.0
      ELSE
        NRIGT=IABS(NRIGT)
        IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
        EL0=RL/NRIGT
        SCL=1.0
      END IF
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6002) SCL,NRIGT,EL0,RL
 6002 format(/' Suggest SCL in right side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
      SCL=0.9*SCMAX
      B=RL*(SCL-1.0)/SCL/EL0+1.0
      NRIGT=LOG(B)/LOG(SCL)
      IF(NRIGT.LT.1) NRIGT=1
      IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
      CALL SOLVSL(NRIGT,EL0,RL,SCL)
C     WRITE(IO_WORK,6003) scl,nrigt,el0,rl
 6003 format(' SCL > SCMAX Program sets ',
     1 'that in right side SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
      NRIGT=RL/EL0
      IF(NRIGT.LT.1) NRIGT=1
      IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
      EL0=RL/NRIGT
      SCL=1.0D0
C     WRITE(IO_WORK,6004) scl,nrigt,el0,rl
 6004 format(' SCL < 1.0 Program sets ',
     1 'that in right side SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      X=COORD(IN1,1)
      DO K=1,NRIGT
      X=X+EL0*SCL**K
      IF(K.EQ.NRIGT) X=XRIGT
      DO I=1,NYRT
      IN=IN+1
      INP=NDYRT(I)
      Y=COORD(INP,2)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
      ELR=EL0*SCL**NRIGT
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.GE.8) THEN
        L6=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT/2
          L1=L6-1
          DO I=1,NYRT/2
            L01=NDYRT(2*I-1)
            L02=NDYRT(2*I)
            L03=NDYRT(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYRT
            L5=L4+1
            L6=L5+1
            L7=L4+NYRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L9
            LNODS(IE,3)=L7
            LNODS(IE,4)=L1
            LNODS(IE,5)=L6
            LNODS(IE,6)=L8
            LNODS(IE,7)=L4
            LNODS(IE,8)=L2
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L03
              LNODS(IE,8)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT/2
          L1=L6-1
          DO I=1,NYRT/2
            L01=NDYRT(2*I-1)
            L02=NDYRT(2*I)
            L03=NDYRT(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYRT
            L5=L4+1
            L6=L5+1
            L7=L4+NYRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L9
            LNODS(IE,3)=L7
            LNODS(IE,4)=L1
            LNODS(IE,5)=L6
            LNODS(IE,6)=L8
            LNODS(IE,7)=L4
            LNODS(IE,8)=L2
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L03
              LNODS(IE,8)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT
          L1=L2
          DO I=1,NYRT-1
            L01=NDYRT(I)
            L02=NDYRT(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+NYRT
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L2
            LNODS(IE,2)=L4
            LNODS(IE,3)=L3
            LNODS(IE,4)=L1
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INR1=IN
      INR2=INR1-NYRT
      END DO
      GOTO 1
      ELSE IF(STRING(1:8).EQ.'*UPSMESH'.OR.
     &        STRING(1:8).EQ.'*DWNMESH') THEN
C
C     GENERATING UPPER SIDE ELEMENT
C
      KCASE = 1
      IF(STRING(1:8).EQ.'*DWNMESH') KCASE = 2
      READ(IO_INPUT,*) IUP
c     WRITE(IO_WRITE,*) ' IUP=',IUP
      DO III=1,IUP
c     WRITE(IO_WRITE,*) ' IUP=',III,NNODE,NELEM
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      IF(KCASE.EQ.1) THEN
        EL0=ELU
        CALL SEAND(NDU,2,YMAX,KU,1)
      ELSE IF(KCASE.EQ.2) THEN
        EL0=-ELD
        CALL SEAND(NDU,2,YMIN,KU,3)
      END IF
      READ(IO_INPUT,*) NUP,YUP,IMSET,NODE
C
      IN1=NDU(1)
      RL=YUP-COORD(IN1,2)
      IF(NUP.GT.0) THEN
        IF(NODE.GE.8) SCMAX=1.5
        IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
        CALL SOLVSL(NUP,EL0,RL,SCL)
      ELSE IF(NUP.EQ.-999) THEN
        NUP=NINT(RL/EL0)
        IF(NODE.GE.8) NUP=2*NINT(RL/EL0/2.0)
        EL0=RL/NUP
        SCL=1.0
      ELSE
        NUP=IABS(NUP)
        IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
        EL0=RL/NUP
        SCL=1.0
      END IF
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6006) SCL,NUP,EL0,RL
 6006 format(/' Suggest SCL in upper side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
      SCL=1.4
      B=RL*(SCL-1.0)/SCL/EL0+1.0
      NUP=LOG(B)/LOG(SCL)
      IF(NUP.LT.1) NUP=1
      IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
      CALL SOLVSL(NUP,EL0,RL,SCL)
C     WRITE(IO_WORK,6007) scl,nup,el0,rl
 6007 format(' SCL > SCMAX Program sets ',
     1 'that in upper side',' SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
      NUP=RL/EL0
      IF(NUP.LT.1) NUP=1
      IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
      EL0=RL/NUP
      SCL=1.0D0
C     WRITE(IO_WORK,6008) scl,nup,el0,rl
 6008 format(' SCL < 1.0 Program sets ',
     1 'that in upper side SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      Y=COORD(IN1,2)
      DO K=1,NUP
      Y=Y+EL0*SCL**K
      IF(K.EQ.NUP) Y=YUP
      DO I=1,KU
      IN=IN+1
      INP=NDU(I)
      X=COORD(INP,1)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-KU
        IE=NELEM
        DO J=1,NUP/2
          L1=L6-1
          DO I=1,KU/2
            L01=NDU(2*I-1)
            L02=NDU(2*I)
            L03=NDU(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+KU
            L5=L4+1
            L6=L5+1
            L7=L4+KU
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
            LNODS(IE,1)=L01
            LNODS(IE,2)=L03
            LNODS(IE,5)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-KU
        IE=NELEM
        DO J=1,NUP/2
          L1=L6-1
          DO I=1,KU/2
            L01=NDU(2*I-1)
            L02=NDU(2*I)
            L03=NDU(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+KU
            L5=L4+1
            L6=L5+1
            L7=L4+KU
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
            LNODS(IE,1)=L01
            LNODS(IE,2)=L03
            LNODS(IE,5)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-KU
        IE=NELEM
        DO J=1,NUP
          L1=L2
          DO I=1,KU-1
            L01=NDU(I)
            L02=NDU(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+KU
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,1)=L01
              LNODS(IE,2)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      N1=NNODE-KU+1
      N2=NNODE
      IF(KCASE.EQ.1) THEN
        ELU=EL0*SCL**NUP
      ELSE IF(KCASE.EQ.2) THEN
        ELD=EL0*SCL**NUP
      END IF
      END DO
      GOTO 1
      ELSE IF(STRING(1:8).EQ.'*CTPMESH') THEN
C
C     GENERATING CT SPECIMEN ELEMENT MESH
C
      READ(IO_INPUT,*) NXCT,XCT,IMSET,NODE
C
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      CALL SEAND(NCT,1,XMIN,NYCT,1)
      X_LDCT=COORD(NCT(1),1)
      EL0=ELL
      RL=X_LDCT-XCT
      IF(NXCT.GT.0) THEN
        IF(NODE.GE.8) SCMAX=1.5
        IF(NODE.GE.8.AND.INT(NXCT/2)*2.NE.NXCT) NXCT=NXCT+1
        CALL SOLVSL(NXCT,EL0,RL,SCL)
        IF(NXCT.LT.1) NXCT=1
      ELSE
        NXCT=-NXCT
        IF(NODE.GE.8.AND.INT(NXCT/2)*2.NE.NXCT) NXCT=NXCT+1
        EL0=RL/NXCT
        ELL=EL0
        SCL=1.0D0
      END IF
C     WRITE(IO_WORK,6009) nxct,el0,rl
 6009 format(/' left side of CT Specimen',' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4/)
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      X=X_LDCT
      DO K=1,NXCT
      X=X-EL0*SCL**K
      IF(K.EQ.NXCT) X=XCT
      DO I=1,NYCT
      IN=IN+1
      INP=NCT(I)
      Y=COORD(INP,2)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NYCT
        IE=NELEM
        DO J=1,NXCT/2
          L1=L6-1
          DO I=1,NYCT/2
            L01=NCT(2*I-1)
            L02=NCT(2*I)
            L03=NCT(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYCT
            L5=L4+1
            L6=L5+1
            L7=L4+NYCT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NYCT
        IE=NELEM
        DO J=1,NXCT/2
          L1=L6-1
          DO I=1,NYCT/2
            L01=NCT(2*I-1)
            L02=NCT(2*I)
            L03=NCT(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYCT
            L5=L4+1
            L6=L5+1
            L7=L4+NYCT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,27)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
      L2=NNODE-NYCT
      IE=NELEM
      DO J=1,NXCT
      L1=L2
      DO I=1,NYCT-1
      L01=NCT(I)
      L02=NCT(I+1)
      L1=L1+1
      L2=L1+1
      L3=L1+NYCT
      L4=L3+1
      IE=IE+1
      MATSET(IMSET,1)=MATSET(IMSET,1)+1
      MATSET(IMSET,MATSET(IMSET,1))=IE
      LNODS(IE,1)=L3
      LNODS(IE,2)=L1
      LNODS(IE,3)=L2
      LNODS(IE,4)=L4
      LNODS(IE,MXNOD)=NODE
      LNODS(IE,27)=IMSET
          ELTYP(IE)='C2D4'
      IF(J.EQ.1) THEN
      LNODS(IE,2)=L01
      LNODS(IE,3)=L02
      ENDIF
      CALL DNODE(IE,NODE)
      END DO
      END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
C
C     DETERMINING LDCT
C
      IN1=NCT(1)
      IN2=NCT(NYCT)
      YEB=COORD(IN2,2)-COORD(IN1,2)
      YEB=YEB*2.0/3.0
      YEB=ABS(YEB)
      Y23=1.E20
      DO I=1,NYCT
      IN=NCT(I)
      Y=COORD(IN,2)
      IF(ABS(Y-YEB).LT.Y23) THEN
      LDCT=IN
      Y23=ABS(Y-YEB)
      END IF
      END DO
      WRITE(IO_WRITE,1010) LDCT,COORD(LDCT,2)
 1010 format(5x,'LDCT=',I5,2X,'Y=',E12.5)
      N1T=N1T+1
      N1OUT(N1T)=LDCT
      GOTO 1
      ELSE IF(STRING(1:7).EQ.'*MESHVL') THEN
        CALL MESHVL
        GOTO 1
      ELSE
        GOTO 1
      END IF
   99 CONTINUE
C
C     NODE COORDINATES TRANSLATION
C
      DO I=1,NNODE
      COORD(I,1)=COORD(I,1)+XORIGN
      COORD(I,2)=COORD(I,2)+YORIGN
      END DO
      N1OUT(1)=N1T
C
      TEXT='END OF EXCUTING SUB. MESH1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  999 CONTINUE
      WRITE(IO_WRITE,1000)
 1000 FORMAT(41H !!! '*END MESH1' NOT FOUND, PROGRAM STOP)
      STOP
      END
