C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE IPLMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(200),YB(200),XE(200),YE(200),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(200),SC2(200),N1OUT(1000),
     2 NDYLF(500),NDYRT(500),NDU(500),NDDWN(500),NCT(500),
     & NOUTCL(1000),MSEC(10),SECCD(1000,2,2),SECXY(10,5)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. IPLMESH'
      TEXT='NOW EXCUTING SUB. IPLMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
      READ(IO_INPUT,*) NY,IMSET,NODE
C
      KEY_PL=0
      IF(NY.LT.0) THEN
        KEY_PL=1
        NY=-NY
      END IF
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NY/2)*2.NE.NY) NY=NY+1
      IF(NODE.EQ.8) THEN
        L6=NNODE-NX123-1
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK3)
              LNODS(IE,5)=NXYB(IK2)
            END IF
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NX123-1
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK3)
              LNODS(IE,5)=NXYB(IK2)
            END IF
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=NNODE-(NX123+1)
        DO I=1,NY
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX123+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            IF(I.EQ.1) THEN
              IK1=J
              IK2=J+1
              LNODS(IE,1)=NXYB(IK1)
              LNODS(IE,2)=NXYB(IK2)
            END IF
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
C
      READ(IO_INPUT,*) (XSG(I),YSG(I),I=1,5)
c     WRITE(IO_WRITE,'(2E20.12)') (XSG(I),YSG(I),I=1,5)
      XE(1)=XSG(1)
      YE(1)=YSG(1)
      II=1
      X1=XSG(1)
      Y1=YSG(1)
      X2=XSG(2)
      Y2=YSG(2)
      DO J=1,NX1
        II=II+1
        X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX1)
        Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX1)
        XE(II)=X
        YE(II)=Y
      END DO
      X1=XSG(2)
      Y1=YSG(2)
      X2=XSG(3)
      Y2=YSG(3)
      DO J=1,NX2
        II=II+1
        X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX2)
        Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX2)
        XE(II)=X
        YE(II)=Y
      END DO
      DO I=3,4
        X1=XSG(I)
        Y1=YSG(I)
        X2=XSG(I+1)
        Y2=YSG(I+1)
        DO J=1,NX34/2
          II=II+1
          X=X1+FLOAT(J)*(X2-X1)/FLOAT(NX34/2)
          Y=Y1+FLOAT(J)*(Y2-Y1)/FLOAT(NX34/2)
          XE(II)=X
          YE(II)=Y
        END DO
      END DO
      II=NNODE-NX123-1
      DO I=1,NX123+1
        II=NXYB(I)
        XB(I)=COORD(II,1)
        YB(I)=COORD(II,2)
      END DO
C
C     GENERATE NODE COORDINATES
C
      EL0=ELL
      IF(EL0.LT.ELU) EL0=ELU
      IF(EL0.LT.ELR) EL0=ELR
      DO I=1,NX123+1
        X1=XB(I)
        Y1=YB(I)
        X2=XE(I)
        Y2=YE(I)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NY,EL0,RL,SCL)
        IF(SCL.LT.1.0.OR.KEY_PL.EQ.1) THEN
          SCL=1.0
          EL0=RL/NY
          ST=RL/EL0
        END IF
        SC2(I)=SCL
        SL=0.0
        IN=NNODE-NX123-1+I
        DO J=1,NY
          IN=IN+NX123+1
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(J.EQ.NY) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELL=EL0*SCL**NY
        IF(I.EQ.NX12+1) ELU=EL0*SCL**NY
        IF(I.EQ.NX123+1) ELR=EL0*SCL**NY
      END DO
C
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NX123
      INL2=INL1-NX123-1
      INR1=IN
      INR2=INR1-NX123-1
      INU1=IN-NX34
      INU2=INU1-NX123-1
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NX123
C     WRITE(IO_WORK,903) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NX123+1)
C     WRITE(IO_WORK,*) ' INL1',INL1,INL2,INR1,INR2
C
C     NODE COORDINATES TRANSLATION
C
C     DO I=1,NNODE
C     COORD(I,1)=COORD(I,1)+XORIGN
C     COORD(I,2)=COORD(I,2)+YORIGN
C     END DO
      N1OUT(1)=N1T
C
      TEXT='END OF EXCUTING SUB. IPLMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  999 CONTINUE
      WRITE(IO_WRITE,1000)
 1000 FORMAT(41H !!! '*END MESH1' NOT FOUND, PROGRAM STOP)
      STOP
      END
