C
C     Output ABAQUS history input
C
      SUBROUTINE SHISTORY
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*3 MOD,ECHO,HISTORY,MODEL
      CHARACTER*6 CTYPE
      CHARACTER REPFIL*25,LOAD_KEY*10,LOAD_SET*8,
     &  COMMD(50)*160,MCOMMD*160
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. SHISTORY'
C
      IREPT  = 0
      ICOMMD = 0
      JD5FQ  = 0
      SYMM(1)=',SYMM '
      SYMM(2)='      '
      PI=4.0*DATAN(1.0D0)
      IF(NTNUM.EQ.0) NTNUM=1
      KSTEP=0
C
C     **************** PRINT OUTPUT VARIABLES ****************
C
  10  CONTINUE
      CALL GETLINE (LEN,IERR)
C
      IF(STRING(1:6).EQ.'*END M') THEN
        GOTO 20
      ELSE IF((STRING(1:5).EQ.'PRINT').OR. 
     &        (STRING(1:6).EQ.'*PRINT')) THEN
         CALL LOCCHR(STRING,'NOP',3,1,K1,K2)
         IF(K2.GE.K1) THEN
 	   NNPRIN = 2
 	   NENPRIN(1,1) = 0
 	   NENPRIN(1,2) = 11
 	   NENPRIN(1,1) = 0
 	   NENPRIN(1,2) = 2
 	   CENPSET(1)   = CNDSET(1)
 	   CENPSET(2)   = "E0000001"
 	   NPVAR(1)     = 1
 	   NPVAR(2)     = 1
 	   PRI_VAR(1,1) = "U"
 	   PRI_VAR(1,2) = "S"
         ELSE
            CALL GETLINE (LEN,IERR)
	    INVAR = 1
	    ITYPE(1) = 1
            CALL SLVLINE (STRING,LEN,IERR)
	    NNPRIN = IVARR(1)
c           WRITE(IO_WRITE,*) NNPRIN
            DO I=1,NNPRIN
	       INVAR = 3
	       ITYPE(1) = 1
	       ITYPE(2) = 1
	       ITYPE(3) = -8
               CALL GETLINE (LEN,IERR)
               CALL SLVLINE (STRING,LEN,IERR)
               NENPRIN(I,1) = IVARR(1)
               NENPRIN(I,2) = IVARR(2)
               IF (IVARR(2).NE.11) CENPSET(I)   = CVARR(3)(1:8)
c-----------   WRITE(IO_WRITE,200) NENPRIN(I,1),NENPRIN(I,2),CENPSET(I)
               CALL GETLINE (LEN,IERR)
	       INVAR = 1
	       ITYPE(1) = 1
               CALL SLVLINE (STRING,LEN,IERR)
	       NPVAR(I) = IVARR(1)
               READ(IO_INPUT,201) (PRI_VAR(K,I),K=1,NPVAR(I))
c-----------   WRITE(IO_WRITE,201) NPVAR(I),(PRI_VAR(K,I),K=1,NPVAR(I))
            END DO
	 END IF
         GOTO 10
  200 FORMAT(2I5,10A8)
  201 FORMAT(A)
C
C     **************** INPUT LOAD INFORMATION ****************
C
C     LOAD_KEY:'BLF     ' FOR BOUNDARY LAYER FORMULATION ANALYSIS
C              'CLOAD   ' PINOT LOAD        - SETS   TYPE INPUT
C              'DLOAD   ' DISTRIBUTED LOAD  - SETS   TYPE INPUT
C              'BOUNDARY' DISPLACEMENT LOAD - SETS   TYPE INPUT
C              'PF      ' PINOT LOAD        - POINTS TYPE INPUT
C              'PU      ' DISPLACEMENT LOAD - POINTS TYPE INPUT
C
      ELSE IF((STRING(1:4).EQ.'LOAD').OR. 
     &        (STRING(1:5).EQ.'*LOAD')) THEN
C
         CALL GETLINE (LEN,IERR)
	 LOAD_KEY = STRING
         IF(LOAD_KEY(1:4).EQ.'BLFBP') THEN
            CALL BLFBPV
         ELSE IF(LOAD_KEY(1:4).EQ.'BLFB') THEN
           CALL BLFBVV
         ELSE IF(LOAD_KEY(1:3).EQ.'BLF') THEN
           CALL GETLINE (LEN,IERR)
	   INVAR = 11
	   DO I=1,11
	      ITYPE(I) = 2
	   ENDDO
           CALL SLVLINE (STRING,LEN,IERR)
           PHI    = RVARR(1)
	   BPARA  = RVARR(2)
	   YOUNG  = RVARR(3)
	   POISS  = RVARR(4)
	   SIGMA0 = RVARR(5)
           BLF_X0 = RVARR(6)
	   BLF_Y0 = RVARR(7)
	   BLF_R0 = RVARR(8)
	   NOTCH  = RVARR(9)
	   BTA    = RVARR(10)
	   RDA    = RVARR(11)
           IF(SIGMA0.LE.0.0) SIGMA0=300.0D0
           PHI  = PHI*PI/180.0E0
           AKIB = 1.0D0
           AKI1 = COS(PHI)
           AKI2 = SIN(PHI)
         ELSE
           CALL GETLINE (LEN,IERR)
	   INVAR = 1
	   ITYPE(1) = 1
           CALL SLVLINE (STRING,LEN,IERR)
           NLOADSET = IVARR(1)
C          WRITE(IO_WRITE,'(" NLOADSET=",I5)') NLOADSET
           DO I=1,NLOADSET
             CALL GETLINE (LEN,IERR)
	     INVAR = 2
	     ITYPE(1) = 1
	     ITYPE(2) = -8
             CALL SLVLINE (STRING,LEN,IERR)
	     ILOADDOF(I) = IVARR(1)
	     CLOADSET(I) = CVARR(2)
             CALL GETLINE (LEN,IERR)
	     INVAR = 1
	     ITYPE(1) = 2
             CALL SLVLINE (STRING,LEN,IERR)
	     PLOADSCL(I) = RVARR(1)
C            WRITE (IO_WRITE,'(I5,A8,F12.5)') 
C    &               ILOADDOF(I),CLOADSET(I),PLOADSCL(I)
           END DO
         END IF
         GOTO 10
C
C     **************** FILES OUTPUT VARIABLES ****************
C
      ELSE IF((STRING(1:4).EQ.'FILE').OR. 
     &        (STRING(1:5).EQ.'*FILE')) THEN
C
         CALL GETLINE (LEN,IERR)
	 INVAR = 1
	 ITYPE(1) = 1
         CALL SLVLINE (STRING,LEN,IERR)
	 NFPRIN = IVARR(1)
c        WRITE(IO_WRITE,*) NFPRIN
         DO I=1,NFPRIN
	    INVAR = 3
	    ITYPE(1) = 1
	    ITYPE(2) = 1
	    ITYPE(3) = -8
            CALL GETLINE (LEN,IERR)
            CALL SLVLINE (STRING,LEN,IERR)
            NFLPRIN(I,1) = IVARR(1) 
	    NFLPRIN(I,2) = IVARR(2)
            CFLPSET(I)   = CVARR(3)(1:8)
c           WRITE(IO_WRITE,200) NFLPRIN(I,1),NFLPRIN(I,2),CFLPSET(I)
            CALL GETLINE (LEN,IERR)
	    INVAR = 1
	    ITYPE(1) = 1
            CALL SLVLINE (STRING,LEN,IERR)
	    NFVAR(I) = IVARR(1)
            READ(IO_INPUT,201) (FIL_VAR(K,I),K=1,NFVAR(I))
c           WRITE(IO_WRITE,201)  
c    &       NPVAR(I),(FIL_VAR(K,I),K=1,NPVAR(I))
         END DO
         GOTO 10
C
      ELSE IF((STRING(1:4).EQ.'J-IN').OR. 
     &        (STRING(1:5).EQ.'*J-IN')) THEN
C
         CALL GETLINE (LEN,IERR)
	 INVAR = 6
	 DO I=1,3
	    ITYPE(I) = 1
	    ITYPE(I+3) = 2
	 ENDDO
         CALL SLVLINE (STRING,LEN,IERR)
	 JFRE   = IVARR(1)
	 JCOUNT = IVARR(2)
	 JSYSM  = IVARR(3)
	 CNX    = RVARR(4)
	 CNY    = RVARR(5)
	 CNZ    = RVARR(6)
         IF(CNX.EQ.0.0.AND.CNY.EQ.0.0.AND.CNZ.EQ.0.0) THEN
           CNX = 0.0
           CNY = 1.0
           CNZ = 0.0
         END IF
         JFRE0=JFRE
	 IF (JSYSM .NE. 1) JSYSM = 2
         GOTO 10
      ELSE IF(STRING(1:7).EQ.'DELTA 5'.OR.  
     &        STRING(1:8).EQ.'*DELTA 5') THEN
         CALL GETLINE (LEN,IERR)
	 INVAR = 5
	 ITYPE(1) = 1
	 ITYPE(2) = 1
	 ITYPE(3) = 2
	 ITYPE(4) = 2
	 ITYPE(5) = 2
         CALL SLVLINE (STRING,LEN,IERR)
	 JD5FQ  = IVARR(1)
	 JD5DIM = IVARR(2)
	 D5X    = RVARR(3)
	 D5Y    = RVARR(4)
	 D5Z    = RVARR(5)
         JD5FQ0=JD5FQ
         GOTO 10
      ELSE IF(STRING(1:7).EQ.'COMMAND'.OR.
     &        STRING(1:7).EQ.'*COMMAN') THEN
         CALL GETLINE (LEN,IERR)
	 INVAR = 1
	 ITYPE(1) = 1
         CALL SLVLINE (STRING,LEN,IERR)
	 ICOMMD = IVARR(1)
         READ(IO_INPUT,'(A)') (COMMD(K),K=1,ICOMMD)
         GOTO 10
      ELSE IF(STRING(1:4).EQ.'WAVE'.OR.
     &        STRING(1:4).EQ.'*WAV') THEN
         WRITE(IO_OUTP,2000)
 2000    FORMAT('*WAVEFRONT MINIZATION,','SUPPRESS')
         GOTO 10
      ELSE IF(STRING(1:12).EQ.'MODE COMMAND'.OR.  
     &        STRING(1:12).EQ.'*MODE COMMAN') THEN
         CALL GETLINE (LEN,IERR)
	 INVAR = 1
	 ITYPE(1) = 1
         CALL SLVLINE (STRING,LEN,IERR)
	 NCOMMD = IVARR(1)
         DO K=1,NCOMMD
            READ(IO_INPUT,'(A)') MCOMMD
            LEN = 160
            CALL DTEXT(MCOMMD,LEN)
            WRITE(IO_OUTP,'(A)') MCOMMD(1:LEN)
         END DO
         GOTO 10
C
C     **************** STEP CONTROL INFORMATION ****************
C
      ELSE IF(STRING(1:4).EQ.'STEP'.OR.STRING(1:4).EQ.'*STE') THEN
C
C------  PREPRINT INFORMATION
         CALL GETLINE (LEN,IERR)
	 INVAR = 3
	 ITYPE(1) = -3
	 ITYPE(2) = -3
	 ITYPE(3) = -3
         CALL SLVLINE (STRING,LEN,IERR)
	 ECHO = CVARR(1)
	 HISTORY = CVARR(2)
	 MODEL   = CVARR(3)
         WRITE(IO_OUTP,2001) ECHO,HISTORY,MODEL
 2001    FORMAT('*PREPRINT',',ECHO=',A3,',HISTORY=',A3,',MODEL=',A3)
         IRIKS  = 0
         PRIKS  = 0.0
         MONND  = 0
         MONFR  = 0
         VMONI  = 0.0
         STRING = ' '
C
C------  STEP INFORMATION
         CALL GETLINE (LEN,IERR)
	 INVAR = 8
	 ITYPE(1) = 1
	 ITYPE(2) = 2
	 ITYPE(3) = 2
	 ITYPE(4) = 1
	 ITYPE(5) = 2
	 ITYPE(6) = 1
	 ITYPE(7) = 1
	 ITYPE(8) = 2
         CALL SLVLINE (STRING,LEN,IERR)
         NT = IVARR(1)
         P0 = RVARR(2)
         PN = RVARR(3)
         IRIKS = IVARR(4)
         PRIKS = RVARR(5)
         MONND = IVARR(6)
         MONFR = IVARR(7)
         VMONI = RVARR(8)
         CALL GETLINE (LEN,IERR)
	 INVAR = 4
	 DO I = 1,4
	    ITYPE(I) = 1
	 ENDDO
         CALL SLVLINE (STRING,LEN,IERR)
         INC    = IVARR(1)
         NLGEOM = IVARR(2)
         KSTEP  = IVARR(3)
         INCRE  = IVARR(4)
         GOTO 10
      ELSE IF(STRING(1:1).EQ.'*') THEN
         BACKSPACE IO_INPUT
         GOTO 20
      ELSE
         GOTO 10
      END IF
C
   20 CONTINUE
C
      T2=1.0
      T3=1.E-6
      MT=0
      PP=P0
      IF(LOAD_KEY(1:4).EQ.'BLF '.AND.NOTCH.EQ.0) CALL BLFVV
      IF(LOAD_KEY(1:3).EQ.'BLF'.AND.NOTCH.EQ.1) CALL BLFVV1
      IF(LOAD_KEY(1:3).EQ.'BLF'.AND.NOTCH.EQ.2) CALL BLFVV2
      IF(LDCT.NE.0) CALL LOAD_CT3DF
      IOVERLAY=0
      CALL GETLINE (LEN,IERR)
      IF(KSTEP.NE.0) CALL RESTART(3,NREST,IOVERLAY,KSTEP,INCRE)
C
      WRITE(IO_INFO,'(///5X,A//)') 'LOAD information :'
      WRITE(IO_WRITE ,'(///5X,A//)') 'LOAD information :'
C
C     **************** BEGIN HISTORY LOOP ****************
C
C     THS     ->   Thermal stress in this load step
C     TS      ->   T-stress in this load step
C    
      DO IS=1,NT
         CALL GETLINE (LEN,IERR)
	 INVAR = 13
	 ITYPE(1) = 1
	 DO I = 2,6
	    ITYPE(I) = 2
	 ENDDO
	 DO I = 7,13
	    ITYPE(I) = 1
	 ENDDO
         CALL SLVLINE (STRING,LEN,IERR)
	 NN     = IVARR(1)
	 DP     = RVARR(2)
	 THS    = RVARR(3)
	 TS     = RVARR(4)
	 T1     = RVARR(5)
	 T4     = RVARR(6)
	 NPFRE  = IVARR(7)
	 IPLOTK = IVARR(8)
	 IFILFREQ = IVARR(9)
	 KERNEL = IVARR(10)
	 KRESTART= IVARR(11)
	 IDISC  = IVARR(12)
	 INC_TIM= IVARR(13)
         IF(IFILFREQ.LE.0) THEN
            JFRE=0
            DO I=1,NFPRIN
               NFLPRIN(I,1)=0
            END DO
         END IF
         DD=DP
         DO J=1,NN
C
C     **************** WRITE STEP INFORMATION ****************
C
          IF(NLGEOM.EQ.0)  WRITE(IO_OUTP,4000) INC
          IF(NLGEOM.EQ.1) WRITE(IO_OUTP,4001) INC
 4000     FORMAT(1H*,5HSTEP,,4HINC=,I4)
 4001     FORMAT(1H*,5HSTEP,,4HINC=,I4,2H, ,6HNLGEOM)
          MT=MT+1
          PP=PP+DD
C
C     **************** WRITE HISTORY INFORMATION ****************
C
          II=MT+KSTEP
          X=COORD(NNODE,1)
          Y=COORD(NNODE,2)
          RK=DSQRT((X-XORIGN)*(X-XORIGN)+(Y-YORIGN)*(Y-YORIGN))
          IF(RK.EQ.0) RK=1.0
          IF(BPARA.NE.0.0) TSTRES=BPARA*PP/DSQRT(PI*RK)
          IF(TS.NE.0.0) TSTRES=TS*SIGMA0    
          IF(THS.NE.0.0) THSTR=THS*SIGMA0    
          IF(LOAD_KEY(1:4).EQ.'BLFB') THEN
            PHAI = PHI*180.0/PI
            WRITE(IO_INFO ,4910) AFA,BFA
            WRITE(IO_WRITE,4910) AFA,BFA
            WRITE(IO_OUTP ,4910) AFA,BFA
            IF(THS.NE.0.0E0) THEN
              WRITE(IO_INFO ,4911) THSTR,THS
              WRITE(IO_WRITE,4911) THSTR,THS
              WRITE(IO_OUTP ,4911) THSTR,THS
            END IF
            WRITE(IO_INFO,900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0,
     &      JFRE,KRESTART/100
            WRITE(IO_WRITE,900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0,
     &      JFRE,KRESTART/100
            WRITE(IO_OUTP,4900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0,
     &      JFRE,KRESTART/100
          ELSE IF(LOAD_KEY(1:3).EQ.'BLF') THEN
            PHAI = PHI*180.0/PI
            WRITE(IO_INFO,900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0
            WRITE(IO_WRITE,900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0
            WRITE(IO_OUTP,4900) II,PP,PHAI,TSTRES,TSTRES/SIGMA0
          ELSE IF(LOAD_KEY(1:5).EQ.'CLOAD') THEN
            WRITE(IO_INFO,901) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_WRITE ,901) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_OUTP,4901) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
          ELSE IF(LOAD_KEY(1:5).EQ.'DLOAD') THEN
            WRITE(IO_INFO,902) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_WRITE ,902) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_OUTP,4902) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
          ELSE IF(LOAD_KEY(1:5).EQ.'BOUND') THEN
            WRITE(IO_INFO,903) 
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_WRITE ,903)
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
            WRITE(IO_OUTP,4903)
     &      (II,PP*PLOADSCL(I),ILOADDOF(I),CLOADSET(I),I=1,NLOADSET)
          ELSE IF(LDCT.NE.0) THEN
            CT_X=COORD(LDCT_3D(2),1)
            CT_Y=COORD(LDCT_3D(2),2)
            WRITE(IO_INFO,904) II,PP,CT_X,CT_Y
            WRITE(IO_WRITE ,904) II,PP,CT_X,CT_Y
            WRITE(IO_OUTP,4904) II,PP,CT_X,CT_Y
          END IF
C         WRITE(7,900) II,PP,TSTRES,TSTRES/SIGMA0    
  900 FORMAT(5X,'Load STEP =',I4,2X,'K =',G12.5,' PHAI=',F6.2,
     & ' T-STRESS=',G12.5,2X,'T/Sig0=',F7.3,2X,'PFQ=',I4,2X,'RFQ=',I4)
  901     FORMAT(5X,'Load STEP =',I2,2X,'CLOAD =',E12.5,
     &    2X,'DOF =',I2,2X,'LOAD SET=',A8)
  902     FORMAT(5X,'Load STEP =',I2,2X,'DLOAD =',E12.5,
     &    2X,'DOF =',I2,2X,'LOAD SET=',A8)
  903     FORMAT(5X,'Load STEP =',I2,2X,'DISPLACEMENT =',E12.5,
     &    2X,'DOF =',I2,2X,'LOAD SET=',A8)
  904     FORMAT(5X,'Load STEP =',I2,2X,'CT SPECIMEN LOAD =',
     &    E12.5,2X,'LOAD POSITION - X =',E11.4,2X,'Y =',E11.4)
 4900 FORMAT(2H**,2X,'Load STEP =',I4,2X,'K =',G12.5,' PHAI=',F6.2,
     & ' T-STRESS=',G12.5,2X,'T/Sig0=',F7.3,2X,'PFQ=',I4,2X,'RFQ=',I4)
 4910 FORMAT(2H**,'Bimaterial interfacial crack - BLF:',
     &       2X,'ALPHA = ',F7.4,' BETA =',F7.4)
 4911 FORMAT(2H**,'Thermal residual stress parallel to interface:',
     &       2X,'TRS = ',G10.4,' TRS/SIG0 =',F7.4)
 4901     FORMAT('**',2X,'Load STEP =',I2,2X,'CLOAD=',E12.5,
     &    2X,'DOF=',I1,2X,'LOAD SET=',A8)
 4902     FORMAT('**',2X,'Load STEP =',I2,2X,'DLOAD=',E12.5,
     &    2X,'DOF=',I1,2X,'LOAD SET=',A8)
 4903     FORMAT('**',2X,'Load STEP =',I2,2X,'DISPLACEMENT=',E12.5,
     &    2X,'DOF=',I1,2X,'LOAD SET=',A8)
 4904     FORMAT('**',2X,'Load STEP =',I2,2X,'CT SPECIMEN LOAD=',
     &    E12.5,2X,'LOAD POSITION: X =',E11.4,2X,'Y =',E11.4)
C
          IF(IRIKS.EQ.0.OR.MT.LT.NT*NN) THEN
             WRITE(IO_OUTP,4100) 
             WRITE(IO_OUTP,4101) T1,T2,T3,T4
          ELSE
             WRITE(IO_OUTP,4110) 
             WRITE(IO_OUTP,4111) T1,T2,T3,T4,
     &       PRIKS,MONND,MONFR,VMONI
          ENDIF
	  IF (KRESTART.GT.100) THEN
             NREST=KRESTART/100
             IOVERLAY=KRESTART - NREST*100
	  ELSE
	     IF (KRESTART.LT.0) IOVERLAY=1
	     NREST = ABS(KRESTART)
	  ENDIF
          II0=INC_TIM/100
          IIR=INC_TIM-II0*100
	  IIMAX = MAX(II0,IIR,15)
          ISTEP=0
          INCRE=0
          IF(NREST.GT.0) CALL RESTART(1,NREST,IOVERLAY,ISTEP,INCRE)
          IF(IDISC.GT.0) WRITE(IO_OUTP,4211)
          IF(KERNEL.GT.0) WRITE(IO_OUTP,4201) 
          IF(INC_TIM.GT.0) WRITE(IO_OUTP,4202) II0,IIR,IIMAX,IIMAX
          IF(ICOMMD.NE.0) THEN
            DO K=1,ICOMMD
              STRING=' '
              STRING=COMMD(K)
              LEN   = 160
              CALL DTEXT(STRING,LEN)
              WRITE(IO_OUTP,'(A)') STRING(1:LEN)
            END DO
          END IF
 4100     FORMAT('*STATIC')
 4110     FORMAT('*STATIC,RIKS')
 4101     FORMAT(F8.4,3(',',F8.4))
 4111     FORMAT(F8.4,3(',',F8.4),',',F10.4,',',I5,',',I1,',',F8.6)
 1000     FORMAT(I11,1X,A5,F20.7)
 4201     FORMAT('*CONTROLS,PARAMETERS=LINE SEARCH',/,'4,4.0,0.05')
 4202     FORMAT('*CONTROLS,PARAMETERS=TIME INCREMENTATION'/4(I4,','))
 4211     FORMAT('*CONTROLS,ANALYSIS=DISCONTINUOUS')
 4400     FORMAT('*DELTA_5,FREQUENCY=',I5,',OUTPUT=BOTH')
 4401     FORMAT(I5,3F10.5)
 4500     FORMAT(A)
C
C     **************** IMPOSE LOAD HISTORY *****************
C
      IF(LOAD_KEY(1:3).EQ.'BLF') THEN
      PLOAD=PP
      CALL LOAD0(PLOAD)
      ELSE IF(LOAD_KEY(1:5).EQ.'CLOAD') THEN
      PLOAD=PP
      CALL CLOAD(PLOAD)
      ELSE IF(LOAD_KEY(1:5).EQ.'DLOAD') THEN
      PLOAD=PP
      CALL DLOAD(PLOAD)
      ELSE IF(LOAD_KEY(1:5).EQ.'BOUND') THEN
      PLOAD=PP
      CALL LOAD2(PLOAD)
      ELSE IF(LDCT.NE.0) THEN
        PLOAD=PP
        CALL LOAD_CT3DO(PLOAD)
      END IF
C
C     **************** WRITE PRINT INFORMATION ****************
C
      CALL ENPRIN
C
C     **************** WRITE FILE INFORMATION ****************
C
      CALL FILPRIN(LOAD_KEY)
C
C     **************** WRITE J-INTEGRAL INFORMATION ****************
C
      IF(JFRE0.NE.0) THEN
        IF(IFRONT.EQ.0) THEN
          WRITE(IO_OUTP,8000) JFRE,JCOUNT,SYMM(JSYSM)
          WRITE(IO_OUTP,8001) CNX,CNY,CNZ,('JN',CNUM(K),K=1,NTNUM)
        ELSE IF(IFRONT.EQ.1) THEN
          DO K=1,NTNUM
            WRITE(IO_OUTP,8000) JFRE,JCOUNT,SYMM(JSYSM)
            THN=TCFRONT(K)
            CNX=SIN(THN)
            CNY=1.0
            CNZ=COS(THN)
            WRITE(IO_OUTP,8001) CNX,CNY,CNZ,'JN',CNUM(K)
          END DO
        ENDIF
      ENDIF
 8000 FORMAT('*CONTOUR INTEGRAL,FREQUENCY=',I4,',CONTOUR=',
     1 I3,',OUTPUT=BOTH',',NORMAL',A6)
 8001 FORMAT(3F10.6/(16(A2,A2,1X)))
      IF(JD5FQ.NE.0) THEN
        JD5FQ=JD5FQ0
        WRITE(IO_OUTP,4400) JD5FQ
        WRITE(IO_OUTP,4401) JD5DIM,D5X,D5Y,D5Z
      END IF
      WRITE(IO_OUTP,8900) NPFRE
 8900 FORMAT('*PRINT,FREQUENCY=',I3)
      WRITE(IO_OUTP,9000)
 9000 FORMAT(9H*END STEP)
C
C     END OF LOOP 1 TO NN
C
      END DO
C
C     END OF LOOP 1 TO NT
C
      END DO
      RETURN
      END
C
      SUBROUTINE ENPRIN
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      IF(NNPRIN.NE.0) THEN
      DO I=1,NNPRIN
      NFRE=NENPRIN(I,1)
      IKEY=NENPRIN(I,2)
      IFMT=1000+IKEY*1000
      IF(IKEY.EQ.1) THEN
         WRITE(IO_OUTP,2000) NFRE,CENPSET(I)
      ELSE IF(IKEY.EQ.11) THEN
         WRITE(IO_OUTP,2010) NFRE
      ELSE IF(IKEY.EQ.2) THEN
         WRITE(IO_OUTP,3000) NFRE,CENPSET(I)
      ENDIF
      WRITE(IO_OUTP,3001) (PRI_VAR(K,I),K=1,NPVAR(I))
      END DO
      END IF
 2000 FORMAT('*NODE PRINT, GLOBAL=YES,FREQUENCY=',I3,', NSET=',A8)
 2010 FORMAT('*NODE PRINT, GLOBAL=YES,FREQUENCY=',I3)
 3000 FORMAT('*EL PRINT,FREQUENCY=',I3,',ELSET=',A8)
 3001 FORMAT(A)
      RETURN
      END
C
      SUBROUTINE FILPRIN(LOAD_KEY)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER LOAD_KEY*10
C
      IF(NFPRIN.NE.0) THEN
      DO I=1,NFPRIN
         NFRE=NFLPRIN(I,1)
         IKEY=NFLPRIN(I,2)/100
         IKEY2=NFLPRIN(I,2)-IKEY*100
         IFMT=1000+IKEY*1000
         IF(NFRE.NE.0) THEN
            IF(IKEY.EQ.1) THEN
               WRITE(IO_OUTP,2000) NFRE,CFLPSET(I)
            ELSE IF(IKEY.EQ.11) THEN
               WRITE(IO_OUTP,2001) NFRE
            ELSE IF(IKEY.EQ.2) THEN
               IF(IKEY2.EQ.1) THEN
                  WRITE(IO_OUTP,5001) NFRE,CFLPSET(I)
               ELSE IF(IKEY2.EQ.2) THEN
                  WRITE(IO_OUTP,5002) NFRE,CFLPSET(I)
               ELSE IF(IKEY2.EQ.3) THEN
                  WRITE(IO_OUTP,5003) NFRE,CFLPSET(I)
               ENDIF
            ENDIF
            WRITE(IO_OUTP,3001) (FIL_VAR(K,I),K=1,NFVAR(I))
         ENDIF
      END DO
C
C     Write file output for LOAD
C
      IF(LOAD_KEY(1:5).EQ.'DLOAD') THEN
        DO I=1,NLOADSET
           IF(ILOADDOF(I).GT.0) THEN
C             WRITE(IO_OUTP,5001) NFRE,CLOADSET(I)
C             WRITE(IO_OUTP,'(A)') 'LOADS'
           ELSE
              DO K=1,7
                IF(CLOADSET(I).EQ.CESET(K)) GOTO 10
              END DO
   10         CONTINUE
              NN=KIDFACE(1,K)
              DO J=2,NN
                ID_FACE=KIDFACE(J,K)
                STRING(1:5)='ELSET'
                WRITE(STRING(6:6),'(I1)') K
                STRING(7:7)='_'
                WRITE(STRING(8:8),'(I1)') ID_FACE
                WRITE(IO_OUTP,5001) NFRE,STRING(1:8)
                WRITE(IO_OUTP,'(A)') 'LOADS'
              END DO
           END IF
        END DO
      END IF
C
      END IF
C     IF(JFRE0.NE.0) THEN
C     WRITE(IO_OUTP,8000) JFRE,JCOUNT,SYMM(JSYSM)
C     WRITE(IO_OUTP,8001) ('JN',CNUM(K),K=1,NTNUM)
C     ENDIF
 2000 FORMAT('*NODE FILE,GLOBAL=YES,FREQUENCY=',I3,',NSET=',A8)
 2001 FORMAT('*NODE FILE,GLOBAL=YES,FREQUENCY=',I3)
 3000 FORMAT('EL FILE,FREQUENCY=',I3,',ELSET=',A8)
 3001 FORMAT(A)
 5001 FORMAT('*EL FILE,FREQUENCY=',I3,',ELSET=',A8)
 5002 FORMAT('*EL FILE,FREQUENCY=',I3,',POSITION=NODES,ELSET=',A8)
 5003 FORMAT('*EL FILE,FREQUENCY=',I3,
     1 ',POSITION=AVERAGED AT NODES,ELSET=',A8)
 8000 FORMAT('*J-INTEGRAL PRINT,FREQUENCY=',I3,',CONTOUR=',
     1 I3,',OUTPUT=FILE',A6)
 8001 FORMAT('0.,-1.,0.'/(16(A2,A2,1X)))
      RETURN
      END
C
C
C
      SUBROUTINE RESTART(IREST,NREST,IOVERLAY,KSTEP,INCRE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER OVERLAY*8
C
      LOVERLAY=1
      OVERLAY(1:8)=' '
      IF(IOVERLAY.EQ.1)  THEN
         LOVERLAY=8
         OVERLAY(1:8)=',OVERLAY'
      END IF
C
      IF(IREST.EQ.1) THEN
         WRITE(IO_OUTP,3001) NREST,OVERLAY(1:LOVERLAY)
      ELSEIF(IREST.EQ.2) THEN
         WRITE(IO_OUTP,3002) NREST,OVERLAY(1:LOVERLAY),KSTEP,INCRE
      ELSEIF(IREST.EQ.3) THEN
         WRITE(IO_OUTP,3003) KSTEP,INCRE
      ENDIF
      GOTO 9
      OPEN(7,FILE='input.step',status='unknown',ERR=8)
      IF(KSTEP.NE.0) THEN
         REWIND 7
    7    READ(7,FMT=3005,END=8) IS
         IF(IS.NE.KSTEP) GOTO 7
      END IF
      GOTO 9
    8 CONTINUE
      WRITE(IO_WRITE,*) ' You use RESTART option but no input.step',
     &  ' be found or KSTEP < MSTEP'
      WRITE(IO_WRITE,*) ' PROGRAM WILL BE continue'
      WRITE(IO_WRITE,*) ' input.step file would be written from', 
     &  'RESTART step'
    9 CONTINUE
      RETURN
 3001 FORMAT('*RESTART,WRITE,FREQUENCY=',I3,A8)
 3002 FORMAT('*RESTART,WRITE,FREQUENCY=',I3,A,',READ,STEP=',
     1 I3,',INC=',I4,',END STEP')
 3003 FORMAT('*RESTART,READ,STEP=',I3,',INC=',I4,',END STEP')
 3005 FORMAT(4X,I4)
      END
C
C
C
C *** SUBROUTINE FOR APPLYING elastic K-Field for Bi-Material
      SUBROUTINE BLFBVV
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C     DIMENSION BLFTH(LNB)
C
      READ(IO_INPUT,*) YOUNG1,POISS1,YOUNG2,POISS2,
     &  PHI,BLF_X0,BLF_Y0,BLF_R0,SIGMA0
      IF(SIGMA0.LE.0.0) SIGMA0=300.0D0
      PHI  = PHI*PI/180.0E0
      AKI1 = COS(PHI)
      AKI2 = SIN(PHI)
      SIG0 = SIGMA0    
      G1   = 0.5E0*YOUNG1/(1.0E0+POISS1)
      G2   = 0.5E0*YOUNG2/(1.0E0+POISS2)
      C1   = 4.0E0*(1.0E0-POISS1)/G1
      C2   = 4.0E0*(1.0E0-POISS2)/G2
      RKP1 = 3.0-4.0*POISS1
      RKP2 = 3.0-4.0*POISS2
      AFA  = (G1*(1.0E0-POISS2)-G2*(1.0E0-POISS1))/
     &       (G1*(1.0E0-POISS2)+G2*(1.0E0-POISS1))
      BFA  = (G1*(1.0E0-2.0E0*POISS2)-G2*(1.0E0-2.0E0*POISS1))/
     &       (G1*(1.0E0-POISS2)+G2*(1.0E0-POISS1))
      BFA  = 0.5E0*BFA
      EPSI = 0.5E0/PI*LOG((1.0E0-BFA)/(1.0E0+BFA))
      PSI  = ATAN(2.0E0*EPSI)
      SRB  = DSQRT(BLF_R0)
      CON1 = 0.5E0/SQRT(2.0E0*PI)/COSH(PI*EPSI)*SRB
C     CON2 = 0.125E0*2.0*C2/(C1+C2)*BLF_R0
C     CON3 = 0.125E0*2.0*C1/(C1+C2)*BLF_R0
      CON2 = 0.125E0*BLF_R0
      CON3 = 0.125E0*BLF_R0
      CON4 = 1.0E0/SQRT(1.0E0+4.0E0*EPSI*EPSI)
      NNBLF=0
 3002 format(3i5,12f12.5)
      IF(BLF_R0.GT.0.0D0) THEN
        KCONT=1
        DO IN=1,NNODE
          X=COORD(IN,1)
          Y=COORD(IN,2)
          R=SQRT((X-BLF_X0)**2+(Y-BLF_Y0)**2)
          IF(ABS(R-BLF_R0).LT.1.0E-2*BLF_R0) THEN
            KCONT=KCONT+1
            NDBLF(KCONT)=IN
          END IF
        END DO
        NDBLF(1)=KCONT
      END IF
   15 CONTINUE
      NNBLF=0
      DO I=2,NDBLF(1)
        IN=NDBLF(I)
        X=COORD(IN,1)
        Y=COORD(IN,2)
        Z=COORD(IN,3)
        DX=X-XORIGN
        DY=Y-YORIGN
        RK=DSQRT(DX*DX+DY*DY)
        DM = DY
        IF(ABS(DY/RK).LT.0.0001E0.AND.DX.LT.0.0E0) THEN
          CALL FIND_IELEM(IN,IE)
          NODE  = LNODS(IE,MXNOD)
          IMSET = LNODS(IE,MXNOD-1)
          NN = NODE
          IF(NN.GT.4) NN=NN/2
          XM = 0.0D0
          YM = 0.0D0
          DO K=1,NN
            IP=LNODS(IE,K)
            XM = XM + COORD(IP,1)
            YM = YM + COORD(IP,2)
          END DO
          XM = XM/NN
          YM = YM/NN
          DM = YM-YORIGN
        END IF
        TT=DASIN(ABS(DY/RK))
        IF(DX.LT.0.0.AND.DM.GT.0.0) TT = PI-TT
        IF(DX.LT.0.0.AND.DM.LE.0.0) TT =-PI+TT
        IF(DX.GE.0.0.AND.DM.LT.0.0) TT =-TT
        IF(ABS(TT).LT.1.D-8) TT = 0.0E0
        IF(ABS(TT-PI).LT.1.D-8) TT = PI
C       BLFTH(I) =TT
        THI   = TT - PI
        IF(TT.LT.0.0E0) THI = TT + PI
        PSI1  = PSI + 0.5E0*TT - PHI
        PSI2  = PSI - 0.5E0*TT - PHI
        PHI2  = PHI + 0.5E0*TT
        AG1   = EXP( EPSI*THI)
        AG2   = EXP(-EPSI*THI)
        CPSI1 = COS(PSI1)
        CPSI2 = COS(PSI2)
        SPSI1 = SIN(PSI1)
        SPSI2 = SIN(PSI2)
        CPHI2 = COS(PHI2)
        SPHI2 = SIN(PHI2)
        CTH   = COS(TT)
        STH   = SIN(TT)
        IF(TT.GE.0.0E0) THEN
          GX  = (RKP1*CON4*AG1*CPSI1-CON4*AG2*CPSI2+AG1*STH*SPHI2)
          GY  = (RKP1*CON4*AG1*SPSI1-CON4*AG2*SPSI2-AG1*STH*CPHI2)
          GX  = GX/G1
          GY  = GY/G1
          GXT = CON2*(RKP1+1.0E0)*CTH/G1
          GYT = CON2*(RKP1-3.0E0)*STH/G1
        ELSE
          GX  = (RKP2*CON4*AG1*CPSI1-CON4*AG2*CPSI2+AG1*STH*SPHI2)
          GY  = (RKP2*CON4*AG1*SPSI1-CON4*AG2*SPSI2-AG1*STH*CPHI2)
          GX  = GX/G2
          GY  = GY/G2
          GXT = CON3*(RKP2+1.0E0)*CTH/G2
          GYT = CON3*(RKP2-3.0E0)*STH/G2
        END IF
        UB    = CON1*GX
        VB    = CON1*GY
        UBT   = GXT
        VBT   = GYT
        NNBLF = NNBLF+1
        NFBLF(NNBLF)=IN*10+1
        VVBLF(NNBLF)=UB
        BPBLF(NNBLF)=UBT
        BLFTH(NNBLF)=TT
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+2
        VVBLF(NNBLF)=VB
        BPBLF(NNBLF)=VBT
        BLFTH(NNBLF)=TT
      END DO
      IF(NNBLF.GT.LNB) THEN
      WRITE(2,4000) NNBLF,LNB
 4000 FORMAT(' NNBLF=',I5,'>','LNB=',I5,' PROGRAM STOP')
      STOP
      END IF
 3009 format(5x,'T STRESS PARAMETER B=',F6.3,' RK=',E12.5)
C     WRITE(9,3300) (NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,
C    1 BLFTH(K)*180./PI,VVBLF(K),BPBLF(K),K=1,NNBLF)
 3300 FORMAT(I6,I2,3E15.5)
      RETURN
      END
C *** SUBROUTINE FOR APPLYING elastic K-Field for homogeneous case
      SUBROUTINE BLFVV
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION TH(LNB)
C
C     YOUNG=PROPS(3,1)
C     POISS=PROPS(4,1)
      SIG0=SIGMA0    
      RKP=3.0-4.0*POISS
      STRING=ELSET_TYP(1)
      IF(STRING(1:3).EQ.'CPS'.OR.KEY3D.NE.0) THEN
        RKP=(3.0-POISS)/(1.0+POISS)
        PS=POISS/(1.0+POISS)
        ES=YOUNG*(1.0+2.0*POISS)/((1.0+POISS)*(1.0+POISS))
        YOUNG=ES
        POISS=PS
      ENDIF
      CONS1=1.0-2.0*POISS
      CONS2=2.0*(1.0-POISS)
      CONS3=1.0/(RKP+1.0)
      CONS4=4.0*RKP+1.0
      PI=4.0*DATAN(1.0D0)
      SPI2=1.0/DSQRT(2.0D0*PI)
      AM=(1.0+POISS)/YOUNG
      NNBLF=0
 3002 format(3i5,12f12.5)
      IF(BLF_R0.GT.0.0D0) THEN
        KCONT=1
        DO IN=1,NNODE
          X=COORD(IN,1)
          Y=COORD(IN,2)
          R=SQRT((X-BLF_X0)**2+(Y-BLF_Y0)**2)
          IF(ABS(R-BLF_R0).LT.1.0E-2*BLF_R0) THEN
            KCONT=KCONT+1
            NDBLF(KCONT)=IN
          END IF
        END DO
        NDBLF(1)=KCONT
      END IF
   15 CONTINUE
      NNBLF=0
      DO I=2,NDBLF(1)
        IN=NDBLF(I)
        X=COORD(IN,1)
        Y=COORD(IN,2)
        Z=COORD(IN,3)
        DX=X-XORIGN
        DY=Y-YORIGN
        RK=DSQRT(DX*DX+DY*DY)
        DM = DY
        IF(ABS(DY/RK).LT.0.0001E0.AND.DX.LT.0.0E0) THEN
          CALL FIND_IELEM(IN,IE)
          NODE  = LNODS(IE,MXNOD)
          IMSET = LNODS(IE,MXNOD-1)
          NN = NODE
          IF(NN.GT.4) NN=NN/2
          XM = 0.0D0
          YM = 0.0D0
          DO K=1,NN
            IP=LNODS(IE,K)
            XM = XM + COORD(IP,1)
            YM = YM + COORD(IP,2)
          END DO
          XM = XM/NN
          YM = YM/NN
          DM = YM-YORIGN
        END IF
        TT=DASIN(ABS(DY/RK))
        IF(DX.LT.0.0.AND.DM.GT.0.0) TT = PI-TT
        IF(DX.LT.0.0.AND.DM.LE.0.0) TT =-PI+TT
        IF(DX.GE.0.0.AND.DM.LT.0.0) TT =-TT
        TH(I)=TT
        SR=DSQRT(RK)
        CT=DCOS(0.5*TT)
        ST=DSIN(0.5*TT)
        CT1=DCOS(TT)
        ST1=DSIN(TT)
        CT3=DCOS(1.5*TT)
        ST3=DSIN(1.5*TT)
        IF(ABS(TT).LT.1.D-8) THEN
          CT=1.0D0
          ST=0.0D0
          CT1=1.0D0
          ST1=0.0D0
          CT3=1.0D0
          ST3=0.0D0
        ENDIF
        IF(ABS(TT-PI).LT.1.D-8) THEN
          CT=0.0D0
          ST=1.0D0
          CT1=-1.0D0
          ST1=0.0D0
          CT3=0.0D0
          ST3=-1.0D0
        ENDIF
        IF(KCON.EQ.0) THEN
          UB=AKI1*AM*SR*SPI2*CT*(RKP-CT1)
     1      +AKI2*AM*SR*SPI2*ST*(RKP+2.0+CT1)
          VB=AKI1*AM*SR*SPI2*ST*(RKP-CT1)
     1      -AKI2*AM*SR*SPI2*CT*(RKP-2.0+CT1)
          WB=-POISS*2.0*CT*SPI2/SR*Z
          UBT=(1.0-POISS)*AM*RK*CT1
          VBT=-POISS*AM*RK*ST1
        ELSE
          UB=AM*SR*SPI2*CONS3*(CONS4*ST+ST3)
          VB=AM*SR*SPI2*CONS3*(CT-CT3)
        ENDIF
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+1
        VVBLF(NNBLF)=UB
        BPBLF(NNBLF)=UBT
        TH(NNBLF)=TT
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+2
        VVBLF(NNBLF)=VB
        BPBLF(NNBLF)=VBT
        TH(NNBLF)=TT
        IF(KEY3D.NE.0) THEN
          NNBLF=NNBLF+1
          NFBLF(NNBLF)=IN*10+3
          VVBLF(NNBLF)=WB
          BPBLF(NNBLF)=WBT
          TH(NNBLF)=TT
        END IF
      END DO
      IF(NNBLF.GT.LNB) THEN
      WRITE(2,4000) NNBLF,LNB
 4000 FORMAT(' NNBLF=',I5,'>','LNB=',I5,' PROGRAM STOP')
      STOP
      END IF
C     WRITE(9,3009) BPARA,RK
C     WRITE(2,3009) BPARA,RK
 3009 format(5x,'T STRESS PARAMETER B=',F6.3,' RK=',E12.5)
C     WRITE(9,3300) (NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,
C    1 TH(K)*180./PI,VVBLF(K),BPBLF(K),K=1,NNBLF)
 3300 FORMAT(I6,I2,3E15.5)
      RETURN
      END
      SUBROUTINE BLFVV1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION TH(600),U(600),V(600),THN(600)
      CHARACTER CKEY*1
      OPEN(30,FILE='NOTCH',STATUS='OLD')
      READ(30,'(A)') CKEY
      NT=0
    1 READ(30,*,END=99) THN(NT+1),U(NT+1),V(NT+1)
      NT=NT+1
      GOTO 1
   99 CONTINUE
      PI=4.0*DATAN(1.0D0)
      DO I=1,NT
      THN(I)=THN(I)*PI/180.0
      END DO
C     write(9,'(3e12.5)') (thn(i),u(i),v(i),i=1,nt)
      NNBLF=0
 3002 format(3i5,12f12.5)
      NNBLF=0
      DO I=2,NDBLF(1)
       IN=NDBLF(I)
       X=COORD(IN,1)
       Y=COORD(IN,2)
       DX=X-XORIGN
       DY=Y-YORIGN
       RK=DSQRT(DX*DX+DY*DY)
       IF(DX.EQ.0.0) THEN
       TT=PI/2.
       ELSE
       TT=DATAN(DY/DX)
       IF(DX.LT.0.0) TT=PI+TT
       END IF
       TM=TT
       DO J=1,NT
       IF(TT.GT.THN(J)) GOTO 30
       IF(ABS(TT-THN(J)).LT.1.0E-4) GOTO 30
       END DO
  30   CONTINUE
       J1=J-1
       IF(J.EQ.1) J1=J+1
       T1=THN(J1)
       T2=THN(J)
       U1=U(J1)
       U2=U(J)
       V1=V(J1)
       V2=V(J)
       UBR=U1+(TT-T1)*(U2-U1)/(T2-T1)
       VBR=V1+(TT-T1)*(V2-V1)/(T2-T1)
       CT=DCOS(TT)
       ST=DSIN(TT)
       IF(CKEY.EQ.'R') THEN
         UB=UBR*CT-VBR*ST
         VB=UBR*ST+VBR*CT
       ELSE IF(CKEY.EQ.'C') THEN
         UB=UBR
         VB=VBR
       END IF
        IF(ABS(UB).LT.1.0E-14) UB=0.0
        IF(ABS(VB).LT.1.0E-14) VB=0.0
        IF(ABS(UBT).LT.1.0E-14) UBT=0.0
        IF(ABS(VBT).LT.1.0E-14) VBT=0.0
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+1
        VVBLF(NNBLF)=UB
        BPBLF(NNBLF)=UBT
        TH(NNBLF)=TT
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+2
        VVBLF(NNBLF)=VB
        BPBLF(NNBLF)=VBT
        TH(NNBLF)=TT
      END DO
C     WRITE(9,3009) BPARA,RK
C     WRITE(2,3009) BPARA,RK
C     WRITE(9,3300) (NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,
C    1 TH(K)*180./PI,VVBLF(K),BPBLF(K),K=1,NNBLF)
 3300 FORMAT(I6,I2,3E15.5)
 3009 format(5x,'T STRESS PARAMETER B=',F6.3,' RK=',E12.5)
      RETURN
      END
      SUBROUTINE BLFVV2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION TH(600),U(600),V(600),THN(600)
      YOUNG=PROPS(3,1)
      POISS=PROPS(4,1)
      SIG0=SIGMA0    
      RKP=3.0-4.0*POISS
      CONS3=1.0/(RKP+1.0)
      CONS4=4.0*RKP+1.0
      PI=4.0*DATAN(1.0D0)
      BTA=BTA*PI/180.0
      AM=(1.0+POISS)/YOUNG
      NNBLF=0
      DO I=2,NDBLF(1)
       IN=NDBLF(I)
       X=COORD(IN,1)
       Y=COORD(IN,2)
       DX=X-XORIGN
       DY=Y-YORIGN
       RK=DSQRT(DX*DX+DY*DY)
       IF(DX.EQ.0.0) THEN
       TT=PI/2.
       ELSE
       TT=DATAN(DY/DX)
       IF(DX.LT.0.0) TT=PI+TT
       END IF
       TM=TT
       TT=BTA/2-TT
       G1TR=G1(TT,RDA)
       G1BR=G1(BTA,RDA)
       G2TR=G2(TT,RDA)
       G2BR=G2(BTA,RDA)
       G1BTR=G1B(TT,RDA)
       G1BBR=G1B(BTA,RDA)
       G2BTR=G2B(TT,RDA)
       G2BBR=G2B(BTA,RDA)
       G1BBTR=G1BB(TT,RDA)
       G1BBBR=G1BB(BTA,RDA)
       G2BBTR=G2BB(TT,RDA)
       G2BBBR=G2BB(BTA,RDA)
       FF=G1TR*G2BR-G1BR*G2TR
       FB=G1BTR*G2BR-G1BR*G2BTR
       FBB=G1BBTR*G2BR-G1BR*G2BBTR
       RDAM1=RDA-1.0
       RDAP1=RDA+1.0
       CT=DCOS(RDAM1*TT)
       ST=DSIN(RDAM1*TT)
       HF=4.0/RDAM1*(RDAP1*G2BR*CT+G1BR*ST)
       HFB=4.0*(-RDAP1*G2BR*ST+G1BR*CT)
       SR=RK**RDA
       UBR=AM*SR*((1-POISS)*HFB-RDAP1*FF)
       VBR=AM*SR*(-FB+(1.0-POISS)*RDAM1*HF)
c      write(9,'(I5,10E12.5)') in,tm*180./pi,ubr,vbr
       VBR=-VBR
       CT=DCOS(TM)
       ST=DSIN(TM)
       UB=UBR*CT-VBR*ST
       VB=UBR*ST+VBR*CT
        IF(ABS(UB).LT.1.0E-12) UB=0.
        IF(ABS(VB).LT.1.0E-12) VB=0.
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+1
        VVBLF(NNBLF)=UB
        BPBLF(NNBLF)=UBT
        TH(NNBLF)=TM
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+2
        VVBLF(NNBLF)=VB
        BPBLF(NNBLF)=VBT
        TH(NNBLF)=TM
      END DO
C     WRITE(9,3009) BPARA,RK,RDA
C     WRITE(2,3009) BPARA,RK,RDA
C     WRITE(9,3300) (NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,
C    1 TH(K)*180./PI,VVBLF(K),BPBLF(K),K=1,NNBLF)
 3300 FORMAT(I6,I2,3E15.5)
 3009 format(5x,'T STRESS PARAMETER B=',F6.3,' RK=',E12.5,
     1 ' RDA=',E12.5)
      RETURN
      END
      FUNCTION G1(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G1=(RDA-1.0)*SIN((RDA+1.0)*BTA)-(RDA+1.0)*SIN((RDA-1.0)*BTA)
      RETURN
      END
      FUNCTION G2(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G2=COS((RDA+1.0)*BTA)-COS((RDA-1.0)*BTA)
      RETURN
      END
      FUNCTION G1B(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G1B=(RDA**2-1.0)*COS((RDA+1.0)*BTA)-
     1 (RDA**2-1.0)*COS((RDA-1.0)*BTA)
      RETURN
      END
      FUNCTION G2B(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G2B=-(RDA+1.0)*SIN((RDA+1.0)*BTA)+(RDA-1.0)*SIN((RDA-1.0)*BTA)
      RETURN
      END
      FUNCTION G1BB(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G1BB=-(RDA+1.0)*(RDA**2-1.0)*SIN((RDA+1.0)*BTA)+
     1 (RDA-1.0)*(RDA**2-1.0)*SIN((RDA-1.0)*BTA)
      RETURN
      END
      FUNCTION G2BB(BTA,RDA)
      IMPLICIT REAL*8(A-H,O-Z)
      G2BB=-(RDA+1.0)**2*COS((RDA+1.0)*BTA)+
     1 (RDA-1.0)**2*COS((RDA-1.0)*BTA)
      RETURN
      END
C
      SUBROUTINE LOAD0(PV)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_OUTP,2000)
      DO K=1,NNBLF
        TT=BLFTH(K)
        IF(TT.GE.0.0E0) THEN
          PP=VVBLF(K)*PV+(TSTRES*(1.0E0+AFA)+THSTR)*BPBLF(K)
        ELSE
C         PP=VVBLF(K)*PV+(TSTRES*(1.0E0-AFA)-THSTR)*BPBLF(K)
          PP=VVBLF(K)*PV+(TSTRES*(1.0E0-AFA))*BPBLF(K)
        END IF
      WRITE(IO_OUTP,2100) NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,PP
      END DO
 2000 FORMAT('*BOUNDARY,OP=MOD')
 2100 FORMAT(I10,1H,,I2,2H,,,E15.8)
      RETURN
      END
C
      SUBROUTINE CLOAD(PV)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_OUTP,1000)
 1000 FORMAT('*CLOAD,OP=MOD')
      IFMT=IFMT+1
      DO I=1,NLOADSET
        WRITE(IO_OUTP,1001) CLOADSET(I),ILOADDOF(I),PV*PLOADSCL(I)
      END DO
 1001 FORMAT(2X,A8,2H, ,I1,1H,,E13.6)
      RETURN
      END
C
      SUBROUTINE DLOAD(PV)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_OUTP,2000)
 2000 FORMAT('*DLOAD,OP=MOD')
      IFMT=IFMT+1
      DO I=1,NLOADSET
        IF(ILOADDOF(I).GT.0) THEN
          WRITE(IO_OUTP,2001) CLOADSET(I),ILOADDOF(I),PV*PLOADSCL(I)
        ELSE
          DO K=1,7
            IF(CLOADSET(I).EQ.CESET(K)) GOTO 10
          END DO
   10     CONTINUE
          NN=KIDFACE(1,K)
          DO J=2,NN
            ID_FACE=KIDFACE(J,K)
            IF(ID_FACE.GT.0) THEN
              STRING(1:5)='ELSET'
              WRITE(STRING(6:6),'(I1)') K
              STRING(7:7)='_'
              WRITE(STRING(8:8),'(I1)') ID_FACE
              WRITE(IO_OUTP,2001) STRING(1:8),ID_FACE,PV*PLOADSCL(I)
            END IF
          END DO
        END IF
      END DO
 2001 FORMAT(2X,A8,2H,P,I1,1H,,E13.6)
      RETURN
      END
C
      SUBROUTINE LOAD2(PV)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      IFMT=LOADTYPE*1000
      WRITE(IO_OUTP,FMT=1000)
 1000 FORMAT('*BOUNDARY,OP=MOD')
      DO I=1,NLOADSET
      WRITE(IO_OUTP,1001) CLOADSET(I),ILOADDOF(I),PV*PLOADSCL(I)
      END DO
 1001 FORMAT(2X,A8,2H, ,I1,2H,,,E13.6)
      RETURN
      END
C
C     CALCULATIN 3D CT LOAD FACTOR
C
      SUBROUTINE LOAD_CT3DF
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      IF(LDCT_3D(1).GT.2) THEN
        DO I=3,LDCT_3D(1)
          IN1=LDCT_3D(I-1)
          Z1=COORD(IN1,3)
          IN2=LDCT_3D(  I)
          Z2=COORD(IN2,3)
          FACT=0.5*(Z2-Z1)
          CT_LOAD(I-1)=CT_LOAD(I-1)+FACT
          CT_LOAD(  I)=CT_LOAD(  I)+FACT
        END DO
      ELSE
        CT_LOAD(2)=1.0
      END IF
      RETURN
      END
C
C     OUTPUT 3D CT LOAD 
C
      SUBROUTINE LOAD_CT3DO(PLOAD)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_OUTP,1000)
 1000 FORMAT('*CLOAD,OP=MOD')
      DO I=2,LDCT_3D(1)
        IN=LDCT_3D(I)
        F= CT_LOAD(I)
        WRITE(IO_OUTP,1010) CNUM(I-1),F*PLOAD
      END DO
 1010 FORMAT(2X,'LOADCT',A2, 3H,2, ,E13.6)
      RETURN
      END
C
C     IMPOSE THE MULTIPOINT CONSTRAINTS CONDITIONS
C
      SUBROUTINE MPCSUB
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NW(10,2)
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MPCSUB'
C
      TEXT='NOW EXCUTING SUB. MPCSUB'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) NMPC
      IF(NMPC.NE.0) THEN
      DO I=1,NMPC
         READ(IO_INPUT,*) MPC,IFREDOM,K1
         NW(I,1)=IFREDOM
         NW(I,2)=K1
         KU=NNSET(K1)
         IF(IOUT.NE.1) WRITE(IO_OUTP,1400) I,(INSET(J,K1),J=2,KU)
         IF(IOUT.NE.1) WRITE(IO_OUTP,1410) I,INSET(1,K1)
      END DO
      IF(IOUT.NE.1) THEN
         WRITE(IO_OUTP,1500)
         DO I=1,NMPC
            IFRE=NW(I,1)
            WRITE(IO_OUTP,1520)
            WRITE(IO_OUTP,1530) 'MPCSET',I,IFRE,INSET(1,NW(I,2)),IFRE
         END DO
      END IF
      ENDIF
C
      TEXT='END OF EXCUTING SUB. MPCSUB'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
 1400 FORMAT('*NSET,NSET=MPCSET',I1/11(I6,','))
 1410 FORMAT('*NSET,NSET=MPCMSTR',I1/I6)
 1500 FORMAT('*EQUATION')
 1520 FORMAT(4X,'2')
 1530 FORMAT(1X,A6,I1,',',I1,', 1.000,',I6,',',I1,',-1.000')
      END
