      SUBROUTINE SORTCD(JBU,NBU,IAX)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION JBU(*)
C
C     SORT A POSITION ARRAY ACCORDING TO A GIVEN DIRECTION OF COORDINATES
C
      DO I = 1,NBU
        II   = JBU(I)
        JM1  = I
        JM2  = II
        AREF = 1.0E20
        DO J = I,NBU
          JJ = JBU(J)
          A  = COORD(JJ,IAX)
          IF(A.LT.AREF) THEN
            JM1 = J
            JM2 = JJ
            AREF=A
          END IF
        END DO
        JBU(I)=JM2
        JBU(JM1)=II
      END DO
      RETURN
      END
      SUBROUTINE INVERIA(JBU,NBU)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION JBU(*)
C
C     INVERT A INTEGER ARRAY
C
      DO I=1,NBU/2
        K1=JBU(I)
        JBU(I)=JBU(NBU-I+1)
        JBU(NBU-I+1)=K1
      END DO
      RETURN
      END
C
      SUBROUTINE FN_LIN_ND(XP1,XP2,JBU,NBU)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION JBU(*),XP1(3),XP2(3)
C
C     FIND NODES ALONG A GIVEN LINE
C
      NBU = 0
      XI1 = XP1(1)
      YI1 = XP1(2)
      ZI1 = XP1(3)
      XI2 = XP2(1)
      YI2 = XP2(2)
      ZI2 = XP2(3)
      DO I = 1,NNODE
        IF(INCOD(I).NE.0) THEN
          XK = COORD(I,1)
          YK = COORD(I,2)
          ZK = COORD(I,3)
          HX = (XK-XI1)*(XK-XI2)
          HY = (YK-YI1)*(YK-YI2)
          HZ = (ZK-ZI1)*(ZK-ZI2)
          HX = SQSN(HX)
          HY = SQSN(HY)
          HZ = SQSN(HZ)
          HXY = (XK-XI1)*(YK-YI2)-(XK-XI2)*(YK-YI1)
          HXZ = (XK-XI1)*(ZK-ZI2)-(XK-XI2)*(ZK-ZI1)
          HXZ = (XK-XI1)*(ZK-ZI2)-(XK-XI2)*(ZK-ZI1)
          IF(HX.LT.TOLER.AND.HY.LT.TOLER.AND.HZ.LT.TOLER) THEN
            IF(ABS(XI1-XI2).LT.TOLER.OR.ABS(YI1-YI2).LT.TOLER.OR.
     &         HXY.LT.TOLER) THEN
              NBU = NBU + 1
              JBU(NBU) = I
            END IF
          END IF
        END IF
      END DO
C     WRITE(IO_WORK,'(1HL,16I5)') (JBU(I),I=1,NBU)
      RETURN
      END
      FUNCTION SQSN(XX)
      IMPLICIT REAL*8(A-H,O-Z)
      IF(XX.EQ.0.0D0) THEN
        SQSN = 0.0D0
      ELSE
        AXX = ABS(XX)
        SQSN = SIGN(SQRT(AXX),XX)
      END IF
      RETURN
      END
