      SUBROUTINE GETLINE (LEN,IERR)
C     Routine for reading a line from a file
C     Converts small to kapital letters and multiple to single spaces
C     ignores comments 
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CHARI,CHARN
      LOGICAL LTRENN
C
C
      LTRENN = .TRUE.
      IA     = ICHAR('a')
      IZ     = ICHAR('z')
      IAKAP  = ICHAR('A')
      IKAPDF = IA - IAKAP
      IERR   = 0
C
  80  CONTINUE
      DO I = 1,160
	 STRING(I:I) = " "
      END DO
      READ (IO_INPUT,"(A)",END=800) STRING
      IF (STRING(1:2).EQ."**") GOTO 80
C     WRITE (IO_INFO,"(A)") STRING
C
      K = 0
      DO 100 I = 1, 159
	 CHARI = STRING(I:I)
	 CHARN = STRING(I+1:I+1)
	 IF (CHARI.EQ." ") THEN
            IF (CHARN.EQ." ".OR.CHARN.EQ.",") THEN
	       GOTO 100
	    ELSE
	       IF (LTRENN) GOTO 100
	    ENDIF
	 ELSE
	    LTRENN = .FALSE.
	    IF (CHARI.EQ.",") LTRENN = .TRUE.
	    IASCII = ICHAR(CHARI)
	    IF ((IASCII.GE.IA) .AND. (IASCII.LE.IZ)) THEN
	       CHARI = CHAR(IASCII - IKAPDF)
	    ENDIF
	 ENDIF
	 K = K + 1
	 STRING(K:K) = CHARI
 100  CONTINUE
      LEN = K 
      DO I = LEN+1,160
	 STRING(I:I) = " "
      END DO
C     WRITE (IO_INFO,"(2A,I3,A)") STRING(1:LEN),"(LAENGE",LEN,")"
      RETURN
 800  CONTINUE
      IERR = 1
      RETURN
      END
C
C
C
      SUBROUTINE SLVLINE (CSTRING,LEN,IERR)
C     subroutine for splitting a string into several numbers
C     itype=1: integer, itype=2: real, sonst: string
C     numbers are seperated by comma or spaces
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*(*) CSTRING
      CHARACTER*20 CPART
C
C
      II = 0
      LEN1 = LEN + 1
      CSTRING(LEN1:LEN1) = " "
      INUM = 0
 100  CONTINUE
  90     CONTINUE
	    II = II + 1
	    IF (II.GT.LEN) GOTO 800
         IF (CSTRING(II:II).EQ." ") GOTO 90 
	 INUM = INUM  + 1
	 IKOMMA = 0
	 ISPACE = 0
C        WRITE (IO_INFO,*) "AUSGEWERTET WIRD",II," BIS",LEN1
         IF (II.LE.LEN) IKOMMA = INDEX(CSTRING(II:LEN),",")
         IF (II.LE.LEN1) ISPACE = INDEX(CSTRING(II:LEN1)," ")
	 IF (IKOMMA.GT.0 .AND. ISPACE.GT.0) THEN
	    IBLANK = MIN(IKOMMA,ISPACE)
	 ELSEIF (ISPACE.GT.0) THEN
	    IBLANK = ISPACE
	 ELSEIF (IKOMMA.GT.0) THEN
	    IBLANK = IKOMMA
	 ELSE
	    GOTO 800
	 ENDIF
	 IF (IBLANK.GT.1) THEN
            CPART(1:IBLANK-1) = CSTRING(II:II+IBLANK-2)
	    CPART(IBLANK:IBLANK) = ","
   	    DO 120 K = IBLANK+1,20
	       CPART(K:K) = " "
 120        CONTINUE
	    IF (ITYPE(INUM).EQ.1) THEN
	       READ (CPART,"(I20)",ERR=900) IVARR(INUM)
	    ELSEIF (ITYPE(INUM).EQ.2) THEN
	       READ (CPART,"(F20.0)",ERR=910) RVARR(INUM)
	    ELSE
	       CPART(IBLANK:IBLANK) = " "
	       CVARR(INUM) = CPART
	    ENDIF
C           WRITE (IO_INFO,*) 
C    1            "NR.:",INUM,"STR.:",CPART,"ZEICHEN:",IBLANK
	 ELSE
	    IVARR(INUM) = 0
	    RVARR(INUM) = 0.0
	 ENDIF
	 II = IBLANK + II - 1
      IF (INUM.LT.INVAR) GOTO 100
      RETURN
C
 800  CONTINUE
      INUM = INUM  + 1
      IF (INUM .LT. INVAR) THEN
         DO K = INUM,INVAR
            IVARR(K) = 0
            RVARR(K) = 0.0
         END DO
      ENDIF
      RETURN
 900  CONTINUE
      WRITE (IO_WRITE,1000) CSTRING(1:LEN),INUM
      RETURN
 910  CONTINUE
      WRITE (IO_WRITE,1010) CSTRING(1:LEN),INUM
      RETURN
 1000 FORMAT ("ERROR READING",/,A,/,"INTEGER EXPECTED AT POSITION ",I2)
 1010 FORMAT ("ERROR READING",/,A,/,"REAL EXPECTED AT POSITION ",I2)
      END




