C
C     SUBROUTINE SOLID FOR OUT SOLID SECTION INFORMATION
C
      SUBROUTINE SOLID
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CMATER*8,CA*20
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. SOLID'
C
      TEXT='NOW EXCUTING SUB. SOLID'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      
      NLERR = 1
      CERRRPT(1)(20:80) = ': *SOLID SECTION option'
C
      IMATS=0
   10 CONTINUE
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 10
      ELSE IF(STRING(1:8).EQ.'*ELASTIC') THEN
        MATER = 1
        IMATS=IMATS+1
        IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER1
      ELSE IF(STRING(1:8).EQ.'*PLASTIC') THEN
        MATER = 2
        IMATS=IMATS+1
        IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER2
      ELSE IF((STRING(1:8).EQ.'*POWER L').OR.
     &        (STRING(1:8).EQ.'*USER MA')) THEN
        MATER = 3
c       IMATS=IMATS+1
c       IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER3
      ELSE IF(STRING(1:8).EQ.'*CRYSTAL') THEN
        MATER = 3
c       IMATS=IMATS+1
c       IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER3
      ELSE IF(STRING(1:7).EQ.'*GURSON') THEN
        MATER = 3
c       IMATS=IMATS+1
c       IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER3
      ELSE IF(STRING(1:8).EQ.'*DEFORMA') THEN
        MATER = 4
        IMATS=IMATS+1
        IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER4
      ELSE IF(STRING(1:8).EQ.'*TENSION') THEN
        MATER = 5
        IMATS=IMATS+1
        IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
        CALL MATER5
      ELSE IF(STRING(1:8).EQ.'*INTERFA') THEN
        MATER = 6
        IMATS = IMATS+1
        K1    = 1
        CALL MATER6
      ELSE IF(STRING(1:8).EQ.'*SECTION') THEN
        CALL LOCCHR(STRING,'MATER',5,1,KPOS1,KPOS2)
        IF(KPOS2.GE.KPOS1) THEN
	   READ(STRING(KPOS1:KPOS2),*) IM
	   IMATS = IMATS + 1
	   IS = IMATS
	ELSE
	   READ(IO_INPUT,*) IS,IM
	ENDIF
        IF(IOUT.NE.1) WRITE(IO_OUTP,1110) CNUM(IS),CNUM(IM)
      ELSE IF(STRING(1:8).EQ.'*COMMOND') THEN
        READ(IO_INPUT,'(A)') STRING
        CALL DTEXT(STRING,LEN)
        IF(IOUT.NE.1) WRITE(IO_OUTP,'(A)') STRING(1:LEN)
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 999
      ELSE
        GOTO 10
      END IF
      PROPS(1,IMATS)=MATER
      GOTO 10
  999 CONTINUE
 1110 FORMAT('*SOLID SECTION,ELSET=E00000',A,',MATERIAL=M00010',A)
C
      TEXT='END OF EXCUTING SUB. SOLID'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
      SUBROUTINE MATER1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      READ(IO_INPUT,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
c     WRITE(IO_WRITE,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
      IF(IOUT.NE.1) THEN
      WRITE(IO_OUTP,1130) CNUM(IMATS)
      WRITE(IO_OUTP,2000) PROPS(3,IMATS),PROPS(4,IMATS)
      PROPS(2,IMATS)=2
      END IF
 1000 FORMAT(16I5)
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
 2000 FORMAT('*ELASTIC'/E15.6,',',E15.6)
      RETURN
      END
C
C     MATERIAL MODEL SUBROUTINE
C
      SUBROUTINE MATER2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
Calt  CALL LOCCHR(STRING,'POWER LA',6,1,KPOS1,KPOS2)
Calt  KPOWER = 1
Calt  IF(KPOS2.GE.KPOS1) THEN
Calt    READ(STRING(KPOS1:KPOS2),*) KPOWER
Calt  END IF
      CALL LOCCHR(STRING,'EMOD   ',4,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
	 CALL MATPLA
	 RETURN
      END IF
      READ(IO_INPUT,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
c     WRITE(IO_WRITE,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
      IF(IOUT.NE.1) THEN
        PROPS(2,IMATS)=NM+2
        YOUNG=PROPS(3,IMATS)
        POISS=PROPS(4,IMATS)
        SIG0=PROPS(5,IMATS)
        HN=PROPS(6,IMATS)
        AF=PROPS(7,IMATS)
        IF(AF.EQ.0.0) AF=1.0
        RMU=PROPS(8,IMATS)
        BTA=PROPS(9,IMATS)
        SIG02=PROPS(10,IMATS)
        NT=PROPS(11,IMATS)
        PRAGER=PROPS(12,IMATS)
        WRITE(IO_OUTP,1130) CNUM(IMATS)
        CALL DPRAGER(YOUNG,POISS,HN,RMU,SIG0,NT,PRAGER,BTA,AF,IO_OUTP)
      END IF
 1000 FORMAT(16I5)
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
      RETURN
      END
C
C     PLASTIC MATERIAL MODEL SUBROUTINE
C
      SUBROUTINE MATPLA
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*5 CINPTY
C
      EY = 200000.0
      POISSON = 0.3
      HN = 9999.9
      SIG0 = 300.0
      SMAX = 0.1
      NVAL = 40
      MAXTYP = 2
C
      WRITE(IO_OUTP,1130) CNUM(IMATS)
C---  ELASTIC PROPERTIES
      CALL LOCCHR(STRING,'EMOD    ',4,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        READ(STRING(KPOS1:KPOS2),*) EY
      END IF
      CALL LOCCHR(STRING,'NU      ',2,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        READ(STRING(KPOS1:KPOS2),*) POISSON
      END IF
      WRITE(IO_OUTP,1000) EY,POISSON
      WRITE(IO_OUTP,1010)
C
      CALL LOCCHR(STRING,'INPUT   ',2,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
         READ(STRING(KPOS1:KPOS2),*) CINPTY
      ELSE
         CALL LOCCHR(STRING,'HARD    ',4,1,KPOS1,KPOS2)
         IF(KPOS2.GE.KPOS1) THEN
           READ(STRING(KPOS1:KPOS2),*) HN
         ENDIF
         CALL LOCCHR(STRING,'SIG0    ',4,1,KPOS1,KPOS2)
         IF(KPOS2.GE.KPOS1) THEN
           READ(STRING(KPOS1:KPOS2),*) SIG0
         ENDIF
         CALL LOCCHR(STRING,'SIGMAX  ',6,1,KPOS1,KPOS2)
         IF(KPOS2.GE.KPOS1) THEN
           READ(STRING(KPOS1:KPOS2),*) SMAX 
	   MAXTYP = 1
         ENDIF
         CALL LOCCHR(STRING,'EPSMAX  ',6,1,KPOS1,KPOS2)
         IF(KPOS2.GE.KPOS1) THEN
           READ(STRING(KPOS1:KPOS2),*) SMAX
	   MAXTYP = 2
         ENDIF
         CALL LOCCHR(STRING,'NVAL    ',4,1,KPOS1,KPOS2)
         IF(KPOS2.GE.KPOS1) THEN
           READ(STRING(KPOS1:KPOS2),*) NVAL
         ENDIF
C
         IF(HN.LT.98.0) THEN
            EPS0 = SIG0 / EY
            SIG  = SIG0
	    IF (MAXTYP.EQ.1) THEN
	       DSIG = (SMAX-SIG0)/NVAL
               NVAL=NVAL+1
               DO I=1,NVAL
                  SAKT = SIG/SIG0
                  EPS  = EPS0*(SAKT**HN-SAKT)
                  WRITE(IO_OUTP,2000) SIG,EPS
                  SIG = SIG+DSIG
               END DO
               SIG  = (SIG-DSIG)*10.0
               SAKT = SIG/SIG0
               EPS  = EPS0*(SAKT**HN-SAKT*EPS0)
               IF (EPS.LT.1000.0) WRITE(IO_OUTP,2000) SIG,EPS
C
	    ELSE
	       FEPS = (SMAX/EPS0)**(1./REAL(NVAL))
               WRITE(IO_OUTP,2000) SIG0,EPS0
  100          CONTINUE
                  SAKT = SIG/SIG0
	          DEPS = EPS0*(HN*SAKT**(HN-1.)-EPS0)
                  EPS  = EPS0*(SAKT**HN-SIG/EY)
	          DSIG = EPS/DEPS*(FEPS - 1.0)
	          print *,eps,deps,sakt,hn,dsig
                  WRITE(IO_OUTP,2000) SIG,EPS
	          SIG  = SIG + DSIG
	       IF (EPS.LT.SMAX) GOTO 100
            ENDIF
         ELSE
            WRITE(IO_OUTP,2000) SIG0,0.
         ENDIF
      ENDIF
C
      RETURN
 1000 FORMAT('*ELASTIC'/E15.6,',',F7.3)
 1010 FORMAT('*PLASTIC')
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
 2000 FORMAT(E15.9,',',E15.9)
      END
C
C
      SUBROUTINE MATER3
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      REAL*4 AW(100)
      DIMENSION RADNUM(1000),THG(10,1000),KDLIST(1000)
      CHARACTER CH_USER*80,CSYMM(2)*8,CSOLID*8,CMATER*8
      DATA CSYMM/'        ',',UNSYMM '/
      PI=4.0D0*DATAN(1.0D0)
      LCH_USER = 0
      CSOLID ='E00000'
      KSOLID = 0
      CMATER ='M00010'
      KMATER = 0
      NM = 0
      NDEPVAR = 0
      HSTIFS = 0.0E0
      KUSER = 1
      KSYMM = 0
      KRANDOM = 0
      KMATS = IMATS + 1
      KREPT = 0
      KEYCRY= 0
      NRCR  = 0
      NRSL  = 0
      NRVS  = 0
      NRHN  = 0
      THICK = 1.0
      DO K=1,1000
        KDLIST(K)=K
      END DO
      CALL CONCHR(STRING,'CRYSTA  ',6,1,KEYCRY)
      CALL CONCHR(STRING,'UNSYMM  ',6,1,KSYMM)
      IF(STRING(1:8).NE.'*USER MA') THEN
        KUSER = 0
        READ(IO_INPUT,*) NM,(PROPS(K,KMATS),K=3,NM+2)
      END IF
C
      CALL LOCCHR(STRING,'ELSET   ',5,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        KSOLID = 1
        CSOLID = STRING(KPOS1:KPOS2)
      END IF
C
      CALL LOCCHR(STRING,'MATER   ',5,10,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        KMATER = 1
        CMATER = STRING(KPOS1:KPOS2)
      END IF
C
C---  randomly distributed material properties
      NREPT = 1
      CALL LOCCHR(STRING,'REPEAT  ',6,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        READ(STRING(KPOS1:KPOS2),*) NREPT
      END IF
      CALL LOCCHR(STRING,'RANDOM  ',6,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        KRANDOM = 3
        IF(STRING(KPOS1:KPOS1+1).EQ.'2D') KRANDOM = 1
        DO K=1,KRANDOM*NREPT
          RADNUM(K) = RAND()
        END DO
      END IF
      IOUNIT = IO_INPUT
      CALL LOCCHR(STRING,'INPUT   ',5,1,KPOS1,KPOS2)
      IF(KPOS2.GE.KPOS1) THEN
        READ(STRING(KPOS1:KPOS2),'(A)') TEXT
        CALL DTEXT(TEXT,LEN)
        OPEN(IOUNIT,FILE=TEXT(1:LEN),STATUS='OLD',ERR=9991)
      END IF
C
C
    5 CONTINUE
      STRING = ' '
      READ(IOUNIT  ,'(A)') STRING
      IF(STRING(1:2).EQ.'**') THEN
C-----  comments
      ELSE IF(STRING(1:6).EQ.'*THICK') THEN
C-----  thickness definition
        READ(IOUNIT,*) THICK
        IF(THICK.LE.0.0) THICK = 1.0E0
      ELSE IF(STRING(1:7).EQ.'*DOMAIN') THEN
C-----  domain definition
        READ(IOUNIT,*) NDLIST,(IWORK(K),K=1,2*NDLIST)
        KI = 0
        DO K=1,NDLIST
          KI = KI + 1
          I1 = IWORK(KI)
          KI = KI + 1
          I2 = IWORK(KI)
c         KDLIST(IMATS+I1) = I2
          KDLIST(I1) = I2
        END DO
      ELSE IF(STRING(1:4).EQ.'DEPV') THEN
C-----  define state variable number for abaqus
        KPOS1=1
        CALL LOCCHR(STRING,'DEPVAR  ',6,1,KPOS1,KPOS2)
        NDEPVAR = 0
        READ(STRING(KPOS1:KPOS2),*) NDEPVAR
      ELSE IF(STRING(1:4).EQ.'HOUR') THEN
C-----  defining hourglass stiffness
        HSTIFS=0.005*PROPS(4,KMATS)*0.5/(1.0+PROPS(5,KMATS))
        IF(IOUT.NE.1) 
     &   WRITE(IO_OUTP,'(20H*HOURGLASS STIFFNESS/F10.4)') HSTIFS
      ELSE IF(STRING(1:5).EQ.'USER=') THEN
        CALL DTEXT(STRING,LEN)
        LCH_USER = LEN - 5
        CH_USER(1:LCH_USER) = STRING(6:LEN)
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
        GOTO 10
      ELSE IF(KUSER.EQ.1) THEN
C       NN = NM + 2
C       NM1= NM + 1 
C       NM = NM + 8
C       READ(STRING(1:100),2001) (PROPS(K,KMATS),K=NM1+2,NM+2)
        DO K=1,8
          AW(K) = 0.0E0
        END DO
        CALL RDNUM(STRING,1,NW,AW)
        DO K=1,8
          NM = NM + 1
          PROPS(NM+2,KMATS) = AW(K)
        END DO
      END IF
      GOTO 5
   10 CONTINUE
C
      IF(KRANDOM.NE.0.OR.KEYCRY.NE.0) THEN
        IF(KMATS.EQ.1) WRITE(IO_INFO,1010)
 1010 FORMAT(/5X,'Crystal orientations has been generated randomly'/)
        IAD = 18
        NVISCO= PROPS( 4,KMATS)
        NHARDN= PROPS( 5,KMATS)
        KCRYST= PROPS(11,KMATS)
        NSPST = PROPS(12,KMATS)
        KLEAS = PROPS(13,KMATS)
        KEULER= PROPS(14,KMATS)
        IF(KLEAS.LE.2) THEN
          IAD = IAD + 8
          NRCR= 4
        ELSE IF(KLEAS.EQ.3) THEN
          IAD = IAD + 16
          NRCR= 5
        ELSE IF(KLEAS.EQ.4) THEN
          IAD = IAD + 24
          NRCR= 6
        END IF
        IF(KEULER.EQ.1) THEN
          ANGLE0=PROPS(IAD+3,KMATS)
          TANGLE=PROPS(IAD+4,KMATS)
          PROPS(IAD+4,KMATS) = 0.0E0
          THG(1,1) = PROPS(IAD+1,KMATS)
          THG(2,1) = PROPS(IAD+2,KMATS)
          IF(TANGLE.GT.180.0) THEN
            TANGLE = 360.0
          ELSE
            TANGLE = 180.0
          END IF
        ELSE
          IAD = IAD + 8
          PHI =PROPS(IAD+4,KMATS)
          PHI0=PHI
          ANGLE0 = PROPS(IAD+5,KMATS)
          PHI = PHI*PI/180.0E0
          COSPHI = COS(PHI)
          SINPHI = SIN(PHI)
        END IF
        NRSL = NRCR + KEULER
        NRVS = NRSL
        DO K=1,NSPST
          NSLIP = PROPS((NRVS-1)*8+3,KMATS)
          NRVS = NRVS + NSLIP + 1
        END DO
        NRHN = NRVS + NVISCO
      END IF
C
   12 CONTINUE
      STRING = ' '
      READ(IOUNIT  ,'(A)') STRING
      IF(STRING(1:2).EQ.'**') THEN
      ELSE IF(STRING(1:5).EQ.'*DEPV') THEN
C-----  DEFINE STATE VARIABLE NUMBER FOR ABAQUS
        KPOS1=1
        CALL LOCCHR(STRING,'DEPVAR  ',6,1,KPOS1,KPOS2)
        IF(KPOS2.GT.KPOS1) READ(STRING(KPOS1:KPOS2),*) NDEPVAR
        GOTO 12
      ELSE IF(STRING(1:5).EQ.'*HOUR') THEN
C-----  DEFINING HOURGLASS STIFFNESS
        HSTIFS=0.005*PROPS(4,KMATS)*0.5/(1.0+PROPS(5,KMATS))
        GOTO 12
      ELSE IF(STRING(1:8).EQ.'*USER SU') THEN
        KPOS1=1
        CALL LOCCHR(STRING,'INPUT   ',5,1,KPOS1,KPOS2)
        LCH_USER = KPOS2-KPOS1+1
        IF(KPOS2.GT.KPOS1) CH_USER(1:LCH_USER)=STRING(KPOS1:KPOS2)
        GOTO 12
      ELSE IF(STRING(1:1).EQ.' ') THEN
        GOTO 12
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
        GOTO 20
      END IF
   20 CONTINUE
      IMATS=IMATS+1

      IF(KSOLID.EQ.0) THEN
        CSOLID(7:8) = CNUM(IMATS)
      END IF

      IF(KMATER.EQ.0) THEN
        CMATER(7:8) = CNUM(IMATS)
      END IF

      IF(KRANDOM.NE.0) THEN
c       IAD = 18
c       KLEAS = PROPS(13,KMATS)
c       IF(KLEAS.LE.2) THEN
c         IAD = IAD + 8
c       ELSE IF(KLEAS.EQ.3) THEN
c         IAD = IAD + 16
c       ELSE IF(KLEAS.EQ.4) THEN
c         IAD = IAD + 24
c       END IF
        JMATS = KDLIST(IMATS)

        THG(1,IMATS) = THG(1,KMATS)
        THG(2,IMATS) = THG(2,KMATS)

        IF(KEULER.EQ.1) THEN
          DO K=1,KRANDOM 
            NRAND = NRAND + 1
c           JMATS = KDLIST(NRAND)
            TH = ANGLE0+RADNUM(NRAND)*TANGLE
            IF(TH.GT.TANGLE) TH = TH - TANGLE
            TH = ANINT(TH)
            IF(JMATS.EQ.IMATS) THEN
              PROPS(IAD+4-K,KMATS) = TH
            ELSE
              PROPS(IAD+4-K,KMATS) = THG(4-K,JMATS)
            END IF
            THG(4-K,IMATS) = PROPS(IAD+4-K,KMATS)
          END DO
          WRITE(IO_INFO,1011) CSOLID,(THG(K,IMATS),K=1,3)
 1011 FORMAT(5X,'ELSET-',A8,3X,'Euler angles',3F10.4)
        ELSE
          NRAND = NRAND + 1
c         JMATS = KDLIST(NRAND)
          KGAMMA= AINT(6.0E0*RADNUM(JMATS))
c         KGAMMA= AINT(10.0*(0.1E0+0.5E0*RADNUM(JMATS)))
c         IF(KGAMMA.GT.6) KGAMMA = KGAMMA-6
          TH = ANGLE0+KGAMMA*60.0E0
          TH0= TH
          TH = TH*PI/180.0E0
          SINTH = SIN(TH)
          COSTH = COS(TH)
          PROPS(IAD+4,KMATS) = COSTH*SINPHI
          PROPS(IAD+5,KMATS) = COSTH*COSPHI
          PROPS(IAD+6,KMATS) = SINTH
          WRITE(IO_INFO,1012) CSOLID,PHI0,TH0
 1012 FORMAT(5X,'ELSET-',A8,3X,'L. angle ',F10.4,' D. angle ',F10.4)
        END IF
      END IF
      IF(IOUT.NE.1) THEN
        PROPS(1,KMATS)=NM+2
C       WRITE(IO_OUTP,1110) CNUM(IMATS),CNUM(IMATS)
c       WRITE(IO_OUTP,1130) CNUM(IMATS)
        WRITE(IO_OUTP,1111) CSOLID,CMATER
        IF(ABS(THICK-1.0).GT.1.0E-5) 
     &     WRITE(IO_OUTP,'(F10.4,1H,)') THICK
        WRITE(IO_OUTP,1131) CMATER
        WRITE(IO_OUTP,2000) NM,CSYMM(KSYMM+1)
c       WRITE(IO_OUTP,2001) (PROPS(K,KMATS),K=3,NM+2)
        NC = 0
        LP = 0
        LDIGT = 10
  100   CONTINUE
        NC = NC + 1
        PP = PROPS(NC+2,KMATS)
        IF(ABS(PP).LT.1.0E-20) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.8)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E-4) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(E10.4)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E-0) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.8)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+1) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.7)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+2) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.6)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+3) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.5)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+4) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.4)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+5) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.3)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+6) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.2)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+7) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.1)') PP
          LP = LP + LDIGT
        ELSE IF(ABS(PP).LT.1.0E+8) THEN
          WRITE(TEXT(LP+1:LP+LDIGT),'(F10.0)') PP
          LP = LP + LDIGT
        ELSE
          WRITE(TEXT(LP+1:LP+LDIGT),'(E10.4)') PP
          LP = LP + LDIGT
        END IF
        NC8 = (NC/8)*8
        IF(NC8.EQ.NC.OR.NC.EQ.NM) THEN
          NC8 = NC/8
          IF(KEYCRY.NE.0.AND.KREPT.LE.0) THEN
            IF(NC8.EQ.1) THEN
              WRITE(IO_OUTP,3001)
            ELSE IF(NC8.EQ.2) THEN
              WRITE(IO_OUTP,3002)
            ELSE IF(NC8.EQ.3) THEN
              WRITE(IO_OUTP,3003)
            ELSE IF(NC8.EQ.NRCR) THEN
              WRITE(IO_OUTP,3004)
            ELSE IF(NC8.EQ.NRSL) THEN
              WRITE(IO_OUTP,3005)
            ELSE IF(NC8.EQ.NRVS) THEN
              WRITE(IO_OUTP,3006)
            ELSE IF(NC8.EQ.NRHN) THEN
              WRITE(IO_OUTP,3007)
            END IF
          END IF
          WRITE(IO_OUTP,'(A)') TEXT(1:LP)
          LP = 0
        END IF
        IF(NC.LT.NM) GOTO 100
      ENDIF
      IF(IOUT.NE.1.AND.NDEPVAR.GT.0) WRITE(IO_OUTP,2002) NDEPVAR
      IF(IOUT.NE.1.AND.HSTIFS.GT.0.0E0)
     &  WRITE(IO_OUTP,'(20H*HOURGLASS STIFFNESS/F10.4)') HSTIFS
      IF(LCH_USER.GT.0) WRITE(IO_OUTP,2003) CH_USER(1:LCH_USER)
      KREPT = KREPT + 1
      IF(KREPT.LT.NREPT) GOTO 20
C
 1110 FORMAT('*SOLID SECTION,ELSET=E00000',A,',MATERIAL=M00010',A)
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
 1111 FORMAT('*SOLID SECTION,ELSET=',A,',MATERIAL=',A)
 1131 FORMAT('*MATERIAL,NAME=',A)
 2000 FORMAT('*USER MATERIAL,CONSTANT=',I4,2A)
 2001 FORMAT(8(G11.5,1H,))
 2002 FORMAT('*DEPVAR'/I5)
 2003 FORMAT('*USER SUBROUTINE,INPUT=',A)
 3001 FORMAT('**'/
     & '** NCRYST  NVISCO   NHARDEN   THETA    NLGEOM   ',
     &       'ITERATN   MAXITR    GERRMAX'/
     & '**')
 3002 FORMAT('**'/
     & '** KCRYST  NSET     KELASTIC  KEULER   CARATIO  '/
     & '**         KCRYST    type of input data for crystal   '/
c    & '**                   1 - 3 for f.c.c. 4 for h.c.p.    '/
     & '**         NSET      number of slip system sets       '/
c    & '**         KELASTIC  elastic properties index         '/
c    & '**         KEULER    crystal orientation input type   '/
     & '**')
 3003 FORMAT('**'/
     & '** elastic moduli :',/
     & '** KELASTIC<=2 1 card; =3,2 card2; =4 3 cards')
 3004 FORMAT('**'/
     & '** Crystal orientation: '/
     & '** KEULER =1   1 card for euler angles,'/
     & '**        =2   2 crads for two vectors'/
     & '**')
 3005 FORMAT('**'/
     & '** Slip systems total NSET and for each enter:'/
     & '** first card  : NSLIP IDXVS IDXHN TWINF '/
     & '**               NSLIP number of slip in this set'/
     & '**               IDXVS index of viscoplastic data set'/
     & '**               IDXHN index of hardening    data set'/
     & '**               TWINF = 1. for considering twinning'/
     & '** NSLIP cards : for NSLIP slip systems'/
     & '**   for f.c.c. slip plane (n1 n2 n3)  ',
     &                 'slip direction (s1 s2 s3)'/
     & '**   for h.c.p. slip plane (n1 n2 n3 n4)  ',
     &                 'slip direction (s1 s2 s3 s4)'/
     & '**')
 3006 FORMAT('**'/
     & '** Visco plastic parameters: NVISCO cards'/
     & '** first  card : m   adot '/
     & '** second card :  ....'/
     & '**')
 3007 FORMAT('**'/
     & '** Hardening parameters: NHARDEN*2 cards'/
     & '** first card  : hardening paramerter'/
     & '** second card : q q1 KTYPE type of harden'/
     & '**                    1 for power law'/
     & '**                    2 for Asaro, Pierce etc.'/
     & '**                    3 for Bassani  '/
     & '**                    4 for linear '/
     & '**                    5 for Voce type'/
     & '**   Repeat for NHARDENs'/
     & '**')
      RETURN
 9991 CONTINUE
      CERRRPT(2)(20:80) = ': *USER MATERIAL option'
      CERRRPT(3)(20:80) = 
     &    ': Input file, '//TEXT(1:LEN)//', is not exist'
      NLERR = 3
      IUNIT = 6
      CALL MERRPT(IUNIT,KERR,NLERR)
      IUNIT = IO_INFO
      CALL MERRPT(IUNIT,KERR,NLERR)
      STOP
      END
C
      SUBROUTINE MATER4
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      READ(IO_INPUT,'(I5/12E15.7)') N,(PROPS(2+K,IMATS),K=1,N)
c     WRITE(IO_WRITE,'(I5/12E15.7)') N,(PROPS(2+K,IMATS),K=1,N)
      IF(IOUT.NE.1) THEN
      WRITE(IO_OUTP,1130) CNUM(IMATS)
      WRITE(IO_OUTP,2000) (PROPS(2+K,IMATS),K=1,N)
      PROPS(2,IMATS)=2
      END IF
 1000 FORMAT(16I5)
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
 2000 FORMAT('*DEFORMATION PLASTICITY'/E12.6,',',F6.3,3(',',F10.4))
      RETURN
      END
C
      SUBROUTINE MATER5
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION RMATDAT(2000,2)
      IOMATER=8
      READ(IO_INPUT,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
      READ(IO_INPUT,'(A)') STRING
      LEN=120
      CALL DTEXT(STRING,LEN)
c     WRITE(IO_WRITE,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
      IF(IOUT.EQ.1) RETURN
      WRITE(IO_OUTP,1130) CNUM(IMATS)
      WRITE(IO_OUTP,2000) (PROPS(K,IMATS),K=3,5)
      PROPS(2,IMATS)=NM
      WRITE(IO_OUTP,2010)
    5 IT=1
      OPEN(IOMATER,FILE=STRING(1:LEN),ERR=999)
   10 READ(IOMATER,*,END=50) RMATDAT(IT,1),RMATDAT(IT,2)
      WRITE(IO_OUTP,2011) RMATDAT(IT,1),RMATDAT(IT,2)
      IT=IT+1
      GOTO 10
   50 CONTINUE
      IF(IT.EQ.1) GOTO 999
      CLOSE(IOMATER)
 1000 FORMAT(16I5)
 1130 FORMAT('*MATERIAL,NAME=M00010',A)
 2000 FORMAT('*ELASTIC'/E15.6,2(1H,,E15.6))
 2010 FORMAT('*PLASTIC')
 2011 FORMAT(E15.6,1H,,E15.6)
      RETURN
  999 CONTINUE
      WRITE(IO_WRITE,3000) STRING(1:LEN)
 3000 FORMAT(5X,'FILE ',A,' does not exist'/
     &       5X,'ENTER keyword 0 for STOP, and 1 for retrying:')
      READ(IO_READ,'(I5)') KEYWORD
      IF(KEYWORD.EQ.1) GOTO 5
      STOP
      END
C
      SUBROUTINE MATER6
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CH_USER*80,CA*20,STRFMT*27
C
      CALL LOCCHR(STRING,'NORM    ',4,1,K1,K2)
      IF(K2.GT.K1) THEN
         CA=',NORMAL=SMOTH'
         IF(STRING(K1:K1+3).EQ.'UNSM') CA=',NORMAL=UNSMOTH'
      ELSE
         CA='                    '
      ENDIF
C
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:5).EQ.'*COHE') THEN
        IF(IOUT.NE.1) WRITE(IO_OUTP,1112) CNUM(IMATS),CNUM(IMATS),CA
        READ(IO_INPUT,'(I5/(8E15.7))') NM,(PROPS(K,IMATS),K=3,NM+2)
        PROPS(1,IMATS)=NM+2
        WRITE(IO_OUTP,2001) (PROPS(K,IMATS),K=3,NM+2)
      ELSEIF (STRING(1:4).EQ.'*ABA') THEN
        CALL LOCCHR(STRING,'MODEL   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
	  READ (STRING(K1:K1),'(I1)') INTERM
	ELSE
	  WRITE(IO_WRITE,1000)
	  READ (IO_READ,*) INTERM
        END IF
	IFIXED = 1
        IF (INDEX(STRING,'FIX').NE.0) IFIXED = 0
        READ(IO_INPUT,'(I5/8E15.7)') NM,(PROPS(K,IMATS),K=3,NM+2)
        READ(IO_INPUT,'(A)') CH_USER
	PROPS(NM+3,IMATS) = REAL(INTERM)
	PROPS(1,IMATS) = NM + 3
        WRITE(IO_OUTP,2100) CNUM(IMATS)
	IF (NM.LE.6) WRITE (STRFMT,2101) NM
	IF (NM.EQ.7) STRFMT='(7(G10.4,","),I3/I3)'
	IF (NM.EQ.8) STRFMT='(7(G10.4,","),/,I3,",",I3)'
	IF (NM.GT.8) WRITE (STRFMT,2102) NM
        WRITE(IO_OUTP,STRFMT) (PROPS(K,IMATS),K=3,NM+2),INTERM,IFIXED
        WRITE(IO_OUTP,2003) CH_USER
      ELSE
        BACKSPACE 1
      END IF
C
      RETURN
C
 1000 FORMAT('NUMBER OF ABAQUS COHESIVE POTENTIAL FUNCTION REQUIRED:',
     1       /,'1=NEEDLEMAN, 2=ROSE, 3=LIN. PLEASE INSERT NUMBER:')
 1112 FORMAT('*INTERFACE,ELSET=E00000',A,',NAME=M00010',A,A)
 2001 FORMAT('*COHESIVE'/(8G10.4))
 2003 FORMAT('*USER SUBROUTINE,INPUT=',A)
 2100 FORMAT('*UEL PROPERTY,ELSET=E00000',A2)
 2101 FORMAT('(',I1,'(G10.4,","),I3,",",I3)')
 2102 FORMAT('(8G10.4,/,',I1,'(G10.4,","),I3,",",I3)')
      END
C
      SUBROUTINE DPRAGER(EY,PS,HN,RMU,S0,NT,PRAGER,BT,AF,IO_OUTP)
      IMPLICIT REAL*8(A-H,O-z)
      SE=PRAGER
      SQ3=SQRT(3.0)
      CONST=1.0 / (1.0D0+RMU/SQ3)
      IF(RMU.NE.0.0) THEN
         PARAK=1.0D0
         PI=4.0D0*DATAN(1.0D0)
         BTA=DATAN(SQ3*RMU)
         BETA=BTA*180.0D0/PI
         FAI=BETA
         WRITE(IO_OUTP,2000)
         WRITE(IO_OUTP,2010) BETA,PARAK,FAI
         WRITE(IO_OUTP,1000) EY,PS
         WRITE(IO_OUTP,1010) 'TENSION'
      ELSE
         WRITE(IO_OUTP,1000) EY,PS
         WRITE(IO_OUTP,1020)
      ENDIF
      E0=S0/EY
      D=(SE-S0)/NT
      S=S0
      IF(HN.LT.9998.0) THEN
         NT=NT+1
         DO 100 I=1,NT
            SS=S/S0
            EPS=E0*SS**HN-S/EY
            SIG=S*CONST
            WRITE(IO_OUTP,3000) SIG,EPS
            S=S+D
  100    CONTINUE
         NT=NT+1
         S=S*10.0
         SS=S/S0
         EPS=E0*SS**HN-S/EY
         SIG=S*CONST
         WRITE(IO_OUTP,3000) SIG,EPS
      ELSE
         WRITE(IO_OUTP,3000) S0*CONST,0.
C        WRITE(IO_OUTP,3000) S0*CONST,1.0D+10
      ENDIF
      RETURN
 1000 FORMAT('*ELASTIC'/E15.6,',',F7.3)
 1010 FORMAT('*DRUCKER PRAGER HARDENING, TYPE=',A)
 1020 FORMAT('*PLASTIC')
 2000 FORMAT('*DRUCKER PRAGER,DEPENDENCES=3')
 2010 FORMAT(F11.6,2(',',F11.6))
 3000 FORMAT(E15.9,',',D15.9)
      END
C
C     SUBROUTINE TO DEFINE INTERFACE ELEMENTS
C
      SUBROUTINE INTER
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CHINTER*10
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. INTER'
C
      TEXT='NOW EXCUTING SUB. INTER'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KEYSL=0
      INORMAL=0
      NSET_SOLID=NTYPE
C
      READ(IO_INPUT,'(A)') CHINTER
      IF(CHINTER(1:5).EQ.'INTER') THEN
        IF(CHINTER(6:6).EQ.'1') THEN
          INTERTY=1
          INORMAL=NTYPE
          K1=24
          K2=1
        ELSE IF(CHINTER(6:6).EQ.'2') THEN
          INTERTY=2
          INORMAL=0
          K1=24
          K2=2
        END IF
        CALL INTER1
      ELSE IF(CHINTER(1:3).EQ.'ISL') THEN
        INTERTY=3
        IF(CHINTER(4:5).EQ.'21') THEN
          KEYSL=1
          K1=23
          K2=1
          CALL ISL21
        ELSE IF(CHINTER(4:5).EQ.'31') THEN
          K1=23
          K2=2
          KEYSL=2
        END IF
      END IF
C
      DO LCH=10,1,-1
        IF(CHINTER(LCH:LCH).NE.' ') GOTO 100
      END DO
  100 CONTINUE
      DO K=2,INTERSET(1)
        NTYPE=NTYPE+1
        NSETS=NSETS+1
        ELSET_TYP(NTYPE)=CHINTER(1:LCH)
      END DO
C
      RETURN
      END
C
C     SUBROUTINE TO DETERMINE NODES ON INTERFACES
C
      SUBROUTINE DSLINE
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IEL(10),IELOC(10),INLOC(10)
C
C     DETERMIN NODES ON INTERFACES
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCULTING SUB. DSLINE'
      TEXT='NOW EXCUTING SUB. DSLINE'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      ICHECK=0
      READ(IO_INPUT,'(2I5/(8I5))') NN,ICHECK,(INTERSET(I),I=2,NN+1)
      NN=NN+1
      INTERSET(1)=NN
      READ(IO_INPUT,'(8I5)') (NSDN(I),I=1,NN-1)
      READ(IO_INPUT,'(6E12.5)') ((SLCD(J,I),J=1,3),I=1,NN-1)
      INTERSET(1)=NN
      DO I=1,NNODE
      IWORK(I)=I
      END DO
      DO J=1,INTERSET(1)-1
        SLX=SLCD(1,J)
        SLY=SLCD(2,J)
        SLZ=SLCD(3,J)
        RMIN=1.0E30
        XLM=1.0E-3*SLX+1.0E-15
        YLM=1.0E-3*SLY+1.0E-15
        ZLM=1.0E-3*SLZ+1.0E-15
        DO IN=1,NNODE
          X=COORD(IN,1)
          Y=COORD(IN,2)
          Z=COORD(IN,3)
          R=SQRT((X-SLX)*(X-SLX)+(Y-SLY)*(Y-SLY)+(Z-SLZ)*(Z-SLZ))
          IF(R.LT.RMIN) THEN
            RMIN=R
            SLCD(1,J)=X
            SLCD(2,J)=Y
            SLCD(3,J)=Z
          END IF
        END DO
    4   CONTINUE
      END DO
      DO I=1,5
      NSLINE(1,I)=1
      END DO
      INTERND=NNODE
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        DO J=1,NODE
          IN=LNODS(I,J)
          NT=NUMBORD(IN,1)
          IF(NT.EQ.0) THEN
            NUMBORD(IN,1)=1
            NUMBORD(IN,2)=IMSET
          ELSE IF(NT.GT.0) THEN
            KEY=0
            DO IK=1,NT
              IF(IMSET.EQ.NUMBORD(IN,IK+1)) KEY=1
            END DO
            IF(KEY.EQ.0) THEN
              NUMBORD(IN,1)=NUMBORD(IN,1)+1
              NUMBORD(IN,NUMBORD(IN,1)+1)=IMSET
              IM1=NUMBORD(IN,2)*10+IMSET
              IM2=NUMBORD(IN,2)+IMSET*10
              DO K=2,INTERSET(1)
                ITM=INTERSET(K)/10
                ITM=INTERSET(K)
                IF(IM1.EQ.ITM.OR.IM2.EQ.ITM) THEN
                  ISLINE=K-1
                  IMM=INTERSET(K)-(ITM/10)*10
                  NSLINE(1,ISLINE)=NSLINE(1,ISLINE)+1
                  NSLINE(NSLINE(1,ISLINE),ISLINE)=IN*10+IMM
                  INTERND=INTERND+1
                  IWORK(IN)=INTERND*10+IMM
                END IF
              END DO
            END IF
          END IF
        END DO
      END DO
      DO IN=1,NNODE
        IF(NUMBORD(IN,1).GT.1) THEN
          X=COORD(IN,1)
          Y=COORD(IN,2)
          R=SQRT(X*X+Y*Y)
          WRITE(35,'(I5,3E12.5,5I5)') 
     &   IN,X,Y,R,(NUMBORD(IN,K+1),K=1,NUMBORD(IN,1))
        END IF
      END DO
      PI=4.0*ATAN(1.0)
      DO I=1,INTERSET(1)-1
        NN=NSLINE(1,I)
        DO J=2,NN
          TMIN=1.0E+30
          KJ=J
          DO K=J,NN
            IN=NSLINE(K,I)/10
            X=COORD(IN,1)
            Y=COORD(IN,2)
            DX=X-SLCD(1,I)
            DY=Y-SLCD(2,I)
            IF(ABS(DX).GT.0.0) THEN
              TH=ATAN(DY/DX)
              IF(DX.LT.0.) THEN
                TH=PI+TH
              END IF
            ELSE
              IF(DY.GT.0) THEN
                TH=PI/2.0
              ELSE IF(DY.LT.0) THEN
                TH=3.0*PI/2.
              END IF
            END IF
            IF(TH.LT.TMIN) THEN
              TMIN=TH
              KJ=K
            END IF
          END DO
          CSLINE(J,I)=TMIN
          IF(KJ.NE.J) THEN
            KM=NSLINE(KJ,I)
            NSLINE(KJ,I)=NSLINE(J,I)
            NSLINE(J,I)=KM
          END IF
        END DO
      END DO
      DO I=1,INTERSET(1)-1
       IF(NSDN(I).EQ.-1) THEN
        NN=NSLINE(1,I)-1
        NN2=NN/2
        DO J=1,NN2
          KM=NSLINE(J+1,I)
          NSLINE(J+1,I)=NSLINE(NN+2-J,I)
          NSLINE(NN+2-J,I)=KM
          CM=CSLINE(J+1,I)
          CSLINE(J+1,I)=CSLINE(NN+2-J,I)
          CSLINE(NN+2-J,I)=CM
        END DO
       END IF
      END DO
      IF(ICHECK.EQ.0) RETURN
      DO I=1,INTERSET(1)-1
        NN=NSLINE(1,I)
        X0=SLCD(1,I)
        Y0=SLCD(2,I)
        DO J=2,NN
         K1=NSLINE(J,I)/10
         X=COORD(K1,1)
         Y=COORD(K1,2)
         R=SQRT((X-X0)*(X-X0)+(Y-Y0)*(Y-Y0))
         TH=CSLINE(J,I)*180.0/PI
         write(32,'(4I9,2F12.4)') I,J,K1,IWORK(k1),R,TH
        END DO
      END DO
      CLOSE(32)
      RETURN
      END
C
C     SUBROUTINE TO DEFINE INTERFACE ELEMENTS
C
      SUBROUTINE ISL21
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IEL(10),IELOC(10),INLOC(10)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCULTING SUB. ISL21'
      NSEL=NELEM
      DO IT=1,INTERSET(1)-1
        NN=NSLINE(1,IT)
        IM=INTERSET(IT+1)-INTERSET(IT+1)/10*10
        DO IS=2,NN-1
          INLOC(1)=NSLINE(IS,IT)/10
          INLOC(2)=NSLINE(IS+1,IT)/10
          DO I=1,NELEM
            NODE=LNODS(I,MXNOD)
            IMSET=LNODS(I,MXNOD-1)
            DO J=1,NODE
              NBORD=NBORD+1
              J1=J
              J2=J+1
              IF(J2.GT.NODE) J2=1
              IEL(1)=LNODS(I,J1)
              IEL(2)=LNODS(I,J2)
              IF(IM.EQ.IMSET) THEN
                IF((IEL(1).EQ.INLOC(1).AND.IEL(2).EQ.INLOC(2)).OR.
     1          (IEL(2).EQ.INLOC(1).AND.IEL(1).EQ.INLOC(2))) THEN
                  NSEL=NSEL+1
                  IMM=NTYPE+IT
                  LNODS(NSEL,1)=IWORK(INLOC(1))/10
                  LNODS(NSEL,2)=IWORK(INLOC(2))/10
                  LNODS(NSEL,MXNOD)=2
                  LNODS(NSEL,MXNOD-1)=IMM
                  MATSET(IMM,1)=MATSET(IMM,1)+1
                  MATSET(IMM,MATSET(IMM,1))=NSEL
                  GOTO 10
                END IF
              END IF
            END DO
          END DO
  10      CONTINUE
        END DO
      END DO
c     DO I=NELEM+1,NSEL
c      nn=lnods(i,MXNOD)
c      write(33,'(12i5)') i,(LNODS(I,J),j=1,nn)
c     END DO
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        DO J=1,NODE
          IN=LNODS(I,J)
          IF(IN.NE.IWORK(IN)) THEN
            IN1=IWORK(IN)/10
            IM1=IWORK(IN)-IN1*10
            IF(IM1.NE.IMSET) THEN
              LNODS(I,J)=IN1
              INCOD(IN1)=1
              DO L=1,3
                COORD(IN1,L)=COORD(IN,L)
              END DO
            END IF
          END IF
        END DO
      END DO
      NNODE=INTERND
      NELEM=NSEL
      RETURN
      END
C
C     SUBROUTINE TO DEFINE INTERFACE ELEMENTS INTER1
C
      SUBROUTINE INTER1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IEL(10),IELOC(10),INLOC(10)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCULTING SUB. INTER1'
      NSEL=NELEM
      DO IT=1,INTERSET(1)-1
        IMM=NTYPE+IT
        NN=NSLINE(1,IT)
        IM=INTERSET(IT+1)-INTERSET(IT+1)/10*10
        NODE=2
        IF(INTERTY.EQ.2) THEN
          NN=NN-1
          NODE=4
        END IF
        DO IS=2,NN
          NSEL=NSEL+1
          DO II=1,INTERTY
          IN=NSLINE(IS+II-1,IT)/10
          LNODS(NSEL,II)=IN
          LNODS(NSEL,NODE+II)=IS+II-1
          JJ=2*INTERTY+1-II
          LNODS(NSEL,JJ)=IWORK(IN)/10
          END DO
          LNODS(NSEL,MXNOD)=NODE
          LNODS(NSEL,MXNOD-1)=IMM
          MATSET(IMM,1)=MATSET(IMM,1)+1
          MATSET(IMM,MATSET(IMM,1))=NSEL
        END DO
      END DO
C     DO I=NELEM+1,NSEL
C      nn=lnods(i,MXNOD)
C      write(33,'(12i5)') i,(LNODS(I,J),j=1,nn)
C     END DO
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        DO J=1,NODE
          IN=LNODS(I,J)
          IF(IN.NE.IWORK(IN)) THEN
            IN1=IWORK(IN)/10
            IM1=IWORK(IN)-IN1*10
            IF(IM1.NE.IMSET) THEN
              LNODS(I,J)=IN1
              INCOD(IN1)=1
              DO L=1,3
                COORD(IN1,L)=COORD(IN,L)
              END DO
            END IF
          END IF
        END DO
      END DO
      NNODE=INTERND
      NELEM=NSEL
      RETURN
      END
C
C     WRITE CONTACT RIGID SURFACE DEFINITION AND INTERFACE PROPERTIES
C
      SUBROUTINE CONTACT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*1 CHTK
      CHARACTER INTERP*20,ESET*10,NAME*10,SOFTEN*8,CHNORM*8,CTYPE*8
      CHARACTER*9 CHSM(2)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CONTACT'
C
      TEXT='NOW EXCUTING SUB. CONTACT'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      CHSM(1)='LINEAR   '
      CHSM(2)='PARABOLIC'
C
C     DEFINING THE INTERFACE PROPERTIES
C
      KEYSU=0
      KEYSO=0
      KEYFR=0
C
      READ(IO_INPUT,'(12I5)') NINTER
      INORM=0
      DO I=1,NINTER
    1   READ(IO_INPUT,'(A)') INTERP
        IF(INTERP(1:10).EQ.'*INTERFACE') THEN
          READ(IO_INPUT,'(A)') ESET
          READ(IO_INPUT,'(A)') NAME
          DO NEL=10,1,-1
            IF(ESET(NEL:NEL).NE.' ') GOTO 2
          END DO
    2     CONTINUE
          DO NNA=10,1,-1
            IF(NAME(NNA:NNA).NE.' ') GOTO 4
          END DO
    4     CONTINUE
          WRITE(IO_OUTP,3001) ESET(1:NEL),NAME(1:NNA)
          DO IMSET=1,NTYPE
            STRING=ELSET_TYP(IMSET)
            CHNORM=ELSET_NAME(IMSET)
            HL=0.0
            IF(STRING(1:6).EQ.'INTER1'.AND.
     &        CHNORM(1:NNA).EQ.ESET(1:NNA)) THEN
              NN=MATSET(IMSET,1)-1
              DO J=2,NN
                IE1=MATSET(IMSET,J)
                NODE=LNODS(IE1,MXNOD)
                IN1=LNODS(IE1,1)
                X1=COORD(IN1,1)
                Y1=COORD(IN1,2)
                IE2=MATSET(IMSET,J+1)
                IN2=LNODS(IE2,1)
                X2=COORD(IN2,1)
                Y2=COORD(IN2,2)
                RL=SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
                CRL=HL+0.5*RL
                HL=0.5*RL
                IL=LNODS(IE1,NODE+1)
                TH=CSLINE(IL,IMSET-NSET_SOLID)
                CNX=COS(TH)
                CNY=SIN(TH)
                CNZ=0.0
                INORM=INORM+1
                CHNORM(1:5)='I0000'
                IF(INORM.LT.10) THEN
                  WRITE(CHNORM(5:5),'(I1)') INORM
                ELSE IF(INORM.LT.100) THEN
                  WRITE(CHNORM(4:5),'(I2)') INORM
                ELSE IF(INORM.LT.1000) THEN
                  WRITE(CHNORM(3:5),'(I3)') INORM
                END IF
                WRITE(IO_OUTP,1011) CHNORM(1:5),CRL,CNX,CNY,CNZ
                IF(J.EQ.NN) THEN
                  INORM=INORM+1
                  IF(INORM.LT.10) THEN
                    WRITE(CHNORM(5:5),'(I1)') INORM
                  ELSE IF(INORM.LT.100) THEN
                    WRITE(CHNORM(4:5),'(I2)') INORM
                  ELSE IF(INORM.LT.1000) THEN
                    WRITE(CHNORM(3:5),'(I3)') INORM
                  END IF
                  IL=LNODS(IE2,NODE+1)
                  TH=CSLINE(IL,IMSET-NSET_SOLID)
                  CNX=COS(TH)
                  CNY=SIN(TH)
                  CNZ=0.0
                  WRITE(IO_OUTP,1011) CHNORM(1:5),HL,CNX,CNY,CNZ
                END IF
              END DO
            END IF
          END DO
 1011 FORMAT('*INTERFACE,ELSET=',A5/4F10.7)
          GOTO 1
C         READ(IO_INPUT,'(A1)') CHTK
C         IF(CHTK.EQ.'*') THEN
C           BACKSPACE 1
C         ELSE
C           BACKSPACE 1
C           READ(IO_INPUT,'(4E12.5)') THK,CN1,CN2,CN3
C         END IF
C         IF(THK.EQ.0) THK=1.0
C
C  *** SURFACE CONTACT
C
        ELSE IF(INTERP(1:7).EQ.'*NORMAL') THEN
          READ(IO_INPUT,'(A)') CTYPE
          WRITE(IO_OUTP,2010)
          DO IMSET=1,NTYPE
            STRING=ELSET_NAME(IMSET)
            IF(STRING(1:8).EQ.CTYPE(1:8)) THEN
              DO J=2,MATSET(IMSET,1)
                IE=MATSET(IMSET,J)
                NODE=LNODS(IE,MXNOD)
                DO K=1,NODE/2
                  IN=LNODS(IE,K)
                  IL=LNODS(IE,NODE+K)
                  TH=CSLINE(IL,IMSET-NSET_SOLID)
                  CNX=COS(TH)
                  CNY=SIN(TH)
                  CNZ=0.0
                  WRITE(IO_OUTP,2011) IE,IN,CNX,CNY,CNZ
                END DO
              END DO
            END IF
          END DO
 2010 FORMAT('*NORMAL')
 2011 FORMAT(2I5,3F10.7)
          GOTO 1
        ELSE IF(INTERP(1:16).EQ.'*SURFACE CONTACT') THEN
          READ(IO_INPUT,'(A)') SOFTEN
          IF(SOFTEN.EQ.'SOFTENED') THEN
            READ(IO_INPUT,'(2E12.5)') SOF1,SOF2
            KEYSO=1
            KEYSU=0
          ELSE
            BACKSPACE 1
            READ(IO_INPUT,'(2E12.5)') SUF1,SUF2
            KEYSO=0
            KEYSU=1
          END IF
          GOTO 1
C
C  *** FRICTION
C
        ELSE IF(INTERP(1:9).EQ.'*FRICTION') THEN
          READ(IO_INPUT,'(3E12.5)') FRF1,FRF2,FRF3
          KEYFR=1
          IF(IOUT.NE.1) THEN
            IF(INTERTY.NE.1) THEN
              WRITE(IO_OUTP,3001) ESET(1:NEL),NAME(1:NNA)
              IF(CHTK.NE.'*') WRITE(IO_OUTP,3002) THK,CN1,CN2,CN3
              IF(KEYSO.NE.0) WRITE(IO_OUTP,3010) SOF1,SOF2
              IF(KEYSU.NE.0) WRITE(IO_OUTP,3012) SUF1,SUF2
              IF(KEYFR.NE.0) WRITE(IO_OUTP,3014) FRF1,FRF2,FRF3
            ELSE
              CHNORM='I0000'
              NN=NSLINE(1,I)
              DO J=2,NN
                INORM=INORM+1
                IF(INORM.LT.10) THEN
                  WRITE(CHNORM(5:5),'(I1)') INORM
                ELSE IF(INORM.LT.100) THEN
                  WRITE(CHNORM(4:5),'(I2)') INORM
                ELSE IF(INORM.LT.1000) THEN
                  WRITE(CHNORM(3:5),'(I3)') INORM
                END IF
                WRITE(IO_OUTP,3001) CHNORM,NAME(1:NNA)
                TH=CSLINE(J,I)
                CN1=COS(TH)
                CN2=SIN(TH)
                CN3=0.0
                WRITE(IO_OUTP,3002) THK,CN1,CN2,CN3
                IF(KEYFR.NE.0.AND.J.EQ.2) 
     &            WRITE(IO_OUTP,3014) FRF1,FRF2,FRF3
                IF(KEYSO.NE.0.AND.J.EQ.2) 
     &            WRITE(IO_OUTP,3010) SOF1,SOF2
                IF(KEYSU.NE.0.AND.J.EQ.2) 
     &            WRITE(IO_OUTP,3012) SUF1,SUF2
              END DO
            END IF
          END IF
C       
C      DEFINE SLIDE LINE
C
          GOTO 1
        ELSE IF(INTERP(1:11).EQ.'*SLIDE LINE') THEN
          READ(IO_INPUT,'(A,1X,E12.5)') INTERP(1:6),SF
          KEYSM=0
          IF(INTERP(1:6).EQ.'SMOOTH') THEN
            KEYSM=1
          ELSE
            BACKSPACE 1
          END IF
          IF(IOUT.NE.1) THEN
            IF(KEYSM.EQ.1) THEN
              WRITE(IO_OUTP,4001) ESET(1:NEL),CHSM(KEYSL),SF
            ELSE
              WRITE(IO_OUTP,4002) ESET(1:NEL),CHSM(KEYSL)
            END IF
            WRITE(IO_OUTP,4003) (NSLINE(J,I),J=2,NSLINE(1,I))
          END IF
          GOTO 1
        ELSE
          BACKSPACE 1
          GOTO 300
        END IF
      END DO
C
  300 CONTINUE
      TEXT='END OF EXCUTING SUB. CONTACT'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
 2001 FORMAT('*INTERFACE,ELSET=',A)
 2100 FORMAT('*RIGID SURFACE,ELSET=EIRS,TYPE=SEGMENTS'
     1 /'START,',E12.5,1H,,F12.5/'LINE, ',E12.5,1H,,F12.5)
 3001 FORMAT('*INTERFACE,ELSET=',A,',NAME=',A)
 3002 FORMAT(4F10.6)
 3010 FORMAT('*SURFACE CONTACT,SOFTENED'/2F10.5)
 3012 FORMAT('*SURFACE CONTACT'/2F10.5)
 3014 FORMAT('*FRICTION'/3E10.4)
 4001 FORMAT('*SLIDE LINE,','ELSET=',A,',TYPE=',A9,',SMOOTH=',F5.2)
 4002 FORMAT('*SLIDE LINE,','ELSET=',A,',TYPE=',A9)
 4003 FORMAT(16I5)
      RETURN
      END
C
