C
C     OUTPUT
C
      SUBROUTINE MESHOUT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION EL(500),CL(500),NCONT(200),IW(50)
C
      CHARACTER CTYPE*8, CHNORM*8
      CHARACTER TITLE*120
      CHARACTER CELSD(MXMSET)*8

C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESHOUT'
C
      TEXT='NOW EXCUTING SUB. MESHOUT'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF

      KCGPESET1 = 0
      KCGPESET2 = 0
 
      READ(IO_INPUT,'(A)') TITLE
C     WRITE(IO_WRITE,1000) TITLE
      IF(INDEX(STRING,'SPARSE').GT.0) THEN
         WRITE(IO_OUTP,1100) TITLE
      ELSE
         WRITE(IO_OUTP,1101) TITLE
      ENDIF
      IF(INDEX(STRING,'USER').GT.0) THEN
	 DO I = 1,NTYPE
	    IF (ELSET_TYP(I)(1:1) .EQ. "U") THEN
	       READ(ELSET_TYP(I)(2:2),'(I1)') IUTYP
	       IF (IUTYP.LE.2) THEN
	          WRITE(IO_OUTP,1110) ELSET_TYP(I),4,7,14
	       ELSE
	          IUSRND = LNODS(MATSET(I,2),MXNOD)
		  NUVARS = 40
		  IF (IUTYP.EQ.3) NUVARS = 10
		  IF (IUTYP.EQ.4 .AND. IUSRND.EQ.6) NUVARS = 30
	          WRITE(IO_OUTP,1111) ELSET_TYP(I),IUSRND,6,NUVARS
	       ENDIF
	       GOTO 100
	    ENDIF
	 END DO
      ENDIF
 1000 FORMAT(' PROBLEM TITLE IS : ',A)
 1100 FORMAT('*HEADING,SPARSE'/A)
 1101 FORMAT('*HEADING'/A)
 1110 FORMAT('*USER ELEMENT,TYPE=',A2,',NODES=',I2,',PROPERT=',I1,
     1       ',IPROP=2,','COORDI=2,VAR=',I2,/,' 1,2')
 1111 FORMAT('*USER ELEMENT,TYPE=',A2,',NODES=',I2,',PROPERT=',I1,
     1       ',IPROP=2,','COORDI=3,VAR=',I2,/,' 1,2,3')
C
C     **************** BEGIN IF(IOUT.NE.1) ****************
C
  100 CONTINUE
C
      IF(IOUT.EQ.1) RETURN
      KCGPE = 0
      DO I=1,NTYPE
        STRING=ELSET_TYP(I)
        IF(STRING(1:4).EQ.'CGPE') KCGPE = 1
      END DO
C *** node output
      WRITE(IO_OUTP,2000)
 2000 FORMAT('*NODE, SYSTEM=R')
      DO IN=1,NNODE
       X=COORD(IN,1)
       Y=COORD(IN,2)
       Z=COORD(IN,3)
       WRITE(IO_OUTP,2001) IN,X,Y,Z
      END DO
      IF(KCGPE.EQ.1) THEN
        X = 0.0E0
        Y = 0.0E0
        Z = 0.0E0
        NNODE = NNODE + 1
        WRITE(IO_OUTP,2001) NNODE,X,Y,Z
        KCGPESET1 = NNODE
        NNODE = NNODE + 1
        WRITE(IO_OUTP,2001) NNODE,X,Y,Z
        KCGPESET2 = NNODE
c       WRITE(IO_OUTP,2002) 1,KCGPESET1
c       WRITE(IO_OUTP,2002) 2,KCGPESET2
      END IF
c2002 FORMAT('*NSET,NSET=CGPEND',I1/I5,1H,)
C
 2001 FORMAT(I10,1H,,E15.9,2(1H,,E15.9))
 2002 FORMAT('*NODE,NSET=RSNODE'/I10,1H,,E15.9,2(1H,,E15.9))
C
C *** element output
C
      KICONT=0
      KECONT=0
      NELSD = 0
      IF(NTYPE.LE.0) NTYPE=1
      DO I=1,NTYPE
        KN=MATSET(I,1)
        KCGPE = 0
        IF(KN.GT.1) THEN
          STRING=ELSET_TYP(I)
C         IF(STRING(1:1).EQ.'I') THEN
C           KICONT=KICONT+1
C           CTYPE(1:8)='I00000'//CNUM(KICONT)
C         ELSE
            KECONT=KECONT+1
            CTYPE(1:8)='E00000'//CNUM(KECONT)
C         END IF
          IF(STRING(1:4).EQ.'CGPE') KCGPE = 1
          ELSET_NAME(I)=CTYPE(1:8)
          NELSD = NELSD + 1
          CELSD(NELSD) = CTYPE(1:8)
          WRITE(IO_OUTP,2010) ELSET_TYP(I),ELSET_NAME(I)
          DO J=2,KN
            IE=MATSET(I,J)
            IF(IE.NE.0) THEN
              NODE=LNODS(IE,MXNOD)
              DO IN = 1,NODE
                IW(IN) = LNODS(IE,IN)
              END DO
              IF(KCGPE.EQ.1) THEN
                NODE = NODE + 1
                IW(NODE) = KCGPESET1
                NODE = NODE + 1
                IW(NODE) = KCGPESET2
              END IF
              WRITE(IO_OUTP,2011) IE,(IW(IN),IN=1,NODE)
            END IF
          END DO
        END IF
      END DO
 2010 FORMAT('*ELEMENT,TYPE=',A8,',ELSET=',A)
 2011 FORMAT(11(I6,','))
C
C     OUTPUT THE NORMAL DEFINATION
C
      INORM=0
      DO I=1,NTYPE
        KN=MATSET(I,1)
        STRING=ELSET_TYP(I)
        IF(STRING(1:6).EQ.'INTER1') THEN
          DO J=2,KN
            CHNORM='I000'
            INORM=INORM+1
            IF(INORM.LT.10) THEN
              WRITE(CHNORM(5:5),'(I1)') INORM
            ELSE IF(INORM.LT.100) THEN
              WRITE(CHNORM(4:5),'(I2)') INORM
            ELSE IF(INORM.LT.1000) THEN
              WRITE(CHNORM(3:5),'(I3)') INORM
            END IF
            IE=MATSET(I,J)
            WRITE(IO_OUTP,3000) CHNORM(1:5),IE
          END DO
        END IF
      END DO
c         DO I=1,INTERSET(1)-1
c           WRITE(IO_OUTP,3010)
c           NN=NSLINE(1,I)
c           IMSET=INORMAL+I
c           DO J=2,NN
c             IE=MATSET(IMSET,J)
c             IN=NSLINE(J,I)/10
c             TH=CSLINE(J,I)
c             CNX=COS(TH)
c             CNY=SIN(TH)
c             CNZ=0.0
c             WRITE(IO_OUTP,3011) IE,IN,CNX,CNY,CNZ
c           END DO
c         END DO
c       END IF
 3000 FORMAT('*ELSET,ELSET=',A/I5)
 3010 FORMAT('*NORMAL')
 3011 FORMAT(2I5,3F10.7)
      IF(KCGPESET1.NE.0) THEN
        WRITE(IO_OUTP,4000) 'CGPNSET',1,KCGPESET1
        NDSET = NDSET + 1
        INSET(1,NDSET) = KCGPESET1
        NNSET(NDSET)  = 1
        CNDSET(NDSET) = 'CGPNSET1'
      END IF
      IF(KCGPESET2.NE.0) THEN
        WRITE(IO_OUTP,4000) 'CGPNSET',2,KCGPESET2
        NDSET = NDSET + 1
        INSET(1,NDSET) = KCGPESET2
        NNSET(NDSET)  = 1
        CNDSET(NDSET) = 'CGPNSET2'
      END IF
 4000 FORMAT('*NSET,NSET=',A,I1/I5)
C
C     Define a global elset
C
C     IF(NELSD.GT.1) WRITE(IO_OUTP,5000) (CELSD(K),K=1,NELSD)
 5000 FORMAT('*ELSET,ELSET=GLOBAL'/(5(A,1H,)))
C
C     **************** END IF(IOUT.NE.1) ****************
C
      RETURN
      END
