C----------------------------------------------------------------------
C     DEFINE ELEMENT SETS FOR DIFFERENT MATERIALS 
C----------------------------------------------------------------------
C
      SUBROUTINE MRNELSET
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
C
      TEXT='NOW EXCUTING SUB. MRNELSET'
      TEXT1=' '
      WRITE(IO_JNL,'(5X,A)') TEXT
      WRITE(IO_WRITE,'(5X,A)') TEXT
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IOUNIT = IO_INPUT
      CALL LOCCHR(STRING,'INPUT    ',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        TEXT = STRING(K1:K2)
        IO_INPUT = 31
        OPEN(IO_INPUT,FILE=TEXT(1:K2-K1+1),STATUS='OLD',ERR=5)
        GOTO 6
    5   CONTINUE
        CERRRPT(1)(20:80)= ': *RENEW ELSET  option - parameter INPUT'
        CERRRPT(2)(20:80)= ': File-'//TEXT(1:K2-K1+1)//' does not exist'
        NLERR = 2
        IUNIT = 6
        CALL MERRPT(IUNIT,KERR,NLERR)
        STOP
    6   CONTINUE
      END IF
      IMSET1 = 0
      IMSET2 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,9,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*MULTIMAT,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*POLYGON',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*POINT  ',20X,'(option)'/21X,'X1, Y1, Z1',
     & /20X,'*CIRCLE ',20X,'(option)'/21X,'Xo, Yo , R1, R2, TH1, TH2'/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
C
C
      NSETS = 0
      DO I=1,MXMSET
        IF(MATSET(I,1).LE.1) GOTO 111
	NSETS=NSETS+1
      END DO
  111 CONTINUE
Ctest write (io_write,*) "sets defined up to now:",nsets
      CALL FIND_ELSET_new(IMSET1,IWORK,NELE)
      IF (NELE .GT. 0) THEN
         IF (IMSET2.GT.0) THEN
            KIM = IMSET2
         ELSE
            KIM = NSETS + 1
         END IF
	 DO I = 1, NELE
	    IE = IWORK(I)
	    IMSET = LNODS(IE,MXNOD-1)
            LNODS(IE,MXNOD-1)=KIM
            MATSET(KIM,1)=MATSET(KIM,1)+1
            MATSET(KIM,MATSET(KIM,1))=IE
            IF (ELSET_TYP(KIM)(1:4).EQ.'    ') 
     &         ELSET_TYP(KIM)=ELSET_TYP(IMSET)
C---------  deleting the element in the old element set list...
	    DO J = 2,MATSET(IMSET,1)
	       IF (IE .EQ. MATSET(IMSET,J)) THEN
	          MATSET(IMSET,J) = 0
	          GOTO 200
	       ENDIF
	    END DO
  200       CONTINUE
         END DO
	 WRITE (IO_WRITE,3000) MATSET(KIM,1)-1,"PUT",KIM
         KSETB = 1
         KSETE = NSETS
         IF(IMSET1.GT.0) THEN
           KSETB = IMSET1
           KSETE = IMSET1
         END IF
         DO IMSET=KSETB,KSETE
	    K = 1
	    DO J = 2,MATSET(IMSET,1)
	       IF (MATSET(IMSET,J).NE.0) THEN
	          K = K + 1
	          IF (J.NE.K) MATSET(IMSET,K) = MATSET(IMSET,J)
	       ENDIF
	    END DO
            MATSET(IMSET,1) = K
	    WRITE (IO_WRITE,3000) K-1,"LET",IMSET
	 END DO
      ELSE
	 WRITE (IO_WRITE,3100)
      END IF
C
C     CALL MATSET_ORDER 
      DO IMSET=1,NTYPE 
	DO J=2,MATSET(IMSET,1)
          IE =  MATSET(IMSET,J)
          LNODS(IE,MXNOD-1) = IMSET
        END DO
      END DO
C     NTYPE=NTYPE+1
C
      IF(IO_INPUT.NE.IOUNIT) CLOSE(IO_INPUT,STATUS='KEEP')
      IO_INPUT = IOUNIT
      RETURN
  900 CONTINUE
        WRITE(STRING,'(A,I2)') 'maximum is',MXAREA
        CERRRPT(1)(20:80) = ': Too many material aeras, '//STRING
        NLERR = 1
        IUNIT = 6
        CALL MERRPT(IUNIT,KERR,NLERR)
        IUNIT = IO_INFO
        CALL MERRPT(IUNIT,KERR,NLERR)
      RETURN
 3000 FORMAT (I5," ELEMENTS ",A," IN ELEMENT GROUP ",I2,
     &           " WITH *RENEW ELSET")
 3100 FORMAT ("NO ELEMENTS FOUND FOR NEW ELSET")
      END
