      SUBROUTINE WRENUM
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION JNEW(NEMAX),NEWEL(NEMAX),JPOS(NEMAX),JMEM(NEMAX),
     & MEMJ(MXMEM),JOINT(NEMAX),IW(MXNOD),JW(MXNOD),NEWM(NEMAX),
     & LNODSM(NEMAX,MXNOD)
      CHARACTER ELTYPM(NEMAX)*8
C
C *** ORIGINAL WAVE FRONTWIDTH
C
      CALL CWFRONT(NFRON0)
C
C *** LOOKING FOR THE CONNECTING ELEMENT
C
      DO JELEM=1,NELEM
        ELTYPM(JELEM)=ELTYP(JELEM)
        DO K=1,MXNOD
          LNODSM(JELEM,K)=LNODS(JELEM,K)
        END DO
      END DO
      NEDIF=0
      JSUB =0
      DO IELEM=1,NELEM
        NODEI=LNODS(IELEM,MXNOD)
C       JSUB=(IELEM-1)*MXCON
        DO INODE=1,NODEI
          IW(INODE)=LNODS(IELEM,INODE)
        END DO
        DO JELEM=1,NELEM
          IF(JELEM.NE.IELEM) THEN
            NODEJ=LNODS(JELEM,MXNOD)
            DO JNODE=1,NODEJ
              JW(JNODE)=LNODS(JELEM,JNODE)
              DO INODE=1,NODEI
                IF(LNODS(IELEM,INODE).EQ.LNODS(JELEM,JNODE)) THEN
                  JMEM(IELEM)=JMEM(IELEM)+1
                  MJT=JSUB+JMEM(IELEM)
                  MEMJ(MJT)=JELEM
                  IF(IABS(IELEM-JELEM).GT.NEDIF) NEDIF=IABS(IELEM-JELEM)
                  GOTO 10
                END IF
              END DO
            END DO
   10       CONTINUE
          END IF
        END DO
        JPOS(IELEM)=JSUB
        JSUB=JSUB+JMEM(IELEM)
      END DO
C
C *** OPTIMAL WAVE FRONT WIDTH
C
      MINMX=NEDIF
      KSTAR=0
      DO IELEM=1,NELEM
        DO JELEM=1,NELEM
          NEWEL(JELEM)=0
          JOINT(JELEM)=0
        END DO
        MAXEL=0
        KELEM=1
        NEWEL(KELEM)=IELEM
        JOINT(IELEM)=KELEM
        KCONT=1
   20   CONTINUE
        NELCN=JMEM(NEWEL(KELEM))
        IF(NELCN.EQ.0) GOTO 40
        JSUB=(NEWEL(KELEM)-1)*MXCON
        JSUB=JPOS(NEWEL(KELEM))
        DO JELCN=1,NELCN
          IELCN=MEMJ(JSUB+JELCN)
          IF(JOINT(IELCN).EQ.0) THEN
            KCONT=KCONT+1
            NEWEL(KCONT)=IELCN
            JOINT(IELCN)=KCONT
            NDIFF=IABS(KELEM-KCONT)
            IF(NDIFF.GT.MINMX) GOTO 70
            IF(NDIFF.GT.MAXEL) MAXEL=NDIFF
          END IF
        END DO
        IF(KCONT.EQ.NELEM) GOTO 50
   40   KELEM=KELEM+1
        GOTO 20
   50   MINMX=MAXEL
        KSTAR=IELEM
        DO JELEM=1,NELEM
          JNEW(JELEM)=JOINT(JELEM)
          NEWM(JELEM)=NEWEL(JELEM)
        END DO
        DO JELEM=1,NELEM
          NEWEL(JNEW(JELEM))=JELEM
        END DO
        DO JELEM=1,NELEM
          ELTYP(JELEM)=ELTYPM(NEWEL(JELEM))
          DO K=1,MXNOD
            LNODS(JELEM,K)=LNODSM(NEWEL(JELEM),K)
          END DO
        END DO
        CALL CWFRONT(NFRON1)
        IF(NFRON1.LT.MFRON) MFRON=NFRON1
   70   CONTINUE
      END DO
      IF(MINMX.LT.NEDIF) THEN
        DO IELEM=1,NELEM
          NEWEL(JNEW(IELEM))=IELEM
        END DO
        DO IELEM=1,NELEM
          ELTYP(IELEM)=ELTYPM(NEWEL(IELEM))
          DO K=1,MXNOD
            LNODS(IELEM,K)=LNODSM(NEWEL(IELEM),K)
          END DO
        END DO
        CALL CWFRONT(NFRON1)
C       MFRON=NFRON1
      END IF
      WRITE(IO_INFO,'(1(4I6,2X))')
     &   (I,JNEW(I),NEWEL(I),NEWM(I),I=1,NELEM)
      WRITE(IO_INFO,1000)
      WRITE(IO_INFO,1010) NNODE,NELEM,NFRON0,MFRON
      WRITE(IO_INFO,1012) KSTAR
      WRITE(IO_WRITE,1000)
      WRITE(IO_WRITE,1010) NNODE,NELEM,NFRON0,NFRON1
      WRITE(IO_WRITE,1012) KSTAR
      IF(MINMX.GE.NEDIF) WRITE(IO_OUTPUT,1014)
 1000 FORMAT(//30X,'W A V E F R O N T  M I N I M I Z A T I O N'/)
 1010 FORMAT(
     & //5X,'NUMBER OF NODES                                 ',I6,
     &  /5X,'NUMBER OF ELEMENTS                              ',I6,
     &  /5X,'ORIGINAL MAXIMUM D.O.F WAVEFRONT ESTIMATED AS   ',I6,
     &  /5X,'OPTIMIZER RMS D.O.F WAVEFRONT ESTIMATED AS      ',I6//)
 1012 FORMAT(5X,'WAVEFRONT OPTIMIZED  BY CHOOSING:',I6,
     &  'AS THE STARTING ELEMENT'//)
 1014 FORMAT(5X,'OPTIMIZER IS UNSUCCESSFUL IN RENUMBERING ELEMENTS'//)
      RETURN
      END
      SUBROUTINE CWFRONT(NFRON)
      INCLUDE 'common'
      DIMENSION NDFOR(NEMAX)
      KLAST=0
      NLAST=0
      NDOFN=3
      IF(ELTYP(1)(1:3).NE.'C3D') NDOFN=2
      KDOFN=NDOFN
      DO IFRON=1,NELEM
        NDFOR(IFRON)=0
      END DO
      DO IPOIN=1,NNODE
        KSTAR=0
        DO IELEM=1,NELEM
          NODE=LNODS(IELEM,MXNOD)
          DO INODE=1,NODE
            LNODE=LNODS(IELEM,INODE)
            IF(LNODE.NE.IPOIN) GOTO 50
            IF(KSTAR.NE.0) GOTO 40
            KSTAR=IELEM
            NDFOR(IELEM)=NDFOR(IELEM)+NDOFN
   40       CONTINUE
            KLAST=IELEM
            NLAST=INODE
   50       CONTINUE
          END DO
        END DO
        IF(KLAST.LT.NELEM) NDFOR(KLAST+1)=NDFOR(KLAST+1)-KDOFN
      END DO
      NFRON=0
      KFRON=0
      DO IELEM=1,NELEM
        NFRON=NFRON+NDFOR(IELEM)
        IF(NFRON.GT.KFRON) KFRON=NFRON
      END DO
      NFRON=KFRON
      WRITE(IO_INFO,'(5(2HI=,I5,I6,2X))') (I,NDFOR(I),I=1,NELEM)
      RETURN
      END
