C
C     SUBROUTINE FOR GENERATING 3-D mesh form 2-D mesh
C
      SUBROUTINE MESH3D
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(28),ND_SCZ(20),SCZ_DI(20),TH_DI(20)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH3D'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. MESH3D'
C
      TEXT='NOW EXCUTING SUB. MESH3D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) THICK
      NODE_2D = LNODS(1,MXNOD)
      IF(NODE_2D.EQ.4) THEN
        NODE = 8
      ELSE IF(NODE_2D.EQ.8) THEN
        NODE = 20
      ELSE IF(NODE_2D.EQ.9) THEN
        NODE = 27
      END IF
      KEY3D=1
      IF(NODE.EQ.8) KEY3D=2
      READ(IO_INPUT,*) NN_SCZ,(ND_SCZ(I),SCZ_DI(I),TH_DI(I),I=1,NN_SCZ)
      ZT=0.0
      EL=1.0
      NTNUM=1
      NZNUM=0
      ZTHICK(1)=0.
      ZT1=0
      IF(THICK.GT.0) THEN
        DO K=1,NN_SCZ
          NZNUM=NZNUM+ND_SCZ(K)
          ZSCAL=SCZ_DI(K)
          IF(KEY3D.EQ.1) THEN
            DO I=1,ND_SCZ(K)
              ZT=ZT+EL*ZSCAL**I
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=(ZT1+ZT)*THICK*0.5
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=ZT*THICK
              ZT1=ZT
            END DO
          ELSE IF(KEY3D.EQ.2) THEN
            DO I=1,ND_SCZ(K)
              ZT=ZT+EL*ZSCAL**I
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=ZT*THICK
            END DO
          END IF
          EL=EL*ZSCAL**ND_SCZ(K)
        END DO
        DO I=1,NTNUM
          ZTHICK(I)=ZTHICK(I)/ZT
        END DO
      ELSE
        XZ0 = 0.0E0
        DO K=1,NN_SCZ
          ZT=0.0
          ZT0=0.0
          EL=1.0
          ZTHICK(1)=0.
          ZT1=0
          NZNUM=NZNUM+ND_SCZ(K)
          ZSCAL=SCZ_DI(K)
          DO I=1,ND_SCZ(K)
            ZT0=ZT0+EL*ZSCAL**I
          END DO
          ZT0=1.0/ZT0
          IF(KEY3D.EQ.1) THEN
            DO I=1,ND_SCZ(K)
              ZT=ZT+EL*ZSCAL**I
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=(ZT1+ZT)*TH_DI(K)*0.5*ZT0+XZ0
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=ZT*TH_DI(K)*ZT0+XZ0
              ZT1=ZT
            END DO
          ELSE IF(KEY3D.EQ.2) THEN
            DO I=1,ND_SCZ(K)
              ZT=ZT+EL*ZSCAL**I
              NTNUM=NTNUM+1
              ZTHICK(NTNUM)=ZT*TH_DI(K)*ZT0+XZ0
            END DO
          END IF
          XZ0 = XZ0+TH_DI(K)
        END DO
        THICK = XZ0
      END IF
C     WRITE(9,'(10E12.5)') (ZTHICK(I),I=1,NTNUM)
      DO I=1,NTNUM
        ZM=-ZTHICK(I)+THICK
        ZTHICK(I)=ZM
      END DO
C     DO I=1,NTNUM
C       NTHICK(1,I)=1
C     END DO
      NDLIG2(1)=1
      NDBLF(1)=1
C     WRITE(9,'(10E12.5)') (ZTHICK(I),I=1,NTNUM)
C
      ICT=NNODE
      DO I=1,NNODE
        COORD(I,3)=ZTHICK(1)
      END DO
      DO IZ=2,NTNUM
        NDTIP(IZ,1)=NDTIP(1,1)
        DO IT=2,NDTIP(1,1)
          IN_2D=NDTIP(1,IT)
          NDTIP(IZ,IT)=IN_2D+(IZ-1)*NNODE
        END DO
        Z=ZTHICK(IZ)
        DO I=1,NNODE
          X=COORD(I,1)
          Y=COORD(I,2)
          ICT=ICT+1
          IN=I+(IZ-1)*NNODE
          COORD(IN,1)=X
          COORD(IN,2)=Y
          COORD(IN,3)=Z
        END DO
      END DO
      IET=0
      DO IMSET=1,MXMSET
        MATSET(IMSET,1)=1
      END DO
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        DO K=1,NODE
          KWORK(K)=LNODS(I,K)
        END DO
        DO IZ=1,NZNUM
          IET=IET+1
          IE=I+(IZ-1)*NELEM
          IF(NODE.EQ.4) THEN
            ELTYP(IE)='C3D8'
            LNODS(IE,MXNOD)=8
            LNODS(IE,MXNOD-1)=IMSET
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE, 1)=KWORK(1)+(IZ-1)*NNODE
            LNODS(IE, 2)=KWORK(2)+(IZ-1)*NNODE
            LNODS(IE, 3)=KWORK(2)+IZ*NNODE
            LNODS(IE, 4)=KWORK(1)+IZ*NNODE
            LNODS(IE, 5)=KWORK(4)+(IZ-1)*NNODE
            LNODS(IE, 6)=KWORK(3)+(IZ-1)*NNODE
            LNODS(IE, 7)=KWORK(3)+IZ*NNODE
            LNODS(IE, 8)=KWORK(4)+IZ*NNODE
          ELSE IF(NODE.EQ.8) THEN
            ELTYP(IE)='C3D20'
            LNODS(IE,MXNOD)=20
            LNODS(IE,MXNOD-1)=IMSET
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE, 1)=KWORK(1)+2*(IZ-1)*NNODE
            LNODS(IE, 2)=KWORK(2)+2*(IZ-1)*NNODE
            LNODS(IE, 3)=KWORK(2)+2*IZ*NNODE
            LNODS(IE, 4)=KWORK(1)+2*IZ*NNODE
            LNODS(IE, 5)=KWORK(4)+2*(IZ-1)*NNODE
            LNODS(IE, 6)=KWORK(3)+2*(IZ-1)*NNODE
            LNODS(IE, 7)=KWORK(3)+2*IZ*NNODE
            LNODS(IE, 8)=KWORK(4)+2*IZ*NNODE
            LNODS(IE, 9)=KWORK(5)+2*(IZ-1)*NNODE
            LNODS(IE,10)=KWORK(2)+(2*IZ-1)*NNODE
            LNODS(IE,11)=KWORK(5)+2*IZ*NNODE
            LNODS(IE,12)=KWORK(1)+(2*IZ-1)*NNODE
            LNODS(IE,13)=KWORK(7)+2*(IZ-1)*NNODE
            LNODS(IE,14)=KWORK(3)+(2*IZ-1)*NNODE
            LNODS(IE,15)=KWORK(7)+2*IZ*NNODE
            LNODS(IE,16)=KWORK(4)+(2*IZ-1)*NNODE
            LNODS(IE,17)=KWORK(8)+2*(IZ-1)*NNODE
            LNODS(IE,18)=KWORK(6)+2*(IZ-1)*NNODE
            LNODS(IE,19)=KWORK(6)+2*IZ*NNODE
            LNODS(IE,20)=KWORK(8)+2*IZ*NNODE
          ELSE IF(NODE.EQ.9) THEN
            ELTYP(IE)='C3D27'
            LNODS(IE,MXNOD)=27
            LNODS(IE,MXNOD-1)=IMSET
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE, 1)=KWORK(1)+2*(IZ-1)*NNODE
            LNODS(IE, 2)=KWORK(2)+2*(IZ-1)*NNODE
            LNODS(IE, 3)=KWORK(2)+2*IZ*NNODE
            LNODS(IE, 4)=KWORK(1)+2*IZ*NNODE
            LNODS(IE, 5)=KWORK(4)+2*(IZ-1)*NNODE
            LNODS(IE, 6)=KWORK(3)+2*(IZ-1)*NNODE
            LNODS(IE, 7)=KWORK(3)+2*IZ*NNODE
            LNODS(IE, 8)=KWORK(4)+2*IZ*NNODE
            LNODS(IE, 9)=KWORK(5)+2*(IZ-1)*NNODE
            LNODS(IE,10)=KWORK(2)+(2*IZ-1)*NNODE
            LNODS(IE,11)=KWORK(5)+2*IZ*NNODE
            LNODS(IE,12)=KWORK(1)+(2*IZ-1)*NNODE
            LNODS(IE,13)=KWORK(7)+2*(IZ-1)*NNODE
            LNODS(IE,14)=KWORK(3)+(2*IZ-1)*NNODE
            LNODS(IE,15)=KWORK(7)+2*IZ*NNODE
            LNODS(IE,16)=KWORK(4)+(2*IZ-1)*NNODE
            LNODS(IE,17)=KWORK(8)+2*(IZ-1)*NNODE
            LNODS(IE,18)=KWORK(6)+2*(IZ-1)*NNODE
            LNODS(IE,19)=KWORK(6)+2*IZ*NNODE
            LNODS(IE,20)=KWORK(8)+2*IZ*NNODE
            LNODS(IE,21)=KWORK(9)+(2*IZ-1)*NNODE
            LNODS(IE,22)=KWORK(5)+(2*IZ-1)*NNODE
            LNODS(IE,23)=KWORK(7)+(2*IZ-1)*NNODE
            LNODS(IE,24)=KWORK(9)+2*(IZ-1)*NNODE
            LNODS(IE,25)=KWORK(6)+(2*IZ-1)*NNODE
            LNODS(IE,26)=KWORK(9)+2*IZ*NNODE
            LNODS(IE,27)=KWORK(8)+(2*IZ-1)*NNODE
          END IF
          CALL DNODE(IE,LNODS(IE,MXNOD))
        END DO
      END DO
      NELEM=IET
      NNODE=ICT
C
      TEXT='END OF EXCUTING SUB. MESH3D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D extended FEM mesh1
C
      SUBROUTINE MESH_EX3D1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (LENW1 = 1000, LENW2=1000, LENW3 = 2000 )
      DIMENSION WORK1(LENW1),WORK2(LENW2),KWORK_IJ(LENW1,LENW2),
     &  NUM_SE(LENW3),IE_TYP(LENW3),INTER_EXT(LENW3),
     & LNODS_BASE(1000,MXNOD_2D),
     & LCELDF_EXT(20,10),COEF_EXT(1000),NDCD_EXT(2,1000),
     & LNODS_EXT(1000,8,2),NDBDF_EXT(2,1000),
     & LNODS_MEM(1000,8,2),NDCD_MEM(2,1000,4)
C
      DIMENSION LCELDF(20,20,20),LCNDDF(30),LCWORK(10,6),
     & COEF_CD(20,6),NODE_CD(20,6,6),INTE_ND(20,6),NE_IETYP(6)
C
      TEXT='NOW EXCUTING SUB. MESH_EX3D1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
C
      LCELDF_EXT( 1,1)= 11
      LCELDF_EXT( 2,1)= 21
      LCELDF_EXT( 3,1)= 22
      LCELDF_EXT( 4,1)= 12
      LCELDF_EXT( 5,1)= 41
      LCELDF_EXT( 6,1)= 31
      LCELDF_EXT( 7,1)= 32
      LCELDF_EXT( 8,1)= 42
C
      LCELDF_EXT( 1,2)= 11
      LCELDF_EXT( 2,2)= 12
      LCELDF_EXT( 3,2)= 22
      LCELDF_EXT( 4,2)= 21
      LCELDF_EXT( 5,2)= 41
      LCELDF_EXT( 6,2)= 42
      LCELDF_EXT( 7,2)= 32
      LCELDF_EXT( 8,2)= 31
C
      CALL DATADEF(LCELDF,LCWORK,COEF_CD,NODE_CD,INTE_ND)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_EX3D'
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
      DO KEY_SND=1,6
        IEX_AXI=INT(FLOAT(KEY_SND)/2.0+0.5)
        CALL SEAND(INSET(1,KEY_SND),IEX_AXI,CBOUND(KEY_SND),
     &           NNSET(KEY_SND),1)
      END DO
C
      IMSET_ext = 1
      CALL LOCCHR(STRING,'ELSET',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET_ext
      END IF
C
C     READ(IO_INPUT,*) IMSET_ext
      READ(IO_INPUT,*) NN_TYP,(NUM_SE(K),IE_TYP(K),K=1,NN_TYP)
C     IF(NN_TYP.EQ.0) THEN
C       NN_TYP=1
C       IE_TYP(1)=6
C     END IF
C
      NODE_EXT = 8
C
      READ(IO_INPUT,*) NLOOP
C
      MEMO_KEY=0
      DO ILOOP=1,NLOOP
C
      READ(IO_INPUT,'(A)') STRING
C
      IF(STRING(1:2).EQ.'XL') THEN
        KEY_SND = 1
        VW3_AXI =-1.0
        IEX_AXI = 1
        IF(STRING(3:4).EQ.'ZY') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 3
          KW2_AXI = 2
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'YZ') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 2
          KW2_AXI = 3
          ILC_TYP = 2
        END IF
      ELSE IF(STRING(1:2).EQ.'XR') THEN
        KEY_SND = 2
        VW3_AXI = 1.0
        IEX_AXI = 1
        IF(STRING(3:4).EQ.'ZY') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 3
          KW2_AXI = 2
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'YZ') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 2
          KW2_AXI = 3
          ILC_TYP = 2
        END IF
      ELSE IF(STRING(1:2).EQ.'YU') THEN
        KEY_SND = 4
        VW3_AXI = 1.0
        IEX_AXI = 2
        IF(STRING(3:4).EQ.'XZ') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 1
          KW2_AXI = 3
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'ZX') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 3
          KW2_AXI = 1
          ILC_TYP = 2
        END IF
      ELSE IF(STRING(1:2).EQ.'YD') THEN
        KEY_SND =3
        VW3_AXI =-1.0
        IEX_AXI = 2
        IF(STRING(3:4).EQ.'XZ') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 1
          KW2_AXI = 3
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'ZX') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 3
          KW2_AXI = 1
          ILC_TYP = 2
        END IF
      ELSE IF(STRING(1:2).EQ.'ZB') THEN
        KEY_SND = 5
        VW3_AXI =-1.0
        IEX_AXI = 3
        IF(STRING(3:4).EQ.'XY') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 1
          KW2_AXI = 2
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'YX') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 2
          KW2_AXI = 1
          ILC_TYP = 2
        END IF
      ELSE IF(STRING(1:2).EQ.'ZF') THEN
        KEY_SND = 6
        IEX_AXI = 3
        VW3_AXI = 1.0
        IF(STRING(3:4).EQ.'XY') THEN
          VW1_AXI = 1.0
          VW2_AXI =-1.0
          KW1_AXI = 1
          KW2_AXI = 2
          ILC_TYP = 2
        ELSE IF(STRING(3:4).EQ.'YX') THEN
          VW1_AXI = 1.0
          VW2_AXI = 1.0
          KW1_AXI = 2
          KW2_AXI = 1
          ILC_TYP = 2
        END IF
      END IF
C
      NT_KW1=0
      NT_KW2=0
      DO IW=1,NNSET(KEY_SND)
        IN=INSET(IW,KEY_SND)
        W1=COORD(IN,KW1_AXI)
        W2=COORD(IN,KW2_AXI)
        IF(NT_KW1.EQ.0) THEN
          NT_KW1=1
          WORK1(NT_KW1)=W1
        ELSE
          DO K=1,NT_KW1
            IF(ABS(W1-WORK1(K)).LT.TOLER) GOTO 100
          END DO
          NT_KW1=NT_KW1+1
          WORK1(NT_KW1)=W1
        END IF
  100   CONTINUE
        IF(NT_KW2.EQ.0) THEN
          NT_KW2=1
          WORK2(NT_KW2)=W2
        ELSE
          DO K=1,NT_KW2
            IF(ABS(W2-WORK2(K)).LT.TOLER) GOTO 200
          END DO
          NT_KW2=NT_KW2+1
          WORK2(NT_KW2)=W2
        END IF
  200   CONTINUE
      END DO
C
      DO K=1,NT_KW1
        WORK1(K)=VW1_AXI*WORK1(K)
      END DO
      DO K=1,NT_KW2
        WORK2(K)=VW2_AXI*WORK2(K)
      END DO
C
      CALL ARRANG(WORK1,NT_KW1,LENW1)
      CALL ARRANG(WORK2,NT_KW2,LENW2)
C
      DO K=1,NT_KW1
        WORK1(K)=VW1_AXI*WORK1(K)
      END DO
      DO K=1,NT_KW2
        WORK2(K)=VW2_AXI*WORK2(K)
      END DO
C
      DO IW=1,NNSET(KEY_SND)
        IN=INSET(IW,KEY_SND)
        W1=COORD(IN,KW1_AXI)
        W2=COORD(IN,KW2_AXI)
        DO IKW1=1,NT_KW1
          IF(ABS(W1-WORK1(IKW1)).LT.TOLER) GOTO 300
        END DO
  300   CONTINUE
        DO IKW2=1,NT_KW2
          IF(ABS(W2-WORK2(IKW2)).LT.TOLER) GOTO 400
        END DO
  400   CONTINUE
        KWORK_IJ(IKW1,IKW2)=IN
      END DO
C
c     write(8,'(I5/(12e10.4))') nt_kw1,(work1(k),k=1,nt_kw1)
c     write(8,'(I5/(12e10.4))') nt_kw2,(work2(k),k=1,nt_kw2)
c     do k=1,nt_kw2
c     write(8,'(20I5)') (kwork_ij(i,k),i=1,nt_kw1)
c     end do
C
C     GENERATING LNODS BASE ELEMENT DINIFITION
C
      ICONT=0
      KEEP =0
      IF(NN_TYP.GT.1) THEN
        DO I=1,NN_TYP
          IF(NUM_SE(I).NE.0) THEN
            NT_ICONT=ICONT+NUM_SE(I)*LCWORK(2,IE_TYP(I))
            IF(NT_ICONT.GT.NT_KW1-1) GOTO 600
            ICONT=ICONT+NUM_SE(I)*LCWORK(2,IE_TYP(I))
          ELSE
            KEEP=I
          END IF
        END DO
      ELSE
        NN_TYP= 1
        NELGE = NT_KW1 - 1
        NEL30 = NELGE-(NELGE/3)*3
        NEL40 = NELGE-(NELGE/4)*4
        IF(NELGE.EQ.3) THEN
          NN_TYP= 1
          NUM_SE(1) = 1
          IE_TYP(1) = 3
        ELSE IF(NELGE.EQ.4) THEN
          NN_TYP= 1
          NUM_SE(1) = 1
          IE_TYP(1) = 4
        ELSE IF(IE_TYP(1).EQ.3.OR.IE_TYP(1).EQ.0) THEN
          IF(NEL30.EQ.0) THEN
            NN_TYP= 1
            NUM_SE(1) = NELGE/3
            IE_TYP(1) = 3
          ELSE IF(NEL30.EQ.1) THEN
            NN_TYP= 2
            NUM_SE(1) = NELGE/3 - 1
            IE_TYP(1) = 3
            NUM_SE(2) = 1
            IE_TYP(2) = 4
          ELSE IF(NEL30.EQ.2) THEN
            NN_TYP= 2
            IF(NELGE/3 - 2.GT.0) THEN
              NUM_SE(1) = NELGE/3 - 2
              IE_TYP(1) = 3
              NUM_SE(2) = 2
              IE_TYP(2) = 4
            ELSE
              NUM_SE(1) = NELGE/3
              IE_TYP(1) = 3
              NUM_SE(2) = NEL30
              IE_TYP(2) = 6
            END IF
          END IF
        ELSE
          IF(NEL40.EQ.0) THEN
            NN_TYP= 1
            NUM_SE(1) = NELGE/4
            IE_TYP(1) = 4
          ELSE IF(NEL40.EQ.1) THEN
            NN_TYP= 2
            IF(NELGE/4 - 2.GT.0) THEN
              NUM_SE(1) = NELGE/4 - 2
              IE_TYP(1) = 4
              NUM_SE(2) = 3
              IE_TYP(2) = 3
            ELSE
              NUM_SE(1) = NELGE/4
              IE_TYP(1) = 4
              NUM_SE(2) = NEL40
              IE_TYP(2) = 6
            END IF
          ELSE IF(NEL40.EQ.2) THEN
            NN_TYP= 2
            IF(NELGE/4 - 1.GT.0) THEN
              NUM_SE(1) = NELGE/4 - 1
              IE_TYP(1) = 4
              NUM_SE(2) = 2
              IE_TYP(2) = 3
            ELSE
              NUM_SE(1) = NELGE/4
              IE_TYP(1) = 4
              NUM_SE(2) = NEL40
              IE_TYP(2) = 6
            END IF
          ELSE IF(NEL40.EQ.3) THEN
            NN_TYP= 2
            NUM_SE(1) = NELGE/4
            IE_TYP(1) = 4
            NUM_SE(2) = 1
            IE_TYP(2) = 3
          END IF
        END IF
      END IF
  600 CONTINUE
      IF(KEEP.NE.0) NUM_SE(KEEP)=NT_KW1-1-ICONT
C
      BLMIN= 1.E30
      BLMAX=-1.E30
      IW1=0
      DO I=1,NN_TYP
        NN=NUM_SE(I)
        ITYP=IE_TYP(I)
        NDIN=LCWORK(2,ITYP)
        DO L=1,NN
          DO K=1,NDIN
            IW1=IW1+1
            IF(ITYP.LE.4) THEN
              BL=ABS(WORK1(IW1+1)-WORK1(IW1))
              IF(BLMIN.GT.BL.AND.BL.NE.0.0) BLMIN=BL
              IF(BLMAX.LT.BL.AND.BL.NE.0.0) BLMAX=BL
            END IF
          END DO
        END DO
      END DO
C
      IE=0
      ND0=0
      ND1=0
      ND2=0
      DO I=1,NN_TYP
        NN=NUM_SE(I)
        ITYP=IE_TYP(I)
        IF(ITYP.LE.2.OR.ITYP.EQ.5) THEN
          NODE_EXT = 20
        ELSE
          NODE_EXT = 8
        END IF
        NNEL=LCWORK(3,ITYP)
        NODE=LCWORK(6,ITYP)
        DO L=1,NN
          DO K=1,NNEL
            IE=IE+1
            LNODS_BASE(IE,MXNOD_2D)=NODE
            DO J=1,NODE
              LNODS_BASE(IE,J)=LCELDF(J,K,ITYP)+ND0
            END DO
          END DO
          NDIN=LCWORK(7,ITYP)
          DO K=1,NDIN
            INTER_EXT(K+ND1)=INTE_ND(K,ITYP)+ND0
          END DO
          NTNOD=LCWORK(4,ITYP)
          DO K=1,NTNOD
            NDCD_EXT(1,K+ND2)=NODE_CD(K,1,ITYP)+ND0
            NDCD_EXT(2,K+ND2)=NODE_CD(K,2,ITYP)+ND0
            COEF_EXT(K+ND2)=COEF_CD(K,ITYP)
          END DO
          ND0=ND0+LCWORK(1,ITYP)-2
          ND1=ND1+NDIN-1
          ND2=ND2+NTNOD-1
        END DO
      END DO
      NELEM_BASE=IE
      NNODE_BASE=ND0+2
      NT_NDCD=ND2+1
c
      IE=0
      IN=KWORK_IJ(1,1)
      CD_EXT0=COORD(IN,IEX_AXI)
      BL_EXT=0.60*(BLMIN+BLMAX)
      IF(BLMAX.GT.10.0*BLMIN) BL_EXT=0.25*(BLMIN+BLMAX)
      IF(BLMAX.LE.4.0*BLMIN) BL_EXT=0.60*BLMAX
      IF(BLMAX.LE.2.0*BLMIN) BL_EXT=BLMAX
      DO IW2=1,NT_KW2
          DO IN_BASE=1,NNODE_BASE
            NDBDF_EXT(1,IN_BASE)=IN_BASE+(IW2-1)*NNODE_BASE+NNODE
          END DO
          DO IW1=1,NT_KW1
            IN_INTER=INTER_EXT(IW1)
            NDBDF_EXT(1,IN_INTER)=KWORK_IJ(IW1,IW2)
          END DO
          DO K=1,NT_NDCD
            INC=INC+1
            IN1=NDBDF_EXT(1,NDCD_EXT(1,K))
            IF(IW2.EQ.1) THEN
              NDCD_MEM(1,K,2)=IN1
            END IF
            IF(IW2.EQ.NT_KW2) THEN
              NDCD_MEM(2,K,2)=IN1
            END IF
            IN2=NDBDF_EXT(1,NDCD_EXT(2,K))
            COEF=COEF_EXT(K)
            DCD_EXT=COEF*BL_EXT*VW3_AXI
            COORD(IN1,IEX_AXI)=COORD(IN2,IEX_AXI)+DCD_EXT
            COORD(IN1,KW1_AXI)=COORD(IN2,KW1_AXI)
            COORD(IN1,KW2_AXI)=COORD(IN2,KW2_AXI)
          END DO
      END DO
C
      IE=NELEM
      DO IW2=1,NT_KW2-1
          DO IN_BASE=1,NNODE_BASE
            NDBDF_EXT(1,IN_BASE)=IN_BASE+(IW2-1)*NNODE_BASE+NNODE
            NDBDF_EXT(2,IN_BASE)=IN_BASE+IW2*NNODE_BASE+NNODE
          END DO
            DO IW1=1,NT_KW1
              IN_INTER=INTER_EXT(IW1)
              NDBDF_EXT(1,IN_INTER)=KWORK_IJ(IW1,IW2)
              NDBDF_EXT(2,IN_INTER)=KWORK_IJ(IW1,IW2+1)
            END DO
          DO IE_BASE=1,NELEM_BASE
            NODE=LNODS_BASE(IE_BASE,MXNOD_2D)
            DO J=1,NODE
              IN=LNODS_BASE(IE_BASE,J)
              LNODS_EXT(IE_BASE,J,1)=NDBDF_EXT(1,IN)
              LNODS_EXT(IE_BASE,J,2)=NDBDF_EXT(2,IN)
            END DO
c           II=ie_base
c           write(13,'(i5,2x,20i5)') II,(LNODS_ext(II,J,1),j=1,node)
c           write(14,'(i5,2x,20i5)') II,(LNODS_ext(II,J,2),j=1,node)
          END DO
          DO IE_BASE=1,NELEM_BASE
            IE=IE+1
            DO J=1,NODE_EXT
              LN_BASE=LCELDF_EXT(J,ILC_TYP)/10
              I_BASE=LCELDF_EXT(J,ILC_TYP)-LN_BASE*10
              LNODS(IE,J)=LNODS_EXT(IE_BASE,LN_BASE,I_BASE)
            END DO
            IMSET=IMSET_EXT
            NODE=NODE_EXT
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C3D8'
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
c           write(8,'(i5,2x,20i5)') ie,(LNODS(IE,J),j=1,node)
            CALL DNODE(IE,NODE)
          END DO
      END DO
      NELEM=IE
      NNODE=NNODE+NNODE_BASE*NT_KW2
      MEM_AXI2=IEX_AXI
      MEM_AXI3=KW1_AXI
      IF(MEMO_KEY.GT.0) THEN
        DO K=1,NT_NDCD
          IN=NNODE+K
          IN1=NDCD_MEM(2,K,1)
          IN2=NDCD_MEM(1,K,2)
          COORD(IN,MEM_AXI1)=COORD(IN1,MEM_AXI1)
          COORD(IN,MEM_AXI2)=COORD(IN2,MEM_AXI2)
          COORD(IN,MEM_AXI3)=COORD(IN1,MEM_AXI3)
c         write(8,'(3I5,3e12.5)')
c    &    in1,in2,in,(COORD(IN,J),j=1,3)
          NDCD_MEM(1,K,1)=IN1
          NDCD_MEM(1,K,3)=IN
        END DO
        DO IW1=1,NT_KW1
          NDCD_MEM(1,IW1,4)=KWORK_IJ(IW1,1)
        END DO
C
C     ELEMENT DEFINITION
C
        ND0=0
        ND1=0
        IE=NELEM
        DO I=1,NN_TYP
          NN=NUM_SE(I)
          ITYP=IE_TYP(I)
          NNEL=LCWORK(9,ITYP)
          NDCD=LCWORK(8,ITYP)
          NDIN=LCWORK(7,ITYP)
          NODE=NODE_EXT
          DO L=1,NN
            DO K=1,NNEL
              IE=IE+1
              LNODS(IE,MXNOD)=NODE
              DO J=1,NODE
                K1=LCELDF(J,K,ITYP+10)/10
                K2=LCELDF(J,K,ITYP+10)-K1*10
                L1=K1+ND0
                IF(K2.EQ.4) L1=K1+ND1
                LNODS(IE,J)=NDCD_MEM(1,L1,K2)
              END DO
              IMSET=IMSET_EXT
              LNODS(IE,MXNOD)=NODE
              LNODS(IE,MXNOD-1)=IMSET
              ELTYP(IE)='C3D8'
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IE
c             write(8,'(i5,2x,20i5)') ie,(LNODS(IE,J),j=1,node)
              CALL DNODE(IE,NODE)
            END DO
            ND0=ND0+NDCD-1
            ND1=ND1+NDIN-1
          END DO
        END DO
C
        NELEM=IE
        NNODE=IN
      END IF
C
      MEMO_KEY=1
      MEM_AXI1=MEM_AXI2
      DO K=1,NT_NDCD
        NDCD_MEM(1,K,1)=NDCD_MEM(1,K,2)
        NDCD_MEM(2,K,1)=NDCD_MEM(2,K,2)
      END DO
C
C     end of iloop
C
      END DO
C
C     CALL REORDER
C
C
      TEXT='END OF EXCUTING SUB. MESH_EX3D1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D extended FEM mesh2
C
      SUBROUTINE MESH_EX3D2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (LENW1 = 1000, LENW2=1000)
      DIMENSION WORK1(LENW1),WORK2(LENW2),KWORK_IJ(1000,1000),
     & LNODS_BASE(1000,MXNOD_2D),NUM_SE(10),IE_TYP(10),INTER_EXT(1000),
     & LCELDF_EXT(20,10),COEF_EXT(1000),NDCD_EXT(2,1000),
     & LNODS_EXT(1000,8,2),NDBDF_EXT(2,1000)
C
      DIMENSION LCELDF(20,20,20),LCNDDF(30),LCWORK(10,6),
     & COEF_CD(20,6),NODE_CD(20,6,6),INTE_ND(20,6),NE_IETYP(6)
C
      TEXT='NOW EXCUTING SUB. MESH_EX3D2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      LCELDF_EXT( 1,1)= 11
      LCELDF_EXT( 2,1)= 21
      LCELDF_EXT( 3,1)= 22
      LCELDF_EXT( 4,1)= 12
      LCELDF_EXT( 5,1)= 41
      LCELDF_EXT( 6,1)= 31
      LCELDF_EXT( 7,1)= 32
      LCELDF_EXT( 8,1)= 42
C
      LCELDF_EXT( 1,2)= 11
      LCELDF_EXT( 2,2)= 12
      LCELDF_EXT( 3,2)= 22
      LCELDF_EXT( 4,2)= 21
      LCELDF_EXT( 5,2)= 41
      LCELDF_EXT( 6,2)= 42
      LCELDF_EXT( 7,2)= 32
      LCELDF_EXT( 8,2)= 31
C
      CALL DATADEF(LCELDF,LCWORK,COEF_CD,NODE_CD,INTE_ND)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_EX3D'
C
      IMSET_ext = 1
      CALL LOCCHR(STRING,'ELSET',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET_ext
      END IF
C
      READ(IO_INPUT,'(A)') STRING
      READ(IO_INPUT,*) NEXT,AEXT
      NN_TYP=1
      IE_TYP(1)=6
      NODE_EXT = 8
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
      IF(STRING(1:2).EQ.'XL') THEN
        KEY_SND = 1
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI =-1.0
        IEX_AXI = 1
        KW1_AXI = 3
        KW2_AXI = 2
        ILC_TYP = 2
C
      ELSE IF(STRING(1:2).EQ.'XR') THEN
        KEY_SND = 2
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI = 1.0
        IEX_AXI = 1
        KW1_AXI = 3
        KW2_AXI = 2
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'YU') THEN
        KEY_SND = 4
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI = 1.0
        IEX_AXI = 2
        KW1_AXI = 3
        KW2_AXI = 1
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'YD') THEN
        KEY_SND =3
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI =-1.0
        IEX_AXI = 2
        KW1_AXI = 3
        KW2_AXI = 1
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'ZB') THEN
        KEY_SND =5
        VW1_AXI = 1.0
        VW2_AXI = 1.0
        VW3_AXI =-1.0
        IEX_AXI = 3
        KW1_AXI = 1
        KW2_AXI = 2
        ILC_TYP = 2
      ELSE IF(STRING(1:2).EQ.'ZF') THEN
        KEY_SND = 6
        VW1_AXI = 1.0
        VW2_AXI =-1.0
        VW3_AXI = 1.0
        IEX_AXI = 3
        KW1_AXI = 1
        KW2_AXI = 2
        ILC_TYP = 2
      END IF
C
      CALL SEAND(INSET(1,KEY_SND),IEX_AXI,CBOUND(KEY_SND),
     &           NNSET(KEY_SND),1)
C
      NT_KW1=0
      NT_KW2=0
      DO IW=1,NNSET(KEY_SND)
        IN=INSET(IW,KEY_SND)
        W1=COORD(IN,KW1_AXI)
        W2=COORD(IN,KW2_AXI)
        IF(NT_KW1.EQ.0) THEN
          NT_KW1=1
          WORK1(NT_KW1)=W1
        ELSE
          DO K=1,NT_KW1
            IF(ABS(W1-WORK1(K)).LT.TOLER) GOTO 100
          END DO
          NT_KW1=NT_KW1+1
          WORK1(NT_KW1)=W1
        END IF
  100   CONTINUE
        IF(NT_KW2.EQ.0) THEN
          NT_KW2=1
          WORK2(NT_KW2)=W2
        ELSE
          DO K=1,NT_KW2
            IF(ABS(W2-WORK2(K)).LT.TOLER) GOTO 200
          END DO
          NT_KW2=NT_KW2+1
          WORK2(NT_KW2)=W2
        END IF
  200   CONTINUE
      END DO
C
      DO K=1,NT_KW1
        WORK1(K)=VW1_AXI*WORK1(K)
      END DO
      DO K=1,NT_KW2
        WORK2(K)=VW2_AXI*WORK2(K)
      END DO
C
      CALL ARRANG(WORK1,NT_KW1,LENW1)
      CALL ARRANG(WORK2,NT_KW2,LENW2)
C
      DO K=1,NT_KW1
        WORK1(K)=VW1_AXI*WORK1(K)
      END DO
      DO K=1,NT_KW2
        WORK2(K)=VW2_AXI*WORK2(K)
      END DO
C
      BL1_MIN= 1.E30
      BL1_MAX=-1.E30
      DO I=1,NT_KW1-1
        BL=ABS(WORK1(I+1)-WORK1(I))
        IF(BL1_MIN.GT.BL) BL1_MIN=BL
        IF(BL1_MAX.LT.BL) BL1_MAX=BL
      END DO
C
      BL2_MIN= 1.E30
      BL2_MAX=-1.E30
      DO I=1,NT_KW2-1
        BL=ABS(WORK2(I+1)-WORK2(I))
        IF(BL2_MIN.GT.BL) BL2_MIN=BL
        IF(BL2_MAX.LT.BL) BL2_MAX=BL
      END DO
      DO IW=1,NNSET(KEY_SND)
        IN=INSET(IW,KEY_SND)
        W1=COORD(IN,KW1_AXI)
        W2=COORD(IN,KW2_AXI)
        DO IKW1=1,NT_KW1
          IF(ABS(W1-WORK1(IKW1)).LT.TOLER) GOTO 300
        END DO
  300   CONTINUE
        DO IKW2=1,NT_KW2
          IF(ABS(W2-WORK2(IKW2)).LT.TOLER) GOTO 400
        END DO
  400   CONTINUE
        KWORK_IJ(IKW1,IKW2)=IN
      END DO
C
      IF(STRING(3:4).EQ.'CT') THEN
C
C       DETERMINING LDCT
C
        IF(KW2_AXI.EQ.2) THEN
          NLDCT=NT_KW2
          Y0=WORK2(NT_KW2)
          YEB=WORK2(1)-WORK2(NT_KW2)
          YEB=YEB*2.0/3.0+Y0
        ELSE IF(KW1_AXI.EQ.2) THEN
          NLDCT=NT_KW1
          Y0=WORK1(1)
          YEB=WORK1(NT_KW1)-WORK2(1)
          YEB=YEB*2.0/3.0+Y0
        END IF
        Y23=1.E20
        DO I=1,NLDCT
          IF(KW2_AXI.EQ.2) THEN
            Y=WORK2(I)
          ELSE IF(KW1_AXI.EQ.2) THEN
            Y=WORK1(I)
          END IF
          IF(ABS(Y-YEB).LT.Y23) THEN
            LDCT=I
            Y23=ABS(Y-YEB)
          END IF
        END DO
        IF(KW2_AXI.EQ.2) THEN
          LDCT=KWORK_IJ(1,LDCT)
        ELSE IF(KW1_AXI.EQ.2) THEN
          LDCT=KWORK_IJ(LDCT,1)
        END IF
      END IF
C
C     write(8,'(I5/(12e10.4))') nt_kw1,(work1(k),k=1,nt_kw1)
C     write(8,'(I5/(12e10.4))') nt_kw2,(work2(k),k=1,nt_kw2)
C     do k=1,nt_kw2
C     write(8,'(20I5)') (kwork_ij(i,k),i=1,nt_kw1)
C     end do
C
C     GENERATING LNODS BASE ELEMENT DINIFITION
C
      NUM_SE(1)=NT_KW1-1
      IE=0
      ND2=0
      DO I=1,NN_TYP
        NN=NUM_SE(I)
        ITYP=IE_TYP(I)
        NNEL=LCWORK(2,ITYP)
        NODE=LCWORK(6,ITYP)
        DO IW1=1,NT_KW1-1
          IE=IE+1
          LNODS_BASE(IE,MXNOD_2D)=NODE
          IF(NODE.EQ.4) THEN
            LNODS_BASE(IE,1)=IW1
            LNODS_BASE(IE,2)=IW1+1
            LNODS_BASE(IE,3)=IW1+1+NT_KW1
            LNODS_BASE(IE,4)=IW1+NT_KW1
          END IF
        END DO
        DO K=1,NT_KW1
          INTER_EXT(K)=K
        END DO
      END DO
      NELEM_BASE=IE
      NNODE_BASE=2*NT_KW1
c
C     do i=1,ie
C     write(8,'(10I5)') (lnods_base(i,j),j=1,node)
C     end do
      IE=0
      BL1_EXT=0.5*(BL1_MIN+BL1_MAX)
      BL2_EXT=0.5*(BL2_MIN+BL2_MAX)
      IF(BL1_MAX.GT.3*BL1_MIN) BL1_EXT=0.40*(BL1_MIN+BL1_MAX)
      IF(BL2_MAX.GT.3*BL2_MIN) BL2_EXT=0.40*(BL2_MIN+BL2_MAX)
      IF(BL1_MAX.GT.5*BL1_MIN) BL1_EXT=0.30*(BL1_MIN+BL1_MAX)
      IF(BL2_MAX.GT.5*BL2_MIN) BL2_EXT=0.30*(BL2_MIN+BL2_MAX)
      BL_EXT=DMAX1(BL1_EXT,BL2_EXT)
      EL_EXT0=BL_EXT*VW3_AXI
      IN0=KWORK_IJ(1,1)
      CD_EXT=COORD(IN0,IEX_AXI)
      RL=AEXT-CD_EXT
C
      IF(RL*VW3_AXI.LT.0.0) GOTO 900
C
      IF(NEXT.GT.0) THEN
        CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
        IF(SCL.LT.1.0) THEN
          IF(SCL.GT.0.9) THEN
            SCL=1.0
            EL_EXT0 = RL/FLOAT(NEXT)
          ELSE
            NEXT=INT(RL/EL_EXT0)
            SCL=1.0
            EL_EXT0 = RL/FLOAT(NEXT)
          END IF
        ELSE IF(SCL.GT.SCMAX) THEN
          DO I=1,90
            NEXT=NEXT+1
            CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
            IF(SCL.LT.SCMAX) GOTO 92
          END DO
   92     CONTINUE
          CALL SOLVSL(NEXT,EL_EXT0,RL,SCL)
        END IF
      ELSE
        NEXT=-NEXT
        EL_EXT0=RL/FLOAT(NEXT)
        SCL=1.0
      END IF
      SC_EXT=SCL
      DO IW2=1,NT_KW2
        IN0=KWORK_IJ(1,1)
        CD_EXT=COORD(IN0,IEX_AXI)
        DO IEX=1,NEXT
          CD_EXT=CD_EXT+EL_EXT0*SC_EXT**IEX
          DO IW1=1,NT_KW1
            IN1=IW1+IEX*NT_KW1+(IW2-1)*NT_KW1*NEXT+NNODE
            IN2=KWORK_IJ(IW1,IW2)
            COORD(IN1,IEX_AXI)=CD_EXT
            COORD(IN1,KW1_AXI)=COORD(IN2,KW1_AXI)
            COORD(IN1,KW2_AXI)=COORD(IN2,KW2_AXI)
C           write(8,'(2i5,3e12.5)') in2,in1,(coord(In1,J),j=1,3)
          END DO
        END DO
      END DO
C
      IE=NELEM
      DO IW2=1,NT_KW2-1
        DO IEX=1,NEXT
          DO IN_BASE=1,NNODE_BASE
            NDBDF_EXT(1,IN_BASE)=IN_BASE+(IW2-1)*NT_KW1*NEXT
     &      +(IEX-1)*NT_KW1+NNODE
            NDBDF_EXT(2,IN_BASE)=IN_BASE+IW2*NT_KW1*NEXT
     &      +(IEX-1)*NT_KW1+NNODE
          END DO
          IF(IEX.EQ.1) THEN
            DO IW1=1,NT_KW1
              IN_INTER=INTER_EXT(IW1)
              NDBDF_EXT(1,IN_INTER)=KWORK_IJ(IW1,IW2)
              NDBDF_EXT(2,IN_INTER)=KWORK_IJ(IW1,IW2+1)
            END DO
          END IF
          DO IE_BASE=1,NELEM_BASE
            NODE=LNODS_BASE(IE_BASE,MXNOD_2D)
            DO J=1,NODE
              IN=LNODS_BASE(IE_BASE,J)
              LNODS_EXT(IE_BASE,J,1)=NDBDF_EXT(1,IN)
              LNODS_EXT(IE_BASE,J,2)=NDBDF_EXT(2,IN)
            END DO
            II=ie_base
C           write(13,'(i5,2x,20i5)') II,(LNODS_ext(II,J,1),j=1,node)
C           write(14,'(i5,2x,20i5)') II,(LNODS_ext(II,J,2),j=1,node)
          END DO
          DO IE_BASE=1,NELEM_BASE
            IE=IE+1
            DO J=1,NODE_EXT
              LN_BASE=LCELDF_EXT(J,ILC_TYP)/10
              I_BASE=LCELDF_EXT(J,ILC_TYP)-LN_BASE*10
              LNODS(IE,J)=LNODS_EXT(IE_BASE,LN_BASE,I_BASE)
            END DO
            IMSET=IMSET_EXT
            NODE=NODE_EXT
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C3D8'
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
C           write(8,'(i5,2x,20i5)') ie,(LNODS(IE,J),j=1,node)
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END DO
      NELEM=IE
      NNODE=NNODE+(NEXT+1)*NT_KW1*NT_KW2
C
C     CALL REORDER
C
      TEXT='END OF EXCUTING SUB. MESH_EX3D2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  900 CONTINUE
      WRITE(6,1000) STRING(1:2),AEXT
 1000 FORMAT(///4X,5(1H*),' ERROR IN INPUT DATA FOR OPTION ',
     & 11H'*EXT_3D2' ,5(1H*)//
     & 4X,'KEY CHARACTER = ',1H',A,1H'/
     & 4X,'AEXT=',E10.4,' may be take opsitive signal'///)
      STOP
      END
