C
C     DEFINE BOUNDARY CONDITION
C
      SUBROUTINE BOUND1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. BOUND1'
C
      TEXT='NOW EXCUTING SUB. BOUND1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) IBOUND
      IF(IOUT.NE.1) WRITE(IO_OUTP,1310) 
 1310 FORMAT('*BOUNDARY')
 1330 FORMAT(4X,A8,1H,,I1,2H,,,E12.5)
 1331 FORMAT(I12,1H,,I1,2H,,,E12.5)
C
      IF(IBOUND.EQ.1.AND.IOUT.NE.1) THEN
         WRITE(IO_OUTP,1330) CNSET(1),1,0.0
         NLOC=INSET(2,1)
         WRITE(IO_OUTP,1331) NLOC,1,0.0
      ELSE IF(IBOUND.EQ.2.AND.IOUT.NE.1) THEN
         WRITE(IO_OUTP,1330) CNSET(1),1,0.0
         WRITE(IO_OUTP,1330) CNSET(3),2,0.0
      ELSE IF(IBOUND.EQ.3.AND.IOUT.NE.1) THEN
         WRITE(IO_OUTP,1330) CNSET(1),1,0.0
         WRITE(IO_OUTP,1330) CNSET(1),2,0.0
      ELSE IF(IBOUND.GT.90) THEN
         KU=IBOUND-(IBOUND/10)*10
         DO I=1,KU
            READ(IO_INPUT,'(A8,I5,F12.5)') CTYPE,K1,F1
            IF(IOUT.NE.1) WRITE(IO_OUTP,1330) CTYPE,K1,F1
         END DO
      ENDIF
C
      IF(KCON.NE.0.AND.IOUT.NE.1) THEN
         WRITE(IO_OUTP,1331) 9999,1,0.
         WRITE(IO_OUTP,1331) 9999,2,0.
         WRITE(IO_OUTP,1331) 9999,6,0.
      ENDIF
C
      TEXT='END OF EXCUTING SUB. BOUND1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     DEFINE BOUNDARY CONDITION
C
      SUBROUTINE MBOUNDARY
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CTYPE*8
      CHARACTER CHAR*8
C
      TEXT='NOW EXCUTING SUB. MBOUNDARY'
      CALL DTEXT(TEXT,LEN)
      WRITE(IO_JNL,'(5X,A)') TEXT(1:LEN)
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF

      KBOUND = 0
    5 CONTINUE
      CALL GETLINE (LEN,IERR)
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        RETURN
      ELSE
        IF(IOUT.EQ.1) GOTO 5
        KPOS0 = 1
	ITYPE(1) = -8
	ITYPE(2) = 1
	ITYPE(3) = 2
	INVAR = 3
        CALL SLVLINE(STRING,LEN,IERR)
        CHAR  = CVARR(1)(1:8)
	IFDOM = IVARR(2)
	FV    = RVARR(3)
C
        CALL FINDSET(CNDSET,NDSET,CHAR,ISET)
C
        IF(ISET.EQ.0) THEN
          CERRRPT(1)(20:80) = ': *BOUNDARY  option'
          CERRRPT(2)(20:80) =
     &    ': Node set: '//CHAR//' does not exist'
          CERRRPT(3)(20:80) = 
     &    ': Ignoring input card - '//STRING(1:LEN)
          NLERR = 3
          IUNIT = 6
          CALL MWARNING(IUNIT,KERR,NLERR)
          IUNIT = IO_INFO
          CALL MWARNING(IUNIT,KERR,NLERR)
          GOTO 5
        END IF
C
        IF(IOUT.NE.1) THEN
          IF(KBOUND.EQ.0) WRITE(IO_OUTP,1310) 
          WRITE(IO_OUTP,1330) CHAR,IFDOM,FV
          KBOUND = 1
        END IF
        GOTO 5
      END IF
C
 1001 FORMAT(10A)  
 1310 FORMAT('*BOUNDARY')
 1330 FORMAT(4X,A8,1H,,I1,2H,,,E12.5)
 1331 FORMAT(I12,1H,,I1,2H,,,E12.5)
C
      TEXT='END OF EXCUTING SUB. MBOUNDARY'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
