C
C     READ 3D MESH DAT FOR CAEDS OUTPUT DAT
C
      SUBROUTINE RCAEDS
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*1 TEXT_caeds(120),STA
      CHARACTER*7 TEXT1_caeds*7, TEXT2_caeds*3
      CHARACTER FILNAM*120
      CHARACTER*8 CMATER(10)
      CHARACTER  ELTYPE_C*8
      DIMENSION IEL(50),NDU(500,6),NWORK(500),XYZ(3)
      LOGICAL FEXIST1
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. RCAEDS'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. RCAEDS'
C
      IOUNIT = 25
      IREORD = 0
      TEXT='NOW EXCUTING SUB. RCAEDS'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,'(A)',END=20) STRING
      LEN = 160
      CALL DTEXT(STRING,LEN)
      FILNAM = STRING(1:LEN)
      WRITE(IO_INFO,'(5X,2A)') 'Input file - ',FILNAM
      INQUIRE (FILE=FILNAM,EXIST = FEXIST1 )
      IF(FEXIST1) THEN
         OPEN(IOUNIT,FILE=FILNAM,STATUS='OLD')
      ELSE
    1   CONTINUE
        WRITE(IO_WRITE,'(1X,A,1X,A,1X,A/1X,A,$)')
     &   ' Input file',FILNAM,' does not exists,',
     &   ' enter the new filename:'
        READ(IO_READ ,'(A)') STRING
        LEN = 160
        CALL DTEXT(STRING,LEN)
        INQUIRE (FILE=STRING(1:LEN),EXIST = FEXIST1 )
        IF(FEXIST1) THEN
          OPEN(IOUNIT,FILE=STRING(1:LEN),STATUS='OLD',ERR=20)
        ELSE
          GOTO 1
        END IF
      END IF
C
      AMAGX = 1.0D0
      AMAGY = 1.0D0
      AMAGZ = 1.0D0
    2 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
        GOTO 3
      ELSE
        CALL CONCHR(STRING,'REORDER ',7,1,IREORD)
        CALL LOCCHR(STRING,'MAGX    ',4,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) AMAGX
        END IF
        CALL LOCCHR(STRING,'MAGY    ',4,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) AMAGY
        END IF
        CALL LOCCHR(STRING,'MAGZ    ',4,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) AMAGZ
        END IF
        CALL LOCCHR(STRING,'ORIG    ',4,1,K1,K2)
        IF(K2.GT.K1) 
     &  READ(STRING(K1:K1+60),*) XTRANS,YTRANS,ZTRANS
      END IF
      GOTO 2
   3  CONTINUE
C
C     READ DATA GENERATED BY CAEDS
C
      NNODE0 = NNODE
      NELEM0 = NELEM
      NDIME  = 3
      DO I=1,28
      IEL(I)=0
      END DO
   5  CONTINUE
      READ(IOUNIT,'(A)',END=20) STRING
   6  IF(STRING(1:5).EQ.'*NODE') THEN
         WRITE(IO_WRITE,'(5X,2A)') 'READING NODE DATA FROM ',FILNAM
   7     CONTINUE
         READ(IOUNIT,'(A)',END=20) STRING
         IF(STRING(1:1).EQ.'*') GOTO 6
	 INVAR = 4
	 ITYPE(1) = 1
	 ITYPE(2) = 2
	 ITYPE(3) = 2
	 ITYPE(4) = 2
	 LEN=120
	 CALL DTEXT (STRING,LEN)
	 CALL SLVLINE (STRING,LEN,IERR)
	 IF (IERR.EQ.1) GOTO 6
         X=AMAGX*RVARR(2)+XTRANS
         Y=AMAGY*RVARR(3)+YTRANS
         Z=AMAGZ*RVARR(4)+ZTRANS
         NNODE=NNODE0+IVARR(1)
         INCOD(NNODE)=NNODE
         XDIST=X-XORIGN
         YDIST=Y-YORIGN
         COORD(NNODE,1)=X
         COORD(NNODE,2)=Y
         COORD(NNODE,3)=Z
	 GOTO 7
      ELSEIF(STRING(1:5).EQ.'*ELEM') THEN
         WRITE(IO_WRITE,'(5X,2A)') 'READING ELEMENT DATA FROM ',FILNAM
  12     CONTINUE
	 NSETS = NSETS + 1
         CALL LOCCHR(STRING,'TYPE    ',4,1,K1,K2)
         IF(K2.GE.K1) THEN
	   LTP = K2-K1+1
           READ(STRING(K1:K2),'(A)') ELTYPE_c(1:LTP)
	 ELSE
	   GOTO 900
         END IF
         IF(ELTYPE_c(1:2).EQ.'CP') ELTYPE_c(1:3)='C2D'
         IF(ELTYPE_c(LTP:LTP).EQ.'R') LTP=LTP-1
         IF(LTP.EQ.4) READ(STRING(K1+3:K1+3),'(I1)') NODE
         IF(LTP.GE.5) READ(STRING(K1+3:K1+4),'(I2)') NODE
  15     CONTINUE
         READ(IOUNIT,'(A)',END=20) STRING
         IF(STRING(1:8).EQ.'*ELEMENT') GOTO 12
         IF (STRING(1:1).EQ.'*') GOTO 20
	 NMIN8 = MIN0(8,NODE)
	 NMIN16 = MIN0(16,NODE)
	 NMIN24 = MIN0(24,NODE)
         READ(STRING,1000) K,(IEL(J),J=1,NMIN8)
	 IF (NODE.GT. 8) READ(IOUNIT,1001,END=20) (IEL(J),J= 9,NMIN16)
	 IF (NODE.GT.16) READ(IOUNIT,1001,END=20) (IEL(J),J=16,NMIN24)
	 IF (NODE.GT.24) READ(IOUNIT,1001,END=20) (IEL(J),J=25,NODE)
 1000    FORMAT (I7,8(',',I7))
 1001    FORMAT (8X,I7,7(',',I7))
         NELEM=NELEM+1
         IF(IREORD.EQ.1) THEN
	    IF (ELTYPE_c(1:4).EQ.'C2D4') THEN
               MMM    = IEL(2)
               IEL(2) = IEL(4)
               IEL(4) = MMM
            ELSEIF (ELTYPE_c(1:4).EQ.'C2D8') THEN
               MMM    = IEL(2)
               IEL(2) = IEL(4)
               IEL(4) = MMM
               MMM    = IEL(5)
               IEL(5) = IEL(8)
               IEL(8) = MMM
               MMM    = IEL(6)
               IEL(6) = IEL(7)
               IEL(7) = MMM
            END IF
	 END IF
         DO I=1,NODE
           LNODS(NELEM,I) = IEL(I)+NNODE0
         END DO
         LNODS(NELEM,MXNOD)=NODE
         LNODS(NELEM,MXNOD-1)=NSETS
         MATSET(NSETS,1)=MATSET(NSETS,1)+1
         MATSET(NSETS,MATSET(NSETS,1))=NELEM
         IF(ELSET_TYP(NSETS).EQ.'        ') THEN
           ELTYP(NELEM)=ELTYPE_c(1:LTP)
           ELSET_TYP(NSETS)=ELTYPE_c(1:LTP)
         ELSE
           ELTYP(NELEM)=ELSET_TYP(NSETS)
         END IF
         GOTO 15
      ELSE
         GOTO 5
      ENDIF
  20  CONTINUE
      CLOSE(IOUNIT,STATUS='KEEP')
      WRITE(IO_WRITE,'(5X,I6,A)') NNODE-NNODE0,
     1                      ' NODES READ FROM EXTERNAL INPUT FILE'
      WRITE(IO_WRITE,'(5X,I6,A)') NELEM-NELEM0,
     1                      ' ELEMENTS READ FROM EXTERNAL INPUT FILE'
C
      TEXT='END OF EXCUTING SUB. RCAEDS'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  900 CONTINUE
      RETURN
      END
C
C     SUBROUTINE OUTPUT GEOMETRY INFORMATION *.UGD FOR CAEDS
C
      SUBROUTINE TCAEDS
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION ID(3),IDN(8),IEL(21)
      DATA (ID(I),I=1,3)/0,0,11/
      DATA IDN/1,54,1,50,1,1,7,4/
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. TCAEDS '
     1 ,':(OUTPUT CAEDS FILE is abq.ugd)'
C
      TEXT='NOW EXCUTING SUB. TCAEDS :(OUTPUT CAEDS FILE is abq.ugd)'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
C     OUTPUT FILE *.UAL FOR CAEDS
C
      OPEN(99,FILE='abq.ugd',STATUS='UNKNOWN')
      WRITE(99,9901) -1
      WRITE(99,9901) 15
 9901 FORMAT(I6)
      ID(1)=0
      ID(2)=0
      ID(3)=11
      DO I=1,NNODE
      WRITE(99,9902) 
     1  I,ID,(COORD(I,K),K=1,3)
      END DO
 9902 FORMAT(4I10,3E13.6)
      WRITE(99,9901) -1
      WRITE(99,9901) -1
      WRITE(99,9901) 780
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        STRING(1:8)=ELTYP(I)
        IDN(1)=I
        IDN(8)=NODE
        IF(NODE.EQ.3) IDN(2)=51
        IF(NODE.EQ.6) IDN(2)=52
        IF(NODE.EQ.4) IDN(2)=54
        IF(NODE.EQ.8) IDN(2)=55
        IF(NODE.EQ.8.AND.STRING(1:3).NE.'C3D') THEN
          IEL(1)=LNODS(I,1)
          IEL(2)=LNODS(I,5)
          IEL(3)=LNODS(I,2)
          IEL(4)=LNODS(I,6)
          IEL(5)=LNODS(I,3)
          IEL(6)=LNODS(I,7)
          IEL(7)=LNODS(I,4)
          IEL(8)=LNODS(I,8)
        ELSE IF(NODE.LE.8.AND.STRING(1:3).EQ.'C3D') THEN
          IDN(2)=115
          IF(NODE.EQ.6) IDN(2)=112
          DO K=1,NODE
            IEL(K)=LNODS(I,K)
          END DO
        ELSE IF(NODE.EQ.6) THEN
          IEL(1)=LNODS(I,1)
          IEL(2)=LNODS(I,4)
          IEL(3)=LNODS(I,2)
          IEL(4)=LNODS(I,5)
          IEL(5)=LNODS(I,3)
          IEL(6)=LNODS(I,6)
        ELSE IF(NODE.LE.4) THEN
          DO J=1,NODE
            IEL(J)=LNODS(I,J)
          END DO
        ELSE IF(NODE.EQ.15) THEN
          IDN(2)=113
          IEL( 1)=LNODS(I, 1)
          IEL( 2)=LNODS(I, 7)
          IEL( 3)=LNODS(I, 2)
          IEL( 4)=LNODS(I, 8)
          IEL( 5)=LNODS(I, 3)
          IEL( 6)=LNODS(I, 9)
          IEL( 7)=LNODS(I,13)
          IEL( 8)=LNODS(I,14)
          IEL( 9)=LNODS(I,15)
          IEL(10)=LNODS(I, 4)
          IEL(11)=LNODS(I,10)
          IEL(12)=LNODS(I, 5)
          IEL(13)=LNODS(I,11)
          IEL(14)=LNODS(I, 6)
          IEL(15)=LNODS(I,12)
        ELSE IF(NODE.EQ.20) THEN
          IDN(2)=116
          IEL( 1)=LNODS(I, 1)
          IEL( 2)=LNODS(I, 9)
          IEL( 3)=LNODS(I, 2)
          IEL( 4)=LNODS(I,10)
          IEL( 5)=LNODS(I, 3)
          IEL( 6)=LNODS(I,11)
          IEL( 7)=LNODS(I, 4)
          IEL( 8)=LNODS(I,12)
          IEL( 9)=LNODS(I,17)
          IEL(10)=LNODS(I,18)
          IEL(11)=LNODS(I,19)
          IEL(12)=LNODS(I,20)
          IEL(13)=LNODS(I, 5)
          IEL(14)=LNODS(I,13)
          IEL(15)=LNODS(I, 6)
          IEL(16)=LNODS(I,14)
          IEL(17)=LNODS(I, 7)
          IEL(18)=LNODS(I,15)
          IEL(19)=LNODS(I, 8)
          IEL(20)=LNODS(I,16)
        ENDIF
        IDN(4)=IDN(2)/10*10
        WRITE(99,9903) IDN
        WRITE(99,9903) (IEL(J),J=1,NODE)
      END DO
      WRITE(99,9901) -1
 9903 FORMAT(8I10)
      CLOSE(99)
C
      TEXT='END OF EXCUTING SUB. TCAEDS'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
