C----------------------------------------------------------------------
C     CALCULATING MINMUM AND MAXIMUM ELEMENT LENGTH
C----------------------------------------------------------------------
      SUBROUTINE CMINLEN
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CMINLEN'
C
      TEXT='NOW EXCUTING SUB. CMINLEN'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      GL_MAX=-1.0E30
      GL_MIN=+1.0E30
      EL_MAX_RATIO=-1.0E30
      DO IELEM=1,NELEM
        EL_MAX=-1.0E30
        EL_MIN=+1.0E30
        NODE=LNODS(IELEM,MXNOD)
        IMSET=LNODS(IELEM,MXNOD-1)
        STRING=ELSET_TYP(IMSET)
        IF(KEY3D.EQ.0) THEN
          IF(NODE.LE.4) THEN
            NN=NODE
          ELSE
            NN=NODE/2
          END IF
          DO IN=1,NN
            IN1=IN
            IN2=IN+1
            IF(IN2.GT.NN) IN2=IN2-NN
            KNODE1=IN1
            INODE1=LNODS(IELEM,KNODE1)
            X1=COORD(INODE1,1)
            Y1=COORD(INODE1,2)
            Z1=COORD(INODE1,3)
            KNODE2=IN2
            INODE2=LNODS(IELEM,KNODE2)
            X2=COORD(INODE2,1)
            Y2=COORD(INODE2,2)
            Z2=COORD(INODE2,3)
C           IF(TOLER.GT.ABS(X2-X1)) TOLER=ABS(X2-X1)
C           IF(TOLER.GT.ABS(X2-X1)) TOLER=ABS(Y2-Y1)
C           IF(TOLER.GT.ABS(Z2-Z1)) TOLER=ABS(Z2-Z1)
            R=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2)+(Z1-Z2)*(Z1-Z2))
            IF(R.LT.EL_MIN.AND.R.GE.1.0E-12) EL_MIN=R
            IF(R.GT.EL_MAX.AND.R.GE.1.0E-12) EL_MAX=R
          END DO
        ELSE
          IF(NODE.EQ.20.OR.NODE.EQ.8) THEN
            DO IK=1,2
              NN=4*(IK-1)
              DO IN=1,4
                IN1=IN+NN
                IN2=IN1+1
                IF(IN.EQ.4) IN2=IN2-4
                KNODE1=IN1
                INODE1=LNODS(IELEM,KNODE1)
                X1=COORD(INODE1,1)
                Y1=COORD(INODE1,2)
                Z1=COORD(INODE1,3)
                KNODE2=IN2
                INODE2=LNODS(IELEM,KNODE2)
                X2=COORD(INODE2,1)
                Y2=COORD(INODE2,2)
                Z2=COORD(INODE2,3)
                R=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2)+
     &                 (Z1-Z2)*(Z1-Z2))
                IF(R.LT.EL_MIN.AND.R.GE.1.0E-12) EL_MIN=R
                IF(R.GT.EL_MAX.AND.R.GE.1.0E-12) EL_MAX=R
              END DO
            END DO
            DO IN=1,4
              IN1=IN
              IN2=IN1+4
              KNODE1=IN1
              INODE1=LNODS(IELEM,KNODE1)
              X1=COORD(INODE1,1)
              Y1=COORD(INODE1,2)
              Z1=COORD(INODE1,3)
              KNODE2=IN2
              INODE2=LNODS(IELEM,KNODE2)
              X2=COORD(INODE2,1)
              Y2=COORD(INODE2,2)
              Z2=COORD(INODE2,3)
              R=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2)+
     &               (Z1-Z2)*(Z1-Z2))
              IF(R.LT.EL_MIN.AND.R.GE.1.0E-12) EL_MIN=R
              IF(R.GT.EL_MAX.AND.R.GE.1.0E-12) EL_MAX=R
            END DO
          END IF
        END IF
        IF(GL_MIN.GT.EL_MIN) GL_MIN=EL_MIN
        IF(GL_MAX.LT.EL_MAX) GL_MAX=EL_MAX
        EL_RATIO=EL_MAX/EL_MIN
        IF(EL_MAX_RATIO.LT.EL_RATIO) THEN
          EL_MAX_RATIO=EL_RATIO
          IE_MAX_RATIO=IELEM
        END IF
      END DO
      IF(GL_MIN.LE.+1.0E20) THEN
        TOLER  = GL_MIN/100.0
        TOLER1 = GL_MIN/2.0
        GL_MAX_RATIO=GL_MAX/GL_MIN
      END IF
      IF(TOLER .LT.1.0E-12) TOLER  = 1.0E-12
      IF(TOLER1.LT.1.0E-12) TOLER1 = 1.0E-12
C     WRITE(IO_WORK,'(12E12.5)') EL_MAX_RATIO,GL_MIN,GL_MAX,GL_MAX_RATIO
C
      TEXT='END OF EXCUTING SUB. CMINLEN'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
