C
      SUBROUTINE DRAWMESH(KEY_DRAW)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*4 SPSIZE
      INCLUDE 'common'
      DIMENSION X_CORD(100),Y_CORD(100),NW(10)
      COMMON /MESHBORD/IX1_BORD,IY1_BORD,IX2_BORD,IY2_BORD
      CHARACTER KEYCHR*80,PSFILE*80,MPLFIL*80,DRWFIL*80
      LOGICAL LEX
      PARAMETER (IXXTEN = 595,IYXTEN = 842)
C
      DIMENSION ARRMPL(500),IARMPL(2,500)
      CHARACTER CARMPL(500)*8
C
      EQUIVALENCE (ARRMPL(1),IARMPL(1,1))
      EQUIVALENCE (ARRMPL(1),CARMPL(1))
C
C
      WRITE(IO_JNL,'(5X,A)') 'Now excuting DRAWMESH'
C
      IO_PS = 97
      IO_MPL= 98
      XMIN= 1.0E30
      YMIN= 1.0E30
      XMAX=-1.0E30
      YMAX=-1.0E30
      PHAI=45.0
      PI=4.0*ATAN(1.0)
      CHPHAI=COS(PHAI/180.0*PI)
      SHPHAI=SIN(PHAI/180.0*PI)
      DO I=1,NNODE
        X=COORD(I,1)-CHPHAI*COORD(I,3)
        Y=COORD(I,2)-SHPHAI*COORD(I,3)
        IF(XMIN.GT.X) XMIN=X
        IF(YMIN.GT.Y) YMIN=Y
        IF(XMAX.LT.X) XMAX=X
        IF(YMAX.LT.Y) YMAX=Y
      END DO
      XCENT_P=(XMAX+XMIN)/2.0
      YCENT_P=(YMAX+YMIN)/2.0
C
      SC_EXTR=1.0
      ICENTER=0
      IPOSTS =0
      IMPL   =0
      IINPUT =1
      IF(KEY_DRAW.EQ.1) GOTO 5
      CALL LOCCHR(STRING,'SCALE',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) SC_EXTR
      END IF
      CALL LOCCHR(STRING,'CX',2,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XCENT_P
	ICENTER = 1
      END IF
      CALL LOCCHR(STRING,'CY',2,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) YCENT_P
	ICENTER = 1
      END IF
      CALL LOCCHR(STRING,'PS',2,1,K1,K2)
      IF(K2.GE.K1) THEN
	IPOSTS = 1
        READ(STRING(K1:K2),*) DRWFIL
	LEN = K2 - K1 + 1
	LENPS = LEN + 6
	NFIL = 0
    1   CONTINUE
           NFIL = NFIL + 1
           PSFILE = DRWFIL(1:LEN) // ".ps." // CNUM(NFIL)
           INQUIRE (FILE=PSFILE(1:LENPS),EXIST=LEX)
	IF (LEX) GOTO 1
	OPEN (IO_PS,FILE=PSFILE(1:LENPS),FORM="FORMATTED")
      END IF
      CALL LOCCHR(STRING,'MPL',3,1,K1,K2)
      IF(K2.GE.K1) THEN
	IMPL = 1
        READ(STRING(K1:K2),*) DRWFIL
	LEN = K2 - K1 + 1
	LENMPL = LEN + 7
	NFIL = 0
    2   CONTINUE
           NFIL = NFIL + 1
           MPLFIL = DRWFIL(1:LEN) // ".mpl." // CNUM(NFIL)
           INQUIRE (FILE=MPLFIL(1:LENMPL),EXIST=LEX)
	IF (LEX) GOTO 2
	OPEN (IO_MPL,FILE=MPLFIL(1:LENMPL),FORM="UNFORMATTED")
      END IF
C
    5 CONTINUE
C
      CALL X11OPN(IFLAG,IWPX,IHPX)
      IF(IFLAG.EQ.0) RETURN
      SPSIZE=12.
      IP1X=40
      IP1Y=0
      IP2X=IWPX-IP1X
      IP2Y=IHPX-IP1Y-200
      CALL X11WIN(IP1X,IP1Y,IP2X,IP2Y)
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 3
	 IARMPL(1,2) = 1
	 IARMPL(1,3) = 2
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
  100 CONTINUE
      CALL X11COL(2)
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 3
	 IARMPL(1,2) = 4
	 IARMPL(1,3) = 2
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
      IX1_BORD=IP1X+20
      IY1_BORD=IP1Y+40
      IX2_BORD=IP2X-50
      IY2_BORD=IP2Y-40
C     CALL X11DRW(IX1_BORD,IY1_BORD,IX2_BORD,IY1_BORD)
C     CALL X11DRW(IX2_BORD,IY1_BORD,IX2_BORD,IY2_BORD)
C     CALL X11DRW(IX2_BORD,IY2_BORD,IX1_BORD,IY2_BORD)
C     CALL X11DRW(IX1_BORD,IY2_BORD,IX1_BORD,IY1_BORD)
      XPSIZE = DBLE(IX2_BORD - IX1_BORD)
      YPSIZE = DBLE(IY2_BORD - IY1_BORD)
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 11
	 IARMPL(1,2) = 5
	 IARMPL(1,6) = 15
	 ARRMPL(  3) = 0.0D0
	 ARRMPL(  4) = DBLE(IWPX)
	 ARRMPL(  5) = DBLE(IHPX)
	 ARRMPL(  7) = 0.0D0
	 ARRMPL(  8) = XPSIZE
	 ARRMPL(  9) = YPSIZE
	 ARRMPL( 10) = 2.0D1
	 ARRMPL( 11) = 4.0D1
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
      IF (IPOSTS.EQ.1) THEN
	 SC1 = 842.0 / REAL(IP2X - IP1X)
	 SC2 = 595.0 / REAL(IP2Y - IP1Y)
	 PSSCAL = MIN(SC1,SC2)
         IP1XPS = INT(IP1X * PSSCAL)
         IP2YPS = INT(IP2Y * PSSCAL)
         WRITE (IO_PS,1000) PSFILE(1:LENPS-6),0, 0, 595, 842
         WRITE (IO_PS,1100)
         WRITE (IO_PS,1110)
Cclip    WRITE (IO_PS,1120)
         WRITE (IO_PS,1150) 
         WRITE (IO_PS,1160) REAL(IP1XPS*(-1)),REAL(IP2YPS*(-1)),PSSCAL
Cclip    WRITE (IO_PS,1170) IX1_BORD,IY1_BORD,IX2_BORD,IY2_BORD
         WRITE (IO_PS,1200) CNUM(1)
      END IF
      XSCAL=XPSIZE/(XMAX-XMIN)
      YSCAL=YPSIZE/(YMAX-YMIN)
      SCAL=DMIN1(XSCAL,YSCAL)
      SCAL=SCAL*0.85*SC_EXTR
      XCENT_S=(IX2_BORD+IX1_BORD)/2.0
      YCENT_S=(IY2_BORD+IY1_BORD)/2.0
      CALL X11COL(4)
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 3
	 IARMPL(1,2) = 4
	 IARMPL(1,3) = 4
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
      IF (IPOSTS.EQ.1) WRITE (IO_PS,1200) CNUM(5)
      NSETS=0
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) NSETS=NSETS+1
      END DO
      DO IM=1,NSETS
        ICOL = 1 + IM
        IF(ICOL.GT.16) THEN
          II = INT(ICOL/16)
          ICOL = ICOL - 16*II
          IF(ICOL.EQ.0) ICOL = 16
        END IF
        CALL X11COL(ICOL)
        IF (IMPL.EQ.1) THEN
	  IARMPL(1,1) = 3
	  IARMPL(1,2) = 4
	  IARMPL(1,3) = 1+IM
          WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
        ENDIF
        IF (IPOSTS.EQ.1) WRITE (IO_PS,1200) CNUM(2+IM)
        DO K=2,MATSET(IM,1)
          IELEM=MATSET(IM,K)
          IF(IELEM.EQ.0) GOTO 200
          NODE=LNODS(IELEM,MXNOD)
          IMSET=LNODS(IELEM,MXNOD-1)
          STRING=ELSET_TYP(IMSET)
          IF(KEY3D.EQ.0) THEN
C---------- 2D structure
            IF(NODE.EQ.2) THEN
              NN=1
              NT=2
            ELSE IF(NODE.EQ.3.OR.NODE.EQ.4) THEN
              NN=NODE
              NT=2
            ELSE IF(NODE.EQ.6.AND.ELTYP(IELEM)(1:1).NE.'C') THEN
              NN=1
              NT=3
            ELSE IF(NODE.EQ.6.OR.NODE.GE.8) THEN
              NN=NODE/2
              NT=3
            END IF
            DO IN=1,NN
              IF(NODE.EQ.2) THEN
                NW(1)=IN
                NW(2)=IN+1
              ELSE IF(NODE.EQ.3.OR.NODE.EQ.4) THEN
                NW(1)=IN
                NW(2)=IN+1
                IF(NW(2).GT.NN) NW(2)=NW(2)-NN
              ELSE IF(NODE.EQ.6.AND.ELTYP(IELEM)(1:1).NE.'C') THEN
                NW(1)=IN
                NW(2)=IN+1
                NW(3)=IN+2
              ELSE IF(NODE.EQ.6.OR.NODE.GE.8) THEN
                NW(1)=IN
                NW(2)=IN+NN
                NW(3)=IN+1
                IF(NW(3).GT.NN) NW(3)=NW(3)-NN
              END IF
              DO IT=1,NT
                KNODE=NW(IT)
                INODE=LNODS(IELEM,KNODE)
                Z=COORD(INODE,3)
                X=(COORD(INODE,1)-XCENT_P-CHPHAI*Z)*SCAL
                Y=(COORD(INODE,2)-YCENT_P-SHPHAI*Z)*SCAL
                X_CORD(IT)= X+XCENT_S
                Y_CORD(IT)=-Y+YCENT_S
              END DO
              R=SQRT((X_CORD(1)-X_CORD(NT))**2+
     &               (Y_CORD(1)-Y_CORD(NT))**2)
              IF(R.GT.1.0E-5) THEN
	        CALL DRW_LINE(X_CORD,Y_CORD,NT)
                IF (IMPL.EQ.1) THEN
	          IARMPL(1,1) = 4
	          IARMPL(1,2) = 3
	          ARRMPL(  3) = X_CORD(1)
	          ARRMPL(  4) = Y_CORD(1)
                  WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		  DO I_NT = 2,NT
	             IARMPL(1,1) = 4
	             IARMPL(1,2) = 2
	             ARRMPL(  3) = X_CORD(I_NT)
	             ARRMPL(  4) = Y_CORD(I_NT)
                     WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		  END DO
	        ENDIF
                IF (IPOSTS.EQ.1) THEN
		  WRITE (IO_PS,1300) 
     1                   (X_CORD(II),REAL(IYXTEN)-Y_CORD(II),II=1,NT-1)
		  WRITE (IO_PS,1310) 
     1               NT-1,X_CORD(NT),REAL(IYXTEN)-Y_CORD(NT)
	        ENDIF
	      ENDIF
            END DO
          ELSE
C---------- 3D structure
            IF(NODE.GE.20.OR.NODE.EQ.8) THEN
              DO IK=1,2
                NN=4*(IK-1)
                DO IN=1,4
                  IF(NODE.GE.20) THEN
                    NT=3
                    NW(1)=IN+NN
                    NW(2)=NW(1)+8
                    NW(3)=NW(1)+1
                    IF(IN.EQ.4) NW(3)=NW(3)-4
                  ELSE IF(NODE.EQ.8) THEN
                    NT=2
                    NW(1)=IN+NN
                    NW(2)=NW(1)+1
                    IF(IN.EQ.4) NW(2)=NW(2)-4
                  END IF
                  DO IT=1,NT
                    KNODE=NW(IT)
                    INODE=LNODS(IELEM,KNODE)
                    Z=COORD(INODE,3)
                    X=(COORD(INODE,1)-XCENT_P-CHPHAI*Z)*SCAL
                    Y=(COORD(INODE,2)-YCENT_P-SHPHAI*Z)*SCAL
                    X_CORD(IT)= X+XCENT_S
                    Y_CORD(IT)=-Y+YCENT_S
                  END DO
                  R=SQRT((X_CORD(1)-X_CORD(NT))**2+
     &                   (Y_CORD(1)-Y_CORD(NT))**2)
                  IF(R.GT.1.0E-5) THEN
		    CALL DRW_LINE(X_CORD,Y_CORD,NT)
                    IF (IMPL.EQ.1) THEN
	              IARMPL(1,1) = 4
	              IARMPL(1,2) = 3
	              ARRMPL(  3) = X_CORD(1)
	              ARRMPL(  4) = Y_CORD(1)
                      WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		      DO I_NT = 2,NT
	                 IARMPL(1,1) = 4
	                 IARMPL(1,2) = 2
	                 ARRMPL(  3) = X_CORD(I_NT)
	                 ARRMPL(  4) = Y_CORD(I_NT)
                         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		      END DO
	            ENDIF
                    IF (IPOSTS.EQ.1) THEN
		      WRITE (IO_PS,1300) 
     1                    (X_CORD(II),REAL(IYXTEN)-Y_CORD(II),II=1,NT-1)
		      WRITE (IO_PS,1310) 
     1                    NT-1,X_CORD(NT),REAL(IYXTEN)-Y_CORD(NT)
	            ENDIF
		  ENDIF
                END DO
              END DO
              DO IN=1,4
                IF(NODE.GE.20) THEN
                  NT=3
                  NW(1)=IN
                  NW(2)=IN+16
                  NW(3)=IN+4
                ELSE IF(NODE.EQ.8) THEN
                  NT=2
                  NW(1)=IN
                  NW(2)=IN+4
                END IF
                DO IT=1,NT
                  KNODE=NW(IT)
                  INODE=LNODS(IELEM,KNODE)
                  Z=COORD(INODE,3)
                  X=(COORD(INODE,1)-XCENT_P-CHPHAI*Z)*SCAL
                  Y=(COORD(INODE,2)-YCENT_P-SHPHAI*Z)*SCAL
                  X_CORD(IT)= X+XCENT_S
                  Y_CORD(IT)=-Y+YCENT_S
                END DO
                R=SQRT((X_CORD(1)-X_CORD(NT))**2+
     &                 (Y_CORD(1)-Y_CORD(NT))**2)
                IF(R.GT.1.0E-5) THEN
	  	   CALL DRW_LINE(X_CORD,Y_CORD,NT)
                   IF (IMPL.EQ.1) THEN
	              IARMPL(1,1) = 4
	              IARMPL(1,2) = 3
	              ARRMPL(  3) = X_CORD(1)
	              ARRMPL(  4) = Y_CORD(1)
                      WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		      DO I_NT = 2,NT
	                 IARMPL(1,1) = 4
	                 IARMPL(1,2) = 2
	                 ARRMPL(  3) = X_CORD(I_NT)
	                 ARRMPL(  4) = Y_CORD(I_NT)
                         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		      END DO
	           ENDIF
                   IF (IPOSTS.EQ.1) THEN
		    WRITE (IO_PS,1300) 
     1                    (X_CORD(II),REAL(IYXTEN)-Y_CORD(II),II=1,NT-1)
		    WRITE (IO_PS,1310) 
     1                NT-1,X_CORD(NT),REAL(IYXTEN)-Y_CORD(NT)
	           ENDIF
	        ENDIF
              END DO
            ELSE IF(NODE.EQ.4) THEN
C------------ tetrahedron
	      DO IFAC = 1,4
		 DO I1 = 1,3
		    I2 = I1+1
		    IF (I1.EQ.3) I2 = 1
		    INOD1 = LNODS(IELEM,NFACE_DF(I1,IFAC,3))
		    INOD2 = LNODS(IELEM,NFACE_DF(I2,IFAC,3))
                    Z=(COORD(INOD1,3)-ZCENT_P)*SCAL
                    X_CORD(1) = (COORD(INOD1,1)-XCENT_P)*SCAL 
     1                        + XCENT_S - CHPHAI*Z
                    Y_CORD(1) = (COORD(INOD1,1)-YCENT_P)*SCAL 
     1                        + YCENT_S - CHPHAI*Z
                    Z=(COORD(INOD2,3)-ZCENT_P)*SCAL
                    X_CORD(2) = (COORD(INOD2,1)-XCENT_P)*SCAL 
     1                        + XCENT_S - CHPHAI*Z
                    Y_CORD(2) = (COORD(INOD2,1)-YCENT_P)*SCAL 
     1                        + YCENT_S - CHPHAI*Z
                    R=SQRT((X_CORD(1)-X_CORD(NT))**2+
     &                     (Y_CORD(1)-Y_CORD(NT))**2)
                    IF(R.GT.1.0E-5) THEN
	  	       CALL DRW_LINE(X_CORD,Y_CORD,NT)
                       IF (IMPL.EQ.1) THEN
	                  IARMPL(1,1) = 4
	                  IARMPL(1,2) = 3
	                  ARRMPL(  3) = X_CORD(1)
	                  ARRMPL(  4) = Y_CORD(1)
                          WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		          DO I_NT = 2,NT
	                    IARMPL(1,1) = 4
	                    IARMPL(1,2) = 2
	                    ARRMPL(  3) = X_CORD(I_NT)
	                    ARRMPL(  4) = Y_CORD(I_NT)
                            WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
		          END DO
	               ENDIF
                       IF (IPOSTS.EQ.1) THEN
		          WRITE (IO_PS,1300) 
     1                    (X_CORD(II),REAL(IYXTEN)-Y_CORD(II),II=1,NT-1)
		          WRITE (IO_PS,1310) 
     1                      NT-1,X_CORD(NT),REAL(IYXTEN)-Y_CORD(NT)
	               ENDIF
	            ENDIF
	         END DO
	      END DO
            END IF
          END IF
  200     CONTINUE
        END DO
      END DO
      CALL X11COL(1)
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 3
	 IARMPL(1,2) = 4
	 IARMPL(1,3) = 1
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
      IF (IPOSTS.EQ.1) WRITE (IO_PS,1200) CNUM(1)
      SPSIZE=12.0
      NCHAR=26
      TEXT(1:NCHAR)=' *** Present EXTR_SCALE = '
      WRITE(TEXT(NCHAR:NCHAR+8),'(E8.3)') SC_EXTR
      NCHAR=NCHAR+8
      IX=IX1_BORD
      IY=IY2_BORD
      CALL X11CHI(SPSIZE)
      CALL X11CHR(IX,IY,NCHAR,TEXT)
      IF (IMPL.EQ.1) THEN
	 NWORD = (NCHAR-1) / 8 + 1
	 IARMPL(1,1) = NWORD
	 IARMPL(1,2) = 6
	 ARRMPL(  3) = DBLE(IX)
	 ARRMPL(  4) = DBLE(IY)
	 ARRMPL(  5) = DBLE(SPSIZE)
	 ARRMPL(  5) = DBLE(SPSIZE)
	 ARRMPL(  6) = 0.0D0
	 DO IWO = 1, NWORD
	    CARMPL(6+IWO) = TEXT((IWO-1)*8+1:IWO*8)
	 END DO
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
      ENDIF
      IF (IPOSTS.EQ.1) THEN
	 IYT2 = IY
	 WRITE (IO_PS,1400) SPSIZE
	 IF (ABS(1.0 - SC_EXTR).GT.0.01) THEN
            WRITE (IO_PS,1410) REAL(IX),REAL(IY),TEXT(1:NCHAR)
	    IYT2 = IY - 13
	 ENDIF
	 CALL DTEXT(FINPUT,LINPUT)
         NCHAR = 14 + LINPUT
         WRITE(TEXT(1:NCHAR),1420) FINPUT
	 WRITE (IO_PS,1410) REAL(IX),REAL(IYT2),TEXT(1:NCHAR)
      ENDIF
      NCHAR=35
      TEXT(1:NCHAR)=' *** Press RETURN for continue *** '
      IX=IX1_BORD
      IY=IY2_BORD+SPSIZE+3
      CALL X11CHI(SPSIZE)
      CALL X11CHR(IX,IY,NCHAR,TEXT)
      CALL X11FLS
      READ (5,'(I1)') IDUM
      IF (IMPL.EQ.1) THEN
	 IARMPL(1,1) = 3
	 IARMPL(1,2) = 7
	 ARRMPL(  3) = 0.0D0
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
	 IARMPL(1,1) = 2
	 IARMPL(1,2) = 8
         WRITE (IO_MPL) (ARRMPL(1:J),J=1,IARMPL(1,1))
         WRITE (IO_JNL,'(5X,A,A,A)') 
     1         'Datei ',MPLFIL(1:LENMPL),' erfolgreich geschrieben'
         WRITE (IO_WRITE,'(5X,A,A,A)') 
     1         'Datei ',MPLFIL(1:LENMPL),' erfolgreich geschrieben'
	 CLOSE (IO_MPL)
      ENDIF
      IF (IPOSTS.EQ.1) THEN
	 WRITE (IO_PS,1500)
         WRITE (IO_JNL,'(5X,A,A,A)') 
     1         'Datei ',PSFILE(1:LENPS),' erfolgreich geschrieben'
	 CLOSE (IO_PS)
      ENDIF
      RETURN
  999 CONTINUE
      CALL X11END
      RETURN
 1000 FORMAT ('%!PS-Adobe-2.0 EPSF-2.0',/,'%%Title: ',A,/,
     1        '%%BoundingBox: ',4I6,/,'%%EndComments')
 1100 FORMAT ('/lt {lineto} def',/,'/mt { moveto} def',/,
     1        '/drpoly {newpath mt {lt} repeat stroke} def',/,
     2        '/col01 {0.0 0.0 0.0 setrgbcolor} def',/,
     3        '/col02 {1.0 1.0 1.0 setrgbcolor} def',/,
     4        '/col03 {1.0 0.0 0.0 setrgbcolor} def',/,
     5        '/col04 {1.0 0.5 0.0 setrgbcolor} def',/,
     6        '/col05 {1.0 1.0 0.0 setrgbcolor} def',/,
     7        '/col06 {0.5 1.0 0.0 setrgbcolor} def',/,
     8        '/col07 {0.0 1.0 0.0 setrgbcolor} def',/,
     9        '/col08 {0.0 1.0 0.5 setrgbcolor} def',/,
     A        '/col09 {0.0 1.0 1.0 setrgbcolor} def')
 1110 FORMAT ('/col10 {0.0 0.5 1.0 setrgbcolor} def',/,
     1        '/col11 {0.0 0.0 1.0 setrgbcolor} def',/,
     2        '/col12 {0.5 0.0 1.0 setrgbcolor} def',/,
     3        '/col13 {1.0 0.0 1.0 setrgbcolor} def',/,
     4        '/col14 {1.0 0.0 0.5 setrgbcolor} def',/,
     5        '/col15 {0.0 0.0 0.0 setrgbcolor} def')
 1120 FORMAT ('/clipdef {/y2 exch def /x2 exch def /y1 exch def ',
     1        '/x1 exch def',/,
     2        'x1 y1 mt x2 y1 ln x2 y2 ln x1 y2 ln closepath clip} def')
 1150 FORMAT ('%%EndProlog',/,'%%Page: 1 1',/,'gsave')
 1160 FORMAT (' 90 rotate',/,2F8.2,' translate',/,F6.3,' dup scale')
 1170 FORMAT (4I6,' clipdef')
 1200 FORMAT ('col',A2)
 1300 FORMAT (8F9.3,/)
 1310 FORMAT (I5,2F9.3,' drpoly')
 1400 FORMAT ('/Courier findfont ',F4.1,' scalefont setfont')
 1410 FORMAT (F9.3,F9.3,' mt ',/,'  (',A,') show')
 1420 FORMAT ('problem name: ',A)
 1500 FORMAT ('showpage',/,'grestore')
      END
C
C
C
C
      SUBROUTINE DRW_LINE(XI,YI,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XI(100),YI(100)
      COMMON /MESHBORD/IX1_BORD,IY1_BORD,IX2_BORD,IY2_BORD
      XD=XI(N)-XI(1)
      YD=YI(N)-YI(1)
      IF(ABS(YD).LT.ABS(XD)) THEN
      TYP_KEY=1
      BX=XD
      X0=XI(1)
      Y0=YI(1)
      ELSE
      TYP_KEY=2
      BX=YD
      X0=YI(1)
      Y0=XI(1)
      END IF
      IF(ABS(BX).LT.5.0) THEN
        NX=5
      ELSE IF(ABS(BX).LT.10.0) THEN
        NX=10
      ELSE IF(ABS(BX).LT.50.0) THEN
        NX=20
      ELSE IF(ABS(BX).LT.100.0) THEN
        NX=40
      ELSE
        NX=50
      END IF
      DD=BX/NX
      X2=X0
      X1=X0
      Y1=Y0
      DO I=1,NX
      X2=X2+DD
      IF(TYP_KEY.EQ.1) THEN
        CALL INTERP(X2,Y2,XI,YI,N)
        IX1=INT(X1)
        IY1=INT(Y1)
        IX2=INT(X2)
        IY2=INT(Y2)
      ELSE IF(TYP_KEY.EQ.2) THEN
        CALL INTERP(X2,Y2,YI,XI,N)
        IX1=INT(Y1)
        IY1=INT(X1)
        IX2=INT(Y2)
        IY2=INT(X2)
      END IF
      IF(IX1.GE.IX1_BORD.AND.IX1.LE.IX2_BORD.AND.
     &   IY1.GE.IY1_BORD.AND.IY1.LE.IY2_BORD.AND.
     &   IX2.GE.IX1_BORD.AND.IX2.LE.IX2_BORD.AND.
     &   IY2.GE.IY1_BORD.AND.IY2.LE.IY2_BORD)
     &  CALL X11DRW(IX1,IY1,IX2,IY2)
      X1=X2
      Y1=Y2
      END DO
      RETURN
      END
C
C
C
      SUBROUTINE INTERP(X,Y,XI,YI,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XI(100),YI(100),AL(100)
      do i=1,n
      al(i)=1.0D0
        do j=1,n
          if(i.ne.j) then
             al(i)=al(i)*(x-xi(j))/(xi(i)-xi(j))
          end if
        end do
      end do
      y=0.0
      do i=1,n
        y=y+al(i)*yi(i)
      end do
      return
      end
