C
C     GENERATING COHESIVE ELEMENT IN A ELSET OR GIVEN AREA
C
      SUBROUTINE COHESIV1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP(6)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV1'
C
      TEXT='NOW EXCUTING SUB. COHESIV1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
      IF(IMSET2.EQ.0) THEN
        WRITE(IO_WRITE,1000) 'COHESIV1','No (NEW ELSET) parameter.',
     &  ' Please check file *.inf'
        WRITE(IO_INFO ,1000) 'COHESIV1','No (NEW ELSET) parameter.'
        WRITE(IO_INFO ,1001) 'COHESIV1'
        WRITE(IO_INFO ,1002) 
        STOP
      END IF
      KEY = 1
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND LINE OF ',1X,A,' - ',A,
     &  /20X,'*COHESIV1,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*LINE   ',20X,'(Sub-option)'/20X,'X1, Y1, X2, Y2',
     & /20X,'*POLYGON',20X,'(Sub-option)'/20X,'X1, Y1, X2, Y2',
     & /20X,'*CIRCLE ',20X,'(Sub-option)'/20X,'Xo, Yo , Ri, TH1, TH2'/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:5).EQ.'*POLY') THEN
        KEY = 2
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*LINE') THEN
        KEY = 3
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*CIRC') THEN
        KEY = 4
        READ(IO_INPUT,*) (XP(K),K=1,5)
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
      ELSE
        WRITE(IO_INFO,1010) 'COHESIV1',STRING
        GOTO 1
      END IF
C
      MXEL  = 2
      IADR1 = NELEM*MXEL
      DO K=1,NELEM*MXEL+NNODE
        IWORK(K) = 0
      END DO
      NEG = 0
      IF(KEY.EQ.1) THEN
        WRITE(IO_INFO ,1000) 'COHESIV1','No Sub-option.'
        WRITE(IO_INFO ,'(20X,A,3H - ,A)') 'COHESIV1','Sub-option'
        WRITE(IO_INFO ,1002) 
      ELSE
        XB1 = XP(1)
        YB1 = XP(2)
        XB2 = XP(3)
        YB2 = XP(4)
        IF(IMSET1.EQ.0) THEN
          NUMEL1 = 1
          NUMEL2 = NELEM
          IE     = 1
        ELSE
          NUMEL1 = 2
          NUMEL2 = MATSET(IMSET1,1)
          IE     = MATSET(IMSET1,2)
        END IF
        NND   = LNODS(IE,MXNOD)
        KND   = 1
        IF(NND.GT.4) KND = 2
        ND2 = NND/KND
        NN  = NND/KND
        DO K1 = NUMEL1,NUMEL2
          IF(IMSET1.EQ.0) THEN
            IE   = K1
          ELSE
            IE   = MATSET(IMSET1,K1)
          END IF
          IF(ELTYP(IE)(1:2).EQ.'IC') GOTO 10
          DO IN = 1, ND2
            IN1 = IN
            IN2 = IN + 1
            IF(IN2.GT.ND2) IN2 = IN2-ND2
            LN1 = LNODS(IE,IN1)
            LN2 = LNODS(IE,IN2)
            X1  = COORD(LN1,1)
            Y1  = COORD(LN1,2)
            X2  = COORD(LN2,1)
            Y2  = COORD(LN2,2)
            H1  = (X1-XB1)*(X1-XB2)
            H2  = (Y1-YB1)*(Y1-YB2)
            H3  = (X2-XB1)*(X2-XB2)
            H4  = (Y2-YB1)*(Y2-YB2)
            IF(KEY.EQ.2) THEN
C-----------  polygon
              IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &           H3.LE.TOLER.AND.H4.LE.TOLER) THEN
                NEG = NEG + 1
                KG  = (NEG-1)*MXEL
                IWORK(KG+1) = IE*100+IN1
                IWORK(KG+2) = IE*100+IN2
                GOTO 10
              END IF
            ELSE IF(KEY.EQ.3) THEN
C-----------  line
              H5  = (X1-XB1)*(Y1-YB2)-(X1-XB2)*(Y1-YB1)
              H6  = (X2-XB1)*(Y2-YB2)-(X2-XB2)*(Y2-YB1)
              IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &           H3.LE.TOLER.AND.H4.LE.TOLER.AND.
     &           H5.LE.TOLER.AND.H6.LE.TOLER) THEN
                NEG = NEG + 1
                KG  = (NEG-1)*MXEL
                IWORK(KG+1) = IE*100+IN1
                IWORK(KG+2) = IE*100+IN2
                GOTO 10
              END IF
            END IF
          END DO
   10     CONTINUE
        END DO
      END IF
C
      IF(NEG.EQ.0) THEN
        RETURN
      END IF
C
      DO IEG = 1, NEG-1
        NG = (IEG-1)*MXEL
        IG = NG + 1
        IE1 = IWORK(IG)/100
        IN1 = IWORK(IG)-100*IE1
        IG = IG + 1
        IE2 = IWORK(IG)/100
        IN2 = IWORK(IG)-100*IE2
        IP1 = LNODS(IE1,IN1)
        IP2 = LNODS(IE1,IN2)
        XI  = 0.5*(COORD(IP1,1)+COORD(IP2,1))
        YI  = 0.5*(COORD(IP1,2)+COORD(IP2,2))
        KEG = IEG
        DO JEG = IEG+1, NEG
          NG = (JEG-1)*MXEL
          JG = NG + 1
          JE1 = IWORK(JG)/100
          JN1 = IWORK(JG)-100*JE1
          IG = IG + 1
          JE2 = IWORK(JG)/100
          JN2 = IWORK(JG)-100*JE2
          JP1 = LNODS(JE1,JN1)
          JP2 = LNODS(JE1,JN2)
          XJ  = 0.5*(COORD(JP1,1)+COORD(JP2,1))
          YJ  = 0.5*(COORD(JP1,2)+COORD(JP2,2))
          IF(XJ.LT.XI) THEN
            XI  = XJ
            KEG = JEG
          ELSE IF(ABS(XJ-XI).LT.TOLER.AND.YJ.LE.YI) THEN
            YI  = YJ
            KEG = JEG
          END IF
        END DO
        IF(KEG.NE.IEG) THEN
          IG = (IEG-1)*MXEL
          KG = (KEG-1)*MXEL
          IM = IWORK(IG+1)
          IWORK(IG+1) = IWORK(KG+1)
          IWORK(KG+1) = IM
          IM = IWORK(IG+2)
          IWORK(IG+2) = IWORK(KG+2)
          IWORK(KG+2) = IM
        END IF
      END DO
C
C---  define cohesive elements and generate bottom nodes
      NODNEW = NNODE
      IENEW  = NELEM
      MATSET(IMSET2,1) = 1
      DO IEG = 1, NEG
        NG = (IEG-1)*MXEL
        IG = NG + 1
        IE1 = IWORK(IG)/100
        IN1 = IWORK(IG) - 100*IE1
        IG  = IG + 1
        IE2 = IWORK(IG)/100
        IN2 = IWORK(IG) - 100*IE2
        IP1 = LNODS(IE1,IN1)
        IP2 = LNODS(IE1,IN2)
	IF (KND.EQ.2) THEN
	   IN3 = IN2
	   IP3 = IP2
	   IN2 = IN1 + ND2
	   IP2 = LNODS(IE1,IN2)
	ENDIF
	IF (IWORK(IADR1+IP1).EQ.0) THEN
	   NODNEW = NODNEW + 1
	   COORD(NODNEW,1) = COORD(IP1,1)
	   COORD(NODNEW,2) = COORD(IP1,2)
	   COORD(NODNEW,3) = COORD(IP1,3)
	   INCOD(NODNEW)   = NODNEW
	   IWORK(IADR1+IP1) = NODNEW
           INSET(NODNEW-NNODE,NDSET+1) = NODNEW
           INSET(NODNEW-NNODE,NDSET+2) = IP1
	ENDIF
	IF (IWORK(IADR1+IP2).EQ.0) THEN
	   NODNEW = NODNEW + 1
	   COORD(NODNEW,1) = COORD(IP2,1)
	   COORD(NODNEW,2) = COORD(IP2,2)
	   COORD(NODNEW,3) = COORD(IP2,3)
	   INCOD(NODNEW)   = NODNEW
	   IWORK(IADR1+IP2) = NODNEW
           INSET(NODNEW-NNODE,NDSET+1) = NODNEW
           INSET(NODNEW-NNODE,NDSET+2) = IP2
	ENDIF
        IENEW = IENEW + 1
        MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
        MATSET(IMSET2,MATSET(IMSET2,1))=IENEW
        LNODS(IENEW,MXNOD)   = 4
        LNODS(IENEW,MXNOD-1) = IMSET2
        ELTYP(IENEW)   = 'ICOHE2'
        LNODS(IENEW,1) = IP2
        LNODS(IENEW,2) = IP1
        LNODS(IENEW,3) = IWORK(IADR1+IP2)
        LNODS(IENEW,4) = IWORK(IADR1+IP1)
	LNODS(IENEW,MXNOD) = 4
	CALL DNODE(IENEW,4)
	IF (KND.EQ.2) THEN
C--------  quadratic continuum elements
	   IF (IWORK(IADR1+IP3).EQ.0) THEN
		NODNEW = NODNEW + 1
		COORD(NODNEW,1)  = COORD(IP3,1)
		COORD(NODNEW,2)  = COORD(IP3,2)
		COORD(NODNEW,3)  = COORD(IP3,3)
		INCOD(NODNEW)    = NODNEW
		IWORK(IADR1+IP3) = NODNEW
                INSET(NODNEW-NNODE,NDSET+1) = NODNEW
                INSET(NODNEW-NNODE,NDSET+2) = IP3
	   ENDIF
           IENEW = IENEW + 1
           MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
           MATSET(IMSET2,MATSET(IMSET2,1))=IENEW
           LNODS(IENEW,MXNOD) = 4
           LNODS(IENEW,MXNOD-1) = IMSET2
           ELTYP(IENEW)   = 'ICOHE2'
           LNODS(IENEW,1) = IP3
           LNODS(IENEW,2) = IP2
           LNODS(IENEW,3) = IWORK(IADR1+IP3)
           LNODS(IENEW,4) = IWORK(IADR1+IP2)
	   CALL DNODE(IENEW,4)
	ENDIF
      END DO
C
      IF (NODNEW.GT.NNODE) THEN
         NDSET = NDSET + 1
         NNSET(NDSET)  = NODNEW-NNODE
         CNDSET(NDSET) = 'BOTTOM  '
         NDSET = NDSET + 1
         NNSET(NDSET)  = NODNEW-NNODE
         CNDSET(NDSET) = 'BOTTOM2 '
         NELEM = IENEW
         NNODE = NODNEW
      ENDIF
C
      RETURN
      END
