C
C     GENERATING COHESIVE ELEMENT IN A ELSET OR GIVEN AREA
C
      SUBROUTINE COHESIV4
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KWORK(50,2,2),IW(100)
      DIMENSION XP(6)
      CHARACTER CHAR1*8,CHAR2*8
      INCLUDE 'common'
      INCLUDE 'mcommon1'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4'
C
      TEXT='NOW EXCUTING SUB. COHESIV4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
      IF(IMSET2.EQ.0) THEN
        WRITE(IO_WRITE,1000) 'COHESIV4','No (NEW ELSET) parameter.',
     &  ' Please check file *.inf'
        WRITE(IO_INFO ,1000) 'COHESIV4','No (NEW ELSET) parameter.'
        WRITE(IO_INFO ,1001) 'COHESIV4'
        WRITE(IO_INFO ,1002) 
        STOP
      END IF
      KEY = 1
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*COHESIV4,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*LINE   ',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*POLYGON',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*ELSET  ',20X,'(option)'/21X,'ELSET1 , ELSET2 '/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:5).EQ.'*POLY') THEN
        KEY = 2
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*LINE') THEN
        KEY = 3
        READ(IO_INPUT,*) (XP(K),K=1,4)
        GOTO 1
      ELSE IF(STRING(1:6).EQ.'*ELSET') THEN
        KEY = 5
        IESET1 = 0
        READ(IO_INPUT,'(A)') STRING
        IF(STRING(1:1).EQ.'*') THEN
          WRITE(IO_INFO ,1000) 'COHESIV4','No (*ELSET) parameter.',
     &    ' Please give ELSET1, ELSET2'
          WRITE(IO_WRITE,1000) 'COHESIV4','No (*ELSET) parameter.',
     &    ' Please give ELSET1, ELSET2'
          WRITE(IO_INFO ,1001) 'COHESIV4'
          WRITE(IO_INFO ,1002) 
        ELSE
          READ(STRING(1:100),*) IMESET1,IMESET2
        END IF
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
      ELSE
        WRITE(IO_INFO,1010) 'COHESIV4',STRING
        GOTO 1
      END IF
C *** CHECKING MESH BOARD   
C----------------------------------------------------------------------
C     CALL DELEDGE
C
      IADA  = 0
      DO K=1,NELEM
        IWORK(IADA+K) = 0
      END DO
      MXEL  = 6
      IADB  = IADA + NELEM
      DO K=1,NELEM*MXEL
        IWORK(IADB+K) = 0
      END DO
      KEB   = 0
      NEG   = 0
      IF(KEY.EQ.1) THEN
        KEB = 1
        IF(IMSET1.EQ.0) THEN
          NUMEL1 = 1
          NUMEL2 = NELEM
          IE     = 1
        ELSE
          NUMEL1 = 2
          NUMEL2 = MATSET(IMSET1,1)
          IE     = MATSET(IMSET1,2)
        END IF
        NND   = LNODS(IE,MXNOD)
        KND   = 1
        IF(NND.GT.4) KND = 2
        ND2 = NND/KND
        NN  = NND/KND
        DO K1 = NUMEL1,NUMEL2-1
          IF(IMSET1.EQ.0) THEN
            IE   = K1
          ELSE
            IE   = MATSET(IMSET1,K1)
          END IF
          IF(IE.EQ.0) GOTO 60
          XM1 = 0.0E0
          YM1 = 0.0E0
          DO IN = 1, ND2
            IN1 = IN
            IN2 = IN + 1
            IF(IN2.GT.ND2) IN2 = IN2-ND2
            LN1 = LNODS(IE,IN1)
            LN2 = LNODS(IE,IN2)
            IG  = (IN-1)*2
            KWORK(IG+1,1,1) = LN1
            KWORK(IG+2,1,1) = LN2
            KWORK(IG+1,2,1) = IE*100+IN1
            KWORK(IG+2,2,1) = IE*100+IN2
            XM1 = XM1 + COORD(LN1,1)
            YM1 = YM1 + COORD(LN1,2)
          END DO
          XM1 = XM1/FLOAT(ND2)
          YM1 = YM1/FLOAT(ND2)
          DO K2 = K1+1,NUMEL2
            IF(IMSET1.EQ.0) THEN
              IE   = K2
            ELSE
              IE   = MATSET(IMSET1,K2)
            END IF
            IF(IE.EQ.0) GOTO 50
            DO IN = 1, ND2
              IN1 = IN
              IN2 = IN + 1
              IF(IN2.GT.ND2) IN2 = IN2-ND2
              LN1 = LNODS(IE,IN1)
              LN2 = LNODS(IE,IN2)
              IG  = (IN-1)*2
              KWORK(IG+1,1,2) = LN1
              KWORK(IG+2,1,2) = LN2
              KWORK(IG+1,2,2) = IE*100+IN1
              KWORK(IG+2,2,2) = IE*100+IN2
            END DO
            DO J1 = 1,ND2
              IG = (J1-1)*2
              IP1 = KWORK(IG+1,1,1)
              IP2 = KWORK(IG+2,1,1)
              XI1 = COORD(IP1,1)
              YI1 = COORD(IP1,2)
              XI2 = COORD(IP2,1)
              YI2 = COORD(IP2,2)
              DO J2 = 1,ND2
                JG = (J2-1)*2
                JP1 = KWORK(JG+1,1,2)
                JP2 = KWORK(JG+2,1,2)
                IF(IP1.EQ.JP2.AND.IP2.EQ.JP1) THEN
                  IF(ABS(XI1-XI2).LT.TOLER) THEN
                    IF(YI1.LT.YI2) THEN
                      AG  = XI1
                      XI1 = XI2
                      XI2 = AG
                      AG  = YI1
                      YI1 = YI2
                      YI2 = AG
                    END IF
                  ELSE IF(XI1.GT.XI2) THEN
                    AG  = XI1
                    XI1 = XI2
                    XI2 = AG
                    AG  = YI1
                    YI1 = YI2
                    YI2 = AG
                  END IF
                  A  = FAREA(XM1,YM1,XI1,YI1,XI2,YI2)
                  IM1 = 1
                  IM2 = 2
                  IG1 = IG
                  IG2 = JG
                  IF(A.GT.0.0E0) THEN
                    IMESETK= IMESET1
                    IM1 = 2
                    IM2 = 1
                    IG1 = JG
                    IG2 = IG
                  END IF
                  IK1 = 2
                  IK2 = 1
                  NEG = NEG + 1
                  KG  = (NEG-1)*MXEL
                  IWORK(IADB+KG+1) = KWORK(IG1+IK1,2,IM1)
                  IWORK(IADB+KG+2) = KWORK(IG1+IK2,2,IM1)
                  IWORK(IADB+KG+3) = KWORK(IG2+IK2,2,IM2)
                  IWORK(IADB+KG+4) = KWORK(IG2+IK1,2,IM2)
                  GOTO 50
                END IF
              END DO
            END DO
   50       CONTINUE
          END DO
   60     CONTINUE
        END DO
C----------------------------------------------------------------------
      ELSE IF(KEY.LT.5) THEN
        KEB = 0
        XB1 = XP(1)
        YB1 = XP(2)
        XB2 = XP(3)
        YB2 = XP(4)
        IF(IMSET1.EQ.0) THEN
          NUMEL1 = 1
          NUMEL2 = NELEM
          IE     = 1
        ELSE
          NUMEL1 = 2
          NUMEL2 = MATSET(IMSET1,1)
          IE     = MATSET(IMSET1,2)
        END IF
        NND   = LNODS(IE,MXNOD)
        KND   = 1
        IF(NND.GT.4) KND = 2
        ND2 = NND/KND
        NN  = NND/KND
C-----  loop over all elements
        DO K1 = NUMEL1,NUMEL2-1
          IF(IMSET1.EQ.0) THEN
            IE   = K1
          ELSE
            IE   = MATSET(IMSET1,K1)
          END IF
          IF(ELTYP(IE)(1:2).EQ.'IC'.OR.IE.EQ.0) GOTO 200
          IE1 = IE
          DO IG = 1, ND2*2
            KWORK(IG,1,1) = 0
            KWORK(IG,2,1) = 0
          END DO
          IK1 = 0
C-------  loop over all element edges
          DO IN = 1, ND2
            IN1 = IN
            IN2 = IN + 1
            IF(IN2.GT.ND2) IN2 = IN2-ND2
            LN1 = LNODS(IE,IN1)
            LN2 = LNODS(IE,IN2)
            X1  = COORD(LN1,1)
            Y1  = COORD(LN1,2)
            X2  = COORD(LN2,1)
            Y2  = COORD(LN2,2)
            H1  = (X1-XB1)*(X1-XB2)
            H2  = (Y1-YB1)*(Y1-YB2)
            H3  = (X2-XB1)*(X2-XB2)
            H4  = (Y2-YB1)*(Y2-YB2)
            IG  = (IN-1)*2
            IF(KEY.EQ.2) THEN
C-----------  polygon
              IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &           H3.LE.TOLER.AND.H4.LE.TOLER) THEN
                IK1 = 1
                KWORK(IG+1,1,1) = LN1
                KWORK(IG+2,1,1) = LN2
                KWORK(IG+1,2,1) = IE*100+IN1
                KWORK(IG+2,2,1) = IE*100+IN2
              END IF
            ELSE IF(KEY.EQ.3) THEN
C-----------  line
              H5  = (X1-XB1)*(Y1-YB2)-(X1-XB2)*(Y1-YB1)
              H6  = (X2-XB1)*(Y2-YB2)-(X2-XB2)*(Y2-YB1)
              IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &           H3.LE.TOLER.AND.H4.LE.TOLER.AND.
     &           H5.LE.TOLER.AND.H6.LE.TOLER) THEN
                KWORK(IG+1,1,1) = LN1
                KWORK(IG+2,1,1) = LN2
                KWORK(IG+1,2,1) = IE*100+IN1
                KWORK(IG+2,2,1) = IE*100+IN2
                GOTO 110
              END IF
            END IF
          END DO
          IF(IK1.EQ.0) GOTO 200
  110     CONTINUE
          DO K2 = NUMEL1,NUMEL2-1
C---------  looking for the opposite element of the ligament
            IF(IMSET1.EQ.0) THEN
              IE   = K2
            ELSE
              IE   = MATSET(IMSET1,K2)
            END IF
            IF(ELTYP(IE)(1:2).EQ.'IC'.OR.IE.EQ.0.OR.K2.EQ.K1) GOTO 180
            JE1 = IE
            DO IG = 1, ND2*2
              KWORK(IG,1,2) = 0
              KWORK(IG,2,2) = 0
            END DO
            IK1 = 0
            DO IN = 1, ND2
              IN1 = IN
              IN2 = IN + 1
              IF(IN2.GT.ND2) IN2 = IN2-ND2
              LN1 = LNODS(IE,IN1)
              LN2 = LNODS(IE,IN2)
              X1  = COORD(LN1,1)
              Y1  = COORD(LN1,2)
              X2  = COORD(LN2,1)
              Y2  = COORD(LN2,2)
              H1  = (X1-XB1)*(X1-XB2)
              H2  = (Y1-YB1)*(Y1-YB2)
              H3  = (X2-XB1)*(X2-XB2)
              H4  = (Y2-YB1)*(Y2-YB2)
              IG  = (IN-1)*2
              IF(KEY.EQ.2) THEN
                IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &             H3.LE.TOLER.AND.H4.LE.TOLER) THEN
                  IK1 = 1
                  KWORK(IG+1,1,2) = LN1
                  KWORK(IG+2,1,2) = LN2
                  KWORK(IG+1,2,2) = IE*100+IN1
                  KWORK(IG+2,2,2) = IE*100+IN2
                END IF
              ELSE IF(KEY.EQ.3) THEN
                H5  = (X1-XB1)*(Y1-YB2)-(X1-XB2)*(Y1-YB1)
                H6  = (X2-XB1)*(Y2-YB2)-(X2-XB2)*(Y2-YB1)
                IF(H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &             H3.LE.TOLER.AND.H4.LE.TOLER.AND.
     &             H5.LE.TOLER.AND.H6.LE.TOLER) THEN
                  IK1 = 1
                  KWORK(IG+1,1,2) = LN1
                  KWORK(IG+2,1,2) = LN2
                  KWORK(IG+1,2,2) = IE*100+IN1
                  KWORK(IG+2,2,2) = IE*100+IN2
                ELSE IF((H1.LE.TOLER.AND.H2.LE.TOLER.AND.
     &                   H5.LE.TOLER).OR.
     &                  (H3.LE.TOLER.AND.H4.LE.TOLER.AND.
     &                   H6.LE.TOLER)) THEN
                  IK1 = 1
                  KWORK(IG+1,1,2) = LN1
                  KWORK(IG+2,1,2) = LN2
                  KWORK(IG+1,2,2) = IE*100+IN1
                  KWORK(IG+2,2,2) = IE*100+IN2
                END IF
              ELSE IF(KEY.EQ.4) THEN
              END IF
            END DO
            IF(IK1.EQ.0) GOTO 180
  120       CONTINUE
            XM1 = 0.0E0
            YM1 = 0.0E0
            XM2 = 0.0E0
            YM2 = 0.0E0
            DO J1 = 1,ND2
              LN1 = LNODS(IE1,J1)
              XM1 = XM1 + COORD(LN1,1)
              YM1 = YM1 + COORD(LN1,2)
              LN2 = LNODS(JE1,J1)
              XM2 = XM2 + COORD(LN2,1)
              YM2 = YM2 + COORD(LN2,2)
            END DO
            XM1 = XM1/FLOAT(ND2)
            YM1 = YM1/FLOAT(ND2)
            XM2 = XM2/FLOAT(ND2)
            YM2 = YM2/FLOAT(ND2)
            DO J1 = 1,ND2
              IG = (J1-1)*2
              IP1 = KWORK(IG+1,1,1)
              IP2 = KWORK(IG+2,1,1)
              IF(IP1.EQ.0) GOTO 170
              XI1 = COORD(IP1,1)
              YI1 = COORD(IP1,2)
              XI2 = COORD(IP2,1)
              YI2 = COORD(IP2,2)
              IF(ABS(XI1-XI2).LT.TOLER) THEN
                IF(YI1.LT.YI2) THEN
                  AG  = XI1
                  XI1 = XI2
                  XI2 = AG
                  AG  = YI1
                  YI1 = YI2
                  YI2 = AG
                END IF
              ELSE IF(XI1.GT.XI2) THEN
                AG  = XI1
                XI1 = XI2
                XI2 = AG
                AG  = YI1
                YI1 = YI2
                YI2 = AG
              END IF
              DO J2 = 1,ND2
                JG = (J2-1)*2
                JP1 = KWORK(JG+1,1,2)
                JP2 = KWORK(JG+2,1,2)
                JN1 = KWORK(JG+1,2,2)-JE1*100
                JN2 = KWORK(JG+2,2,2)-JE1*100
                IF(IP1.EQ.JP2.AND.IP2.EQ.JP1) THEN
                  A  = FAREA(XM1,YM1,XI1,YI1,XI2,YI2)
                  IM1 = 1
                  IM2 = 2
                  IG1 = IG
                  IG2 = JG
                  IF(A.GT.0.0E0) THEN
                    IMESETK= IMESET1
                    IM1 = 2
                    IM2 = 1
                    IG1 = JG
                    IG2 = IG
                  END IF
                  IK1 = 2
                  IK2 = 1
                  NEG = NEG + 1
                  KG  = (NEG-1)*MXEL
                  IWORK(IADB+KG+1) = KWORK(IG1+IK1,2,IM1)
                  IWORK(IADB+KG+2) = KWORK(IG1+IK2,2,IM1)
                  IWORK(IADB+KG+3) = KWORK(IG2+IK2,2,IM2)
                  IWORK(IADB+KG+4) = KWORK(IG2+IK1,2,IM2)
                  GOTO 180
                ELSE IF(IP1.EQ.JP1) THEN
                  A  = FAREA(XM2,YM2,XI1,YI1,XI2,YI2)
                  IF(A.GT.0.0E0) IWORK(IADA+JE1) = JN1
                  GOTO 180
                ELSE IF(IP1.EQ.JP2) THEN
                  A  = FAREA(XM2,YM2,XI1,YI1,XI2,YI2)
                  IF(A.GT.0.0E0) IWORK(IADA+JE1) = JN2
                  GOTO 180
                END IF
              END DO
  170         CONTINUE
            END DO
  180       CONTINUE
          END DO
  200     CONTINUE
        END DO
C----------------------------------------------------------------------
      ELSE IF(KEY.EQ.5) THEN
        IMESETK= IMESET2
        KEB    = 0
        NUMEL1 = MATSET(IMESET1,1)
        NUMEL2 = MATSET(IMESET2,1)
        IE     = MATSET(IMESET1,2)
        NND   = LNODS(IE,MXNOD)
        KND   = 1
        IF(NND.GT.4) KND = 2
        ND2 = NND/KND
        NN  = NND/KND
        DO K1 = 2,NUMEL1
          IE1  = MATSET(IMESET1,K1)
          IF(IE1.EQ.0) GOTO 310
          XM1 = 0.0E0
          YM1 = 0.0E0
          DO IN = 1, ND2
            IN1 = IN
            IN2 = IN + 1
            IF(IN2.GT.ND2) IN2 = IN2-ND2
            LN1 = LNODS(IE1,IN1)
            LN2 = LNODS(IE1,IN2)
            IG  = (IN-1)*2
            KWORK(IG+1,1,1) = LN2
            KWORK(IG+2,1,1) = LN1
            KWORK(IG+1,2,1) = IE1*100+IN2
            KWORK(IG+2,2,1) = IE1*100+IN1
            XM1 = XM1 + COORD(LN1,1)
            YM1 = YM1 + COORD(LN1,2)
          END DO
          XM1 = XM1/FLOAT(ND2)
          YM1 = YM1/FLOAT(ND2)
          DO K2 = 2,NUMEL2
            IE2  = MATSET(IMESET2,K2)
            IF(IE2.EQ.0) GOTO 300
            DO IN = 1, ND2
              IN1 = IN
              IN2 = IN + 1
              IF(IN2.GT.ND2) IN2 = IN2-ND2
              LN1 = LNODS(IE2,IN1)
              LN2 = LNODS(IE2,IN2)
              IG  = (IN-1)*2
              KWORK(IG+1,1,2) = LN1
              KWORK(IG+2,1,2) = LN2
              KWORK(IG+1,2,2) = IE2*100+IN1
              KWORK(IG+2,2,2) = IE2*100+IN2
            END DO
            DO J1 = 1,ND2
              IG = (J1-1)*2
              IP1 = KWORK(IG+1,1,1)
              IE1 = KWORK(IG+1,2,1)/100
              IN1 = KWORK(IG+1,2,1)-IE1*100
              IP2 = KWORK(IG+2,1,1)
              XI1 = COORD(IP1,1)
              YI1 = COORD(IP1,2)
              XI2 = COORD(IP2,1)
              YI2 = COORD(IP2,2)
              DO J2 = 1,ND2
                JG = (J2-1)*2
                JP1 = KWORK(JG+1,1,2)
                JP2 = KWORK(JG+2,1,2)
                JE1 = KWORK(JG+1,2,2)/100
                JN1 = KWORK(JG+1,2,2)-JE1*100
                JN2 = KWORK(JG+2,2,2)-JE1*100
                IF(IP1.EQ.JP1.AND.IP2.EQ.JP2) THEN
                  IM1 = 1
                  IM2 = 2
                  IG1 = IG
                  IG2 = JG
                  IK1 = 1
                  IK2 = 2
                  NEG = NEG + 1
                  KG  = (NEG-1)*MXEL
                  IWORK(IADB+KG+1) = KWORK(IG1+IK1,2,IM1)
                  IWORK(IADB+KG+2) = KWORK(IG1+IK2,2,IM1)
                  IWORK(IADB+KG+3) = KWORK(IG2+IK1,2,IM2)
                  IWORK(IADB+KG+4) = KWORK(IG2+IK2,2,IM2)
                  IWORK(IADA+IE1)  = -1
                  IWORK(IADA+JE1)  = -1
                  GOTO 300
                ELSE IF(IP1.EQ.JP1) THEN
                  IF(IWORK(IADA+IE1).NE.-1) IWORK(IADA+IE1) = IN1
                  IF(IWORK(IADA+JE1).NE.-1) IWORK(IADA+JE1) = JN1
C                 GOTO 300
                ELSE IF(IP1.EQ.JP2) THEN
                  IF(IWORK(IADA+IE1).NE.-1) IWORK(IADA+IE1) = IN1
                  IF(IWORK(IADA+JE1).NE.-1) IWORK(IADA+JE1) = JN2
C                 GOTO 300
                END IF
              END DO
            END DO
  300       CONTINUE
          END DO
  310     CONTINUE
        END DO
      END IF
C
      IF(NEG.EQ.0) THEN
        RETURN
      END IF
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 1'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 1'
C
      IADB1 = IADB + NEG*MXEL
      MXEI  = 4
      MXEN  = 3
      DO K=1,NELEM*MXEI*MXEN
        IWORK(IADB1 + K) = 0
      END DO
      IADC  = IADB1+ NELEM*MXEI*MXEN
      MXPE  = 8
      DO K=1,NNODE*MXPE
        IWORK(IADC + K) = 0
      END DO
C
      IF(KEY.GT.2) THEN
        DO IE=1,NELEM
          IF(IWORK(IADA + IE).GT.0) THEN
            IF(KEY.EQ.5) THEN
              IF(LNODS(IE,MXNOD-1).EQ.IMESETK) THEN
                IN = IWORK(IADA + IE)
                LN = LNODS(IE,IN)
                NG = IADC + (LN-1)*MXPE
                IWORK(NG+1) = IWORK(NG+1) + 1
                IG = IWORK(NG+1)
                IWORK(NG+1+IG) = IE*100+IN
              END IF
            ELSE IF(KEY.GT.2) THEN
              IN = IWORK(IADA + IE)
              LN = LNODS(IE,IN)
              NG = IADC + (LN-1)*MXPE
              IWORK(NG+1) = IWORK(NG+1) + 1
              IG = IWORK(NG+1)
              IWORK(NG+1+IG) = IE*100+IN
            END IF
          END IF
        END DO
      END IF
      NNIC = 0
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) THEN
          KE = MATSET(I,2)
          IF(ELTYP(KE)(1:2).EQ.'IC') THEN
            NNIC = NNIC + 1
            IW(NNIC) = I
          END IF
        END IF
      END DO
C
      IF(KEY.LT.3.AND.NNIC.GT.0) THEN
        DO IEG = 1, NEG
          NG  = (IEG-1)*MXEL
          IG  = NG + 1
          IE1 = IWORK(IADB+IG)/100
          IN1 = IWORK(IADB+IG)-100*IE1
          IG  = IG + 1
          IE2 = IWORK(IADB+IG)/100
          IN2 = IWORK(IADB+IG)-100*IE2
          IP1 = LNODS(IE1,IN1)
          IP2 = LNODS(IE1,IN2)
          IG  = IG + 1
          JE1 = IWORK(IADB+IG)/100
          JN1 = IWORK(IADB+IG)-100*JE1
          IG  = IG + 1
          JE2 = IWORK(IADB+IG)/100
          JN2 = IWORK(IADB+IG)-100*JE2
          JP1 = LNODS(JE1,JN1)
          JP2 = LNODS(JE1,JN2)
          DO INIC=1,NNIC
            IMSET = IW(INIC)
            DO J=2,MATSET(IMSET,1)
              KE =MATSET(IMSET,J)
              NNK = LNODS(KE,MXNOD)
              DO KN = 1, NNK
                KN1 = KN
                LN1 = LNODS(KE,KN1)
                IF(LN1.EQ.IP1) THEN
                  INi = IN1
                  JNi = JN1
                  GOTO 340
                ELSE IF(LN1.EQ.IP2) THEN
                  INi = IN2
                  JNi = JN2
                  GOTO 340
                END IF
              END DO
              GOTO 380
  340         CONTINUE
              NDK = NNK
              IF(NNK.GT.3) NDK = NNK/2
              IF(KN1.LE.NDK) THEN
                KN2 = 1
                IF(KN1.EQ.1) KN2 = NDK
              ELSE
                KN2 = NDK+1
                IF(KN1.EQ.NDK+1) KN2 = NNK
              END IF
              LN2 = LNODS(KE,KN2)
              CALL IDENODE(IE1,LN2,KYIDN)
              CALL IDENODE(JE1,LN2,KYJDN)
              IF(KYIDN.EQ.1) THEN
                NG = (IE1-1)*MXEI*MXEN+(INi-1)*MXEN
                IWORK(IADB1+NG+1) = IWORK(IADB1+NG+1) + 1
                IG = IWORK(IADB1+NG+1)
                IWORK(IADB1+NG+1+IG) = KE*100+KN1
              END IF
              IF(KYJDN.EQ.1) THEN
                NG = (JE1-1)*MXEI*MXEN+(JNi-1)*MXEN
                IWORK(IADB1+NG+1) = IWORK(IADB1+NG+1) + 1
                IG = IWORK(IADB1+NG+1)
                IWORK(IADB1+NG+1+IG) = KE*100+KN1
              END IF
  380         CONTINUE
            END DO
          END DO
        END DO
      ELSE IF(KEY.GE.3) THEN
        XM  = 1.0E30
        YM  = 1.0E30
        KIB = 1
        DO IEG = 1, NEG
          NG = (IEG-1)*MXEL
          IG = NG + 1
          IE1 = IWORK(IADB+IG)/100
          IN1 = IWORK(IADB+IG)-100*IE1
          IG = IG + 1
          IE2 = IWORK(IADB+IG)/100
          IN2 = IWORK(IADB+IG)-100*IE2
          IP1 = LNODS(IE1,IN1)
          IP2 = LNODS(IE1,IN2)
          XI  = 0.5*(COORD(IP1,1)+COORD(IP2,1))
          YI  = 0.5*(COORD(IP1,2)+COORD(IP2,2))
          IF(XI.LT.XM) THEN
            XM  = XI
            KIB = IEG
          ELSE IF(ABS(XI-XM).LT.TOLER.AND.YI.LT.YM) THEN
            YM  = YI
            KIB = IEG
          END IF
        END DO
        IM1 = 1
        IM2 = 2
        IJ1 = 5
        IJ2 = 6
  400   CONTINUE
        IEG = 1
        IF(KIB.NE.IEG) THEN
          IG = (IEG-1)*MXEL
          KG = (KIB-1)*MXEL
          DO K = 1,4
            IM = IWORK(IADB+IG+K)
            IWORK(IADB+IG+K) = IWORK(IADB+KG+K)
            IWORK(IADB+KG+K) = IM
          END DO
        END IF
        KIB = 0
        IWORK(IADB+5) = 0
  405   CONTINUE
        KIB = KIB + 1
        NG = (KIB-1)*MXEL
        IG = NG + IM2
        IEB = IWORK(IADB+IG)/100
        INB = IWORK(IADB+IG)-100*IEB
        IPB = LNODS(IEB,INB)
        XIB = COORD(IPB,1)
        YIB = COORD(IPB,2)
        DO IEG = KIB+1, NEG
          NG = (IEG-1)*MXEL
          IG = NG + IM1
          IE1 = IWORK(IADB+IG)/100
          IN1 = IWORK(IADB+IG)-100*IE1
          IP1 = LNODS(IE1,IN1)
          XI1 = COORD(IP1,1)
          YI1 = COORD(IP1,2)
          IF(ABS(XI1-XIB).LT.TOLER.AND.ABS(YI1-YIB).LT.TOLER) THEN
            KEG = KIB + 1
            IF(KEG.NE.IEG) THEN
              IG = (IEG-1)*MXEL
              KG = (KEG-1)*MXEL
              DO K = 1,4
                IM = IWORK(IADB+IG+K)
                IWORK(IADB+IG+K) = IWORK(IADB+KG+K)
                IWORK(IADB+KG+K) = IM
              END DO
            END IF
            GOTO 410
          END IF
        END DO
        IF(KIB.LT.NEG-1) THEN
          IM1 = 2
          IM2 = 1
          IJ1 = 6
          IJ2 = 5
          DO IEG = 1, NEG
            NG = (IEG-1)*MXEL
            IG = NG + 5
            IWORK(IADB+IG) = 0
            IG = NG + 6
            IWORK(IADB+IG) = 0
          END DO
          GOTO 400
        END IF
  410   CONTINUE
        NG = (KEG-1)*MXEL
        IWORK(IADB+NG+IJ1) = KIB
        IF(KIB.LT.NEG-1) GOTO 405
        KIB = KIB + 1
        NG = (KIB-1)*MXEL
        IG = NG + IM2
        IEB = IWORK(IADB+IG)/100
        INB = IWORK(IADB+IG)-100*IEB
        IPB = LNODS(IEB,INB)
        XIB = COORD(IPB,1)
        YIB = COORD(IPB,2)
        IEG = 1
        NG  = (IEG-1)*MXEL
        IG  = NG + IM1
        IE1 = IWORK(IADB+IG)/100
        IN1 = IWORK(IADB+IG)-100*IE1
        IP1 = LNODS(IE1,IN1)
        XI1 = COORD(IP1,1)
        YI1 = COORD(IP1,2)
        IF(ABS(XI1-XIB).LT.TOLER.AND.ABS(YI1-YIB).LT.TOLER) THEN
          NG = (NEG-1)*MXEL
          IWORK(IADB+NG+IJ2) = 1
        END IF
      END IF
C
      IADD = IADC + NNODE*MXPE
      DO K=1,NNODE
        IWORK(IADD+K) = 0
      END DO
      DO IEG = 1, NEG
        NG = (IEG-1)*MXEL
        IG = NG + 1
        IE1 = IWORK(IADB+IG)/100
        IN1 = IWORK(IADB+IG)-100*IE1
        IG = IG + 1
        IE2 = IWORK(IADB+IG)/100
        IN2 = IWORK(IADB+IG)-100*IE2
        IP1 = LNODS(IE1,IN1)
        IP2 = LNODS(IE1,IN2)
        IWORK(IADD+IP1) = IWORK(IADD+IP1) + 1
        IWORK(IADD+IP2) = IWORK(IADD+IP2) + 1
      END DO
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 2'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 2'
C
      IADE = IADD + NNODE*MXPE
      DO K=1,NELEM*8
        IWORK(IADE+K) = 0
      END DO
      IENEW = NELEM
      IPNEW = NNODE
      MATSET(IMSET2,1) = 1
      NDNEW = 2*(2+KND-1)
      DO IEG = 1, NEG
        NG = (IEG-1)*MXEL
        IG = NG + 1
        IE1 = IWORK(IADB+IG)/100
        IN1 = IWORK(IADB+IG)-100*IE1
        IG = IG + 1
        IE2 = IWORK(IADB+IG)/100
        IN2 = IWORK(IADB+IG)-100*IE2
        IC1 = IWORK(IADB+NG+5)
        IC2 = IWORK(IADB+NG+6)
C
        IP1 = LNODS(IE1,IN1)
C
        IP2 = LNODS(IE1,IN2)
C
        IG = IG + 1
        JE1 = IWORK(IADB+IG)/100
        JN1 = IWORK(IADB+IG)-100*JE1
        IG = IG + 1
        JE2 = IWORK(IADB+IG)/100
        JN2 = IWORK(IADB+IG)-100*JE2
        JP1 = LNODS(JE1,JN1)
        JP2 = LNODS(JE1,JN2)
        IENEW = IENEW + 1
        MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
        MATSET(IMSET2,MATSET(IMSET2,1))=IENEW
        LNODS(IENEW,MXNOD)=NDNEW
        LNODS(IENEW,MXNOD-1)=IMSET2
C *** GENERATING 4 node ELEMENT
        IF(KND.EQ.1) THEN
          IADS  = IADE + (JE1-1)*NND+JN1
          IF(IWORK(IADS).EQ.0.OR.KEB.EQ.0) THEN
            KDOUB = IARRAY(IADMBOD+IP1)
            KNGEL = IWORK(IADD+IP1)
            IF(IC1.EQ.0) THEN
              IPNEW = IPNEW + 1
              IPN1  = IPNEW
              COORD(IPN1,1) = COORD(IP1,1)
              COORD(IPN1,2) = COORD(IP1,2)
              LNODS(JE1,JN1) = IPN1
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(JE1-1)*MXEI*MXEN+(JN1-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN1
                END DO
              END IF
              NG  = IADC + (IP1-1)*MXPE
              IF(KEB.EQ.0.AND.IWORK(NG+1).GT.0) THEN
                NPEL = IWORK(NG+1)
                DO K=1,NPEL
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN1
                END DO
              END IF
            ELSE
              KEG = IC1
              NG  = (KEG-1)*MXEL
              KG  = NG + 4
              KEi = IWORK(IADB+KG)/100
              KNi = IWORK(IADB+KG)-100*KEi
              IPN1= LNODS(KEi,KNi)
              LNODS(JE1,JN1) = IPN1
            END IF
          ELSE
            IPN1  = IWORK(IADS)
C
            IADS  = IADE + (IE1-1)*NND+IN1
            IF(IWORK(IADS).EQ.0) THEN
              IPNEW = IPNEW + 1
              IP1   = IPNEW
              COORD(IP1,1) = COORD(IPN1,1)
              COORD(IP1,2) = COORD(IPN1,2)
              LNODS(IE1,IN1) = IP1
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(IE1-1)*MXEI*MXEN+(IN1-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IP1
                END DO
              END IF
C----------------------------------------------------------------------
            ELSE
              IP1 = IWORK(IADS)
            END IF
          END IF
          IADS  = IADE + (JE1-1)*NND+JN2
          IF(IWORK(IADS).EQ.0.OR.KEB.EQ.0) THEN
            KDOUB = IARRAY(IADMBOD+IP2)
            KNGEL = IWORK(IADD+IP2)
            IF(IC2.EQ.0) THEN
              IPNEW = IPNEW + 1
              IPN2  = IPNEW
              COORD(IPN2,1) = COORD(IP2,1)
              COORD(IPN2,2) = COORD(IP2,2)
              LNODS(JE1,JN2) = IPN2
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(JE1-1)*MXEI*MXEN+(JN2-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN2
                END DO
              END IF
C----------------------------------------------------------------------
              NG  = IADC + (IP2-1)*MXPE
              IF(KEB.EQ.0.AND.IWORK(NG+1).GT.0) THEN
                NPEL = IWORK(NG+1)
                DO K=1,NPEL
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN2
                END DO
              END IF
            ELSE
              KEG = IC2
              NG  = (KEG-1)*MXEL
              KG  = NG + 3
              KEi = IWORK(IADB+KG)/100
              KNi = IWORK(IADB+KG)-100*KEi
              IPN2= LNODS(KEi,KNi)
              LNODS(JE1,JN2) = IPN2
            END IF
          ELSE
            IPN2  = IWORK(IADS)
C
            IADS  = IADE + (IE1-1)*NND+IN2
            IF(IWORK(IADS).EQ.0) THEN
              IPNEW = IPNEW + 1
              IP2   = IPNEW
              COORD(IP2,1) = COORD(IPN2,1)
              COORD(IP2,2) = COORD(IPN2,2)
              LNODS(IE1,IN2) = IP2
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(IE1-1)*MXEI*MXEN+(IN2-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IP2
                END DO
              END IF
C----------------------------------------------------------------------
            ELSE
              IP2 = IWORK(IADS)
            END IF
C
          END IF
          LNODS(IENEW,1)=IP1
          LNODS(IENEW,2)=IP2
          LNODS(IENEW,3)=IPN1
          LNODS(IENEW,4)=IPN2
          ELTYP(IENEW)   = 'ICOHE2'
          CALL DNODE(IENEW,NDNEW)
C
          IADS = IADE + (IE1-1)*NND+IN1
          IWORK(IADS) = IP1
          IADS = IADE + (IE1-1)*NND+IN2
          IWORK(IADS) = IP2
C
          IADS = IADE + (JE1-1)*NND+JN1
          IWORK(IADS) = IPN1
          IADS = IADE + (JE1-1)*NND+JN2
          IWORK(IADS) = IPN2
C----------------------------------------------------------------------
        ELSE
          IN3   = IN2 + ND2
C
          IADS  = IADE + (IE1-1)*NND+IN3
          IP3   = LNODS(IE1,IN3)
C
          JN3   = JN1 + ND2
          IADS  = IADE + (JE1-1)*NND+JN1
          IF(IWORK(IADS).EQ.0.OR.KEB.EQ.0) THEN
            KDOUB = IARRAY(IADMBOD+IP1)
            KNGEL = IWORK(IADD+IP1)
C           IF(KNGEL.EQ.1.AND.KDOUB.EQ.0) THEN
C             IPN1  = IP1
C           IF(KEB.EQ.1.OR.IEG.EQ.1) THEN
            IF(IC1.EQ.0) THEN
              IPNEW = IPNEW + 1
              IPN1  = IPNEW
              COORD(IPN1,1) = COORD(IP1,1)
              COORD(IPN1,2) = COORD(IP1,2)
              LNODS(JE1,JN1) = IPN1
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(JE1-1)*MXEI*MXEN+(JN1-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN1
                END DO
              END IF
C----------------------------------------------------------------------
              NG  = IADC + (IP1-1)*MXPE
              IF(KEB.EQ.0.AND.IWORK(NG+1).GT.0) THEN
                NPEL = IWORK(NG+1)
                DO K=1,NPEL
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN1
                END DO
              END IF
            ELSE
              KEG = IC1
              NG  = (KEG-1)*MXEL
              KG  = NG + 4
              KEi = IWORK(IADB+KG)/100
              KNi = IWORK(IADB+KG)-100*KEi
              IPN1= LNODS(KEi,KNi)
              LNODS(JE1,JN1) = IPN1
            END IF
          ELSE
            IPN1  = IWORK(IADS)
C
            IADS  = IADE + (IE1-1)*NND+IN1
            IF(IWORK(IADS).EQ.0) THEN
              IPNEW = IPNEW + 1
              IP1   = IPNEW
              COORD(IP1,1) = COORD(IPN1,1)
              COORD(IP1,2) = COORD(IPN1,2)
              LNODS(IE1,IN1) = IP1
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(IE1-1)*MXEI*MXEN+(IN1-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IP1
                END DO
              END IF
C----------------------------------------------------------------------
            ELSE
              IP1 = IWORK(IADS)
            END IF
C
          END IF
          IADS  = IADE + (JE1-1)*NND+JN2
          IF(IWORK(IADS).EQ.0.OR.KEB.EQ.0) THEN
            KDOUB = IARRAY(IADMBOD+IP2)
            KNGEL = IWORK(IADD+IP2)
C           IF(KNGEL.EQ.1.AND.KDOUB.EQ.0) THEN
C             IPN2  = IP2
            IF(IC2.EQ.0) THEN
              IPNEW = IPNEW + 1
              IPN2  = IPNEW
              COORD(IPN2,1) = COORD(IP2,1)
              COORD(IPN2,2) = COORD(IP2,2)
              LNODS(JE1,JN2) = IPN2
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(JE1-1)*MXEI*MXEN+(JN2-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN2
                END DO
              END IF
C----------------------------------------------------------------------
              NG  = IADC + (IP2-1)*MXPE
              IF(KEB.EQ.0.AND.IWORK(NG+1).GT.0) THEN
                NPEL = IWORK(NG+1)
                DO K=1,NPEL
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IPN2
                END DO
              END IF
            ELSE
              KEG = IC2
              NG  = (KEG-1)*MXEL
              KG  = NG + 3
              KEi = IWORK(IADB+KG)/100
              KNi = IWORK(IADB+KG)-100*KEi
              IPN2= LNODS(KEi,KNi)
              LNODS(JE1,JN2) = IPN2
            END IF
          ELSE
            IPN2  = IWORK(IADS)
C
            IADS  = IADE + (IE1-1)*NND+IN2
            IF(IWORK(IADS).EQ.0) THEN
              IPNEW = IPNEW + 1
              IP2   = IPNEW
              COORD(IP2,1) = COORD(IPN2,1)
              COORD(IP2,2) = COORD(IPN2,2)
              LNODS(IE1,IN2) = IP2
C *** CHANGING INTERFACE ELEMENT NODE CORESPONDE TO NEW NODE
              NG = IADB1+(IE1-1)*MXEI*MXEN+(IN2-1)*MXEN
              NDCH = IWORK(NG+1)
              IF(NDCH.GT.0) THEN
                DO K = 1,NDCH
                  IEi = IWORK(NG+1+K)/100
                  INi = IWORK(NG+1+K)-IEi*100
                  LNODS(IEi,INi) = IP2
                END DO
              END IF
C----------------------------------------------------------------------
            ELSE
              IP2 = IWORK(IADS)
            END IF
C
          END IF
          IADS  = IADE + (JE1-1)*NND+JN3
          IF(IWORK(IADS).EQ.0) THEN
            IPNEW = IPNEW + 1
            IPN3  = IPNEW
            COORD(IPN3,1) = COORD(IP3,1)
            COORD(IPN3,2) = COORD(IP3,2)
            LNODS(JE1,JN3) = IPN3
          ELSE
            IPN3  = IWORK(IADS)
C
            IADS  = IADE + (IE1-1)*NND+IN3
            IF(IWORK(IADS).EQ.0) THEN
              IPNEW = IPNEW + 1
              IP3   = IPNEW
              COORD(IP3,1) = COORD(IPN3,1)
              COORD(IP3,2) = COORD(IPN3,2)
              LNODS(IE1,IN3) = IP3
            ELSE
              IP3 = IWORK(IADS)
            END IF
C
          END IF
          LNODS(IENEW,1)=IP1
          LNODS(IENEW,2)=IP3
          LNODS(IENEW,3)=IP2
          LNODS(IENEW,4)=IPN1
          LNODS(IENEW,5)=IPN3
          LNODS(IENEW,6)=IPN2
          ELTYP(IENEW)   = 'ICOHE3'
          CALL DNODE(IENEW,NDNEW)
C
          IADS = IADE + (IE1-1)*NND+IN1
          IWORK(IADS) = IP1
          IADS = IADE + (IE1-1)*NND+IN2
          IWORK(IADS) = IP2
          IADS = IADE + (IE1-1)*NND+IN3
          IWORK(IADS) = IP3
C
          IADS = IADE + (JE1-1)*NND+JN1
          IWORK(IADS) = IPN1
          IADS = IADE + (JE1-1)*NND+JN2
          IWORK(IADS) = IPN2
          IADS = IADE + (JE1-1)*NND+JN3
          IWORK(IADS) = IPN3
        END IF
      END DO
      NELEM = IENEW
      NNODE = IPNEW
C *** CHECKING CRACK TIP NODE DEFINITION
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 3'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COHESIV4 - MASK 3'
C
      IF(KEY.GT.2) RETURN
      IWORK(1) = 1
      DO IE = 1, NELEM
        NODE = LNODS(IE,MXNOD)
        ND2  = NODE
        IF(NODE.GT.4) ND2 = NODE/2
C       CHAR = ELTYP(IE)
        DO IN = 1, ND2
          LN  = LNODS(IE,IN)
          XI  = COORD(LN,1)
          YI  = COORD(LN,2)
          DI  = DISTN(XTIP,YTIP,0.0E0,XI,YI,0.0E0)
          IF(DI.LE.TOLER) THEN
            IWORK(1) = IWORK(1) + 1
            IWORK(IWORK(1)) = IE*100+IN
          END IF
        END DO
      END DO
      IF(IWORK(1).GT.3) THEN
        NN    = IWORK(1)
        IAD1  = 100
        IAD2  = 200
        IWORK(IAD1) = 0
        IWORK(IAD2) = 0
        DO I = 2, NN
          NG = IWORK(I)
          IE = NG/100
          IN = NG-IE*100
          LNI = LNODS(IE,IN)
          CHAR1 = ELTYP(IE)
          DO J = 2,NN
            NG = IWORK(J)
            JE = NG/100
            JN = NG-JE*100
            LNJ = LNODS(JE,JN)
            CHAR2 = ELTYP(JE)
            IF(LNI.EQ.LNJ.AND.I.NE.J.AND.
     &         CHAR1(1:1).EQ.'C'.AND.CHAR2(1:1).EQ.'C') THEN
              IWORK(IAD1) = IWORK(IAD1) + 1
              IWORK(IAD1+IWORK(IAD1)) = I*100+J
            END IF
          END DO
        END DO
        IF(IWORK(IAD1).GT.0) THEN
          IK0 = 0
          JK0 = 0
          NN1 = IWORK(IAD1)
          DO I1 = 1, NN1-1
            NG1 = IWORK(IAD1+I1)
            IF(NG1.GT.0) THEN
              IK1 = NG1/100
              JK1 = NG1-IK1*100
              DO I2 = I1+1, NN1
                NG2 = IWORK(IAD1+I2)
                IK2 = NG2/100
                JK2 = NG2-IK2*100
                IF((IK1.EQ.JK2.AND.JK1.EQ.IK2).OR.
     &             (IK1.EQ.IK2.AND.JK1.EQ.JK2)) THEN
                  IWORK(IAD1+I2) = 0
                END IF
              END DO
            END IF
          END DO
          IWORK(IAD1) = 0
          DO I1 = 1, NN1
            NG1 = IWORK(IAD1+I1)
            IF(NG1.GT.0) THEN
              IWORK(IAD1) = IWORK(IAD1) + 1
              IWORK(IAD1+IWORK(IAD1)) = IWORK(IAD1+I1)
            END IF
          END DO
          NN1 = IWORK(IAD1)
          DO I1 = 1, NN1
            NG = IWORK(IAD1+I1)
            IK = NG/100
            JK = NG-IK*100
            NG = IWORK(IK)
            IE = NG/100
            IN = NG-IE*100
            NODE = LNODS(IE,MXNOD)
            ND2  = NODE
            IF(NODE.GT.4) ND2 = NODE/2
            IN1 = IN+1
            IN0 = IN-1
            IF(IN1.GT.ND2) IN1 = 1
            IF(IN0.LT.1) IN0 = ND2
            LNI  = LNODS(IE,IN)
            LNI0 = LNODS(IE,IN0)
            LNI1 = LNODS(IE,IN1)
            DO J = 2,NN
              NG = IWORK(J)
              JE = NG/100
              CHAR2 = ELTYP(JE)
              IF(CHAR2(1:1).EQ.'I') THEN
                NODE = LNODS(JE,MXNOD)
                NDJ  = NODE/2
                JN1 = 1
                JN2 = NDJ
                JN3 = NDJ+1
                JN4 = NDJ+NDJ
                LNJ1 = LNODS(JE,JN1)
                LNJ2 = LNODS(JE,JN2)
                LNJ3 = LNODS(JE,JN3)
                LNJ4 = LNODS(JE,JN4)
                IF((LNI.EQ.LNJ1.AND.LNI0.EQ.LNJ2).OR.
     &             (LNI.EQ.LNJ2.AND.LNI0.EQ.LNJ1).OR.
     &             (LNI.EQ.LNJ3.AND.LNI0.EQ.LNJ4).OR.
     &             (LNI.EQ.LNJ4.AND.LNI0.EQ.LNJ3).OR.
     &             (LNI.EQ.LNJ1.AND.LNI1.EQ.LNJ2).OR.
     &             (LNI.EQ.LNJ2.AND.LNI1.EQ.LNJ1).OR.
     &             (LNI.EQ.LNJ3.AND.LNI1.EQ.LNJ4).OR.
     &             (LNI.EQ.LNJ4.AND.LNI1.EQ.LNJ3)) THEN
                  NNODE = NNODE + 1
                  LNODS(IE,IN) = NNODE
                  INCOD(NNODE) = NNODE
                  IF(LNI.EQ.LNJ1) LNODS(JE,JN1) = NNODE
                  IF(LNI.EQ.LNJ2) LNODS(JE,JN2) = NNODE
                  IF(LNI.EQ.LNJ3) LNODS(JE,JN3) = NNODE
                  IF(LNI.EQ.LNJ4) LNODS(JE,JN4) = NNODE
                  DO K = 1,3
                    COORD(NNODE,K) = COORD(LNI,K)
                  END DO
                END IF
              END IF
            END DO
          END DO
        END IF
      END IF
C
      WRITE(IO_JNL,'(5X,A)') 'NOW END OF   SUB. COHESIV4'
      WRITE(IO_WRITE,'(5X,A)') 'NOW END OF   SUB. COHESIV4'
C
      RETURN
      END
      SUBROUTINE IDENODE(IE,IP,KYIDN)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      KYIDN = 1
      NND = LNODS(IE,MXNOD)
      DO IN = 1, NND
        LN = LNODS(IE,IN)
        IF(LN.EQ.IP) RETURN
      END DO
      KYIDN = 0
      RETURN
      END
