C *** SUBROUTINE APPLYING THE ROTATING BOUNDARY
      SUBROUTINE EQUATS
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CHAR(100)*8
      DIMENSION NW(1000)
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. EQUATS'
C
      TEXT='NOW EXCUTING SUB. EQUATS'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) MEQUAT
      IF(MEQUAT.EQ.0) RETURN
      DO K=1,MEQUAT
C       READ(IO_INPUT,'(A)') CHAR(K)
        STRING = ' '
        READ(IO_INPUT,'(A)') STRING
        ZEQU = 0.0E0
        IFREDOM3 = 0
        READ(STRING(1:120),*) 
     &  IFREDOM1,IFREDOM2,XYEQU,WD,IFREDOM3,ZEQU
        STRING = ' '
        READ(IO_INPUT,'(A)') STRING
        READ(STRING(1:120),*) KREF_EQU,XREF_EQU,YREF_EQU
        KREF_EQU = NNODE + K
        NCONT=0
        DO IN=1,NNODE
          IF(INCOD(IN).NE.0) THEN
            XY=COORD(IN,IFREDOM1)
            Z = 0.0D0
            IF(IFREDOM3.GT.0) Z =COORD(IN,IFREDOM3)
            IF(ABS(XY-XYEQU).LT.TOLER.AND.
     &         ABS(Z - ZEQU).LT.TOLER) THEN
              NCONT=NCONT+1
              NW(NCONT)=IN
            END IF
          END IF
        END DO
        IF(IOUT.NE.1) THEN
          IF(NCONT.GT.0) THEN
            WRITE(IO_OUTP,1000) KREF_EQU,XREF_EQU,YREF_EQU,ZEQU
            WRITE(IO_OUTP,1001) CNUM(K),KREF_EQU
            W1   = -1.0E30
            W2   =  1.0E30
            KEQ  = 0
            DO J=1,NCONT
              KNODE=NW(J)
              X=COORD(KNODE,1)
              Y=COORD(KNODE,2)
              W=COORD(KNODE,IFREDOM2)-XREF_EQU
              IF(ABS(W).LE.TOLER) THEN
                KEQ  = KNODE
              ELSE IF(W1.LT.W.AND.W.LT.0) THEN
                W1  = W
                K1  = KNODE
              ELSE IF(W2.GT.W.AND.W.GT.0) THEN
                W2  = W
                K2  = KNODE
              END IF
              ACOEF=W/WD
              WRITE(IO_OUTP,1010) 3,KNODE,IFREDOM1,1.0,
     &                          KREF_EQU,IFREDOM1,-1.0,
     &                          KREF_EQU,IFREDOM2,ACOEF
            END DO
            IF(KEQ.NE.0) THEN
              WRITE(IO_OUTP,1010) 2,KEQ  ,IFREDOM2,1.0,
     &                          KREF_EQU,IFREDOM2,-1.0
            ELSE
              A1   = 1.0E0
              A2   = ABS(W1/W2)
              A3   = -(1.0E0+A2)
              WRITE(IO_OUTP,1010) 3,K1   ,IFREDOM2,A1,
     &                              K2   ,IFREDOM2,A2,
     &                           KREF_EQU,IFREDOM2,A3
            END IF
          END IF
        END IF
      END DO
 1000 FORMAT('*NODE, SYSTEM=R'/I10,3(1H,,1PE15.8))
 1001 FORMAT('*NSET,NSET=EQUAT',A/I5)
 1010 FORMAT('*EQUATION'/I5/2I5,F10.5,2I5,F10.5,2I5,F10.5)
C
      TEXT='END OF EXCUTING SUB. EQUATS'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
      SUBROUTINE EQUATD
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NW(1000)
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. EQUATD'
C
      TEXT='NOW EXCUTING SUB. EQUATD'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) MEQUAT
      IF(MEQUAT.EQ.0) RETURN
      DO K=1,MEQUAT
        READ(IO_INPUT,'(A)') STRING
        READ(IO_INPUT,*) YE,XB,XE
        IFREDOM1 = 1
        IFREDOM2 = 2
        IFREDOM3 = 3
        IF(ABS(XB)+ABS(XE).LE.1.0E-08) THEN
          XB = -1.0E30
          XE =  1.0E30
        END IF
        IF(STRING(1:1).EQ.'H') THEN
          IFREDOM1 = 2
          IFREDOM2 = 1
          IFREDOM3 = 3
        ELSE IF(STRING(1:1).EQ.'V') THEN
          IFREDOM1 = 1
          IFREDOM2 = 2
          IFREDOM3 = 3
        END IF
        NCONT=0
        DO IN=1,NNODE
          IF(INCOD(IN).NE.0) THEN
            YM = COORD(IN,IFREDOM1)
            XM = COORD(IN,IFREDOM2)
            HM = (XM-XB)*(XM-XE)
            IF(ABS(YM-YE).LT.TOLER.AND.HM.LE.1.0E-8) THEN
              NCONT=NCONT+1
              NW(NCONT)=IN
            END IF
          END IF
        END DO
        IF(IOUT.NE.1) THEN
          IF(NCONT.GT.1) THEN
            KREF_EQU = NW(1)
            KEQ  = 0
            DO J=2,NCONT
              KNODE=NW(J)
              WRITE(IO_OUTP,1010) 2,KNODE,IFREDOM1,1.0,
     &                          KREF_EQU,IFREDOM1,-1.0
            END DO
          END IF
        END IF
      END DO
 1000 FORMAT('*NODE, SYSTEM=R'/I10,3(1H,,1PE15.8))
 1001 FORMAT('*NSET,NSET=EQUAT'/I5)
 1010 FORMAT('*EQUATION'/I5/2I5,F10.5,2I5,F10.5,2I5,F10.5)
C
      TEXT='END OF EXCUTING SUB. EQUATD'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C *** SUBROUTINE APPLYING CONSTRAINT EQUATION
      SUBROUTINE EQUATQ
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CHAR(100)*8,NAME*8
      DIMENSION NW(1000)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. EQUATQ'
C
      TEXT='NOW EXCUTING SUB. EQUATQ'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      NAME = 'EQUATQ'
      CALL LOCCHR(STRING,'NAME    ',4,4,K1,K2)
      IF(K2.GE.K1) NAME = STRING(K1:K2)
C
      READ(IO_INPUT,*) X1,Y1,Z1
      KREF_EQU = NNODE+1
      WRITE(IO_OUTP,1000) KREF_EQU,X1,Y1,Z1
      WRITE(IO_OUTP,1002) NAME,KREF_EQU
      READ(IO_INPUT,*) MEQUAT
      IF(MEQUAT.EQ.0) RETURN
      DO K=1,MEQUAT
        READ(IO_INPUT,'(A)') STRING
        READ(IO_INPUT,*) YE,XB,XE
        IFREDOM1 = 1
        IFREDOM2 = 2
        IFREDOM3 = 3
        IF(ABS(XB)+ABS(XE).LE.1.0E-08) THEN
          XB = -1.0E30
          XE =  1.0E30
        END IF
        IF(STRING(1:1).EQ.'H') THEN
          IFREDOM1 = 2
          IFREDOM2 = 1
          IFREDOM3 = 3
        ELSE IF(STRING(1:1).EQ.'V') THEN
          IFREDOM1 = 1
          IFREDOM2 = 2
          IFREDOM3 = 3
        END IF
        NCONT=0
        DO IN=1,NNODE
          IF(INCOD(IN).NE.0) THEN
            YM = COORD(IN,IFREDOM1)
            XM = COORD(IN,IFREDOM2)
            HM = (XM-XB)*(XM-XE)
            IF(ABS(YM-YE).LT.TOLER.AND.HM.LE.1.0E-8) THEN
              NCONT=NCONT+1
              NW(NCONT)=IN
            END IF
          END IF
        END DO
        IF(IOUT.NE.1) THEN
          IF(NCONT.GT.1) THEN
C           KREF_EQU = NW(1)
            KEQ  = 0
            DO J=1,NCONT
              KNODE=NW(J)
              WRITE(IO_OUTP,1010) 2,KNODE,IFREDOM1,1.0,
     &                          KREF_EQU,IFREDOM1,-1.0
            END DO
          END IF
        END IF
      END DO
 1000 FORMAT('*NODE, SYSTEM=R'/I10,3(1H,,1PE15.8))
 1001 FORMAT('*NSET,NSET=EQUAT'/I5)
 1002 FORMAT('*NSET,NSET=',A/I5)
 1010 FORMAT('*EQUATION'/I5/2I5,F10.5,2I5,F10.5,2I5,F10.5)
C
      TEXT='END OF EXCUTING SUB. EQUATQ'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C *** SUBROUTINE APPLYING PERIOD CONSTRAINT EQUATION
      SUBROUTINE EQUATP
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER CHAR*8,CHAR1*8,CHAR2*8,CHBND(100)*8
      DIMENSION NW(100,2),IW(100),KWORK(NDMAX)
      DIMENSION IFBND(100),KPBND(100,3)
C
      CERRRPT(1)(20:80) = ': *PERIOD     option'
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. PERIOD'
C
      TEXT='NOW EXCUTING SUB. EQUATP'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KSORT  = 2
      CALL LOCCHR(STRING,'ORDER   ',5,4,K1,K2)
      IF(K2.GE.K1) THEN
        IF(STRING(K1:K1).EQ.'3') THEN
          KSORT  = 3
        END IF
      END IF
C
      NPBND = 0
   10 CONTINUE
      READ(IO_INPUT,'(A)') STRING
   12 CONTINUE
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 10
      ELSE IF(STRING(1:10).EQ.'*PRE BOUND') THEN
        READ(IO_INPUT,*) NPBND
        DO K=1,NPBND
          READ(IO_INPUT,'(I2,A)') IFBND(K),CHBND(K)
        END DO
      ELSE
        BACKSPACE IO_INPUT
      END IF
   20 CONTINUE

      DO IPBND=1,NPBND
        CHAR = CHBND(IPBND)
        IFD  = IFBND(IPBND)
        KPBND(IPBND,1) = 0
        KPBND(IPBND,2) = 0
        KPBND(IPBND,3) = 0
        CALL FINDSET(CNDSET,NDSET,CHAR,ISET)
        KPBND(IPBND,IFD) = ISET
      END DO

      READ(IO_INPUT,*) MEQUAT
      IF(MEQUAT.EQ.0) RETURN
      DO IEQ=1,MEQUAT
        LWK = IADPRD
    1   CONTINUE
        READ(IO_INPUT,'(A)') STRING
        CALL DTEXT(STRING,LEN)
        IF(IOUT.EQ.1) GOTO 99
        IADPRD = LWK
        KPOS0 = 1
        CALL REACHR(STRING,CHAR,KPOS0,KPOS1,KPOS2)
        READ(CHAR,'(I5)') IFDOM1
        KPOS0 = KPOS2 + 2
        CALL REACHR(STRING,CHAR,KPOS0,KPOS1,KPOS2)
        CHAR1 = CHAR
        DO J=1,NDSET
          IF(CHAR.EQ.CNDSET(J)) THEN
            KSET1 = J
            IADPRD = IADPRD + 1
            KWORK(IADPRD) = NNSET(KSET1)+1
            IADPRD1 = IADPRD
            DO I = 1,NNSET(KSET1)
              IADPRD = IADPRD + 1
              KWORK(IADPRD) = INSET(I,KSET1)
            END DO
            GOTO 5
          END IF
        END DO
c       WRITE(6,1000) CHAR, ' has not been found'

        CERRRPT(1)(20:80) =
     &  ': *PERIOD option for applying PERIODIC CONSTRAINT'
        CERRRPT(2)(20:80) =
     &  ': Node set: '//CHAR//' has not been not found'
        CERRRPT(3)(20:80) =
     &  ': Ignoring input card - '//STRING(1:LEN)
        NLERR = 3
        IUNIT = 6
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_INFO
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_OUTP
        CALL MWARNING(IUNIT,KERR,NLERR)
        IADPRD = LWK

        GOTO 99

    5   CONTINUE
        KPOS0 = KPOS2 + 2
        CALL REACHR(STRING,CHAR,KPOS0,KPOS1,KPOS2)
        CHAR2 = CHAR
        DO J=1,NDSET
          IF(CHAR.EQ.CNDSET(J)) THEN
            KSET2 = J
            IADPRD = IADPRD + 1
            IADPRD2 = IADPRD
            KWORK(IADPRD) = NNSET(KSET2)+1
            DO I = 1,NNSET(KSET2)
              IADPRD = IADPRD + 1
              KWORK(IADPRD) = INSET(I,KSET2)
            END DO
            GOTO 6
          END IF
        END DO
c       WRITE(6,2000) CHAR, ' has not been found'

        CERRRPT(1)(20:80) =
     &  ': *PERIOD option for applying PERIODIC CONSTRINT'
        CERRRPT(2)(20:80) =
     &  ': Node in set: '//CHAR//' is not found' 
        CERRRPT(3)(20:80) =
     &  ': Ignoring input card - '//STRING(1:LEN)
        NLERR = 3
        IUNIT = 6
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_INFO
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_OUTP
        CALL MWARNING(IUNIT,KERR,NLERR)
        IADPRD = LWK

        GOTO 99

    6   CONTINUE
        NEQUATP = NEQUATP + 1
        IF(KWORK(IADPRD1).NE.KWORK(IADPRD2)) THEN

          CERRRPT(1)(20:80) = 
     &    ': *PERIOD option for applying PERIODIC CONSTRINT'
          CERRRPT(2)(20:80) =
     &    ': Node number in set: '//CHAR1//' and '//CHAR2//
     &    ' are not same'
          CERRRPT(3)(20:80) =
     &    ': Ignoring input card - '//STRING(1:LEN)
          NLERR = 3
          IUNIT = 6
          CALL MWARNING(IUNIT,KERR,NLERR)
          IUNIT = IO_INFO
          CALL MWARNING(IUNIT,KERR,NLERR)
          IUNIT = IO_OUTP
          CALL MWARNING(IUNIT,KERR,NLERR)

          IADPRD = LWK
          GOTO 99
        END IF
        NPERD = NPERD + 1
        NW(NPERD,1) = IADPRD1
        NW(NPERD,2) = IADPRD2
        IF(KSORT.EQ.2) THEN
          IAD1 = NW(NPERD,1)
          CALL SORTND(KWORK(IAD1),IFDOM1)
          IAD2 = NW(NPERD,2)
          CALL SORTND(KWORK(IAD2),IFDOM1)
        ELSE
          IAD1 = NW(NPERD,1)
          IAD2 = NW(NPERD,2)
          IFD1 = 2
          IFD2 = 3
          IF(IFDOM1.EQ.2) THEN
            IFD1 = 1
            IFD2 = 3
          ELSE IF(IFDOM1.EQ.3) THEN
            IFD1 = 1
            IFD2 = 2
          END IF
          CALL SAMEND(KWORK(IAD1),KWORK(IAD2),IFD1,IFD2)
        END IF
c       IAD1 = NW(NPERD,1)
c       NN   = KWORK(IAD1)
c       write(81,5555) 'K11',NN,(KWORK(IAD1+K),K=1,NN-1)
c       IAD1 = NW(NPERD,2)
c       NN   = KWORK(IAD1)
c       write(81,5556) 'K12',NN,(KWORK(IAD1+K),K=1,NN-1)
 5555 format(A,I5/(10I5))
 5556 format(A,I5/(10I5))
        IF(NPERD.GT.1) THEN
          IAD1 = NW(NPERD,1)
          IAD2 = NW(NPERD,2)
          NN   = KWORK(IAD1)
          DO K=1,NN-1
            IN1 = KWORK(IAD1+K)
            DO I=1,NPERD-1
              IADI = NW(I,1)
              NI   = KWORK(IADI)
              DO J=1,NI-1
                IF(IN1.EQ.KWORK(IADI+J)) THEN
                  KWORK(IAD1+K) = 0
                  KWORK(IAD2+K) = 0
                END IF
              END DO
            END DO
          END DO
          CALL ZEROSORT(KWORK(IAD1))
          CALL ZEROSORT(KWORK(IAD2))
c         IAD1 = NW(NPERD,2)
c         NN   = KWORK(IAD1)
c         DO K=1,NN-1 
c           IN1 = KWORK(IAD1+K)
c           DO J=1,LWK
c             IF(IN1.EQ.KWORK(J)) KWORK(IAD1+K) = 0
c           END DO
c         END DO
c         CALL ZEROSORT(KWORK(IAD1))
        END IF
C       IWORK(1) = 1
C       IAD1 = NW(NPERD,1)
C       NWK1 = KWORK(IAD) - 1
C       IADI1= 1
C       IADI2= IADI1+NWK1+1
C       NC   = 0
C       DO K=1,NWK1
C         IP = KWORK(IAD1+K)
C         DO IPBND=1,NPBND
C           IFD   = IFBND(IPBND)
C           IBSET = KPBND(IPBND,IFD)
C           DO I = 1,NNSET(IBSET)
C             KB = INSET(I,IBSET)
C             IF(IP.EQ.KB) GOTO 50
C           END DO
C         END DO
C         NC = NC + 1
C         IWORK(IADI1+NC) = KWORK(IAD1+K)
C         IWORK(IADI2+NC) = KWORK(IAD2+K)
C  50     CONTINUE
C       END DO

c       IAD1 = NW(NPERD,1)
c       NN   = KWORK(IAD1)
c       write(81,5555) 'K21',NN,(KWORK(IAD1+K),K=1,NN-1)
c       IAD1 = NW(NPERD,2)
c       NN   = KWORK(IAD1)
c       write(81,5556) 'K22',NN,(KWORK(IAD1+K),K=1,NN-1)

        IF(IOUT.NE.1) THEN
c         NEWNOD = NNODE+NEQUATP
          NNODE  = NNODE + 1
          NEWNOD = NNODE
          WRITE(IO_OUTP,1000) NEWNOD,0.0,0.0,0.0
          CHAR = 'EQUATP'//CNUM(NEQUATP)
          WRITE(IO_OUTP,1001) CHAR,NEWNOD

          NDSET = NDSET + 1
          NNSET (NDSET) = 1
          CNDSET(NDSET) = CHAR
          INSET (1,NDSET) = NEWNOD

          DO IFD =1,KSORT
c           CHAR1 = 'PBNM'//CNUM(NPERD)//CNUM(IFD)
c           CHAR2 = 'PBNS'//CNUM(NPERD)//CNUM(IFD)
            IAD1  = NW(NPERD,1)
            NWK   = KWORK(IAD1) - 1
            IAD2  = NW(NPERD,2)
            NWK   = KWORK(IAD2) - 1

            IADI1 = 1
            IADI2 = IADI1+NWK+1
            NC   = 0
            DO K=1,NWK
              IP = KWORK(IAD1+K)
              DO IPBND=1,NPBND
c               IFD   = IFBND(IPBND)
                IBSET = KPBND(IPBND,IFD)
                IF(IBSET.GT.0) THEN
                  DO I = 1,NNSET(IBSET)
                    KB = INSET(I,IBSET)
                    IF(IP.EQ.KB) GOTO 50
                  END DO
                END IF
              END DO
              NC = NC + 1
              IWORK(IADI1+NC) = KWORK(IAD1+K)
              IWORK(IADI2+NC) = KWORK(IAD2+K)
   50       CONTINUE
            END DO

c           WRITE(IO_OUTP,1002) CHAR1,(KWORK(IAD+K),K=1,NWK)
c           IAD = NW(NPERD,2)
c           NWK = KWORK(IAD) - 1
c           WRITE(IO_OUTP,1002) CHAR2,(KWORK(IAD+K),K=1,NWK)

c           WRITE(IO_OUTP,1002) CHAR1,(IWORK(IADI1+K),K=1,NC)
c           WRITE(IO_OUTP,1002) CHAR2,(IWORK(IADI2+K),K=1,NC)
C
            WRITE(IO_OUTP,2005) CHAR1,CHAR2,IFD,NC

c       write(81,5557) 'K31',IFD,NC,CHAR1,(IWORK(IADI1+K),K=1,NC)
c       write(81,5557) 'K32',IFD,NC,CHAR2,(IWORK(IADI2+K),K=1,NC)
 5557 format(A,2I5,A/(10I5))

            DO K=1,NC
              IP1 = IWORK(IADI1+K)
              IP2 = IWORK(IADI2+K)
              WRITE(IO_OUTP,1012) 3,
     &        IP1,IFD,1.0,IP2,IFD,-1.0,NEWNOD,IFD,-1.0
            END DO
          END DO
        END IF
c       IAD = NW(NPERD,1)
c       KWORK(IAD) = 0
c       IAD = NW(NPERD,2)
c       KWORK(IAD) = 0
   99   CONTINUE
      END DO
 1000 FORMAT('*NODE, SYSTEM=R'/I10,3(1H,,1PE15.8))
 1001 FORMAT('*NSET,NSET=',A/I5)
 1002 FORMAT('*NSET,NSET=',A/13(I5,1H,))
 1010 FORMAT('*EQUATION'/I5/(A,1H,,I5,1H,,F10.5,1H,,
     &                   A,1H,,I5,1H,,F10.5,1H,,2(I5,1H,),F10.5))
 1012 FORMAT('*EQUATION'/I5/3(I5,1H,,I5,1H,,F10.5,1H,))
 2000 FORMAT('!!! ERROR in Sub.EQUATP :',10A)
 2001 FORMAT(5X,10A)
 2005 FORMAT(
     & '**'/
     & '**     Periodc constraint has been applied for node set'/
     & '**        ',A,' and ',A,' on degree of freedom',I2/
     & '**     Total equations are ',I5/
     & '**')
C
      TEXT='END OF EXCUTING SUB. EQUATP'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     REORDER THE NODES ORDER
C
      SUBROUTINE SORTND(KWORK,KAXI)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER REORDERT*8
      DIMENSION KWORK(*)
C
      DO I=2,KWORK(1)-1
        JMIN=I
        IN1=KWORK(I)
        ZMIN=COORD(IN1,KAXI)
        DO J=I+1,KWORK(1)
          IN2=KWORK(J)
          Z=COORD(IN2,KAXI)
          IF(Z.LT.ZMIN) THEN
            JMIN=J
            ZMIN=Z
          END IF
        END DO
        IF(JMIN.NE.I) THEN
          JM=KWORK(I)
          KWORK(I)=KWORK(JMIN)
          KWORK(JMIN)=JM
        END IF
      END DO
c     WRITE(IO_WORK,'(I6,3E10.4)')
c    &   (KWORK(I),(COORD(KWORK(I),K),K=1,3),I=2,KWORK(1))
      RETURN
      END
c *** SORT OUT THE ZERO ELEMENTS
      SUBROUTINE ZEROSORT(KWORK)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KWORK(*)
C
      NN = KWORK(1)
      NN0= NN
      KK = 1
    5 CONTINUE
      KK = KK + 1
      IF(KWORK(KK).LE.0) THEN
    6   CONTINUE
        DO K=KK,NN-1
          KWORK(K) = KWORK(K+1)
        END DO
        NN = NN - 1
        IF(KWORK(KK).LE.0.AND.KK.LT.NN) GOTO 6
      END IF
      IF(KK.LT.NN) GOTO 5
c     NN = 1
c     DO K=2,KWORK(1)
c       IF(KWORK(K).NE.0) NN= NN+1
c     END DO
      DO K=NN+1,KWORK(1)
        KWORK(K) = 0
      END DO
      KWORK(1) = NN
      RETURN
      END
C
C     REORDER THE NODES ORDER
C
      SUBROUTINE SAMEND(KWORK1,KWORK2,IFD1,IFD2)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER REORDERT*8
      DIMENSION KWORK1(*),KWORK2(*)
C
      IF(KWORK1(1).NE.KWORK2(1)) GOTO 10
      DO I=2,KWORK1(1)
        IN1=KWORK1(I)
        X1=COORD(IN1,IFD1)
        Y1=COORD(IN1,IFD2)
        DISTI = 1.0E30
        JI    = I
        DO J=I,KWORK2(1)
          IN2=KWORK2(J)
          X2=COORD(IN2,IFD1)
          Y2=COORD(IN2,IFD2)
          DIST=SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
          IF(DIST.LT.TOLER) THEN
            IF(J.NE.I) THEN
              JM=KWORK2(I)
              KWORK2(I)=KWORK2(J)
              KWORK2(J)=JM
            END IF
            GOTO 5
          ELSE IF(DIST.LT.DISTI) THEN
            DISTI = DIST
            JI    = J
          END IF
        END DO

        JM=KWORK2(JI)
        KWORK2(JI)=KWORK2(I)
        KWORK2(I)=JM

        CERRRPT(2)(20:80) = ': Subroutine SAMEND report'
        WRITE(CERRRPT(3)(20:80),1000) 
     &  ': No same coordinates (d.f. ',IFD1,IFD2,
     &  ') is found for node ',IN1
        WRITE(CERRRPT(4)(20:80),1001) 
     &  ': Node ',JM,' is the closest node, dist=',DISTI
        NLERR = 4
        IUNIT = 6
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_INFO
        CALL MWARNING(IUNIT,KERR,NLERR)
        IUNIT = IO_OUTP
        CALL MWARNING(IUNIT,KERR,NLERR)

   5    CONTINUE
      END DO
      RETURN
  10  CONTINUE
 1000 FORMAT(A,I1,1X,I1,A,I5)
 1001 FORMAT(A,I5,A,E9.4)
      STOP
      END
      SUBROUTINE FINDSET(CSET,NSET,CHAR,ISET)
      CHARACTER CSET(*)*8,CHAR*8
      DO ISET = 1,NSET
        IF(CHAR.EQ.CSET(ISET)) RETURN
      END DO
      ISET = 0
      RETURN
      END
