C
C     SUBROUTINE FOR GENERATING  ELEMENT 
C
      SUBROUTINE MESHVL
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(3,10),XP2(3,10)
      DIMENSION LABEX0(3,2),LABEX1(3,2),LABEX2(3,2)
      DIMENSION NDINTER(20000),LCELDF(20,20,20),LCNDDF(33),
     &          LCWORK(10,6),COEF_CD(20,6),NODE_CD(20,6,6),
     &          KWORK1(2,2),LCTYPE(2),NNELLC(2),INTE_ND(20,6),
     &          KWORK2(8),BLELC(8),INCDLUR(8),XYZ_LUR(8),XYZVL(8),
     &          LCTYPE_L(200),NNELLC_L(200),ELENGI(1000),
     &          LCTYPE_U(200),NNELLC_U(200)
C
      CALL DATADEF(LCELDF,LCWORK,COEF_CD,NODE_CD,INTE_ND)
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
C
      DO I = 1,4
        II = 2*I-1
        XP1(2,II) = -1.0E30
        XP1(3,II) = 0.0E0
        XP2(2,II) = 1.0E30
        XP2(3,II) = 0.0E0
        II = 2*I
        XP1(1,II) = -1.0E30
        XP1(3,II) = 0.0E0
        XP2(1,II) = 1.0E30
        XP2(3,II) = 0.0E0
      END DO
C
      IE=NELEM
      IN=NNODE
      NND0=NNODE
      DO I=1,4
        BLELC(I)=0.0
        INCDLUR(I)=0
        XYZ_LUR(I)=0.0
        XYZVL(I)=0.0
      END DO
      NNINTERL=0
C
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
        GOTO 999
      ELSE
        IEIT1 = 0
        DO I=1,8
          KWORK2(I)=0
        END DO
C----------------------------------------------------------------------
        CALL LOCCHR(STRING,'RYMIN   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP1(2,3)
        END IF
C
        CALL LOCCHR(STRING,'RYMAX   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP2(2,3)
        END IF
        CALL LOCCHR(STRING,'LYMIN   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP1(2,1)
        END IF
C
        CALL LOCCHR(STRING,'LYMAX   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP2(2,1)
        END IF
        CALL LOCCHR(STRING,'UXMIN   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP1(1,2)
        END IF
C
        CALL LOCCHR(STRING,'UXMAX   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP2(1,2)
        END IF
        CALL LOCCHR(STRING,'DXMIN   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP1(1,4)
        END IF
C
        CALL LOCCHR(STRING,'DXMAX   ',5,1,K1,K2)
        IF(K2.GE.K1) THEN
          READ(STRING(K1:K2),*) XP2(1,4)
        END IF
C----------------------------------------------------------------------
        NVME = 0
        IF(STRING(1:5).EQ.'LURDL') THEN
          NVME = 5
          KWORK2(1)=1
          KWORK2(2)=2
          KWORK2(3)=3
          KWORK2(4)=4
          KWORK2(5)=5
          XP2(2,5) = XP1(2,1)
        ELSE IF(STRING(1:4).EQ.'LURD') THEN
          NVME = 4
          KWORK2(1)=1
          KWORK2(2)=2
          KWORK2(3)=3
          KWORK2(4)=4
        ELSE IF(STRING(1:3).EQ.'LUR') THEN
          NVME = 3
          KWORK2(1)=1
          KWORK2(2)=2
          KWORK2(3)=3
        ELSE IF(STRING(1:3).EQ.'URD') THEN
          NVME = 3
          KWORK2(1)=2
          KWORK2(2)=3
          KWORK2(3)=4
        ELSE IF(STRING(1:3).EQ.'RDL') THEN
          NVME = 3
          KWORK2(1)=3
          KWORK2(2)=4
          KWORK2(3)=1
        ELSE IF(STRING(1:2).EQ.'LU') THEN
          NVME = 2
          KWORK2(1)=1
          KWORK2(2)=2
        ELSE IF(STRING(1:2).EQ.'UR') THEN
          NVME = 2
          KWORK2(1)=2
          KWORK2(2)=3
        ELSE IF(STRING(1:2).EQ.'LR') THEN
          NVME = 2
          KWORK2(1)=1
          KWORK2(2)=3
        ELSE IF(STRING(1:2).EQ.'RD') THEN
          NVME = 2
          KWORK2(1)=3
          KWORK2(2)=4
        ELSE IF(STRING(1:2).EQ.'DL') THEN
          NVME = 2
          KWORK2(1)=4
          KWORK2(2)=1
        ELSE IF(STRING(1:2).EQ.'UD') THEN
          NVME = 2
          KWORK2(1)=2
          KWORK2(2)=4
        ELSE IF(STRING(1:1).EQ.'L') THEN
          NVME = 1
          KWORK2(1)=1
        ELSE IF(STRING(1:1).EQ.'U') THEN
          NVME = 1
          KWORK2(1)=2
        ELSE IF(STRING(1:1).EQ.'R') THEN
          NVME = 1
          KWORK2(1)=3
        ELSE IF(STRING(1:1).EQ.'D') THEN
          NVME = 1
          KWORK2(1)=4
        ELSE
          GOTO 1
        END IF
        READ(IO_INPUT,*) KCASE,IMSET,NODE
        READ(IO_INPUT,'(A)') STRING
        IF(STRING(1:1).EQ.'*') THEN
          BACKSPACE 1
        ELSE
          CALL LOCCHR(STRING,'TR      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 3
            XYZVL(IT) = AGASH
          END IF
          CALL LOCCHR(STRING,'DR      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 3
            XYZVL(IT) = AGASH+XMAX
          END IF
          CALL LOCCHR(STRING,'TL      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 1
            XYZVL(IT) = AGASH
          END IF
          CALL LOCCHR(STRING,'DL      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 1
            XYZVL(IT) = AGASH+XMIN
          END IF
          CALL LOCCHR(STRING,'TU      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 2
            XYZVL(IT) = AGASH
          END IF
          CALL LOCCHR(STRING,'DU      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 2
            XYZVL(IT) = AGASH+YMAX
          END IF
          CALL LOCCHR(STRING,'TD      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 4
            XYZVL(IT) = AGASH
          END IF
          CALL LOCCHR(STRING,'DD      ',2,1,K1,K2)
          IF(K2.GT.K1) THEN
            READ(STRING(K1:K2),*) AGASH
            IT = 4
            XYZVL(IT) = AGASH+YMIN
          END IF
        END IF
        DO I = 1,4
          XYZVL(4+I) = XYZVL(I)
        END DO
        DO I = 1,2
          DO J = 1,3
            LABEX1(J,I) = 0
            LABEX2(J,I) = 0
          END DO
        END DO
C
        DO II=1,NVME
          IF(KWORK2(II).NE.0) THEN
            ITi = KWORK2(II)
            IT  = ITi
            IF(ITi.GT.4) IT = ITi - 4
            IF(II.EQ.1) IEIT1 = NELEM + 1
            IF(IT.EQ.1) THEN
              XP1(1,ITi) = XMIN
              XP2(1,ITi) = XMIN
              CALL FN_LIN_ND(XP1(1,ITi),XP2(1,ITi),NDINTER,NNINTER)
              CALL SORTCD(NDINTER,NNINTER,2)
              XC_TYPE=-1.0
              YC_TYPE= 0.0
              NNINTERL=NNINTER
              IF(ABS(XYZVL(IT)).GT.1.0E-6) THEN
                XYZVL(IT) = XYZVL(IT) - XMIN
              END IF
            ELSE IF(IT.EQ.2) THEN
              XP1(2,ITi) = YMAX
              XP2(2,ITi) = YMAX
              CALL FN_LIN_ND(XP1(1,ITi),XP2(1,ITi),NDINTER,NNINTER)
              CALL SORTCD(NDINTER,NNINTER,1)
              XC_TYPE= 0.0
              YC_TYPE= 1.0
              NNINTERU=NNINTER
              IF(ABS(XYZVL(IT)).GT.1.0E-6) THEN
                XYZVL(IT) = XYZVL(IT) - YMAX
              END IF
            ELSE IF(IT.EQ.3) THEN
C             CALL SEAND(NDINTER,1,XMAX,NNINTER,3)
              XP1(1,ITi) = XMAX
              XP2(1,ITi) = XMAX
              CALL FN_LIN_ND(XP1(1,ITi),XP2(1,ITi),NDINTER,NNINTER)
              CALL SORTCD(NDINTER,NNINTER,2)
              CALL INVERIA(NDINTER,NNINTER)
              XC_TYPE= 1.0
              YC_TYPE= 0.0
              IF(ABS(XYZVL(IT)).GT.1.0E-6) THEN
                XYZVL(IT) = XYZVL(IT) - XMAX
              END IF
            ELSE IF(IT.EQ.4) THEN
C             CALL SEAND(NDINTER,2,YMIN,NNINTER,3)
              XP1(2,ITi) = YMIN
              XP2(2,ITi) = YMIN
              CALL FN_LIN_ND(XP1(1,ITi),XP2(1,ITi),NDINTER,NNINTER)
              CALL SORTCD(NDINTER,NNINTER,1)
              CALL INVERIA(NDINTER,NNINTER)
              XC_TYPE= 0.0
              YC_TYPE= -1.0
              IF(ABS(XYZVL(IT)).GT.1.0E-6) THEN
                XYZVL(IT) = XYZVL(IT) - YMIN
              END IF
            END IF
            LABEX2(1,1) = NDINTER(1)
            LABEX2(2,1) = 0
            LABEX2(3,1) = 0
            LABEX2(1,2) = NDINTER(NNINTER)
            LABEX2(2,2) = 0
            LABEX2(3,2) = 0
C
            BLMIN= 1.0E30
            BLMAX=-1.0E30
            ND1=2
            ND2=1
            IF(NODE.GE.8) THEN
              ND1=3
              ND2=2
            END IF
            NELINTER = 0
            DO I=ND1,NNINTER,ND2
              NELINTER = NELINTER + 1
              IL1=NDINTER(I-ND2)
              IL2=NDINTER(I)
              X1=COORD(IL1,1)
              Y1=COORD(IL1,2)
              X2=COORD(IL2,1)
              Y2=COORD(IL2,2)
              DIST = SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
              BLELC(IT) = DIST
              ELENGI(NELINTER) = DIST
              IF(BLMIN.GT.BLELC(IT)) BLMIN=BLELC(IT)
              IF(BLMAX.LT.BLELC(IT)) BLMAX=BLELC(IT)
            END DO
            IF(NELINTER.GT.7.AND.BLMAX.GT.3.0*BLMIN) THEN
              DO I = 1,NELINTER
                DIST = ELENGI(I)
                DIST = ELENGI(I)
              END DO
            END IF
            BLELC(IT)=0.5*(BLMIN+BLMAX)
            IF(ABS(XYZVL(IT)).GT.1.0E-6) THEN
              BLELC(IT) = ABS(XYZVL(IT))*0.5E0
            END IF
C
C
            KWORK1(1,1)=NELINTER-(NELINTER/3)*3
            KWORK1(2,1)=NELINTER-(NELINTER/4)*4
            KWORK1(1,2)=NELINTER/3
            KWORK1(2,2)=NELINTER/4
C
            IF(IT.EQ.3.AND.NNINTER.EQ.NNINTERL) THEN
              LCTYPE(2)=LCTYPE_L(1)
              LCTYPE(1)=LCTYPE_L(2)
              NNELLC(2)=NNELLC_L(1)
              NNELLC(1)=NNELLC_L(2)
            ELSE IF(IT.EQ.4.AND.NNINTER.EQ.NNINTERU) THEN
              LCTYPE(2)=LCTYPE_U(1)
              LCTYPE(1)=LCTYPE_U(2)
              NNELLC(2)=NNELLC_U(1)
              NNELLC(1)=NNELLC_U(2)
            ELSE
              LCTYPE(1)=0
              LCTYPE(2)=0
              IF(KWORK1(KCASE,1).EQ.0) THEN
                LCTYPE(1)=KCASE
                NNELLC(1)=KWORK1(KCASE,2)
                NNELLC(2)=0
              ELSE IF(KWORK1(KCASE,1).EQ.1) THEN
                LCTYPE(1)=KCASE
                IF(KCASE.EQ.2) THEN
                  LCTYPE(2)=1
                  NNELLC(2)=3
                  NNELLC(1)=KWORK1(KCASE,2)-2
                ELSE IF(KCASE.EQ.1) THEN
                  LCTYPE(2)=2
                  NNELLC(2)=1
                  NNELLC(1)=KWORK1(KCASE,2)-1
                END IF
              ELSE IF(KWORK1(KCASE,1).EQ.2) THEN
                LCTYPE(1)=KCASE
                IF(KCASE.EQ.2) THEN
                  LCTYPE(2)=1
                  NNELLC(2)=2
                  NNELLC(1)=KWORK1(KCASE,2)-1
                ELSE IF(KCASE.EQ.1) THEN
                  LCTYPE(2)=2
                  NNELLC(2)=2
                  NNELLC(1)=KWORK1(KCASE,2)-2
                END IF
              ELSE IF(KWORK1(KCASE,1).EQ.3) THEN
                LCTYPE(1)=KCASE
                NNELLC(1)=KWORK1(KCASE,2)
                LCTYPE(2)=1
                NNELLC(2)=1
              END IF
            END IF
C
            IF(IT.EQ.1) THEN
              LCTYPE_L(1)=LCTYPE(1)
              LCTYPE_L(2)=LCTYPE(2)
              NNELLC_L(1)=NNELLC(1)
              NNELLC_L(2)=NNELLC(2)
            END IF
            IF(IT.EQ.2) THEN
              LCTYPE_U(1)=LCTYPE(1)
              LCTYPE_U(2)=LCTYPE(2)
              NNELLC_U(1)=NNELLC(1)
              NNELLC_U(2)=NNELLC(2)
            END IF
            IF(NODE.EQ.4) THEN
              DO K=1,2
                IF(LCTYPE(K).NE.0) LCTYPE(K)=LCTYPE(K)+2
              END DO
            END IF
C
            NND1=0     
C
            DO ILCPART=1,2
              NTELC=NNELLC(ILCPART)
              IF(NTELC.GT.0) THEN
                ILCTYPE=LCTYPE(ILCPART)
                DO INELC=1,NTELC
                  NLCND=LCWORK(1,ILCTYPE)
                  NLCDC=LCWORK(5,ILCTYPE)
                  DO ILCND=1,NLCND
                    LCNDDF(ILCND)=ILCND+(INELC-1)*NLCDC+NND0
                    IN=LCNDDF(ILCND)
                  END DO
                  NLCINT=LCWORK(2,ILCTYPE)
                  DO ILCINT=1,NLCINT+1
                    ILNOD=INTE_ND(ILCINT,ILCTYPE)
                    ILCND=ILCINT+(INELC-1)*NLCINT+NND1
                    LCNDDF(ILNOD)=NDINTER(ILCND)
                    IMEMO=ILCND
                  END DO
                  NLCEL=LCWORK(3,ILCTYPE)
                  DO ILCEL=1,NLCEL
                    IE=IE+1
                    LNODS(IE,MXNOD)=NODE
                    LNODS(IE,MXNOD-1)=IMSET
                    ELTYP(IE)='C2D8'
                    IF(NODE.EQ.4) ELTYP(IE)='C2D4'
                    MATSET(IMSET,1)=MATSET(IMSET,1)+1
                    MATSET(IMSET,MATSET(IMSET,1))=IE
                    DO INODE=1,NODE
                      LCNOD=LCELDF(INODE,ILCEL,ILCTYPE)
                      LNODS(IE,INODE)=LCNDDF(LCNOD)
                    END DO
                    CALL DNODE(IE,NODE)
                  END DO
                  NTNOD=LCWORK(4,ILCTYPE)
                  DO ITNOD=1,NTNOD
                    CO=COEF_CD(ITNOD,ILCTYPE)
                    IL1=NODE_CD(ITNOD,2,ILCTYPE)
                    ILCND1=LCNDDF(IL1)
                    X=COORD(ILCND1,1)
                    Y=COORD(ILCND1,2)
                    IL2=NODE_CD(ITNOD,1,ILCTYPE)
                    ILCND2=LCNDDF(IL2)
                    COORD(ILCND2,1)=X+CO*BLELC(IT)*XC_TYPE
                    COORD(ILCND2,2)=Y+CO*BLELC(IT)*YC_TYPE
                    IF(IT.EQ.1) XYZ_LUR(1)=X+CO*BLELC(IT)*XC_TYPE
                    IF(IT.EQ.2) XYZ_LUR(2)=Y+CO*BLELC(IT)*YC_TYPE
                    IF(IT.EQ.3) XYZ_LUR(3)=X+CO*BLELC(IT)*XC_TYPE
                    IF(IT.EQ.4) XYZ_LUR(4)=Y+CO*BLELC(IT)*YC_TYPE
                  END DO
                END DO
                NND0=IN-3
                IF(NODE.EQ.4) NND0=IN-2
                NND1=IMEMO-1
              END IF
            END DO
C
          END IF
C
          NND0 = IN
          II1  = II + 1
          ITi1 = KWORK2(II1)
          IF((ITi1.NE.0.AND.ITi1.EQ.ITi+1).OR.
     &       (LABEX2(1,2).EQ.LABEX0(1,1))) THEN
            IF(NODE.EQ.4) THEN
              IE=IE+1
              LNODS(IE,MXNOD)=NODE
              LNODS(IE,MXNOD-1)=IMSET
              ELTYP(IE)='C2D4'
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IE
              LNODS(IE,1)=LCNDDF(NLCND-1)
              LNODS(IE,2)=IN+2
              LNODS(IE,3)=IN+1
              LNODS(IE,4)=LCNDDF(NLCND)
              INCDLUR(IT)=IN+1
              IF(LABEX2(1,2).EQ.LABEX0(1,1)) THEN
                LNODS(IE,1) = LNODS(IEIT1,1)
                LNODS(IE,2) = LNODS(IEIT1,4)
                IN = IN + 1
              END IF
              NND0 = IN
              CALL DNODE(IE,NODE)
              IN   = IN + 2
            ELSE IF(NODE.EQ.8) THEN
              IE=IE+1
              LNODS(IE,MXNOD)=NODE
              LNODS(IE,MXNOD-1)=IMSET
              ELTYP(IE)='C2D8'
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IE
              LNODS(IE,1)=LCNDDF(NLCND-2)
              LNODS(IE,2)=IN+5
              LNODS(IE,3)=IN+2
              LNODS(IE,4)=LCNDDF(NLCND)
              LNODS(IE,5)=IN+4
              LNODS(IE,6)=IN+3
              LNODS(IE,7)=IN+1
              LNODS(IE,8)=LCNDDF(NLCND-1)
              IF(LABEX2(1,2).EQ.LABEX0(1,1)) THEN
                LNODS(IE,1) = LNODS(IEIT1,1)
                LNODS(IE,2) = LNODS(IEIT1,4)
                LNODS(IE,5) = LNODS(IEIT1,8)
              END IF
              INCDLUR(IT)=IN+2
              NND0=IN+2
              CALL DNODE(IE,NODE)
              IN   = IN + 5
            END IF
          END IF
          IF(II.EQ.1) THEN
            DO I = 1,2
              DO J = 1,3
                LABEX0(J,I) = LABEX2(J,I) 
              END DO
            END DO
          END IF
          DO I = 1,2
            DO J = 1,3
              LABEX1(J,I) = LABEX2(J,I) 
            END DO
          END DO
C
        END DO
C
      END IF
C
  999 CONTINUE
C
      IF(INCDLUR(1).NE.0) THEN
        COORD(INCDLUR(1),1)=XYZ_LUR(1)
        COORD(INCDLUR(1),2)=XYZ_LUR(2)
      END IF
      IF(INCDLUR(3).NE.0) THEN
        COORD(INCDLUR(3),1)=XYZ_LUR(3)
        COORD(INCDLUR(3),2)=XYZ_LUR(4)
      END IF
      IF(INCDLUR(2).NE.0) THEN
        COORD(INCDLUR(2),1)=XYZ_LUR(3)
        COORD(INCDLUR(2),2)=XYZ_LUR(2)
      END IF
      IF(INCDLUR(4).NE.0) THEN
        COORD(INCDLUR(4),1)=XYZ_LUR(1)
        COORD(INCDLUR(4),2)=XYZ_LUR(4)
      END IF
C
      NE1=NELEM+1
      NELEM=IE
      NNODE=IN
      IF(BLELC(1).NE.0.0) ELL=ABS(BLELC(1)*2)
      IF(BLELC(2).NE.0.0) ELU=ABS(BLELC(2)*2)
      IF(BLELC(3).NE.0.0) ELR=ABS(BLELC(3)*2)
      IF(BLELC(4).NE.0.0) ELD=ABS(BLELC(4)*2)
C
      IF(NODE.EQ.8) CALL NODXY(3,NE1,NELEM)
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      RETURN
      END
